%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% ftciupd                          ftciupd.m                 ftciupd
% =========================================================================  
%                          FlexTools(CI) for Matlab
%                             Copyright (c) 1996
%                       Flexible Intelligence Group (FIG)                            
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
% =========================================================================   
%  PURPOSE   
%         Do certain initialization operations for CI
%  .........................................................................   
%  GIVEN  
%		
%  .........................................................................   
%  OPERATION   
%
%  		 Declare Variables
%  .........................................................................   
%  RETURNS   
%         Nothing. Global variables gets set up.
%  .........................................................................   
%  APPLICATION   
%         CI, ENM, EFM
%  .........................................................................   
%  USE WITH   
%   
%       MUST   
%               FlexTool(CI) FlexTools(ENM), FlexTools(EFM) Matlab   
%       MAY   
%                
%  USES
%  ========================================================================   
%   SYNTAX  /  USAGE  
%   ftciupd(parmcnt, parttype, ptype, partflg, modelflg)
%  ========================================================================  

%  DECLARATION   
%   ftciupd
   
%  ========================================================================  
%   DESCRIPTION -  FLEXTOOL APPROACH  
%
%   
%  ========================================================================   
%  VARIABLE DICTIONARY   
%
%  ========================================================================   
%  ALGORITHM   
%   
%  ========================================================================   
%  CODE
%
% GLOBAL
%

function ftciupd(parmcnt, parttype, ptype, partflg, modelflg)

global ftMaxModelCNTgbl  ftModelCNTgbl    ftModelIDXgbl
global ftModelNameMATgbl ftModelDBVECgbl  ftModelPartCntVECgbl
global ftMaxPartCNTgbl   ftPartTypeVECgbl ftPartCNTgbl
global ftPartIDXgbl      ftPartNameMATgbl ftPartDBVECgbl 
global ftModelTypeVECgbl ftSequenceVECgbl ftEApartCNTgbl
global ftPartInfoMATgbl  ftParmCNTgbl     ftParmIDXgbl

%
% Move to next partition
%     Increment Partition count, Partition Index
%     Update all the other information.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if(modelflg==1)
	    ftModelCNTgbl			= ftModelCNTgbl + 1;
	    ftModelIDXgbl			= ftModelIDXgbl + 1;
        end;

        if(partflg==1)
	    ftPartCNTgbl		        = ftPartCNTgbl + 1;
	    ftPartIDXgbl                        = ftPartIDXgbl + 1;
            ftPartTypeVECgbl(1,ftPartIDXgbl)    = ftPartDBVECgbl(parttype);
	    ftModelPartCntVECgbl(1,ftModelIDXgbl)= ftModelPartCntVECgbl(1,ftModelIDXgbl)+1;
	end;

	ftPartInfoMATgbl(1,ftPartIDXgbl)        = ftModelTypeVECgbl(ftModelIDXgbl);
	ftPartInfoMATgbl(2,ftPartIDXgbl)        = ftPartTypeVECgbl(1,ftPartIDXgbl);
	ftPartInfoMATgbl(3,ftPartIDXgbl)	= ptype;
	if(partflg==1)
		ftPartInfoMATgbl(4,ftPartIDXgbl)= ftParmIDXgbl+1;
	end;
	ftParmIDXgbl			    	= ftParmIDXgbl+parmcnt;
	if(partflg==1)
		ftPartInfoMATgbl(5,ftPartIDXgbl)= ftParmIDXgbl;
		ftPartInfoMATgbl(6,ftPartIDXgbl)= parmcnt;
	else
		ftPartInfoMATgbl(5,ftPartIDXgbl)= ftPartInfoMATgbl(4,ftPartIDXgbl)+parmcnt;
		ftPartInfoMATgbl(6,ftPartIDXgbl)= ftPartInfoMATgbl(5,ftPartIDXgbl)+parmcnt;
	end;
	ftParmCNTgbl			    	= ftParmIDXgbl;
%====================================================================

%  ========================================================================   
%  CAUTION   
%  ========================================================================   
%  EXAMPLE   
   
%  ========================================================================   
%  SEE ALSO   
%   
%  ========================================================================   
%  REFERENCE   
%    
%  Guidelines for Evolutionary Fuzzy Modeling
%  FIG LLC, Tuscaloosa, AL 35486-1477, USA, FIGLLC@AOL.COM
%  ==========================================================================   
% (c) Flexible Intelligence Group (FIG)   
% END ftciupd.m
% ftciupd                           ftciupd.m                  ftciupd
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%