% =================================================================
% ftea1.m
% =================================================================
%                        FlexTool(EA) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(EA)
%

function ftea1(TEXT_)

global ftscr_cntSCAgbl ftflag_edtGUI
global ftFigPos_bigVECgbl ftFigPos_mediumVECgbl 
global ftcolor_bc1VECgbl ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 

global ftEApp_typeMATgbl
global ftEAtitleVECgbl ftEAtypeSCAgbl
global ftciGUI ftXYscaleVECgbl
global ftflag_edtGUI ftscr_cntSCAgbl

global ftEAmm_typeSCAgbl ftEApp_typeMATgbl 
global ftEApp_selMATgbl ftEAnoofpeaksSCAgbl ftEApp_noofpksMATgbl
global ftEApp_mmtypeMATgbl ftEAnselectSCAgbl ftEAnoofpSCAgbl
global ftEAsspopSCAgbl ftEAnpopSCAgbl ftEAngenSCAgbl
global ftEApcrossSCAgbl ftEApmutateSCAgbl ftEAncrossSCAgbl
global ftEAobj_nameGUI ftEAobjfuncVECgbl ftEAnichtestSCAgbl

global ftEAfunpVECgbl
global ftEAinitfuncVECgbl ftEAnoofpSCAgbl
global ftEAcodingSCAgbl ftEAnopSCAgbl ftEAlchromSCAgbl  
global ftEAnoofobjSCAgbl ftEApminVECgbl ftEApmaxVECgbl ftEApresVECgbl
global ftEAp2SCAgbl ftEAmmVECgbl ftEApresuVECgbl ftEAnbitsVECgbl

global ftFigPos_mainVECgbl

global ftEAer_typeSCAgbl ftGAfun_flagSCAgbl

ftEAlala=num2str(ftEApp_typeMATgbl(ftEAtypeSCAgbl,:));
ftEAlala=['FlexTool(EA)-- ' ftEAlala '--Build'];

save_scr_cnt_=ftscr_cntSCAgbl;

%========================
% EA-Parameters Defn Block
%========================

ftEApp1='Min or Max?';
ftEApp3=[0.075 0.13 0.2 0.09];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.075 0.05 0.2 0.1];
ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftEApp4=['ftEAmm_typeSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); '];
ftEApp5= ftEAmm_typeSCAgbl;
ftEApp6=[1:size(ftEApp_mmtypeMATgbl,1)]';
ftEApp2=[ftEApp_mmtypeMATgbl((1:size(ftEApp_mmtypeMATgbl,1)),:)];
ftscrpup(ftciGUI,ftEApp2,ftEApp3,ftEApp4,ftEApp5,ftEApp6,ftscr_cntSCAgbl);
clear ftEApp3 ftEApp2

ftEApp1='Selection';
ftEApp3=[0.4 0.13 0.2 0.09];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.4 0.05 0.2 0.1];

if ftEAtypeSCAgbl~=1 %Other than regular GA
  ftEApp6=[1:(size(ftEApp_selMATgbl,1)-1)]';
else
  ftEApp6=[1:(size(ftEApp_selMATgbl,1))]';
end


if ftEAtypeSCAgbl==2 % micro-GA
   ftEAnselectSCAgbl=2;
   ftEApp1=ftEApp_selMATgbl(ftEAnselectSCAgbl,:);
   ftstxt(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp4=['ftEAnselectSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
   ftEApp5=ftEAnselectSCAgbl;
   ftEApp6=[1:size(ftEApp_selMATgbl,1)]';
   ftscrpup(ftciGUI,ftEApp_selMATgbl,ftEApp3,ftEApp4,ftEApp5,ftEApp6,ftscr_cntSCAgbl);
   clear ftEApp3;
end

ftEApp1='# of Peaks'; 
ftEApp3=[0.725 0.13 0.2 0.09];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.725 0.05 0.2 0.1];

if ftEAtypeSCAgbl==2  % micro-GA
   ftEAnoofpeaksSCAgbl=1;
   ftEApp1=ftEApp_noofpksMATgbl(ftEAnoofpeaksSCAgbl,:);
   ftstxt(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp4=['ftEAnoofpeaksSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
   ftEApp5=ftEAnoofpeaksSCAgbl;
   ftEApp6=[1;2;3;4];
   ftscrpup(ftciGUI,ftEApp_noofpksMATgbl(1:4,:),ftEApp3,ftEApp4,ftEApp5,ftEApp6,ftscr_cntSCAgbl);
   clear ftEApp3;
end

%=================
% EA-function defn
%=================
ftEApp1='Objective Function';
ftEApp2=[' '];
ftEApp3= [0.75 0.04 0.31 0.3 0.07 0.001];

ftscrblk(ftciGUI,ftEApp1,ftEApp2,ftEApp3);

ftEAobj_nameGUI=uicontrol('Style','edit',...
'string',ftEAobjfuncVECgbl,...
'Units','normalized', ...
'Position',[0.05 0.56 0.17 0.1],...
'BackgroundColor', [1 1 1],... %ftcolor_bc2VECgbl,...
'HorizontalAlignment','left',...
'callback',['ftEAobjfuncVECgbl=get(ftEAobj_nameGUI,''string''); ftEAobjfuncVECgbl=ftfile(ftEAobjfuncVECgbl); if(exist(ftEAobjfuncVECgbl)~=2), ftEAobjfuncVECgbl=''objfunc''; end;']);

ftEApp4=['[ftEAjunkname obpath]=uigetfile(''*.m'',''FlexTool(EA): Objective Function. Use a .m File'',50,50);',...
	'if ftEAjunkname~=0, ftEAobjfuncVECgbl=ftEAjunkname; end;',...
      'set(ftEAobj_nameGUI,''string'',ftEAobjfuncVECgbl);ftEAobjfuncVECgbl=ftfile(ftEAobjfuncVECgbl);'];

ftEApp3=[0.23 0.56 0.07 0.1];
ftscrpb(ftciGUI,'..Brws',ftEApp3,ftEApp4);

ftEApp1='# of Params'; 
ftEApp3=[0.05 0.44 0.17 0.1];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.23 0.44 0.07 0.1];
ftEApp1=num2str(ftEAnopSCAgbl);
ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftEApp4=['ftEAnopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'')); ftEAnoofpSCAgbl=ftEAnopSCAgbl; close; ftfun_ch;'];
ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
ftEApp1='Min, Max, Resolution';
ftEApp3=[0.05 0.32 0.25 0.1];
ftEApp4=['close; ftfun_ch;'];

ftscrpb(ftciGUI, ftEApp1, ftEApp3,ftEApp4);
clear ftEApp4 ftEApp1 ftEApp3

%=================
% EA-Recombination
%=================
ftEApp1='EA Recombination';
ftEApp2=[' '];
ftEApp3= [0.75 0.365 0.635 0.3 0.07 0.001];
ftscrblk(ftciGUI,ftEApp1,ftEApp2,ftEApp3);

ftEApp3=[0.375 0.56 0.18 0.1];
ftEApp1='Prob of Xover';
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.56 0.07 0.1];

if ftEAtypeSCAgbl==2  % micro-GA
   ftEApcrossSCAgbl=1;
   ftEApp1=num2str(ftEApcrossSCAgbl);
   ftstxtc(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEApcrossSCAgbl);
   ftEApp4=['ftEApcrossSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp3=[0.375 0.44 0.18 0.1];
ftEApp1='# of Xover Pts';
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.44 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEAncrossSCAgbl=1;
   ftEApp1=num2str(ftEAncrossSCAgbl);
   ftstxtc(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEAncrossSCAgbl);
   ftEApp4=['ftEAncrossSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp1='Prob of Mutation'; 
ftEApp3=[0.375 0.32 0.18 0.1];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.32 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEApmutateSCAgbl=0;
   ftEApp1=num2str(ftEApmutateSCAgbl);
   ftstxtc(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEApmutateSCAgbl);
   ftEApp4=['ftEApmutateSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

%=================
% EA-EA Defn
%=================

ftEApp1='EA Parameters';
ftEApp2=[' '];
ftEApp3= [0.75 0.69 0.96 0.3 0.07 0.001];

ftscrblk(ftciGUI,ftEApp1,ftEApp2,ftEApp3);

ftEApp3=[0.70 0.56 0.18 0.1];
ftEApp1='# of Gen';
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftEApp3=[0.88 0.56 0.07 0.1];
ftEApp1=num2str(ftEAngenSCAgbl);
ftEApp4=['ftEAngenSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);

ftEApp3=[0.7 0.44 0.18 0.1];
ftEApp1='Pop Size';
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.88 0.44 0.07 0.1];
ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
if ftEAtypeSCAgbl==2
   ftEAnpopSCAgbl=5;
   ftEApp1=num2str(ftEAnpopSCAgbl);
   ftEApp4=['ftEAnpopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
else
   ftEApp1=num2str(ftEAnpopSCAgbl);
   ftEApp4=['ftEAnpopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp1='SS Pop Size'; 
ftEApp3=[0.7 0.32 0.18 0.1];
ftscrtxt(ftciGUI,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.88 0.32 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEAsspopSCAgbl=1;
   ftEApp1=num2str(ftEAsspopSCAgbl);
   ftstxtc(ftciGUI,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEAsspopSCAgbl);
   ftEApp4=['ftEAsspopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(ftciGUI,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

%=====================
% Back, quit, next
%=====================

% Need to check to make sure the callback is correct!!!!!!!

ftscrpb(ftciGUI,'BestP',[0.76 0.9 0.1 0.1],'fteabest'); % ftEAbestpMATgbl
ftscrpb(ftciGUI,'Run BestP',[0.87 0.9 0.1 0.1],'ftgaeval');
p4_=['ftgp_def(''gp_cold.mat'',2); ftfp_def(''fp_cold.mat'',2); ftrunga(0);'];
ftscrpb(ftciGUI,'Evolve',[0.65 0.9 0.1 0.1],p4_,'y');

ftscr_cntSCAgbl=save_scr_cnt_;

%
% end ftnn1.m
%
