%
% FTeffunc.m
%
% =========================================================================  
%                          FlexTools(EFM) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  

% Called by ftefmenu.m

global ftFSyinitnameSTRgbl ftFSyouriterSTRgbl ftFSyobjname1STRgbl ftFSyobjname2STRgbl
global ftGAch_flagSCAgbl ftGAgapVECgbl ftGAobjfuncVECgbl initfunc Noofp ftGAnoofobjSCAgbl  
global ftGAnichtestSCAgbl ftGAnoofpeaksSCAgbl ftGAnselectSCAgbl ftGAtsizeSCAgbl ftGAnpopSCAgbl ftGAsspopSCAgbl ftGAngenSCAgbl ftGAregenSCAgbl     
global ftGApcrossSCAgbl ftGApmutateSCAgbl ftGAncrossSCAgbl ftGAp1SCAgbl ftGAp2SCAgbl ftGAmmVECgbl efminitobj efmobjname
global edt_funp edt_gap edt_gap1 edt_gap2 bestP
global ftentrymodeFLGgbl ftFSfuztypeSCAgbl ftFSfuzltypeSCAgbl ftGApminVECgbl ftGApmaxVECgbl ftGApresVECgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl FigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
%global FigurePos_Vsmall  mini maxi p_p gno

position=[40 10 540 430].*ftXYscaleVECgbl;
fig_efrun=ftfigure('fig_efrun','FlexTool(EFM) -- Objective Function',ftFigPos_medVECgbl,'on','figure');

%=================
% Big Text Block
%=================

ftFSpp2_=str2mat(...
     ' Initialization and Objective Function Names need to ',...
     ' be defined. Click on "EXAMPLE" to see sample Functions. ',...
     ' x under Initialization implies an empty function. Use ',...
     ' Browse button to choose a file or manually enter at ',...
     ' the space provided. ');
   
     ftFSpp3_= [0.95 0.10 0.90 0.65 0.002 0.002];
     ftFSpp1_='FlexTool(FS) Help on Options';
     ftscrhlp(fig_efrun,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

x0=0.1; y0=0.5; dy=0.10; dy1=0.08; dx=0.58; dx1=0.2; eps=0.02; dy2=0.09;
 
ftFSpp1_=['Initialization Function Name (.m file) : '];
ftFSpp3_=[x0 y0 dx dy1];
ftscrtxt(fig_efrun,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

edt_funp=uicontrol('Style','edit',...
'Units','normalized', ...
'string',initfunc,...
'Position',[x0+dx+eps y0 dx1 dy1],...
'callback',['ftFSyinitnameSTRgbl=get(edt_funp,''string'');  initfunc=ftfile(ftFSyinitnameSTRgbl); if(exist(ftFSyinitnameSTRgbl)~=2), ftFSyinitnameSTRgbl=''ftefobj5''; ftdispwn(''Attention! Exception!!'',''Using default file ftefobj5.m''); end;']);

pp41=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(EFM): Initialization Function. Use a .m File'',50,50);',...
	'if junkname~=0, initfunc=junkname; end;',...
      'set(edt_funp,''string'',initfunc); initfunc=ftfile(initfunc);'];

ftscrpb(fig_efrun,'..Browse',[x0+dx+eps y0-dy dx1 dy2-0.01],pp41);

ftFSpp1_=['Objective Function Name (.m file) : '];

if(ftFSfuztypeSCAgbl==3)|(ftFSfuztypeSCAgbl==4)
	myfunc='ftefmebb';
else
	myfunc='ftefmeba';
end;

ftFSpp3_=[x0 y0-2.1*dy dx dy1];
ftscrtxt(fig_efrun,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

edt_gap2=uicontrol('Style','edit',...
'string',ftGAobjfuncVECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-2.1*dy dx1 dy1],...
'callback',['ftGAobjfuncVECgbl=get(edt_gap2,''string''); ftGAobjfuncVECgbl=ftfile(ftGAobjfuncVECgbl); if(exist(ftGAobjfuncVECgbl)~=2), ftGAobjfuncVECgbl=myfunc; end;']);

pp42=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(EFM): Objective Function. Use a .m File'',50,50);',...
	'if junkname~=0, ftGAobjfuncVECgbl=junkname; end;',...
      'set(edt_gap2,''string'',ftGAobjfuncVECgbl);ftGAobjfuncVECgbl=ftfile(ftGAobjfuncVECgbl);'];
ftscrpb(fig_efrun,'..Browse',[x0+dx+eps y0-3.1*dy dx1 dy2],pp42);

ftscrpb(fig_efrun,'Run EFM',[0.7 0.02 0.2 0.09],'close; ftrunefm;');
ftscrpb(fig_efrun,'<< Back',[0.1 0.02 0.2 0.09],'close;');
ftscrpb(fig_efrun,'EXAMPLE',[0.4 0.02 0.2 0.09],'ftefhelp(8);');

%
% end fteffunc.m
%
