% FTefmget.m
%
% =========================================================================  
%                          FlexTools(EFM) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Options for auto settings
%
function ftefmget(ftFSjunk_)

global ftscr_cntSCAgbl ftflag_edtGUI ftFSNo_rulesCNTgbl 
global ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl ftFSiLVtypeVECgbl 
global ftFSoLVtypeVECgbl  ftFSbprmSCAgbl
global ftFSfmftypenMATgbl ftcolor_bc1VECgbl ftcolor_fc1VECgbl 
global ftEFMasetlrnMATgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl 
global ftFSmax_outSCAgbl ftFSNo_inCNTgbl ftFSNo_outCNTgbl
global rad_AL_1 rad_AL_2 ftEFMlrnoptSCAgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl FigPos_smallVECgbl 
global ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
global FigurePos_Vsmall
global FTdel_range FTdel_partitions FTdel_fmfparm


if ftEFMlrnoptSCAgbl ~=4
  ftFSfig_fsbaseGUI=ftfigure('ftFSfig_fsbaseGUI','FlexTool(EF)',ftFigPos_medVECgbl,'on','none');
end

if ((exist('FTdel_partitions')==0) | (isempty(FTdel_partitions)==1))
 	FTdel_partitions=64;
end; %if

if ((exist('FTdel_range')==0) | (isempty(FTdel_range)==1)) 
	FTdel_range=10;
end; %if

if ( (exist('FTdel_partitions')==1) & (nargin < 1) & (ftEFMlrnoptSCAgbl>4) ) 
    %=================
    % Big Text Block
    %=================
    x0=0.05; y0=0.35; dy=0.075; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

    ftFSpp1_='ATTENTION! FlexTool(EF) Help on Options';
    ftFSpp2_=str2mat(...
            '         You have already chosen the fine tune parameters.',...
            '                     ',...    
            '         Press Ok to override them or Cancel to retain the old values.');
     ftFSpp3_= [0.95 0.05 0.95 0.65 0.05 0.005];
     ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');
     clear ftFSpp1_ ftFSpp3_

     ftFSpp3_=[x0 y0-(1*dy) dx dy];
     ftscrtxt(ftFSfig_fsbaseGUI,'Fine Tune Range (+/-) %',ftFSpp3_);
     clear ftFSpp1_ ftFSpp3_

     ftFSpp3_=[x0+dx+eps y0-(1*dy) dx1 dy];
     ftscrtxt(ftFSfig_fsbaseGUI,num2str(FTdel_range), ftFSpp3_);

     ftFSpp3_=[x0 y0-(2.5*dy) dx dy];
     ftscrtxt(ftFSfig_fsbaseGUI,'# of Partitions (Resolution)',ftFSpp3_);
     clear ftFSpp1_ ftFSpp3_
  
     ftFSpp3_=[x0+dx+eps y0-(2.5*dy) dx1 dy];
     ftscrtxt(ftFSfig_fsbaseGUI,num2str(FTdel_partitions),ftFSpp3_);
     clear ftFSpp3_

     ftscrpb(ftFSfig_fsbaseGUI,'Ok',[0.15 0.05 0.25 0.09], 'close; ftefmget(0)');
     ftscrpb(ftFSfig_fsbaseGUI,'Cancel',[0.6 0.05 0.25 0.09], 'close');
     return;
end

%=================
% Big Text Block
%=================
if (ftEFMlrnoptSCAgbl <4) % Complete System/Rule Structure/FMF
  ftFSpp1_='FlexTool(EF) Help on Options';
  ftFSpp2_=str2mat(...
            'If Complete System/Rule Structure is chosen, all you need is to define',...
            'the Number of rules and the type of membership functions (if desired).',...
            'If FMF learning is chosen, the type of membership function (if desired)',...
	    'may be chosen. You still need to define the Number of Inputs, Outputs,',...
            'and # of FMFs using the Build EF GUIs.'); 

  ftFSpp3_= [0.95 0.05 0.95 0.65 0.05 0.005];
  ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
 
  x0=0.05; y0=0.35; dy=0.1; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

 if(ftEFMlrnoptSCAgbl ~=3) % not FMF learning option

  ftFSpp1_=['Enter Number of Rules: '];
  ftFSpp3_=[x0 y0 dx dy-.03];
  ftscrtxt(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
  ftFSbprmSCAgbl= num2str(ftFSNo_rulesCNTgbl);
  ftFSpp3_=[x0+dx+eps y0 dx2 dy-.03];

  ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  ftFSpp4_=['ftFSbprmSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); ftFSNo_rulesCNTgbl = str2num(ftFSbprmSCAgbl);'];
  ftscredt(ftFSfig_fsbaseGUI,ftFSbprmSCAgbl, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_

 end; % if
 %-----------------------------------------------------------------------------------------------------
  ftFSpp3_=[x0 y0-(.8*dy) dx dy-.03];
  ftscrtxt(ftFSfig_fsbaseGUI,'Default Input FMF',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp1_=str2mat(ftFSfmftypenMATgbl);
  ftFSpp3_=[x0+dx+eps y0-(.8*dy) dx1 dy-.03];
 % ftFSpp4_=['ftFSiLVtypeVECgbl(1)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
 %    'if ftFSiLVtypeVECgbl(1)==6, ftFSiLVtypeVECgbl(1)=1; end;',...
 %    'ftFSiLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')  = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'...
 %    'ftFSoLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'];
  ftFSpp4_=['ftFSiLVtypeVECgbl(1)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
     'if ftFSiLVtypeVECgbl(1)==6, ftFSiLVtypeVECgbl(1)=1; end;',...
     'ftFSiLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')  = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'];

 ftFSpp5_ = ftFSiLVtypeVECgbl(1);
  ftFSpp6_=[1:size(ftFSpp1_)]';
  ftscrpup(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
  clear ftFSpp1_ ftFSpp3_

  ftFSpp4_=['ftefmlrn(1,0,0); ftefmlrn(0,2,0); ftefmlrn(0,3,0); ftefmlrn(0,10,0); close'];

 %----------------------------------------------------------------------------------------------------
  ftFSpp3_=[x0 y0-(1.6*dy) dx dy-.03];
  ftscrtxt(ftFSfig_fsbaseGUI,'Default Output FMF',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp1_=str2mat(ftFSfmftypenMATgbl);
  ftFSpp3_=[x0+dx+eps y0-(1.6*dy) dx1 dy-.03];
  ftFSpp4_=['ftFSoLVtypeVECgbl(1)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
      'if ftFSoLVtypeVECgbl(1)==6, ftFSoLVtypeVECgbl(1)=1; end;',...
      'ftFSoLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ')+ ftFSoLVtypeVECgbl(1);'];
  ftFSpp5_ = ftFSoLVtypeVECgbl(1);
  ftFSpp6_=[1:size(ftFSpp1_)]';
  ftscrpup(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
  clear ftFSpp1_ ftFSpp3_

  ftFSpp4_=['ftefmlrn(1,0,0); ftefmlrn(0,2,0); ftefmlrn(0,3,0); ftefmlrn(0,10,0); close'];

elseif ftEFMlrnoptSCAgbl == 5

  ftFSpp1_='FlexTool(EF) Help on Options';
  ftFSpp2_=str2mat(...
            'If Complete System w/ Fine Tune is chosen, you need to ', ...
		'define the # of rules, the type of membership functions,',...
		'the Fine Tune Range as a ',...
	    '% of total range (Ex: 10 for 10% of Total Range), and Search Resolution',...
            'in terms of # of partitions of the Fine Tune Range. Later, you need to ',...
            'define the # of Inputs, outputs, and FMFs using the Build EFM GUIs.'); 

  ftFSpp3_= [0.95 0.05 0.95 0.62 0.05 0.005];
  ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  x0=0.05; y0=0.52; dy=0.075; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

  ftFSpp1_=['Enter Number of Rules: '];
  ftFSpp3_=[x0 y0 dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
  ftFSbprmSCAgbl= num2str(ftFSNo_rulesCNTgbl);
  ftFSpp3_=[x0+dx+eps y0 dx2 dy];

  ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  ftFSpp4_=['ftFSbprmSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); ftFSNo_rulesCNTgbl = str2num(ftFSbprmSCAgbl);'];
  ftscredt(ftFSfig_fsbaseGUI,ftFSbprmSCAgbl, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_

  ftFSpp3_=[x0 y0-(1.5*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Default FMF',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp1_=str2mat(ftFSfmftypenMATgbl,' ');
  ftFSpp3_=[x0+dx+eps y0-(1.5*dy) dx1 dy];
  ftFSpp4_=['ftFSiLVtypeVECgbl(1)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
      'if ftFSiLVtypeVECgbl(1)==6, ftFSiLVtypeVECgbl(1)=1; end;',...
      'ftFSiLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')  = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'...
      'ftFSoLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'];
  ftFSpp5_ = ftFSiLVtypeVECgbl(1);
  ftFSpp6_=[1:size(ftFSpp1_)]';
  ftscrpup(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
  clear ftFSpp1_ ftFSpp3_

  ftFSpp3_=[x0 y0-(3*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Enter Fine Tune Range (+/-) %',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
 
  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp3_=[x0+dx+eps y0-(3*dy) dx1 dy];
  ftFSpp4_=['FTdel_range=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
  ftscredt(ftFSfig_fsbaseGUI,FTdel_range, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_

  ftFSpp3_=[x0 y0-(4.5*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Enter # of Partitions (Resolution)',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
  
  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp3_=[x0+dx+eps y0-(4.5*dy) dx1 dy];
  ftFSpp4_=['FTdel_partitions=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
  ftscredt(ftFSfig_fsbaseGUI,FTdel_partitions,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_ ftFSpp1_ ftFSpp3_
  
  ftFSpp4_=['ftefmlrn(1,0,0); ftefmlrn(0,2,0); ftefmlrn(0,3,0); ftefmlrn(0,10,0); FTdel_fmfparm=[]; close'];

elseif ftEFMlrnoptSCAgbl > 5

  ftFSpp1_='FlexTool(EF) Help on Options';
  ftFSpp2_=str2mat(...
            'If FMF Parameters w/ Fine Tune or Partial System w/ Fine Tune is',...
            'chosen, you need to define the Fine Tune Range as a % of total range',...
            '(Ex: 10 for 10% of Total Range), and Search Resolution in terms of # of ',...
            'partitions of the Fine Tune Range. You may also choose the default FMF',...
            'type.');

  ftFSpp3_= [0.95 0.05 0.95 0.65 0.05 0.005];
  ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  x0=0.05; y0=0.55; dy=0.075; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

  ftFSpp3_=[x0 y0-(1.5*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Default FMF',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp1_=str2mat(ftFSfmftypenMATgbl,' ');
  ftFSpp3_=[x0+dx+eps y0-(1.5*dy) dx1 dy];
  ftFSpp4_=['ftFSiLVtypeVECgbl(1)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
      'if ftFSiLVtypeVECgbl(1)==6, ftFSiLVtypeVECgbl(1)=1; end;',...
      'ftFSiLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'...
      'ftFSoLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ')+ ftFSiLVtypeVECgbl(1);'];
  ftFSpp5_ = ftFSiLVtypeVECgbl(1);
  ftFSpp6_=[1:size(ftFSpp1_)]';
  ftscrpup(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
  clear ftFSpp1_ ftFSpp3_

  ftFSpp3_=[x0 y0-(3*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Enter Fine Tune Range (+/-)',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
  
  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp3_=[x0+dx+eps y0-(3*dy) dx1 dy];
  ftFSpp4_=['FTdel_range=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
  ftscredt(ftFSfig_fsbaseGUI,FTdel_range, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_ ftFSpp1_ ftFSpp3_
 
  ftFSpp3_=[x0 y0-(4.5*dy) dx dy];
  ftscrtxt(ftFSfig_fsbaseGUI,'Enter # of Partitions (Resolution)',ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_
  
  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp3_=[x0+dx+eps y0-(4.5*dy) dx1 dy];
  ftFSpp4_=['FTdel_partitions=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
  ftscredt(ftFSfig_fsbaseGUI,FTdel_partitions, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp4_ ftFSpp1_ ftFSpp3_
  ftFSpp4_=['FTdel_fmfparm=[]; close']; 

end

%=====================
% Go back one screen
%=====================
if ftEFMlrnoptSCAgbl ~=4
  ftscrpb(ftFSfig_fsbaseGUI,'Done',[0.4 0.05 0.2 0.09],ftFSpp4_);
end

%
% end ftefmget.m
%
 
