%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% ftefmin                          ftefmin.m                 ftefmin
% =========================================================================  
%                          FlexTools(EFM) for Matlab
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)                            
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
% =========================================================================   
%  PURPOSE   
%         Do certain initialization operations for EFM
%  .........................................................................   
%  GIVEN  
%		  User's choices as to what all should be learned by GA
%  .........................................................................   
%  OPERATION   
%
%  		  Identify indices
%  .........................................................................   
%  RETURNS   
%         Nothing. Global indices gets set up.
%  .........................................................................   
%  APPLICATION   
%         Fuzzy Systems
%  .........................................................................   
%  USE WITH   
%   
%       MUST   
%               FTmfm.m, FlexTools(FS), FlexTools(EFM) Matlab   
%       MAY   
%               FlexTools(GA)   
%  USES
%  ========================================================================   
%   SYNTAX  /  USAGE  
%   ftefmin
%  ========================================================================  

%  DECLARATION   
%   ftefmin   
   
%  ========================================================================  
%   DESCRIPTION -  FLEXTOOL APPROACH  
%
%   
%  ========================================================================   
%  VARIABLE DICTIONARY   
%
%  ========================================================================   
%  ALGORITHM   
%   
%     10 identify indices for loading ftFSinlMATgbl, ftFSoutlMATgbl, and ftEFMparmMATgbl
%        matrices
%     20 do some other initialization work also.
%  ========================================================================   
%  CODE
%
% GLOBAL

function outs=ftefmin

global ftEFMlrnoptSCAgbl ftentrymodeFLGgbl ftEFMfsinoSCAgbl ftEFMefpfGUI
global ftparmnamegbl ftparmoptFLGgbl ftEFMasetlrnMATgbl ftFSlvfmfparmMATgbl
global ftEFMlrnfmfoSCAgbl ftEFMlrnrsoSCAgbl ftFSbldoptgbl ftFSbldoptgbl

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_diffSCAgbl
global ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl ftFSNo_fmfsCNTgbl ftFSNo_defuzCNTgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSidiffVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl ftioLVtypeVECgbl ftioLVlearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl ftFSparmMATgbl
global ftFSaincMATgbl ftFSainlMATgbl ftFSainrMATgbl ftFSaoutcMATgbl ftFSaoutlMATgbl ftFSaoutrMATgbl ftEFMailrnMATgbl ftEFMaolrnMATgbl
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl ftFSaNo_lingCNTgbl ftFSaNo_critCNTgbl ftFSatot_lingVECgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI ftFSdisp1FLGgbl 
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl ftFSpfGUI
global ftFSfmfilenMATgbl ftFSfmfcntVECgbl ftFSimpnameMATgbl ftFSaggrfilenMATgbl ftFSdefuznameMATgbl
global ftFSaggrparmnMATgbl ftFSdefpfilnMATgbl
global ftFSfmftypenMATgbl ftFSimptypenMATgbl ftFSaggrtypenMATgbl ftFSdeftypenMATgbl
global fuztitle ftFSfuncfilenMATgbl
global ftFSdfmfparmMATgbl ftFSdaggrparmMATgbl ftFSddefparmMATgbl
global ftFSfmfparmMATgbl ftFSaggrparmMATgbl ftFSdefparmMATgbl 
global ftFSaggrpcntVECgbl ftFSdefpcntVECgbl
global ftFSfuztypeSCAgbl ftFSfuzltypeSCAgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSimptypeSCAgbl 
global ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSinfnameSTRgbl
global ftscr_cntSCAgbl
global ftFSyouriterSTRgbl ftFSyinitnameSTRgbl ftFSyobjname1STRgbl ftFSyobjname2STRgbl
global tot_fmfp max_fmfp No_fmfp tot_ling
global in_r_idx in_in_idx out_r_idx out_out_idx
global l_rmap l_cmap
global veciidx vecoidx ftFSidiffVECgbl ftFSodiffVECgbl 
global ftEFMparmIDXgbl
global ftEFMcilrnIDXgbl ftEFMrilrnIDXgbl ftEFMcolrnIDXgbl ftEFMrolrnIDXgbl ftEFMilrnrsCNTgbl ftEFMolrnrsCNTgbl ftEFMtotlrnrsCNTgbl
global inlrnfmfcnt ftEFMlrnfmfCNTgbl ftEFMtotlrnCNTgbl inlrnlvcnt ftEFMlrnlvCNTgbl ftFSsum_lingVECgbl ling_idx
global ftEFMcinrsCNTgbl ftEFMcoutrsCNTgbl ftEFMrinrsCNTgbl ftEFMroutrsCNTgbl ftEFMlchromrgbl
global vecimap vecomap
global FTdel_range FTdel_partitions FTdel_fmfparm

global ftGApslopeVECgbl ftGApcVECgbl ftGAch_flagSCAgbl
global fts_tableMATgbl ftm_tableMATgbl ftGAp_typeVECgbl
global ftGApmaxVECgbl     ftGApminVECgbl      ftGApresVECgbl   
global ftGAnopSCAgbl      ftGAnoofpeaksSCAgbl ftGAnichtestSCAgbl
global ftGA_choiceSCAgbl  ftGAgapVECgbl       ftGAnselectSCAgbl 
global ftGAtsizeSCAgbl    ftGAnpopSCAgbl      ftGAsspopSCAgbl 
global ftGAngenSCAgbl     ftGAregenSCAgbl     ftnopVECgbl
global ftGApcrossSCAgbl   ftGApmutateSCAgbl   ftGAncrossSCAgbl 
global ftGAp1SCAgbl       ftGAp2SCAgbl     
global FTdel_range        FTdel_partitions    FTdel_fmfparm
global ftGAlchromSCAgbl   ftENMlchromrgbl     ftGAnbitsVECgbl
global ftGApcVECgbl       ftGApresuVECgbl     ftGAmchildSCAgbl

global ftMaxModelCNTgbl  ftModelCNTgbl    ftModelIDXgbl
global ftModelNameMATgbl ftModelDBVECgbl  ftModelPartCntVECgbl
global ftMaxPartCNTgbl   ftPartTypeVECgbl ftPartCNTgbl
global ftPartIDXgbl      ftPartNameMATgbl ftPartDBVECgbl 
global ftModelTypeVECgbl ftSequenceVECgbl ftEApartCNTgbl
global ftPartInfoMATgbl  ftParmCNTgbl     ftParmIDXgbl

global ftParmUserCNTgbl  ftParmUserMATgbl ftParmUserNameMATgbl
global ftPartUserCNTgbl  ftUserInfoMATgbl ftParmUserMATgbl   
global ftParmUserFLGgbl   ftParmUserVECgbl
global ftInputScaleVECgbl ftOutputScaleVECgbl
global ftIScaleValMATgbl  ftOScaleValMATgbl 
global ftIScaleFLGgbl     ftOScaleFLGgbl

%====================================================================
%
% Mapping provided from user interface to the fuzzy inference engine
% FlexTool: USEr data structure to CALculation data structure
% ftusecal!
% Necessary since user interface use static data structures
% whereas the inference engine requires dynamic data structures.
%
% This function has to be run every time a fuzzy system is created
% or modified (ie the rulebase, and other relevant selections!)
%

%
% Define parameter ranges
%

ftefbase;
if isempty(ftGA_choiceSCAgbl)==1
   ftGA_choiceSCAgbl=1;
end

% Accomodate CI
% add the following!
 if(ftModelCNTgbl<=1)
    % ftcigen;
    ftParmCNTgbl=0;
    ftParmIDXgbl=0;

    ftGApminVECgbl=0;
    ftGApmaxVECgbl=0;
    ftGApresVECgbl=0;

end; %if

ftGAp_typeVECgbl=0;

% 
% total Number of criteria = Number of inputs + Number of outputs
%
ftFSaNo_critCNTgbl = ftFSNo_inCNTgbl + ftFSNo_outCNTgbl;

%
% Convert the static input and output linguistic variable Numbers
% (how many for each variable) into a dynamic sequential structure,
% ftFSaNo_lingCNTgbl(1:ftFSaNo_critCNTgbl)
%
ftFSaNo_lingCNTgbl = [ ftFSilingVECgbl(1:ftFSNo_inCNTgbl) ftFSolingVECgbl(1:ftFSNo_outCNTgbl) ];

% 
% Total Number of Linguistic Variables = Number of Input + Output Variables
%
ftFSatot_lingVECgbl = ftFSNo_ilingCNTgbl + ftFSNo_olingCNTgbl;

% 
% find the difference (distance) between the min and max of the
% universe of discourse
%
ftFSidiffVECgbl = ftFSimaxVECgbl-ftFSiminVECgbl;
ftFSodiffVECgbl = ftFSomaxVECgbl-ftFSominVECgbl;

% 
% find the difference (distance) between the min and max of the
% base set
%
ftFSbase_diffSCAgbl = ftFSbase_maxSCAgbl - ftFSbase_minSCAgbl;

%
% generate ftioLVtypeVECgbl ftioLVlearnVECgbl
%	   veciidx, vecoidx (for mapping ftFSfmfSTRgbl parameter values)
%
ftioLVtypeVECgbl=[];
ftioLVlearnVECgbl=[];
ftFSparmMATgbl=[];
strtidx2=1;
veciidx=[];
vecimap=[];

for(i=1:ftFSNo_inCNTgbl)
	endidx2      = strtidx2+ftFSilingVECgbl(i)-1;
	ftioLVtypeVECgbl  = [ftioLVtypeVECgbl ftFSiLVtypeVECgbl(strtidx2:endidx2)];
	ftioLVlearnVECgbl = [ftioLVlearnVECgbl ftFSiLVlearnVECgbl(strtidx2:endidx2)];
	veciidx      = [veciidx strtidx2:endidx2];
	vecimap	     = [vecimap zeros(1,endidx2-strtidx2+1)+i];
	for(ii=1:4)
	   cc=1;
	   for(jj=strtidx2:endidx2)
		if((ftFSiLVtypeVECgbl(jj)==3)&(ii==2)) % if FMF type is gaussian
			passtype_ = 5;
		elseif((ftFSiLVtypeVECgbl(jj)==4)&(ii==2))  % if FMF type is generalized bell
			passtype_ = 7;
		elseif((ftFSiLVtypeVECgbl(jj)==5)&(ii==3))  % if FMF type is exponential
			passtype_ = 8;
		else    
			passtype_ = 3;
		end; %if
		temp_(cc,ii)=ftmaptob(ftFSiparmMATgbl(jj,ii),passtype_,i);
		cc=cc+1;
	   end; % for
	end; % for ii loop
	ftFSparmMATgbl    = [ftFSparmMATgbl; temp_];
        clear temp_

	strtidx2     = strtidx2 + ftFSmax_LVSCAgbl;
end; % for i loop

iling_idx   = find(ftioLVlearnVECgbl == 2);
inlrnlvcnt   = length(iling_idx);
inlrnfmfcnt = sum(ftFSfmfcntVECgbl(ftioLVtypeVECgbl(iling_idx)));

strtidx2=1;
vecoidx=[];
vecomap=[];

if ftFSfuztypeSCAgbl ~=2 %NOT TSK 
  for(i=1:ftFSNo_outCNTgbl)
	endidx2	 = strtidx2+ftFSolingVECgbl(i)-1;
	ftioLVtypeVECgbl  = [ftioLVtypeVECgbl ftFSoLVtypeVECgbl(strtidx2:endidx2)];
	ftioLVlearnVECgbl = [ftioLVlearnVECgbl ftFSoLVlearnVECgbl(strtidx2:endidx2)];
	vecoidx      = [vecoidx strtidx2:endidx2];
	vecomap	 = [vecomap zeros(1,endidx2-strtidx2+1)+i];
	for(ii=1:4)
	   cc=1;
	   for(jj=strtidx2:endidx2)
		if((ftFSoLVtypeVECgbl(jj)==3)&(ii==2)) % if FMF type is gaussian
			passtype_ = 6;
		elseif((ftFSoLVtypeVECgbl(jj)==4)&(ii==2))  % if FMF type is generalized bell
			passtype_ = 7;
		elseif((ftFSoLVtypeVECgbl(jj)==5)&(ii==3))  % if FMF type is exponential
			passtype_ = 8;
		else    
			passtype_ = 4;
		end; %if
		temp_(cc,ii)=ftmaptob(ftFSoparmMATgbl(jj,ii),passtype_,i);
		cc=cc+1;
	   end; %for jj loop
	end; % for ii loop
	ftFSparmMATgbl    = [ftFSparmMATgbl; temp_];
	clear temp_
	strtidx2     = strtidx2+ftFSmax_LVSCAgbl;
  end; % for i loop
end % NOT TSK
  
%-------------------------------------------------------------
% ftFSilingVECgbl and ftFSolingVECgbl have information about the number of 
% linguistc variables the user has choosen for each criteria.
% We will now create another vector ftFSsum_lingVECgbl that contains
% the cumulative sum of the number of linguistic variables.
%-------------------------------------------------------------
ftFSsum_lingVECgbl(1) = 0;
newsumling_(1)=ftFSilingVECgbl(1);
for(i=2:ftFSNo_inCNTgbl)
	ftFSsum_lingVECgbl(i)	= ftFSsum_lingVECgbl(i-1) + ftFSilingVECgbl(i-1);
	newsumling_(i)  = newsumling_(i-1) + ftFSilingVECgbl(i);
end % for i loop

if ftFSfuztypeSCAgbl ~= 2 %NOT TSK
  for(i=1:ftFSNo_outCNTgbl)
	ftFSsum_lingVECgbl(ftFSNo_inCNTgbl+i)     = ftFSsum_lingVECgbl(ftFSNo_inCNTgbl+i-1)    + ftFSolingVECgbl(i);
	newsumling_(ftFSNo_inCNTgbl+i)  = newsumling_(ftFSNo_inCNTgbl+i-1) + ftFSolingVECgbl(i);
  end % for i loop
end %NOT TSK

newsumling_ = [0 newsumling_];
%-----------------------------------------------
% Create a mapping such that
% the number of fmfp is stored with reference to
% a serial count of the linguistic variable
%-----------------------------------------------
 k=1;	
 for(i=1:ftFSaNo_critCNTgbl)
 	for(j=1:ftFSaNo_lingCNTgbl(i))
 		l_rmap(k) = i;
 		l_cmap(k) = j;
 		k = k + 1;
 	end % for j loop
 end % for i loop
 		
% 
% PACKING MATRICES
%
% ftFSincMATgbl, ftFSinrMATgbl, ftFSinlMATgbl, 
% ftFSoutcMATgbl, ftFSoutrMATgbl, ftFSoutlMATgbl
%
% Currently are static! ie, they are build with max. values
% and the entries are maintained w.r.t. the max. 
%
% Need to change them to dynamic form!
% for example, for a particular ftFSrule_ you may be using only criteria
% 2, and 4 ftFSout_ of the possible 6. In ftFSincMATgbl, the entries would be
% 2 for column 2 and 4 for column 4, where as the rest would be 0.
%
% for the inference engine all that is needed is a matrix that 
% specifies criteria as 2 in column 1 and 4 in column 2, the rest being
% zeros!
% subracting by 1 since, when we created ftFSincMATgbl, we set it as
% default=1 which is for no selection (according to the menu for
% selecting the variable and linguistic term). 

%---------------------
% LEARN RULE STRUCTURE
%---------------------
[ftEFMcinrsCNTgbl,ftEFMrinrsCNTgbl]=find(ftFSincMATgbl' > 1);
if(ftEFMrinrsCNTgbl)
      outs=1;
	ftFSaincMATgbl  = ftmatpak(ftFSincMATgbl-1,ftEFMrinrsCNTgbl,ftEFMcinrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_inCNTgbl,0);
	[rr,cc]   = size(ftFSaincMATgbl);
	ftFSaincMATgbl  = [ftFSaincMATgbl zeros(rr,1)];
	ftFSainrMATgbl  = ftmatpak(ftFSinrMATgbl, ftEFMrinrsCNTgbl,ftEFMcinrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_inCNTgbl,0);
	ftFSainlMATgbl  = ftmatpak(ftFSinlMATgbl, ftEFMrinrsCNTgbl,ftEFMcinrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_inCNTgbl,0);
	ftEFMailrnMATgbl = ftmatpak(ftFSilrnMATgbl,ftEFMrinrsCNTgbl,ftEFMcinrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_inCNTgbl,0);
%
% Set up ftGApminVECgbl, ftGApmaxVECgbl, and ftGApresVECgbl vectors of input Rule Structure learning
% parameters for GA
%
	[ftEFMcilrnIDXgbl,ftEFMrilrnIDXgbl]=find(ftEFMailrnMATgbl' == 2);
	ftEFMilrnrsCNTgbl = length(ftEFMcilrnIDXgbl);

	for(i=1:ftEFMilrnrsCNTgbl)
		ftGApmaxVECgbl(i)=ftFSilingVECgbl(ftFSaincMATgbl(ftEFMrilrnIDXgbl(i),ftEFMcilrnIDXgbl(i)));
        end;
	ftGApminVECgbl(1:ftEFMilrnrsCNTgbl)= ones(1,ftEFMilrnrsCNTgbl);
	ftGApresVECgbl(1:ftEFMilrnrsCNTgbl)= ones(1,ftEFMilrnrsCNTgbl);
	ftGAp_typeVECgbl(1:ftEFMilrnrsCNTgbl)= ones(1,ftEFMilrnrsCNTgbl);
% CI 
	ftciupd(ftEFMilrnrsCNTgbl, 11, 1, 1, 0);
%
% Enter the number of parameters vector for GA
%	
	ftEFMtotlrnrsCNTgbl = ftEFMilrnrsCNTgbl;
else
	ftFSpp4_=                   ['Either the Fuzzy System has not yet been defined'];
	ftFSpp4_=str2mat(ftFSpp4_, '    or the Fuzzy System has been re-defined.');
	ftFSpp4_=str2mat(ftFSpp4_, '       Please select Learning Scheme and ');
	ftFSpp4_=str2mat(ftFSpp4_, '        associated parameters once again.');
	ftdispwn('Attention! Exception!!' , ftFSpp4_);
	outs=0;
	return;
end; % if (ftEFMrinrsCNTgbl)

if ftFSfuztypeSCAgbl ~= 2 %NOT TSK
  [ftEFMcoutrsCNTgbl,ftEFMroutrsCNTgbl]=find(ftFSoutcMATgbl' > 1);
  if(ftEFMroutrsCNTgbl)
        outs=1;
	ftFSaoutcMATgbl = ftmatpak(ftFSoutcMATgbl-1,ftEFMroutrsCNTgbl,ftEFMcoutrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_outCNTgbl,0);
	[rr,cc]   = size(ftFSaoutcMATgbl);
	ftFSaoutcMATgbl = [ftFSaoutcMATgbl zeros(rr,1)];
	ftFSaoutrMATgbl = ftmatpak(ftFSoutrMATgbl,ftEFMroutrsCNTgbl,ftEFMcoutrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_outCNTgbl,0);
	ftFSaoutlMATgbl = ftmatpak(ftFSoutlMATgbl,ftEFMroutrsCNTgbl,ftEFMcoutrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_outCNTgbl,0);
	ftEFMaolrnMATgbl = ftmatpak(ftFSolrnMATgbl,ftEFMroutrsCNTgbl,ftEFMcoutrsCNTgbl,ftFSNo_rulesCNTgbl,ftFSNo_outCNTgbl,0);
%
% Set up ftGApminVECgbl, ftGApmaxVECgbl, and ftGApresVECgbl vectors of output Rule Structure learning
% parameters for GA
%
	[ftEFMcolrnIDXgbl,ftEFMrolrnIDXgbl] = find(ftEFMaolrnMATgbl' == 2);
	ftEFMolrnrsCNTgbl   = length(ftEFMcolrnIDXgbl);
	ftEFMtotlrnrsCNTgbl = ftEFMilrnrsCNTgbl+ftEFMolrnrsCNTgbl;
	j = 1;
	for(i=ftEFMilrnrsCNTgbl+1:ftEFMtotlrnrsCNTgbl)
		ftGApmaxVECgbl(i) = ftFSolingVECgbl(ftFSaoutcMATgbl(ftEFMrolrnIDXgbl(j),ftEFMcolrnIDXgbl(j)));
		j       = j + 1;
     	end;
	ftGApminVECgbl(ftEFMilrnrsCNTgbl+1:ftEFMtotlrnrsCNTgbl) = ones(1,ftEFMolrnrsCNTgbl);
	ftGApresVECgbl(ftEFMilrnrsCNTgbl+1:ftEFMtotlrnrsCNTgbl) = ones(1,ftEFMolrnrsCNTgbl);
	ftGAp_typeVECgbl(ftEFMilrnrsCNTgbl+1:ftEFMtotlrnrsCNTgbl)= ones(1,ftEFMolrnrsCNTgbl);
%% CI 
	ftciupd(ftEFMolrnrsCNTgbl, 12, 1, 1, 0);
%%
  else
	ftFSpp4_=['Either the Fuzzy System has not yet been defined'];
	ftFSpp4_=str2mat(ftFSpp4_, 'or the Fuzzy System has been re-defined.');
	ftFSpp4_=str2mat(ftFSpp4_, 'Please select Learning Scheme and ');
	ftFSpp4_=str2mat(ftFSpp4_, 'associated parameters once again.');
	ftdispwn('Attention! Exception!!' , ftFSpp4_);
	outs=0;
	return;
  end; % if (ftEFMroutrsCNTgbl)
end % if NOT TSK

%--------------------------------------------------------------------
% Find the antecedents in the ftFSrule_ structure that needs to be learned
% using GA (==2). The index of these antecedents in the ftFSilrnMATgbl and
% ftFSolrnMATgbl matrices are specified by the information pair stored in
% the vectors in_r_idx,in_in_idx. Do similarly for consequents.
% We use this index to specify ftGApminVECgbl, ftGApmaxVECgbl, and ftGApresVECgbl for the GA to 
% learn the ftFSrule_ structure.
% Note: ftFSainlMATgbl and ftFSaoutlMATgbl contains the ID of the linguistic
%       variable that dictates the structure of the Fuzzy rule. 
% 	This is the one we need to learn.
%--------------------------------------------------------------------

if(ftFSfuztypeSCAgbl==2) % for TSK Fuzzy Controller
        if ftGA_choiceSCAgbl==4, ftGA_choiceSCAgbl=1; end % do not allow Flex GA.
	iindx=find(ftFSrulelearnVECgbl(1:ftFSNo_rulesCNTgbl)== 2);
        lrntskcnt=0;
        onemat_=ones(ftFSNo_inCNTgbl+1,1);
        for ijk_1=1:max(size(iindx))
            for ijk_2=1:ftFSNo_outCNTgbl
	     ijk_3=i+lrntskcnt+1; 
	     ijk_4=ijk_3+ftFSNo_inCNTgbl; 
             ftGApminVECgbl(ijk_3:ijk_4)= ftFSominVECgbl(ijk_2)*onemat_;
	     ftGApmaxVECgbl(ijk_3:ijk_4)= ftFSomaxVECgbl(ijk_2)*onemat_;
   	     ftGApresVECgbl(ijk_3:ijk_4)= ftFSbase_resSCAgbl*(ftGApmaxVECgbl(ijk_3:ijk_4)-ftGApminVECgbl(ijk_3:ijk_4));
	     lrntskcnt = lrntskcnt+(ftFSNo_inCNTgbl+1);
            end
        end
        ftEFMtotlrnrsCNTgbl=ftEFMtotlrnrsCNTgbl+lrntskcnt;

%% CI Note: could change 15 to some other value 
	ftciupd(lrntskcnt, 15, 1, 1, 0);
%%
end

%---------------------
% LEARN FMF parameters
%---------------------
%-------------------------------------------------------------------------
% Find the linguistic variables whose fuzzy membership function parameters
% need to be learned using GA (==2). The index is available via the ling_idx. 
% Also compute the number of fuzzy linguistic variables that have to be
% learned (ftEFMlrnlvCNTgbl).
%-------------------------------------------------------------------------

	ling_idx = find(ftioLVlearnVECgbl == 2);
	ftEFMlrnlvCNTgbl = length(ling_idx);

%-----------------------------------------------------------------
% Compute the total number of fuzzy membership function parameters
% that have to be learned and the total number (ftFSfmfSTRgbl + rs) that has
% to be learned. Then load the ftGApmaxVECgbl, ftGApminVECgbl, and ftGApresVECgbl vectors.
%-----------------------------------------------------------------	
ftEFMlrnfmfCNTgbl  = sum(ftFSfmfcntVECgbl(ftioLVtypeVECgbl(ling_idx)));

%% CI 
	ftciupd(sum(ftFSfmfcntVECgbl(ftFSiLVtypeVECgbl(veciidx))),13, 3, 1, 0);
	ftciupd(sum(ftFSfmfcntVECgbl(ftFSoLVtypeVECgbl(vecoidx))),14, 3, 1, 0);
%%

%	
% Enter the number of parameters vector for GA
%	
ftnopVECgbl(1) = ftEFMtotlrnrsCNTgbl;
ftnopVECgbl(2) = ftEFMlrnfmfCNTgbl;

%
% Total number of parameters that has to be learned
%
ftEFMtotlrnCNTgbl = ftEFMtotlrnrsCNTgbl + ftEFMlrnfmfCNTgbl;

ftEFMparmIDXgbl   = 2;
i=ftEFMtotlrnrsCNTgbl+1;
ii=1;

%
% FINE TUNING
%
if(ftEFMlrnoptSCAgbl > 4)
	  if ftGA_choiceSCAgbl==4, ftGA_choiceSCAgbl=1; end % do not allow Flex GA.
	   if ((exist('FTdel_fmfparm')==0) | (isempty(FTdel_fmfparm)==1))
		FTdel_fmfparm=ones(1,ftEFMlrnfmfCNTgbl);
		kk=1;
		for(jj=1:ftEFMlrnlvCNTgbl)
			fmftype_ = ftioLVtypeVECgbl(ling_idx(jj));
			temp1= ftFSfmfcntVECgbl(fmftype_);
			FTdel_fmfparm(kk)=ftFSparmMATgbl(jj,1);
			for(cnt_=2:temp1)
			   if(fmftype_ <=2) % triangular or trapizoidal
			      FTdel_fmfparm(kk+cnt_-1)=(ftFSparmMATgbl(jj,cnt_)-ftFSparmMATgbl(jj,cnt_-1));	
			   else
			      FTdel_fmfparm(kk+cnt_-1)=ftFSparmMATgbl(jj,cnt_);	
			   end; %if
			end; %for
			kk=kk+temp1;
		end; %for
	   end %if

	   if  FTdel_partitions <= 0, Ftdel_partitions = 64; end
	   temp1 = ones(ftEFMtotlrnCNTgbl-i+1,1)*(FTdel_range*0.01);
	   ftGApminVECgbl(i:ftEFMtotlrnCNTgbl)= -temp1;
	   ftGApmaxVECgbl(i:ftEFMtotlrnCNTgbl)=  temp1;
	   ftGApresVECgbl(i:ftEFMtotlrnCNTgbl)= (2*temp1)/FTdel_partitions;

else % NOT FINE TUNING
	if (ftGA_choiceSCAgbl~=4) % NOT Flex-GA
	  while(i<=ftEFMtotlrnCNTgbl)
		k=1;
		jj=ftFSfmfcntVECgbl(ftioLVtypeVECgbl(ling_idx(ii)));
		for(j=1:jj)
 		     	ftGApminVECgbl(i) = ftFSlvfmfparmMATgbl(ftioLVtypeVECgbl(ling_idx(ii)),k);
			k=k+1;
			ftGApmaxVECgbl(i) = ftFSlvfmfparmMATgbl(ftioLVtypeVECgbl(ling_idx(ii)),k);
			k=k+1;
			ftGApresVECgbl(i) = ftFSlvfmfparmMATgbl(ftioLVtypeVECgbl(ling_idx(ii)),k);
			k=k+1;
			i = i+1;
		end; % for j loop
		ii = ii + 1;
	  end; % while loop	

	else % Flex-GA

	  max_Nbits=12;	%maximum # of bits per variable 
     	  max_rows=512;

	  while(i<=ftEFMtotlrnCNTgbl)
		for(lv_=2:ftFSaNo_critCNTgbl+1)
			if( (ling_idx(ii)>newsumling_(lv_ - 1))&(ling_idx(ii)<=newsumling_(lv_)) )
				lv_bit_ = ceil(max_Nbits/ftFSaNo_lingCNTgbl(lv_ -1));
				if lv_bit_==2, lv_bit_=3; end
				break;
			end; %if
		end; %for
		jj			= ftFSfmfcntVECgbl(ftioLVtypeVECgbl(ling_idx(ii)));
		delta_ 			= ftFSbase_diffSCAgbl/ftFSaNo_lingCNTgbl(lv_ -1);
		ftGApminVECgbl(i) 		= ftFSbase_minSCAgbl + (ling_idx(ii)-1-newsumling_(lv_ -1))*delta_;
		ftGApmaxVECgbl(i) 		= ftGApminVECgbl(i) + delta_;
	     	ftGApminVECgbl(i+1:(i+jj-1)) 		= zeros(1,jj-1)+0.01;
		ftGApmaxVECgbl(i+1:(i+jj-1)) 		= ones(1,jj-1)*delta_ /2;
		ftGApresVECgbl(i+1:(i+jj-1)) 		= zeros(1,jj-1);
		ftGAp_typeVECgbl(i:(i+jj-1)) 	= ones(1,jj)*lv_bit_;

		i = i+jj;

		ii = ii + 1;
	  end; % while loop	
	end; %if
end; % if Fine Tune

%
% reset i (point i to the end of the string)
%
i=ftEFMtotlrnCNTgbl;

%
% Input Scaling
%
if(ftIScaleFLGgbl)
	ftGApminVECgbl(i+1:No_Inputs+i) = ftIScaleValMATgbl(1,1:No_Inputs);
	ftGApmaxVECgbl(i+1:No_Inputs+i) = ftIScaleValMATgbl(2,1:No_Inputs);
	ftGApresVECgbl(i+1:No_Inputs+i) = ftIScaleValMATgbl(3,1:No_Inputs);
	ftEFMtotlrnCNTgbl           = ftEFMtotlrnCNTgbl + No_Inputs;
	i		    = i+No_Inputs;
	ftEFMtotlrnCNTgbl	    = ftEFMtotlrnCNTgbl+No_Inputs;
	ftciupd(No_Inputs, 9, 3, 1, 0);
end;

%
% Ouput Scaling
%
if(ftOScaleFLGgbl)
	ftGApminVECgbl(i+1:No_Outputs+i) = ftOScaleValMATgbl(1,1:No_Outputs);
	ftGApmaxVECgbl(i+1:No_Outputs+i) = ftOScaleValMATgbl(2,1:No_Outputs);
	ftGApresVECgbl(i+1:No_Outputs+i) = ftOScaleValMATgbl(3,1:No_Outputs);
	i		       = i+No_Outputs;
	ftEFMtotlrnCNTgbl	       = ftEFMtotlrnCNTgbl + No_Outputs;
	ftciupd(No_Outputs, 10, 3, 1, 0);
end;

%
% ADD User Specific parameters here
%
k=0;
for(cnt=1:ftPartUserCNTgbl)
   if(ftParmUserFLGgbl)
	howmany=ftUserInfoMATgbl(5,cnt);
	ftGApminVECgbl(i+1:howmany+i) = ftParmUserMATgbl(1,k+1:k+howmany);
	ftGApmaxVECgbl(i+1:howmany+i) = ftParmUserMATgbl(2,k+1:k+howmany);
	ftGApresVECgbl(i+1:howmany+i) = ftParmUserMATgbl(3,k+1:k+howmany);
	i		       = i+howmany;
	ftEFMtotlrnCNTgbl	       = ftEFMtotlrnCNTgbl + howmany;
	k		       = k+howmany;
	ftciupd(howmany, 16, ftUserInfoMATgbl(2,cnt), 1, 0);
   end;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute number of parameters nop.
%
   ftGAnopSCAgbl	= ftEFMtotlrnCNTgbl;

%----------------   
% Not Flex-GA   
%----------------               
  if ftGA_choiceSCAgbl ~=4 | ftEFMlrnoptSCAgbl > 4 
 
   %
   % Compute range, ftGAnbitsVECgbl, and lchrom.
   %
   range=0;
   ftGAnbitsVECgbl=0;

   range   = (ftGApmaxVECgbl-ftGApminVECgbl)./ftGApresVECgbl;
   ftGAnbitsVECgbl   = ceil(log(range+1.0)./log(2.0));
   ftGApresuVECgbl   = ftGApresVECgbl;
   for(i_=1:ftGAnopSCAgbl)
     if(ftGApresVECgbl(i_) ~= 1)
       ftGApresVECgbl(i_)   = (ftGApmaxVECgbl(i_)-ftGApminVECgbl(i_))/((2^ftGAnbitsVECgbl(i_))-1);
     end;
  end;
%   ftGApresVECgbl   = (ftGApmaxVECgbl-ftGApminVECgbl)./(2.^(ftGAnbitsVECgbl)-1);
   ftGAlchromSCAgbl  = sum(ftGAnbitsVECgbl);
   ftEFMlchromrgbl = sum(ftGAnbitsVECgbl(1:ftEFMtotlrnrsCNTgbl));

   % choose slope and y intercept   
   %---------------------------------  
    ftGApslopeVECgbl=ftGApresVECgbl;   
    ftGApcVECgbl=ftGApminVECgbl;       

  else % Flex-GA

     %------------------------------------------------------------  
     % ftGApcVECgbl,ftGApslopeVECgbl,ftGApresVECgbl,ftGAnbitsVECgbl,mean_table,sigma_table,etc.   
     %------------------------------------------------------------
     ftm_tableMATgbl=zeros(max_rows,ftGAnopSCAgbl);
     fts_tableMATgbl=zeros(max_rows,ftGAnopSCAgbl);

     for j=1:ftGAnopSCAgbl
	if ftGAp_typeVECgbl(j) == 1	%Integer Type
      		ftGApcVECgbl(j)=ftGApminVECgbl(j);
      		ftGAnbitsVECgbl(j)=ceil(log2(ftGApmaxVECgbl(j)-ftGApminVECgbl(j)+1));
      		ftGApslopeVECgbl(j)=(ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAnbitsVECgbl(j)-1);
  	end; %if

	if ftGAp_typeVECgbl(j) == 2	%Real Type with discrete values
		ftGApcVECgbl(j)=ftGApminVECgbl(j);
		ftGApslopeVECgbl(j)=ftGApresVECgbl(j);
		ftGAnbitsVECgbl(j)=ceil(log2((ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/ftGApresVECgbl(j)));
		ftGApslopeVECgbl(j)= (ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAnbitsVECgbl(j)-1);
	end; %if 

	if ftGAp_typeVECgbl(j) > 2	%Real Type with continuous values
		for i=1:2^(ftGAp_typeVECgbl(j))
		      ftGApcVECgbl(j)=0;
		      ftGApslopeVECgbl(j)=(ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAp_typeVECgbl(j)-1);
		      ftm_tableMATgbl(i,j)=ftGApminVECgbl(j)+(i-1)*ftGApslopeVECgbl(j);
		      fts_tableMATgbl(i,j)=ftGApslopeVECgbl(j)/4;
		      ftGAnbitsVECgbl(j)=ftGAp_typeVECgbl(j);     
		end; %for i
     	end; %if
	ftGAlchromSCAgbl=sum(ftGAnbitsVECgbl);
    end; %for j
  end; %if Flex-GA
%====================================================================

%  ========================================================================   
%  CAUTION   
%  ========================================================================   
%  EXAMPLE   
   
%  ========================================================================   
%  SEE ALSO   
%   
%       FlexTools(GA)   
%  ========================================================================   
%  REFERENCE   
%    
%  Guidelines for Evolutionary Fuzzy Modeling
%  FIG LLC, Tuscaloosa, AL 35486-1477, USA, FIGLLC@AOL.COM
%
%  K. Krishnakumar, Antony Satyadas   
%  Discovering Multiple Fuzzy Models using MFMCN Algorithm   
%  ACM Computing Week Symposium of Applied Computing (SAC) Conference,  
%  Nashville, TN, March 1995.   
%  ==========================================================================   
% (c) Flexible Intelligence Group (FIG)   
% END ftefmin.m     
% ftefmin                           ftefmin.m                  ftefmin
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


