%
% fteneval.m
%
% =========================================================================  
%                          FlexTools(NN) for Matlab                          
%                             Copyright (c) 1996                              
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
%
% GUI for TRAIN/VIEW/TEST NN
%
function fteneval

global ftFigPos_medVECgbl ftscr_cntSCAgbl  ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl  ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNweightMATgbl   ftNNweightOPTgbl ftNNassocMATgbl
global ftNNpp_typeMATgbl

%Global for all GUIs
global ftNNevlGUIgbl

temp_=['FlexTool(ENM)--VIEW/SIMULATE NN'];

if exist('ftNNevlGUIgbl') 
  clear ftNNevlGUIgbl
end

global ftNNevlGUIgbl %Need it twice (Matlab problem?)
ftNNevlGUIgbl=ftfigure('ftNNevlGUIgbl',temp_,ftFigPos_medVECgbl,'on','figure');

fthelp(ftNNevlGUIgbl,'NN');

pp3= [0.9 0.05 0.55 0.1 0.05 0.005];

pp2=str2mat('SIMULATE NN WITH WORKSPACE DATA:',...
            ' Use if you want to use existing workspace',...
            ' values. Assign your input ',...
            ' vectors to the variable nn_in.');

pp2=str2mat(pp2,...
            'SIMULATE NN WITH A .m FILE:',...
            ' Use this if the data for the NN',... 
            ' system is being provided through a .m file.');
pp2=str2mat(pp2,...
            'VIEW NEURAL NETWORK:',...
            ' View the Neural Network parameters',... 
            ' such as the number of inputs, outputs,',...
            ' hidden neurons, weight matrix, association',...
            ' matrix and choice of system settings.');
pp2=str2mat(pp2,...
            'VIEW NN Weight Matrix:',...
            ' View the weight matrix that displays',... 
            ' the inter neuron weights');
pp2=str2mat(pp2,...
            'VIEW NN Association Matrix:',...
            ' View the association matrix that displays',... 
            ' the inter neuron connectivity');

pp1='FlexTool(NN) Help on Options Menu';
ftscrhlp(ftNNevlGUIgbl,pp1,pp2,pp3,'left');

non_dim=.0025;
x0=250*non_dim; y0=330*non_dim; 
dx=130*non_dim; dx1=60*non_dim; eps=10*non_dim; 
dy=24*non_dim;


ftscrpb(ftNNevlGUIgbl,'Simulate NN (Wspace Data)',[x0 y0-0*dy dx dy+0.025],'ftnnrun2(2);');
ftscrpb(ftNNevlGUIgbl,'Simulate NN (.m File    )',[x0 y0-2*dy dx dy+0.025],'ftnnrun2(1);');

ftscrpb(ftNNevlGUIgbl,'View Neural Network',[x0 y0-5*dy dx dy+0.025],'ftnndisp;');
ftscrpb(ftNNevlGUIgbl,'View Weight Matrix',[x0 y0-7*dy dx dy+0.025],'ftnnwts(1,1,1);');
ftscrpb(ftNNevlGUIgbl,'View Association Matrix',[x0 y0-9*dy dx dy+0.025],'ftnnasn(1,1,1);');

%=======================
% Back, and Quit)
%=======================

ftscrpb(ftNNevlGUIgbl,' Ok ',[x0+.1 y0-12*dy dx1 dy+0.025],'clear ftNNevlGUIgbl; close;');

%
% end ftnneval.m
%
