%
% FTenga1
%
% =========================================================================  
%                          FlexTools(ENM) for Matlab                          
%                             Copyright (c) 1996                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
%

function ftenga1

global ftGA_choiceSCAgbl ftGAobjfuncVECgbl ftGAinitfuncVECgbl ftGAnoofpSCAgbl
global ftGAcodingSCAgbl ftGAnopSCAgbl ftGAnichtestSCAgbl ftGAnoofpeaksSCAgbl 
global ftGAnselectSCAgbl ftGAnoofobjSCAgbl
global ftGAtsizeSCAgbl ftGAnpopSCAgbl ftGAsspopSCAgbl ftGAngenSCAgbl ftGAregenSCAgbl     
global ftGApcrossSCAgbl ftGApmutateSCAgbl ftGAncrossSCAgbl ftGAp1SCAgbl 
global ftGAp2SCAgbl ftGAmmVECgbl ftGAold_codeSCAgbl

global ftGArga_1GUI ftGArga_2GUI ftGArga_3GUI
global ftGArcode_noGUI ftGArcode_yesGUI 
global ftGArob_1GUI ftGArob_2GUI ftGArob_3GUI
global ftGArob_4GUI 
global ftGArmin_1GUI ftGArmin_2GUI ftGArmin_3GUI ftGArmin_4GUI
global ftGArmax_1GUI ftGArmax_2GUI ftGArmax_3GUI ftGArmax_4GUI
global ftGAeobj_nameGUI ftGAeinit_nameGUI ftGAenopGUI

global ftGAgapVECgbl ftGAfunpVECgbl 
global ftGAch_flagSCAgbl ftGAfun_flagSCAgbl

global ftcolor_bc1VECgbl ftcolor_bc2VECgbl
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 
global ftFigPos_bigVECgbl ftFigPos_medVECgbl

fig_ga1=ftfigure('fig_ga1','FlexTool(ENM) -- User Interface--Screen A',ftFigPos_bigVECgbl,'on','figure');

%=============
% GA menu bar
%=============
%ftgp_def(' ',3);
ftfp_def(' ',3);

ftgambar(fig_ga1,1,'yes');

pp3= [0.97 0.05 0.55 0.15 0.05 0.005];

pp1='FlexTool(GA) Help on Options Menu';

pp2=str2mat(...
            'TYPE OF GA:',...
            '  Micro GA uses a small population. Can',...
            '  be used for small problems.');
pp2=str2mat(pp2,...
            'OBJECTIVE FUNCTION:',...
            '  The first step is to create a fitness',...
            '  function as a .m file which takes the',...
            '  parameters as the input and outputs the',...
            '  fitness. Ex: function J=objfunc(p).'); 
pp2=str2mat(pp2,...
            '# OF OBJECTIVES:',...
            '  Upto 4 objectives can be defined in the',...
            '  user defined .m file. The objectives should',...
            '  be a vector (Ex: [J1 J2 J3 J4]=objfunc(p)).');

pp2=str2mat(pp2,...
            'INIT FUNCTION:',...
            '  To include certain computations that need',...
            '  to be done only once (Ex: initialization',... 
	    '  functions, global declarations, etc.),',...
            '  create a .m file.');
pp2=str2mat(pp2,...
            'MIN, MAX, & RES:',...
            '  Click this button and go to MATLAB',...
            '  workspace to enter the range and',...
            '  resolution desired for the parameters.');

ftscrhlp(fig_ga1,pp1,pp2,pp3,'left');
frame_border=0.02;
frame_pos=[0.60-frame_border 0.17-frame_border ...
           (0.95-0.60)+2*frame_border (0.95-0.17)+2*frame_border];

uicontrol(...
         'Style','frame', ...
         'Units','normalized', ...
         'Position',frame_pos, ...
      	'BackgroundColor',[0.55 .55 .55]);

%=============
% GA GUI's
%=============
if isempty(ftGA_choiceSCAgbl)==1        %KK Matlab 5 fix
   ftGA_choiceSCAgbl=1;
end
 
ga_1_val=0; ga_2_val=0; ga_3_val=0;
 if ftGA_choiceSCAgbl ==1, ga_1_val=1; end
 if ftGA_choiceSCAgbl ==2, ga_2_val=1; end
 if ftGA_choiceSCAgbl ==3, ga_3_val=1; end

 code_1_val=0; code_2_val=0;
 if ftGAcodingSCAgbl ==1, code_1_val=1; end
 if ftGAcodingSCAgbl ==2, code_2_val=1; end

 ob_1_val=0; ob_2_val=0; ob_3_val=0; ob_4_val=0;
 if ftGAnoofobjSCAgbl ==1, ob_1_val=1; end
 if ftGAnoofobjSCAgbl ==2, ob_2_val=1; end
 if ftGAnoofobjSCAgbl ==3, ob_3_val=1; end
 if ftGAnoofobjSCAgbl ==4, ob_4_val=1; end

 for i=1:4, max_val(i)=0; min_val(i)=1; end
 for i=1:ftGAnoofobjSCAgbl
  if ftGAmmVECgbl(i) == -1, max_val(i)=1; min_val(i)=0; end
 end

%========================
% Type of GA radio button
%========================
x0=237; y0=360; dx=85; dy=20; eps=3;

non_dim=.0025;
x0=x0*non_dim; y0=y0*non_dim; 
dx=dx*non_dim; eps=eps*non_dim; 
dy=dy*non_dim;

txt_ga=uicontrol('Style','text',...
'string','Type of GA',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0 dx dy-eps]);

ftGArga_1GUI=uicontrol('Style','radio',...
'string',' Regular',...
'Units','normalized', ...
'Position',[x0 y0-dy dx dy],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'value',ga_1_val,...
'CallBack',[...
        'set(ftGArga_1GUI,''value'',1),'...
        'set(ftGArga_2GUI,''value'',0),'...
        'set(ftGArga_3GUI,''value'',0),'...
        'ftGAch_flagSCAgbl=1;,'...
        'ftGA_choiceSCAgbl=1;']);

ftGArga_2GUI=uicontrol('Style','radio',...
'string',' Micro',...
'Units','normalized', ...
'Position',[x0 y0-2*dy dx dy],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'value',ga_2_val,...
'CallBack',[...
       'set(ftGArga_2GUI,''value'',0),'...
       'if ftGAnoofobjSCAgbl == 1,'...
        'set(ftGArga_1GUI,''value'',0),'...
        'set(ftGArga_2GUI,''value'',1),'...
        'set(ftGArga_3GUI,''value'',0),'...
        'ftGAch_flagSCAgbl=1;,'...
        'ftGA_choiceSCAgbl=2;,'...
       'end']);

% REVISIT
%if(ftENMlrnoptSCAgbl>4)% if FINE TUNE? Cannot use Flex-GA
%
% ftGArga_3GUI=uicontrol('Style','text',...
% 'string',' Flex-GA is N/A',...
% 'Units','normalized', ...
% 'Position',[x0 y0-3*dy dx dy],...
% 'BackgroundColor', ftcolor_bc1VECgbl);

%else

ftGArga_3GUI=uicontrol('Style','radio',...
'string',' Flex-GA',...
'Units','normalized', ...
'Position',[x0 y0-3*dy dx dy],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'value',ga_3_val,...
'CallBack',[...
       'set(ftGArga_3GUI,''value'',0),'...
       'if ftGAnoofobjSCAgbl==1,'...
        'set(ftGArga_1GUI,''value'',0),'...
        'set(ftGArga_2GUI,''value'',0),'...
        'set(ftGArga_3GUI,''value'',1),'...
        'ftGAch_flagSCAgbl=1;,'...
        'ftGA_choiceSCAgbl=4;,'...
       'end']);
%end; % if
%================
% Coding Options
%================
x0=325; y0=360; dx=57; dy=20; eps=3;

non_dim=.0025;
x0=x0*non_dim; y0=y0*non_dim; 
dx=dx*non_dim; eps=eps*non_dim; 
dy=dy*non_dim;

txt_ga=uicontrol('Style','text',...
'string','Coding',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0 dx dy-eps]);

ftGArcode_noGUI=uicontrol('Style','radio',...
'string','Binary',...
'value',code_1_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-dy dx dy],...
'CallBack',[...
        'set(ftGArcode_yesGUI,''value'',0),'...
        'set(ftGArcode_noGUI,''value'',1),'...
        'ftGAold_codeSCAgbl=ftGAcodingSCAgbl; ftGAcodingSCAgbl=1;,'...
        'if ftGAold_codeSCAgbl ~= 1, ftGAfun_flagSCAgbl=6; ftfun_ch; end']);
         
ftGArcode_yesGUI=uicontrol('Style','radio',...
'string','Log',...
'Units','normalized', ...
'Position',[x0 y0-3*dy dx 2*dy],...
'value',code_2_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArcode_yesGUI,''value'',1),'...
        'set(ftGArcode_noGUI,''value'',0),'...
        'ftGAold_codeSCAgbl=ftGAcodingSCAgbl; ftGAcodingSCAgbl=2;,'...
        'if ftGAold_codeSCAgbl ~= 2, ftGAfun_flagSCAgbl=6; ftfun_ch; end']);

%============================
% # of objectives radio button
%============================
x0=237; y0=360; dx=36; dy=25; eps=3; dy1=35; 

non_dim=.0025;
x0=x0*non_dim; y0=y0*non_dim; 
dx=dx*non_dim; eps=eps*non_dim; 
dy=dy*non_dim; dy1=dy1*non_dim;

txt_ga=uicontrol('Style','text',...
'string','Select Objectives and min/max',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-4*dy dx*4 dy1-eps]);

ftGArob_1GUI=uicontrol('Style','radio',...
'string',' 1',...
'Units','normalized', ...
'Position',[x0 y0-5*dy dx dy],...
'value',ob_1_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArob_1GUI,''value'',1),'...
        'set(ftGArob_2GUI,''value'',0),'...
        'set(ftGArob_3GUI,''value'',0),'...
        'set(ftGArob_4GUI,''value'',0),'...
        'ftGAnoofobjSCAgbl=1;']);

ftGArob_2GUI=uicontrol('Style','radio',...
'string',' 2',...
'Units','normalized', ...
'Position',[(x0+dx) y0-5*dy dx dy],...
'value',ob_2_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
       'set(ftGArob_2GUI,''value'',0),'...
       'if ftGA_choiceSCAgbl == 1,'...
        'set(ftGArob_1GUI,''value'',0),'...
        'set(ftGArob_2GUI,''value'',1),'...
        'set(ftGArob_3GUI,''value'',0),'...
        'set(ftGArob_4GUI,''value'',0),'...
        'ftGAnoofobjSCAgbl=2;,'...
        'ftGAmmVECgbl(2)=1;,'...
       'end']);

ftGArob_3GUI=uicontrol('Style','radio',...
'string',' 3',...
'Units','normalized', ...
'Position',[(x0+2*dx) y0-5*dy dx dy],...
'value',ob_3_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
       'set(ftGArob_3GUI,''value'',0),'...
       'if ftGA_choiceSCAgbl == 1,'...
        'set(ftGArob_1GUI,''value'',0),'...
        'set(ftGArob_2GUI,''value'',0),'...
        'set(ftGArob_3GUI,''value'',1),'...
        'set(ftGArob_4GUI,''value'',0),'...
        'ftGAnoofobjSCAgbl=3;,'...
        'ftGAmmVECgbl(3)=1;,'...
       'end']);

ftGArob_4GUI=uicontrol('Style','radio',...
'string',' 4',...
'Units','normalized', ...
'Position',[(x0+3*dx) y0-5*dy dx dy],...
'value',ob_4_val,...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
       'set(ftGArob_4GUI,''value'',0),'...
       'if ftGA_choiceSCAgbl == 1,'...
        'set(ftGArob_1GUI,''value'',0),'...
        'set(ftGArob_2GUI,''value'',0),'...
        'set(ftGArob_3GUI,''value'',0),'...
        'set(ftGArob_4GUI,''value'',1),'...
        'ftGAnoofobjSCAgbl=4;,'...
        'ftGAmmVECgbl(4)=1;,'...
       'end']);

%============================
%Min or Max radio buttons
%============================

i=1;
ftGArmin_1GUI=uicontrol('Style','radio',...
'string','Min',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-6*dy dx dy],...
'value',min_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_1GUI,''value'',1),'...
        'set(ftGArmax_1GUI,''value'',0),'...
        'ftGAmmVECgbl(1)=1;']);

ftGArmax_1GUI=uicontrol('Style','radio',...
'string','Max',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-7*dy dx dy],...
'value',max_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_1GUI,''value'',0),'...
        'set(ftGArmax_1GUI,''value'',1),'...
        'ftGAmmVECgbl(1)=-1;']);

i=2;
ftGArmin_2GUI=uicontrol('Style','radio',...
'string','Min',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-6*dy dx dy],...
'value',min_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_2GUI,''value'',1),'...
        'set(ftGArmax_2GUI,''value'',0),'...
        'ftGAmmVECgbl(2)=1;']);

ftGArmax_2GUI=uicontrol('Style','radio',...
'string','Max',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-7*dy dx dy],...
'value',max_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_2GUI,''value'',0),'...
        'set(ftGArmax_2GUI,''value'',1),'...
        'ftGAmmVECgbl(2)=-1;']);

i=3;
ftGArmin_3GUI=uicontrol('Style','radio',...
'string','Min',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-6*dy dx dy],...
'value',min_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_3GUI,''value'',1),'...
        'set(ftGArmax_3GUI,''value'',0),'...
        'ftGAmmVECgbl(3)=1;']);

ftGArmax_3GUI=uicontrol('Style','radio',...
'string','Max',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-7*dy dx dy],...
'value',max_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_3GUI,''value'',0),'...
        'set(ftGArmax_3GUI,''value'',1),'...
        'ftGAmmVECgbl(3)=-1;']);
i=4;
ftGArmin_4GUI=uicontrol('Style','radio',...
'string','Min',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-6*dy dx dy],...
'value',min_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_4GUI,''value'',1),'...
        'set(ftGArmax_4GUI,''value'',0),'...
        'ftGAmmVECgbl(4)=1;']);

ftGArmax_4GUI=uicontrol('Style','radio',...
'string','Max',...
'Units','normalized', ...
'Position',[x0+(i-1)*dx y0-7*dy dx dy],...
'value',max_val(i),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'CallBack',[...
        'set(ftGArmin_4GUI,''value'',0),'...
        'set(ftGArmax_4GUI,''value'',1),'...
        'ftGAmmVECgbl(4)=-1;']);

%===================
% Objective Function
%===================
x0=237; y0=140; dx=82; dy=30; eps=3; dx1=59; 

non_dim=.0025;
x0=x0*non_dim; y0=y0*non_dim; 
dx=dx*non_dim; dx1=dx1*non_dim; 
eps=eps*non_dim; dy=dy*non_dim;

txt_ga=uicontrol('Style','text',...
'string','Objective Function',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0 dx dy]);

ftGAeobj_nameGUI=uicontrol('Style','edit',...
'string',ftGAobjfuncVECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0+0.5*dy dx1 dy/1.5],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'callback',['ftGAobjfuncVECgbl=get(ftGAeobj_nameGUI,''string''); ftGAobjfuncVECgbl=ftfile(ftGAobjfuncVECgbl); if(exist(ftGAobjfuncVECgbl)~=2), ftGAobjfuncVECgbl=''objfunc''; end;']);

pp42=['[ftGAjunkname obpath]=uigetfile(''*.m'',''FlexTool(ENM): Objective Function. Use a .m File'',50,50);',...
	'if ftGAjunkname~=0, ftGAobjfuncVECgbl=ftGAjunkname; end;',...
      'set(ftGAeobj_nameGUI,''string'',ftGAobjfuncVECgbl);ftGAobjfuncVECgbl=ftfile(ftGAobjfuncVECgbl);'];
ftscrpb(fig_ga1,'..Browse',[x0+dx+eps y0-0.1*dy dx1 dy/2],pp42);

%===================
% Init Function
%===================

txt_ga=uicontrol('Style','text',...
'string','Init Function',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-1.1*dy-eps dx dy]);

ftGAeinit_nameGUI=uicontrol('Style','edit',...
'string',ftGAinitfuncVECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-dy/1.5-eps dx1 dy/1.5],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'callback',['ftGAyourinitname=get(ftGAeinit_nameGUI,''string'');  ftGAinitfuncVECgbl=ftfile(ftGAyourinitname); if(exist(ftGAyourinitname)~=2), ftGAyourinitname=''x''; end;']);

pp41=['[ftGAjunkname obpath]=uigetfile(''*.m'',''FlexTool(ENM): Initialization Function. Use a .m File'',50,50);',...
	'if ftGAjunkname~=0, ftGAinitfuncVECgbl=ftGAjunkname; end;',...
      'set(ftGAeinit_nameGUI,''string'',ftGAinitfuncVECgbl); ftGAinitfuncVECgbl=ftfile(ftGAinitfuncVECgbl);'];

ftscrpb(fig_ga1,'..Browse',[x0+dx+eps y0-1.3*dy dx1 dy/2],pp41);

%=====================
% Number of Parameters
%=====================

txt_ga=uicontrol('Style','text',...
'string','# of Parameters',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-2*(dy+eps) dx dy/2]);

ftGAenopGUI=uicontrol('Style','text',...
'string',num2str(ftGAnopSCAgbl),...
'Units','normalized', ...
'Position',[x0+dx+eps y0-2*(dy+eps) dx1 dy/2],...
'BackgroundColor', ftcolor_bc2VECgbl,...
'callback',['ftGAnopSCAgbl=abs(round(str2num(get(ftGAenopGUI,''string'')))); ftGAfun_flagSCAgbl=6; ftfun_ch;']);

%====================================
% Back one screen, next screen, quit
%====================================

ftscrpb(fig_ga1,'<< Back',[0.05 0.03 0.15 0.07],'ftgp_def(''gp_cold.mat'',2); ftfp_def(''fp_cold.mat'',2); ftensave(''cold''); close; pause(0.25); ftennbld(1); ftennbld;');
%ftscrpb(fig_ga1,'Exit',[0.45 0.03 0.15 0.07],'ftensave(1); ftqtmenu;');
ftscrpb(fig_ga1,'Next >>',[0.8 0.03 0.15 0.07],'ftgp_def(''gp_cold.mat'',2); ftfp_def(''fp_cold.mat'',2); ftensave(''cold''); close; pause(0.1); ftenga2;');

%
% END FTga1ch
%
