%
% FTenga2
%
% =========================================================================  
%                          FlexTools(ENM) for Matlab                          
%                             Copyright (c) 1996                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  

function ftenga2

global ftENMaFLGgbl ftENMSeqTimeVECgbl

global ftGA_choiceSCAgbl ftGAobjfuncVECgbl ftGAinitfuncVECgbl ftGAnoofpSCAgbl
global ftGAcodingSCAgbl ftGAnopSCAgbl ftGAnichtestSCAgbl ftGAnoofpeaksSCAgbl 
global ftGAnselectSCAgbl ftGAnoofobjSCAgbl
global ftGAtsizeSCAgbl ftGAnpopSCAgbl ftGAsspopSCAgbl ftGAngenSCAgbl ftGAregenSCAgbl     
global ftGApcrossSCAgbl ftGApmutateSCAgbl ftGAncrossSCAgbl ftGAp1SCAgbl 
global ftGAp2SCAgbl ftGAmmVECgbl 

global ftGAegenGUI ftGAenpopGUI ftGAepmGUI ftGAepcGUI 
global ftGAencGUI ftGAetsGUI ftGAenopGUI ftGAessGUI 
global ftGAeregGUI ftGAep1GUI ftGAep2GUI ftGApnicGUI ftGApselGUI

global ftGAgapVECgbl ftGAfunpVECgbl 
global ftGAch_flagSCAgbl ftGAfun_flagSCAgbl

global ftENMlrnOPTgbl

global ftcolor_bc1VECgbl ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 
global ftFigPos_bigVECgbl ftFigPos_medVECgbl

fig_ga2=ftfigure('fig_ga2','FlexTool(ENM) -- User Interface--Screen B',ftFigPos_bigVECgbl,'on','figure');

if ftGAch_flagSCAgbl==1
 ftGAch_flagSCAgbl=0;

 if ftGA_choiceSCAgbl == 1     

  ftGAnpopSCAgbl	= 31;     
  ftGAsspopSCAgbl	= 1;     
  ftGAngenSCAgbl	= 77;     
  ftGAregenSCAgbl	= 1;     
  ftGApcrossSCAgbl	= 0.77;     
  ftGApmutateSCAgbl	= 0.0077;
  ftGAregenSCAgbl 	= 1;     

 elseif ftGA_choiceSCAgbl == 2     

  ftGAnpopSCAgbl	= 5;     
  ftGAsspopSCAgbl	= 1;     
  ftGAngenSCAgbl	= 77;     
  ftGAregenSCAgbl	= 7;     
  ftGApcrossSCAgbl	= 1.0;     
  ftGApmutateSCAgbl	= 0; 
  ftGAnselectSCAgbl	= 1;    

 else     

  ftGAnpopSCAgbl	= 31;     
  ftGAsspopSCAgbl	= 15;     
  ftGAngenSCAgbl	= 77;     
  ftGAregenSCAgbl	= 1;     
  ftGApcrossSCAgbl	= 0.77;     
  ftGApmutateSCAgbl	= 0.0077;     
 end
  ftGAnichtestSCAgbl=1;
  if ftGAnopSCAgbl > 1
     ftGAp2SCAgbl=2;
  end
end

if ftGAnoofobjSCAgbl > 1
 ftGAnichtestSCAgbl=1;
 ftGAnoofpeaksSCAgbl=1;
 ftGAnselectSCAgbl=1;
end
if ftGAmmVECgbl(1) == -1, ftGAnselectSCAgbl=1; end
  
%====================================
% Menu Bar-GA Options 
%====================================
     
ftgambar(fig_ga2,2,'yes');

pp3= [0.97 0.05 0.55 0.13 0.05 0.005];

pp1='FlexTool(GA) Help on Options Menu';

pp2=str2mat(...
            'All the default choices are in general',...
            '  good choices if you have no feel for what',...
            '  they should be.');
pp2=str2mat(pp2,...
            '# OF GENERATIONS:',...
            '  GA evolution can be continued using the',...
            '  GA_WARM option once a run is complete.');
pp2=str2mat(pp2,...
            'POPULATION SIZE:',...
            '  Should be as large as possible.'); 
pp2=str2mat(pp2,...
            'NICHING:',...
            '  Use this option if you want GA to look for',...
            '  multiple peaks. See the manual for details.');
pp2=str2mat(pp2,...
            '# OF GEN/MGA LOOP:',...
            '  Micro GA converges quickly and needs to',...
            '  be restarted. FlexTool (GA) does this',...
            '  automatically using this value.');
pp2=str2mat(pp2,...
            'SS POPSIZE:',...
            '  This number of pop members are not',...
            '  altered going into the next generation.');
pp2=str2mat(pp2,...
            'PARAMETERS DISPLAYED:',...
            '  Two parameters chosen by the user are ',...
            '  displayed as they evolve.');

ftscrhlp(fig_ga2,pp1,pp2,pp3,'left');
frame_border=0.02;
frame_pos=[0.60-frame_border 0.15-frame_border ...
      	  (0.95-0.60)+2*frame_border (0.95-0.15)+2*frame_border];

uicontrol(...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frame_pos, ...
	'BackgroundColor',[0.55 0.55 0.55]);

%=================
% Big Text Block
%=================
x0=237; y0=360; dx=105; dx1=37; dy=22; dy1=20; eps=3; dx2=5; dx3=50; 

non_dim=.0025;
x0=x0*non_dim; y0=y0*non_dim; dx3=dx3*non_dim;
dx=dx*non_dim; dx1=dx1*non_dim; eps=eps*non_dim; 
dx2=dx2*non_dim; dy=dy*non_dim; dy1=dy1*non_dim;

txt_gen=uicontrol('Style','text',...
'string','# of Generations              ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0 dx dy1]);

ftGAegenGUI=uicontrol('Style','edit',...
'string',num2str(ftGAngenSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0 dx1 dy1],...
'callback',['ftGAngenSCAgbl=abs(round(str2num(get(ftGAegenGUI,''string''))));']);

txt_npop=uicontrol('Style','text',...
'string','Pop size (Always odd)           ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-dy dx dy1]);

ftGAenpopGUI=uicontrol('Style','edit',...
'string',num2str(ftGAnpopSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-dy dx1 dy1],...
'callback',['ftGAnpopSCAgbl=abs(round(str2num(get(ftGAenpopGUI,''string'')))); if(ftGAsspopSCAgbl>ftGAnpopSCAgbl), ftGAsspopSCAgbl= fix(ftGAnpopSCAgbl/2); if (rem(ftGAsspopSCAgbl,2)==0), ftGAsspopSCAgbl=ftGAsspopSCAgbl-1; end; end;']);

txt_pm=uicontrol('Style','text',...
'string','Prob. of mutation            ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-2*dy dx dy1]);

ftGAepmGUI=uicontrol('Style','edit',...
'string',num2str(ftGApmutateSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-2*dy dx1 dy1],...
'callback',['ftGApmutateSCAgbl=abs(str2num(get(ftGAepmGUI,''string'')));']);

txt_pc=uicontrol('Style','text',...
'string','Prob. of crossover             ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-3*dy dx dy1]);

ftGAepcGUI=uicontrol('Style','edit',...
'string',num2str(ftGApcrossSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-3*dy dx1 dy1],...
'callback',['ftGApcrossSCAgbl=abs(str2num(get(ftGAepcGUI,''string'')));']);

txt_nc=uicontrol('Style','text',...
'string','# of crossover points                               ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-4*dy dx dy1]);

ftGAencGUI=uicontrol('Style','edit',...
'string',num2str(ftGAncrossSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-4*dy dx1 dy1],...
'callback',['ftGAncrossSCAgbl=abs(round(str2num(get(ftGAencGUI,''string''))));']);

txt_nic=uicontrol('Style','text',...
'string','Niching (No/Yes)           ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-5*dy dx-dx2 dy1]);

if ftGA_choiceSCAgbl ~=2 & ftGAnoofobjSCAgbl < 2
 STYLE='popup'; STRING='No|Yes'; COLOR=ftcolor_bc2VECgbl; 
else
 STYLE='text'; STRING='No'; COLOR=ftcolor_bc1VECgbl;
end
 
ftGApnicGUI=uicontrol('Style',STYLE,...
'string',STRING,...
'BackgroundColor', COLOR,...
'value', ftGAnichtestSCAgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps-dx2 y0-5*dy dx1+dx2 dy1],...
'UserData',[1;2],...
'callback',['ftGAnichtestSCAgbl=get(ftGApnicGUI,''value'');']);

txt_nop=uicontrol('Style','text',...
'string','# of assumed peaks           ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-6*dy dx dy1]);

ftGAenopGUI=uicontrol('Style','edit',...
'string',num2str(ftGAnoofpeaksSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-6*dy dx1 dy1],...
'callback',['ftGAnoofpeaksSCAgbl=abs(round(str2num(get(ftGAenopGUI,''string''))));']);

txt_sel=uicontrol('Style','text',...
'string','Selection                ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-7*dy dx-dx3 dy1]);

if ftGA_choiceSCAgbl ~=2 & ftGAnoofobjSCAgbl < 2 & ftGAmmVECgbl(1) ==1,
 STYLE='popup'; STRING='Tournament|R. Wheel|Ranking'; COLOR=ftcolor_bc2VECgbl;
else
 STYLE='text'; STRING='Tournament'; COLOR=ftcolor_bc1VECgbl;
end

ftGApselGUI=uicontrol('Style',STYLE,...
'string',STRING,...
'value',ftGAnselectSCAgbl,...
'BackgroundColor', COLOR,...
'Units','normalized', ...
'Position',[x0+dx+eps-dx3 y0-7*dy dx1+dx3 dy1],...
'UserData',[1;2;3],...
'callback',['ftGAnselectSCAgbl=get(ftGApselGUI,''value'');']);

txt_ts=uicontrol('Style','text',...
'string','Tournament Size              ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-8*dy dx dy1]);

ftGAetsGUI=uicontrol('Style','edit',...
'string',num2str(ftGAtsizeSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-8*dy dx1 dy1],...
'callback',['ftGAtsizeSCAgbl=abs(round(str2num(get(ftGAetsGUI,''string''))));']);

txt_ss=uicontrol('Style','text',...
'string','SS Popsize                               ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-9*dy dx dy1]);

ftGAessGUI=uicontrol('Style','edit',...
'string',num2str(ftGAsspopSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-9*dy dx1 dy1],...
'callback',['ftGAsspopSCAgbl=abs(round(str2num(get(ftGAessGUI,''string''))));']);

txt_reg=uicontrol('Style','text',...
'string','# of Gen/mga loop         ',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-10*dy dx dy1]);

ftGAeregGUI=uicontrol('Style','edit',...
'string',num2str(ftGAregenSCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-10*dy dx1 dy1],...
'callback',['ftGAregenSCAgbl=abs(round(str2num(get(ftGAeregGUI,''string''))));']);

txt_p1=uicontrol('Style','text',...   
'string','First   parameter displayed',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-11.75*dy dx 1.75*dy1]);

ftGAep1GUI=uicontrol('Style','edit',...
'string',num2str(ftGAp1SCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-11.75*dy dx1 1.75*dy1],...
'callback',['ftGAp1SCAgbl=abs(round(str2num(get(ftGAep1GUI,''string''))));',...
             'if ftGAp1SCAgbl > ftGAnopSCAgbl, ftGAp1SCAgbl=ftGAnopSCAgbl; end']);

txt_p2=uicontrol('Style','text',...
'string','Second parameter displayed',...
'BackgroundColor', ftcolor_bc1VECgbl,...
'ForegroundColor', ftcolor_fc1VECgbl,...
'Units','normalized', ...
'Position',[x0 y0-13.5*dy dx 1.75*dy1]);

ftGAep2GUI=uicontrol('Style','edit',...
'string',num2str(ftGAp2SCAgbl),...
'BackgroundColor', ftcolor_bc2VECgbl,...
'Units','normalized', ...
'Position',[x0+dx+eps y0-13.5*dy dx1 1.75*dy1],...
'callback',['ftGAp2SCAgbl=abs(round(str2num(get(ftGAep2GUI,''string''))));',...
            'if ftGAp2SCAgbl > ftGAnopSCAgbl, ftGAp2SCAgbl=ftGAnopSCAgbl; end']);


%====================================
% Back one screen, next screen, quit
%====================================

ftscrpb(fig_ga2,'<< Back',[0.05 0.03 0.15 0.075],'ftgp_def(''gp_cold.mat'',2); ftfp_def(''fp_cold.mat'',2); ftensave(1); close; pause(0.1); ftenga1;');
%ftscrpb(fig_ga2,'Done',[0.8 0.03 0.15 0.075],'ftensave(1); if((ftENMlrnOPTgbl==4)|(ftENMlrnOPTgbl==6)), ftlrnseq; else, ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; if(ftENMaFLGgbl==1), ftENMaFLGgbl=0; end; close; close; close; end;');
ftscrpb(fig_ga2,'Done',[0.8 0.03 0.15 0.075],'ftensave(1); if((ftENMlrnOPTgbl==4)|(ftENMlrnOPTgbl==6)), close; pause(1); ftlrnseq; else, ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; if(ftENMaFLGgbl==1), ftENMaFLGgbl=0; end; close; end; ');

%
% END FTga2ch
%
