%
% ftenlrn2.m
%
% =========================================================================  
%                          FlexTools(ENM) for Matlab                          
%                             Copyright (c) 1996                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
%
% GUI for FlexTool(ENM) Learn Association Matrix
%

function ftenlrn2(pflag_, rfrom_, cfrom_, seq_)

global ftFigPos_bigVECgbl ftscr_cntSCAgbl  ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl  ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl

global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInVECgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl  

global fneuron_ tneuron_ retval_
global ftENMasetFLGgbl ftNNtypeSCAgbl

figpos_ = ftFigPos_bigVECgbl;

ftnn2_flag=pflag_;
title_=['FlexTool (ENM) - Learn Association Matrix'];
fig_enasnGUI=ftfigure('fig_enasn',title_,figpos_,'on','figure');

fthelp(fig_enasnGUI,'EN');

if ftNNtypeSCAgbl < 5

 pp2=str2mat(...
            'FlexTool allows the user to select the associations between',...
	    'Neurons in a network to be learned using the Learn Association Matrix. The rows',...
	    'and columns represent the neurons labeled 1,2,3,... Each cell/element',...
	    'represents an association. The matrix consists of three parts: The Lower',...
	    'triangle, diagonal line, and the Upper triangle. (0) specifies ',...
	    'no learning and (1) specifies learning using EA. ',...
	    'Note that you may choose learning for the weights in the FlexTool DOA GUI.',...
	    '(a) Lower Triangle: The FORWARD associations are provided here. ex. [row,col]',...
	    '=[2,1]: Learning=1 implies the association between Neuron 2 and ');
 pp2=str2mat(pp2,...
	    'Neuron 1 will be learned. This means that Neuron 2 uses the output of Neuron 1.',...
	    '(b) Diagonal: The Self Recurrence associations are provided here. ex. [row,col]=',...
	    '[2,2]: Learning=0 implies that self recurrence association wont be learned for Neuron 2.',...
	    '(c) Upper Triangle: The RECURRENT associations are provided here.',...
	    'ex. [row,col]=[1,2]: Learning=1 implies that the association between Neuron 1',...
	    'and Neuron 2 will be learned. This means that Neuron 1 uses the output of Neuron 2.',...
	    'This is a recurrence relationship since the output of Neuron 2 was',...
	    'generated using the input from Neuron 1. Refer tutorial for more info.',...
	    'Use the "more" and "back" buttons if you have more than 10 neurons.');
 pp2=str2mat(pp2,...
	    'Options are provided to automatically set learning of All, Fwd, Bias, or Bwd set of',...
	    'associations between the neurons. Use this where ever appropriate. Setting',...
	    'choices are No, Yes, and Man. Man -> manual setting.',...
	    'Note: A maximum of 10 neurons will be displayed at a time.');
else
 pp2=str2mat(...
            'FlexTool allows the user to view learning choice for associations between',...
	    'Neurons in a network using the Learn Association Matrix. The rows',...
	    'and columns represent the neurons labeled 1,2,3,... Each cell/element',...
	    'represents a learning choice. "1" specifies that ',...
	    'the association wont be learned and "0" specifies that it will be learned. ');
end 

pp3= [0.95 0.05 0.95 0.7 0.04 0.002];
pp1='FlexTool(ENM) Help on Options';
ftscrhlp(fig_enasnGUI,pp1,pp2,pp3,'left');

y0=0.55; x0=0.23; tx0=x0; dx_no1=0.15; dx_no=0.075; 
dx=.08; dy_no=0.08; dy_no2=0.055;
dy=0.07; dx2=x0-0.21; dy2_no=0.06; y0b=y0;

if ftNNtypeSCAgbl < 5

 pp1='Auto Set';
 pp3=[dx2 y0+dy dx_no1 0.05];
 ftscrtxt(fig_enasnGUI,pp1,pp3);
 clear pp1;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 scr_cnt_ = ftscr_cntSCAgbl;
 fttmpscrcntSCA_ = ftscr_cntSCAgbl;

 pp1= str2mat(...
		'Auto Set',...
		'Manual');
 pp3=[dx2 y0+(0.25*dy) dx_no1 dy2_no];
 pp4=['ftENMasetFLGgbl = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaConVECgbl(1,1)=ftENMasetFLGgbl;',... 
   'close; ftenlrn2(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
 pp5=ftENMassocOPTgbl(1); % Set for auto set
 pp6=[1:size(pp1,1)]';
 ftscrpup(fig_enasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
 clear pp1 pp3

 if ftENMasetFLGgbl==1
  pp1='Forward';
  pp3=[dx2 y0-(1.2*dy) dx_no1 0.05];
  ftscrtxt(fig_enasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'EA');
  pp3=[dx2 y0-(1.95*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaConVECgbl(1,2)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=fneuron_+1:ftNNno_totSCAgbl),',...
   'ftENMassn' num2str(seq_) 'MATgbl(tneuron_,fneuron_) = retval_-1; end; end;',...
   'close; ftenlrn2(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaConVECgbl(1,2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_enasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Self Recur';
  pp3=[dx2 y0-(3.4*dy) dx_no1 0.05];
  ftscrtxt(fig_enasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'EA');
  pp3=[dx2 y0-(4.15*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaConVECgbl(1,3)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), ',...
   'ftENMassn' num2str(seq_) 'MATgbl(fneuron_,fneuron_) = retval_-1; end;',...
   'close; ftenlrn2(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaConVECgbl(1,3); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_enasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Recurrence';
  pp3=[dx2 y0-(5.6*dy) dx_no1 0.05];
  ftscrtxt(fig_enasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'EA');
  pp3=[dx2 y0-(6.35*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaConVECgbl(1,4)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=1:fneuron_-1),',...
   'ftENMassn' num2str(seq_) 'MATgbl(tneuron_,fneuron_) = retval_-1; end; end;',...
   'close; ftenlrn2(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaConVECgbl(1,4); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_enasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3
 end
else
 ftENMasetFLGgbl=1;
end

%================
% Loop through
%================
if ftNNtypeSCAgbl < 5
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_totSCAgbl;
  cfrom_ = 1; cto_ = rto_;
 else
  rto_ = rfrom_+8;
  cto_ = cfrom_+8;
 end;

 if rto_ > ftNNno_totSCAgbl, rto_= ftNNno_totSCAgbl; end
 if rfrom_ > ftNNno_totSCAgbl, rfrom_= ftNNno_totSCAgbl; end
 if cto_ > ftNNno_totSCAgbl, cto_= ftNNno_totSCAgbl; end
 if cfrom_ > ftNNno_totSCAgbl, cfrom_= ftNNno_totSCAgbl; end
else
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_inSCAgbl;
 else
  rto_ = rfrom_+8;
  cto_ = cfrom_+8;
 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_inSCAgbl, cto_= ftNNno_inSCAgbl; end
 if cfrom_ > ftNNno_inSCAgbl, cfrom_= ftNNno_inSCAgbl; end
end

if ftENMasetFLGgbl==1
 
  bigpp1_=[' To:    ' sprintf('%3d     ', [cfrom_:1:cto_])];
  if cfrom_ > 9
    bigpp1_=[' To:    ' sprintf('%3d    ', [cfrom_:1:cto_])];
  end

  bigpp1_=str2mat(bigpp1_,' ',' Fr: ');

  for (fneuron_=rfrom_:rto_)
     if fneuron_ < 10
        pp11=sprintf('  %1d     ',fneuron_);
     elseif fneuron_ < 99
        pp11=sprintf(' %2d    ',fneuron_);
     else
        pp11=sprintf('%3d     ',fneuron_);
     end
     if(seq_==1)
        pp12=sprintf('%3d     ', ftENMassn1MATgbl(fneuron_,cfrom_:cto_));
     elseif(seq_==2)
        pp12=sprintf('%3d     ', ftENMassn2MATgbl(fneuron_,cfrom_:cto_));
     elseif(seq_==3)
        pp12=sprintf('%3d     ', ftENMassn3MATgbl(fneuron_,cfrom_:cto_));
     elseif(seq_==4)
        pp12=sprintf('%3d     ', ftENMassn4MATgbl(fneuron_,cfrom_:cto_));
     end; %if

     bigpp1_=str2mat(bigpp1_,[pp11 pp12]);
  end;  %for fneuron_

  pp3= [0.65 0.20 0.95 0.15 0.04 0.002];
  pp1='FlexTool(ENM) Learn Association Matrix';
  ftscrhlp(fig_enasnGUI,pp1,bigpp1_,pp3,'left');

else
  gblcnt_=0;
  fttmpscrcntSCA_ = ftscr_cntSCAgbl+1;

  for (fneuron_=rfrom_:rto_)
   x0=0.23;

   pp1=num2str(fneuron_);
   pp3=[x0-0.05 y0+0.005 0.05 0.04];
   ftscrtxt(fig_enasnGUI,pp1,pp3);
   clear pp1;
 
   for (tneuron_=cfrom_:cto_)
     gblcnt_=gblcnt_+1;

     if(fneuron_==rfrom_)
   	pp1=num2str(tneuron_);
   	pp3=[x0+0.015 0.61 0.05 0.05];
	ftscrtxt(fig_enasnGUI,pp1,pp3);
	clear pp1;
     end; %if

     ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
     scr_cnt_ = ftscr_cntSCAgbl;
     pp1= str2mat(...
		'No',...
		'Yes');
     pp3=[x0 y0 dx_no dy_no];
     pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
      'ftENMassn' num2str(seq_) 'MATgbl(' num2str(fneuron_) ',' num2str(tneuron_) ') = retval_-1;'];
     pp5=eval(['ftENMassn' num2str(seq_) 'MATgbl(fneuron_,tneuron_)+1']); % default is existing association!
     pp6=[1:size(pp1,1)]';
     ftscrpup(fig_enasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
     clear pp1 pp3
     x0=x0+dx;
   end; %for tneuron_
   y0=y0-dy_no2;
  end;  %for fneuron_
end %ftENMasetFLGgbl

x0=tx0;

%=====================
% Go Back to the Left
%=====================
if cfrom_ > 9
 temp_=cfrom_-9;
 pp1='back <';
 pp3=[x0 0.01 0.1 dy_no];
 pp4=['close; ftenlrn2(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ',' num2str(seq_) ')'];
 ftscrpb(fig_enasnGUI,pp1,pp3,pp4);
end
%=====================
% Go Back Up
%=====================
if rfrom_ > 9
 temp_=rfrom_-9;
 pp1='back ^';
 pp3=[x0+(2*dx) 0.01 0.1 dy_no];
 pp4=['close; ftenlrn2(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ',' num2str(seq_) ')'];
 ftscrpb(fig_enasnGUI,pp1,pp3,pp4);
end
%=====================
% Go to the Right
%=====================
if ftNNno_totSCAgbl > cto_
 temp_=cto_+1;
 pp1='more >';
 pp3=[x0+(4*dx) 0.01 0.1 dy_no];
 pp4=['close; ftenlrn2(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ',' num2str(seq_) ')'];
 ftscrpb(fig_enasnGUI,pp1,pp3,pp4);
end
%=====================
% Go Down
%=====================
if ftNNno_totSCAgbl > rto_
 temp_=rto_+1;
 pp1='more V';
 pp3=[x0+(6*dx) 0.01 0.1 dy_no];
 pp4=['close; ftenlrn2(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ',' num2str(seq_) ')'];
 ftscrpb(fig_enasnGUI,pp1,pp3,pp4);
end

%=====================
% Done
%=====================

ftscrpb(fig_enasnGUI,'Done',[x0+(8*dx) 0.01 0.1 0.07],'ftensave(''warm''); close;');

%
% end ftenlrn2.m
%
