%
% ftenlrn3.m
%
% =========================================================================  
%                          FlexTools(NN) for Matlab                          
%                             Copyright (c) 1996                             
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
%
% GUI for FlexTool(ENM) Learn Degree of Association (weight) Matrix
%

function ftenlrn3(pflag_, rfrom_, cfrom_, seq_)

%
% ENM
%
global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInSCAgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl
%
% NN 
%
global ftFigPos_bigVECgbl ftscr_cntSCAgbl  ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl  ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftENMwtsMATgbl     ftNNassocMATgbl
global ftENMasetFLGgbl ftNNtypeSCAgbl
global fneuron_ tneuron_ retval_

figpos_ = ftFigPos_bigVECgbl;

ftnn2_flag=pflag_;
save_scr_cnt_=ftscr_cntSCAgbl;
title_=['FlexTool (ENM) - Learn Weight Matrix'];
fig_nnwtGUI=ftfigure('fig_wtasnGUI',title_,figpos_,'on','figure');

fthelp(fig_nnwtGUI,'EN');

if ftNNtypeSCAgbl < 5
 pp2=str2mat(...
            'FlexTool allows the user to select the weights (strength of associations)',...
	    'between Neurons in a network to be learned using the Learn Weight Matrix. The rows',...
	    'and columns represent the neurons labeled 1,2,3,... Each cell/element',...
	    'represents an weight. The matrix consists of three parts: The Lower',...
	    'triangle, diagonal line, and the Upper triangle. ',...
	    'Note that you may specify the association in the FlexTool Association GUI.',...
	    '(a) Lower Triangle: The FORWARD weights are provided here. ex. [row,col]',...
	    '=[2,1]: Learning=1 implies that the weight which Neuron 2 is associated ');
 pp2=str2mat(pp2,...
	    'with Neuron will be learned by EA. Note: Neuron 2 uses the output of Neuron 1.',...
	    '(b) Diagonal: The SELF RECURRENCE weights are provided here. ex. [row,col]=',...
	    '[2,2]: Learn=0 implies that self recurrence weights for Neuron 2 wont be learned.',...
	    '(c) Upper Triangle: The RECURRENCE weights are provided here.',...
	    'ex. [row,col]=[1,2]: Learn=1 implies that the weight which Neuron 1 is associated',...
	    'with Neuron 2 will be learned using EA. Note: Neuron 1 uses the output of Neuron 2.',...
	    'This is a recurrence relationship since the output of Neuron 2 was',...
	    'generated using the input from Neuron 1. Refer tutorial for more info.',...
	    'Use the "more" and "back" buttons if you have more than 10 neurons.');
 pp2=str2mat(pp2,...
	    'Options are provided to automatically set All, Forward, Bias, or Recurrent set of',...
	    'weights between the neurons to 0/1/random/manually set values. Use this',...
            'where ever appropriate. ',...
	    'Note: A maximum of 10 neurons will be displayed at a time.',...
            'Use the options under the random pull down menu, to randomly select learning of  a ',...
            '% of the weights. This will be useful for post processing of the NN architectures.');

else
  pp2=str2mat(...
            'FlexTool allows the user to view the learning choice of the weights between',...
	    'Neurons in a network using the Learn Weights Matrix. The rows',...
	    'and columns represent the neurons labeled 1,2,3,... Each cell/element',...
	    'represents the learning choice for the corresponding weight.');
end

pp3= [0.95 0.05 0.95 0.7 0.04 0.002];
pp1='FlexTool(ENM) Help on Options';
ftscrhlp(fig_nnwtGUI,pp1,pp2,pp3,'left');

y0=0.54; x0=0.23; tx0=x0; dx_no1=0.14; dx_no=0.07; 
dx=.075; dy_no=0.04; dy_no2=0.05;
dy=0.07; dx2=x0-0.21; dy2_no=0.06; y0b=y0;

if ftNNtypeSCAgbl < 5
 pp1='Auto Set';
 pp3=[dx2 y0+dy dx_no1 0.05];
 ftscrtxt(fig_nnwtGUI,pp1,pp3);
 clear pp1;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 scr_cnt_ = ftscr_cntSCAgbl;
 fttmpscrcntSCA_ = ftscr_cntSCAgbl;

 pp1= str2mat(...
		'Auto Set',...
		'Manual');
 pp3=[dx2 y0+(0.25*dy) dx_no1 dy2_no];
 pp4=['ftENMasetFLGgbl = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaWtVECgbl(1,1)=ftENMasetFLGgbl;',...
   'close; ftenlrn3(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) ');'];
 pp5=ftENMasetFLGgbl; % Set for all
 pp6=[1:size(pp1,1)]';
 ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_); 
 clear pp1 pp3

 if ftENMasetFLGgbl==1
  pp1='Forward';
  pp3=[dx2 y0-(0.8*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(1.55*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaWtVECgbl(1,2)=retval_; if(retval_==3), retval_=rand(ftNNno_totSCAgbl);',...
   'else, retval_=ones(ftNNno_totSCAgbl)*(retval_-1); end; ',...
   'if(ftENMeaWtVECgbl(1,2)<4), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=fneuron_+1:ftNNno_totSCAgbl),',...
   'ftENMwts' num2str(seq_) 'MATgbl(tneuron_,fneuron_) = retval_(tneuron_,fneuron_); end; end;',...
   'close; ftenlrn3(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaWtVECgbl(1,2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Self Recur';
  pp3=[dx2 y0-(2.6*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(3.35*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaWtVECgbl(1,3)=retval_; if(retval_==3), retval_=rand(ftNNno_totSCAgbl); else,',...
   'retval_=ones(ftNNno_totSCAgbl)*(retval_-1); end; if(ftENMeaWtVECgbl(1,3)<4), for(fneuron_=1:ftNNno_totSCAgbl), ',...
   'ftENMwts' num2str(seq_) 'MATgbl(fneuron_,fneuron_) = retval_(fneuron_,fneuron_); end;',...
   'close; ftenlrn3(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaWtVECgbl(1,3); % Set for all
  pp6=[1:size(pp1,1)]'; 
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Recurrence';
  pp3=[dx2 y0-(4.4*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(5.15*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftENMeaWtVECgbl(1,4)=retval_; if(retval_==3), retval_=rand(ftNNno_totSCAgbl);',...
   'else, retval_ = ones(ftNNno_totSCAgbl)*(retval_ - 1); end;',...
   'if(ftENMeaWtVECgbl(1,4)<4), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=1:fneuron_-1),',...
   'ftENMwts' num2str(seq_) 'MATgbl(tneuron_,fneuron_) = retval_(tneuron_,fneuron_); end; end;',...
   'close; ftenlrn3(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) ',' num2str(seq_) '); end;'];
  pp5=ftENMeaWtVECgbl(1,4); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Random';
  pp3=[dx2 y0-(6.2*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'None',...
		'Forward',...
		'Self Recur',...
		'Recurrence');
  pp3=[dx2 y0-(6.95*dy) dx_no1 dy2_no];


   pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'if retval_ > 1, ftenask(4,' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=1; 	% None
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3 pp2 pp4 pp5 pp6
 end
else
 ftENMasetFLGgbl=1;
end
%================
% Loop through
%================
if ftNNtypeSCAgbl < 5
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_totSCAgbl;
  cfrom_ = 1; cto_ = rto_;
 else
  rto_ = rfrom_+8;
  cto_ = cfrom_+8;
 end;

 if rto_ > ftNNno_totSCAgbl, rto_= ftNNno_totSCAgbl; end
 if rfrom_ > ftNNno_totSCAgbl, rfrom_= ftNNno_totSCAgbl; end
 if cto_ > ftNNno_totSCAgbl, cto_= ftNNno_totSCAgbl; end
 if cfrom_ > ftNNno_totSCAgbl, cfrom_= ftNNno_totSCAgbl; end
else
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_inSCAgbl;
 else
  rto_ = rfrom_+8;
  cto_ = cfrom_+8;
 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_inSCAgbl, cto_= ftNNno_inSCAgbl; end
 if cfrom_ > ftNNno_inSCAgbl, cfrom_= ftNNno_inSCAgbl; end
end
  
if ftENMasetFLGgbl==1
  bigpp1_=[' To:     ' sprintf(' %3d    ', [cfrom_:1:cto_])];
  if cfrom_ > 9
    bigpp1_=[' To:    ' sprintf('%3d     ', [cfrom_:1:cto_])];
  end

  bigpp1_=str2mat(bigpp1_,' ',' Fr: ');

  for (fneuron_=rfrom_:rto_)
    if fneuron_ < 10
       pp11=sprintf('  %1d     ',fneuron_);
    elseif fneuron_ < 99
       pp11=sprintf(' %2d    ',fneuron_);
    else
       pp11=sprintf('%3d     ',fneuron_);
    end

    pp12=eval(['ftENMwts' num2str(seq_) 'MATgbl(fneuron_,cfrom_:cto_))']);
    bigpp1_=str2mat(bigpp1_,[pp11 pp12]);
  end;  %for fneuron_

  pp3= [0.65 0.20 0.95 0.15 0.04 0.002];
  pp1='FlexTool(ENM) Learn Weights Matrix';
  ftscrhlp(fig_nnwtGUI,pp1,bigpp1_,pp3,'left');

else

  gblcnt_=0;
  fttmpscrcntSCA_ = ftscr_cntSCAgbl+1;
  for (fneuron_=rfrom_:rto_)
   x0=0.23;

   pp1=num2str(fneuron_);
   pp3=[x0-0.0575 y0+0.005 0.05 0.04];
   ftscrtxt(fig_nnwtGUI,pp1,pp3);
   clear pp1;

   for (tneuron_=cfrom_:cto_)
   
     gblcnt_=gblcnt_+1;

     if(fneuron_==rfrom_)
   	pp1=num2str(tneuron_);
   	pp3=[x0+0.015 0.61 0.05 0.05];
	ftscrtxt(fig_nnwtGUI,pp1,pp3);
	clear pp1;
     end; %if

     if(seq_==1)
	     pp1= num2str(ftENMwts1MATgbl(fneuron_,tneuron_),3);
     elseif(seq_==2)
	     pp1= num2str(ftENMwts2MATgbl(fneuron_,tneuron_),3);
     elseif(seq_==3)
	     pp1= num2str(ftENMwts3MATgbl(fneuron_,tneuron_),3);
     elseif(seq_==4)
	     pp1= num2str(ftENMwts4MATgbl(fneuron_,tneuron_),3);
     end; %if

     pp3=[x0 y0 dx_no dy_no];
     pp4=['retval_ = str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));',...
      'ftENMwts' num2str(seq_) 'MATgbl(' num2str(fneuron_) ',' num2str(tneuron_) ') = retval_;'];

     if(ftNNassocMATgbl(fneuron_,tneuron_)==0)
	eval(['ftENMwts' num2str(seq_) 'MATgbl(fneuron_,tneuron_)=0']);
	ftscrtxt(fig_nnwtGUI,' ',pp3);
     else
		ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
		scr_cnt_ = ftscr_cntSCAgbl;
		ftscredt(fig_nnwtGUI,pp1,pp3,pp4,scr_cnt_);
     end;

     clear pp1 pp3
     x0=x0+dx;
   end; %for tneuron_
   y0=y0-dy_no2;
  end;  %for fneuron_
end %ftENMasetFLGgbl

x0=tx0;

%=====================
% Go Back to the Left
%=====================
if cfrom_ > 9
 temp_=cfrom_-9;
 pp1='back <';
 pp3=[x0 0.01 0.1 0.07];
 pp4=['close; ftenlrn3(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ',' num2str(seq_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go Back Up
%=====================
if rfrom_ > 9
 temp_=rfrom_-9;
 pp1='back ^';
 pp3=[x0+(2*dx) 0.01 0.1 0.07];
 pp4=['close; ftenlrn3(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ',' num2str(seq_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go to the Right
%=====================
if ftNNno_totSCAgbl > cto_
 temp_=cto_+1;
 pp1='more >';
 pp3=[x0+(4*dx) 0.01 0.1 0.07];
 pp4=['close; ftenlrn3(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ',' num2str(seq_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go Down
%=====================
if ftNNno_totSCAgbl > rto_
 temp_=rto_+1;
 pp1='more V';
 pp3=[x0+(6*dx) 0.01 0.1 0.07];
 pp4=['close; ftenlrn3(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ',' num2str(seq_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end

%=====================
% Done
%=====================

ftscrpb(fig_nnwtGUI,'Done',[x0+(8*dx) 0.01 0.1 0.07],'ftensave(''warm''); close;');

ftscr_cntSCAgbl=save_scr_cnt_;

%
% end ftnnwts.m
%
