%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% ftenmin                          ftenmin.m                 ftenmin
% =========================================================================  
%                          FlexTools(ENM) for Matlab
%                             Copyright (c) 1996                              
%                       Flexible Intelligence Group (FIG)                            
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                 
% =========================================================================  
% =========================================================================   
%  PURPOSE   
%         Do certain initialization operations for ENM
%  .........................................................................   
%  GIVEN  
%	  User's choices as to what all should be learned by GA
%  .........................................................................   
%  OPERATION   
%
%  	  Identify indices
%  .........................................................................   
%  RETURNS   
%         Nothing. Global indices gets set up.
%  .........................................................................   
%  APPLICATION   
%         Fuzzy Systems
%  .........................................................................   
%  USE WITH   
%   
%       MUST   
%               FTmfm.m, FlexTools(FS), FlexTools(ENM) Matlab   
%       MAY   
%               FlexTools(GA)   
%  USES
%  ========================================================================   
%   SYNTAX  /  USAGE  
%   ftenmin(seq)
%  ========================================================================  

%  DECLARATION   
%   ftenmin(seq)   
   
%  ========================================================================  
%   DESCRIPTION -  FLEXTOOL APPROACH  
%
%   
%  ========================================================================   
%  VARIABLE DICTIONARY   
%
%  ========================================================================   
%  ALGORITHM   
%   
%     10 identify indices for loading ftFSinlMATgbl, ftFSoutlMATgbl, and ftEFMparmMATgbl
%        matrices
%     20 do some other initialization work also.
%  ========================================================================   
%  CODE
%
% GLOBAL

function outs=ftenmin(seq)

%% ENM 
global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInVECgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl     ftENMlrnCNTgbl
global ftENMFLGgbl      ftENM2FLGgbl
global ftNNfnflagSCAgbl ftnndef_flag
global ftENMltypeFLGgbl
global ftENMrwtlIDXgbl    ftENMcwtlIDXgbl    ftENMrassnlIDXgbl   
global ftENMcassnlIDXgbl  ftENMwtbufMATgbl   ftENMrbfOPTgbl

%% NEURAL NETWORK
global ftNNbase_minSCAgbl ftNNbase_maxSCAgbl ftNNbase_diffSCAgbl
global ftNNno_inSCAgbl    ftNNno_outSCAgbl   ftNNactno_inSCAgbl
global ftNNpp_typeMATgbl  ftNNinwtsVECgbl    ftNNin_wtsVECgbl
global ftscr_cntSCAgbl ftflag_edtGUI
global ftNNtitleVECgbl ftNNtypeSCAgbl
global ftNNspecialSCAgbl ftNNpp_specMATgbl
global ftNNfn_errMATgbl ftNNer_typeSCAgbl ftNNpp_ertypeMATgbl
global ftNNer_betaSCAgbl
global ftNNlearnSCAgbl ftNNpp_lrnMATgbl
global ftNNconvSCAgbl ftNNpp_cnvMATgbl ftNNpp_actMATgbl
global ftNNno_hidSCAgbl ftNNno_totSCAgbl
global ftNNh_layerSCAgbl ftNNpp_hlayerMATgbl ftNNno_hidVECgbl
global ftNNlrSCAgbl ftNNmrSCAgbl
global ftNNn_epSCAgbl ftNNe_thSCAgbl
global ftNNv_pcntSCAgbl ftNNasetFLGgbl
global ftNNassocMATgbl    ftNNassnCNTgbl   ftNNassocOPTgbl
global ftNNweightMATgbl  ftNNweightOPTgbl 
global ftNNwrnd_pcntSCAgbl ftNNfn_actMATgbl ftNNno_in_userSCAgbl

global ftNNn_inameVECgbl ftNNn_imaxVECgbl ftNNn_iminVECgbl ftNNn_itypeVECgbl
global ftNNn_hnameVECgbl ftNNn_hmaxVECgbl ftNNn_hminVECgbl ftNNn_htypeVECgbl
global ftNNn_onameVECgbl ftNNn_omaxVECgbl ftNNn_ominVECgbl ftNNn_otypeVECgbl

global ftNNbase_maxSCAgbl ftNNbase_minSCAgbl ftNNbase_resSCAgbl

global ftNNn_iparmVECgbl ftNNn_hparmVECgbl ftNNn_oparmVECgbl
global ftNNtrainFLGgbl ftNNsimFLGgbl ftNNst_flagSCAgbl
global ftNNv_stringMATgbl ftNNv_countSCAgbl

global nn_in nn_desired nn_out rbf_mean_ rbf_sd_
global ftNNrbf_sdMATgbl

%% EA
global ftGApslopeVECgbl ftGApcVECgbl ftGAch_flagSCAgbl
global fts_tableMATgbl ftm_tableMATgbl ftGAp_typeVECgbl
global ftGApmaxVECgbl     ftGApminVECgbl      ftGApresVECgbl   
global ftGAnopSCAgbl      ftGAnoofpeaksSCAgbl ftGAnichtestSCAgbl
global ftGA_choiceSCAgbl  ftGAgapVECgbl       ftGAnselectSCAgbl 
global ftGAtsizeSCAgbl    ftGAnpopSCAgbl      ftGAsspopSCAgbl 
global ftGAngenSCAgbl     ftGAregenSCAgbl     
global ftGApcrossSCAgbl   ftGApmutateSCAgbl   ftGAncrossSCAgbl 
global ftGAp1SCAgbl       ftGAp2SCAgbl     
global FTdel_range        FTdel_partitions    FTdel_fmfparm
global ftGAlchromSCAgbl   ftENMlchromrgbl     ftGAnbitsVECgbl
global ftGApcVECgbl       ftGApresuVECgbl     ftGAmchildSCAgbl

%% MODEL, CI, LEARNING, ETC
global ftMaxModelCNTgbl  ftModelCNTgbl    ftModelIDXgbl
global ftModelNameMATgbl ftModelDBVECgbl  ftModelPartCntVECgbl
global ftMaxPartCNTgbl   ftPartTypeVECgbl ftPartCNTgbl
global ftPartIDXgbl      ftPartNameMATgbl ftPartDBVECgbl 
global ftModelTypeVECgbl ftSequenceVECgbl ftEApartCNTgbl
global ftPartInfoMATgbl  ftParmCNTgbl     ftParmIDXgbl

global ftParmUserCNTgbl  ftParmUserMATgbl ftParmUserNameMATgbl
global ftPartUserCNTgbl  ftUserInfoMATgbl ftParmUserMATgbl   
global ftParmUserFLGgbl   ftParmUserVECgbl
global ftInputScaleVECgbl ftOutputScaleVECgbl
global ftIScaleValMATgbl  ftOScaleValMATgbl 
global ftIScaleFLGgbl     ftOScaleFLGgbl

%====================================================================

if (seq<=0)
   outs = 0;
else
   outs = 1;
end;

%
% Mapping provided from user interface to the NN engine
%
% This function has to be run every time a NN system is created
% or modified (ie the relevant selections!)
%

%
% Define parameter ranges
%
%ftenbase;

% Accomodate CI
% add the following!
% if(ftnewModelFLGgbl==1)
    % ftcigen;
    
    if isempty(ftGA_choiceSCAgbl)==1        
       ftGA_choiceSCAgbl=1;
    end

    ftPartCNTgbl=0;
    ftPartIDXgbl=0;
    ftPartInfoMATgbl=zeros(6,ftMaxPartCNTgbl);

    ftParmCNTgbl=0;
    ftParmIDXgbl=0;

    ftGApminVECgbl=0;
    ftGApmaxVECgbl=0;
    ftGApresVECgbl=0;
    ftGAp_typeVECgbl=0;
    
    ftENMlrnCNTgbl=0;
    frm_=1;
% else
%   frm_ = 
% end; %if
ftNNin_wtsVECgbl = zeros(1,ftNNno_in_userSCAgbl);

% 
% find the difference (distance) between the min and max of the
% base set
%
ftNNbase_diffSCAgbl = ftNNbase_maxSCAgbl - ftNNbase_minSCAgbl;

%%%%%%%%%%%%%%%%%%%%%%%
% settings for Flex-GA
%%%%%%%%%%%%%%%%%%%%%%%
max_Nbits=12;	%maximum # of bits per variable 
max_rows=8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if EA learning
if(ftENMSeqChVECgbl(1,seq)==3)
 
  % WEIGHTS
  % First identify the weights that have to be learned using EA
  eval(['[ftENMrwtlIDXgbl, ftENMcwtlIDXgbl] = find(ftENMwts' num2str(seq) 'MATgbl == 1);']);
  % Deterimine the total number of these weights (count).
  tmp_ = length(ftENMrwtlIDXgbl);
  eval(['ftENMwts' num2str(seq) 'CNTgbl = tmp_;']);

  % Update pmin, pmax, pres, ptype info for EA. 

  ftGApmaxVECgbl(frm_:tmp_)     = ones(1,tmp_)*ftNNbase_maxSCAgbl;
  ftGApminVECgbl(frm_:tmp_)     = ones(1,tmp_)*ftNNbase_minSCAgbl;
  ftGApresVECgbl(frm_:tmp_)	= ones(1,tmp_)*ftNNbase_resSCAgbl;
  ftGApresuVECgbl 		= ftGApresVECgbl;
  ftGAp_typeVECgbl(frm_:tmp_)	= ones(1,tmp_);
  if(ftGA_choiceSCAgbl==4) % Flex-GA
    ftGAp_typeVECgbl(frm_:tmp_)	= ones(1,tmp_)*3;
  end; % if

  % Update global learning count variable.
  ftENMlrnCNTgbl = ftENMlrnCNTgbl + tmp_;

  % CI 
  if(tmp_)
	  ftciupd(tmp_, 4, 1, 1, 0);
	  ftnopVECgbl(frm_) = tmp_;
  end; % if
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % CONNECTIONS
  % First identify the weights that have to be learned using EA
  eval(['[ftENMrassnlIDXgbl, ftENMcassnlIDXgbl] = find(ftENMassn' num2str(seq) 'MATgbl == 1);']);
  % Deterimine the total number of these weights (count).
  tmp_ = length(ftENMrassnlIDXgbl);
  eval(['ftENMassn' num2str(seq) 'CNTgbl = tmp_;']);
 
  % Update pmin, pmax, pres, ptype info for EA. 
  ftGApmaxVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_);
  ftGApminVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = zeros(1,tmp_);
  ftGApresVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_);
  ftGApresuVECgbl 					= ftGApresVECgbl;
  ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)= ones(1,tmp_);
  % Update global learning count variable.
  ftENMlrnCNTgbl = ftENMlrnCNTgbl + tmp_;

  % CI 
  if(tmp_)
	  ftciupd(tmp_, 17, 1, 1, 0);
	  ftnopVECgbl(frm_+1) = tmp_;
  end; % if
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % INPUTS (learn best set of inputs by specifying weightage 1/0)
  if(ftENMselInVECgbl(seq) == 2)
    tmp_ = ftNNno_in_userSCAgbl;
    % Update pmin, pmax, pres, ptype info for EA. 
    ftGApmaxVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_);
    ftGApminVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = zeros(1,tmp_);
    ftGApresVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_);
    ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)= ones(1,tmp_);
    ftGApresuVECgbl 					  = ftGApresVECgbl;
    % Update global learning count variable.	
    ftENMlrnCNTgbl = ftENMlrnCNTgbl + tmp_;	
    % CI 
    if(tmp_)
	    ftciupd(tmp_, 18, 1, 1, 0);
	    ftnopVECgbl(frm_+2) = tmp_;
    end; % if
  end; %if
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % If RBF NN learning, learn the SD of the RBF nets.

 if (ftNNtypeSCAgbl == 14)
    if(ftENMrbfOPTgbl == 1)     % Neuron Level
    	[nh_,ni_] = size(nn_in);
    elseif(ftENMrbfOPTgbl == 2) % Network Level
    	[nh_,ni_] = size(nn_in);
	nh_=1;
    end;
    scale_=max(abs(max(nn_in)));
    tmp_ = nh_*ni_;
    ftGApmaxVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_)*(ftNNbase_diffSCAgbl/2)*scale_;
    ftGApminVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_)*0.01;
    ftGApresVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)  = ones(1,tmp_)*0.001*scale_;
    ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+tmp_)= ones(1,tmp_)*3;
    ftGApresuVECgbl 					  = ftGApresVECgbl;
    % Update global learning count variable.	
    ftENMlrnCNTgbl = ftENMlrnCNTgbl + tmp_;	
    % CI 
    if(tmp_)
	    ftciupd(tmp_, 20, 1, 1, 0);
	    ftnopVECgbl(frm_+3) = tmp_;
    end; % if
  end; %if
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
end; % if
%%%%%%%%%

%
% reset i (point i to the end of the string)
%
i=ftENMlrnCNTgbl;

%
% Input Scaling
%
if(ftIScaleFLGgbl)
	ftGApminVECgbl(i+1:ftNNno_in_userSCAgbl+i) = ftIScaleValMATgbl(1,1:ftNNno_in_userSCAgbl);
	ftGApmaxVECgbl(i+1:ftNNno_in_userSCAgbl+i) = ftIScaleValMATgbl(2,1:ftNNno_in_userSCAgbl);
	ftGApresVECgbl(i+1:ftNNno_in_userSCAgbl+i) = ftIScaleValMATgbl(3,1:ftNNno_in_userSCAgbl);
        if(ftGA_choiceSCAgbl == 4) % Flex-GA
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+ftNNno_in_userSCAgbl)= ones(1,ftNNno_in_userSCAgbl)*3;
	else
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+ftNNno_in_userSCAgbl)= ones(1,ftNNno_in_userSCAgbl);
	end; % if
	ftENMlrnCNTgbl           	      = ftENMlrnCNTgbl + ftNNno_in_userSCAgbl;
	i		    		      = i+ftNNno_in_userSCAgbl;
	ftENMlrnCNTgbl	    		      = ftENMlrnCNTgbl+ftNNno_in_userSCAgbl;
	ftciupd(ftNNno_in_userSCAgbl, 9, 3, 1, 0);
end;
%
% Ouput Scaling
%
if(ftOScaleFLGgbl)
	ftGApminVECgbl(i+1:ftNNno_outSCAgbl+i) = ftOScaleValMATgbl(1,1:ftNNno_outSCAgbl);
	ftGApmaxVECgbl(i+1:ftNNno_outSCAgbl+i) = ftOScaleValMATgbl(2,1:ftNNno_outSCAgbl);
	ftGApresVECgbl(i+1:ftNNno_outSCAgbl+i) = ftOScaleValMATgbl(3,1:ftNNno_outSCAgbl);
        if(ftGA_choiceSCAgbl == 4) % Flex-GA
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+ftNNno_outSCAgbl)= ones(1,ftNNno_outSCAgbl)*3;
	else
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+ftNNno_outSCAgbl)= ones(1,ftNNno_outSCAgbl);
	end; % if
	i		       		       = i+ftNNno_outSCAgbl;
	ftENMlrnCNTgbl	       		       = ftENMlrnCNTgbl + ftNNno_outSCAgbl;
	ftciupd(ftNNno_outSCAgbl, 10, 3, 1, 0);
end;

%
% ADD User Specific parameters here
%
k=0;
for(cnt=1:ftPartUserCNTgbl)
   if(ftParmUserFLGgbl)
	howmany=ftUserInfoMATgbl(5,cnt);
	ftGApminVECgbl(i+1:howmany+i) = ftParmUserMATgbl(1,k+1:k+howmany);
	ftGApmaxVECgbl(i+1:howmany+i) = ftParmUserMATgbl(2,k+1:k+howmany);
	ftGApresVECgbl(i+1:howmany+i) = ftParmUserMATgbl(3,k+1:k+howmany);
        if(ftGA_choiceSCAgbl == 4) % Flex-GA
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+howmany)= ones(1,howmany)*3;
	    ftGAmchildSCAgbl=2;
	else
            ftGAp_typeVECgbl(ftENMlrnCNTgbl+1:ftENMlrnCNTgbl+howmany)= ones(1,howmany);
	end; % if
	i		       	      = i+howmany;
	ftENMlrnCNTgbl	       	      = ftENMlrnCNTgbl + howmany;
	k		       	      = k+howmany;
	ftciupd(howmany, 16, ftUserInfoMATgbl(2,cnt), 1, 0);
   end;
end;

% Compute number of parameters nop.
%
   ftGAnopSCAgbl	= ftENMlrnCNTgbl;

%----------------   
% Not Flex-GA   
%----------------               
  if ftGA_choiceSCAgbl ~=4 
 
   %
   % Compute range, ftGAnbitsVECgbl, and lchrom.
   %
   range=0;
   ftGAnbitsVECgbl=0;

   range   	     = (ftGApmaxVECgbl-ftGApminVECgbl)./ftGApresVECgbl;
   ftGAnbitsVECgbl   = ceil(log(range+1.0)./log(2.0));
   ftGApresuVECgbl   = ftGApresVECgbl;
   for(i_=1:ftGAnopSCAgbl)
     if(ftGApresVECgbl(i_) ~= 1)
       ftGApresVECgbl(i_)   = (ftGApmaxVECgbl(i_)-ftGApminVECgbl(i_))/((2^ftGAnbitsVECgbl(i_))-1);
     end;
   end;
   ftGAlchromSCAgbl  = sum(ftGAnbitsVECgbl);
   ftENMlchromrgbl   = sum(ftGAnbitsVECgbl(1:ftENMlrnCNTgbl));

   % choose slope and y intercept   
   %---------------------------------  
    ftGApslopeVECgbl = ftGApresVECgbl;   
    ftGApcVECgbl     = ftGApminVECgbl;       

  else % Flex-GA

     %------------------------------------------------------------  
     % ftGApcVECgbl,ftGApslopeVECgbl,ftGApresVECgbl,ftGAnbitsVECgbl,mean_table,sigma_table,etc.   
     %------------------------------------------------------------
     ftm_tableMATgbl=zeros(max_rows,ftGAnopSCAgbl);
     fts_tableMATgbl=zeros(max_rows,ftGAnopSCAgbl);

     for j=1:ftGAnopSCAgbl
	if ftGAp_typeVECgbl(j) == 1	%Integer Type
      		ftGApcVECgbl(j)     = ftGApminVECgbl(j);
      		ftGAnbitsVECgbl(j)  = ceil(log2(ftGApmaxVECgbl(j)-ftGApminVECgbl(j)+1));
      		ftGApslopeVECgbl(j) = (ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAnbitsVECgbl(j)-1);
  	end; %if

	if ftGAp_typeVECgbl(j) == 2	%Real Type with discrete values
		ftGApcVECgbl(j)     = ftGApminVECgbl(j);
		ftGApslopeVECgbl(j) = ftGApresVECgbl(j);
		ftGAnbitsVECgbl(j)  = ceil(log2((ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/ftGApresVECgbl(j)));
		ftGApslopeVECgbl(j) = (ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAnbitsVECgbl(j)-1);
	end; %if 

	if ftGAp_typeVECgbl(j) > 2	%Real Type with continuous values
		for i=1:2^(ftGAp_typeVECgbl(j))
		      ftGApcVECgbl(j)      = 0;
		      ftGApslopeVECgbl(j)  = (ftGApmaxVECgbl(j)-ftGApminVECgbl(j))/(2^ftGAp_typeVECgbl(j)-1);
		      ftm_tableMATgbl(i,j) = ftGApminVECgbl(j)+(i-1)*ftGApslopeVECgbl(j);
		      fts_tableMATgbl(i,j) = ftGApslopeVECgbl(j)/2;
		      ftGAnbitsVECgbl(j)   = ftGAp_typeVECgbl(j);     
		end; %for i
     	end; %if
	ftGAlchromSCAgbl=sum(ftGAnbitsVECgbl);
    end; %for j

  end; %if Flex-GA

ftfp_def('fp_cold.mat',2); 
%====================================================================

%  ========================================================================   
%  CAUTION   
%  ========================================================================   
%  EXAMPLE   
   
%  ========================================================================   
%  SEE ALSO   
%   
%       FlexTools(GA)   
%  ========================================================================   
%  REFERENCE   
%    
%  Guidelines for Evolutionary Fuzzy Modeling
%  FIG LLC, Tuscaloosa, AL 35486-1477, USA, FIGLLC@AOL.COM
%
%  K. Krishnakumar, Antony Satyadas   
%  Discovering Multiple Fuzzy Models using MFMCN Algorithm   
%  ACM Computing Week Symposium of Applied Computing (SAC) Conference,  
%  Nashville, TN, March 1995.   
%  ==========================================================================   
% (c) Flexible Intelligence Group (FIG)   
% END ftenmin.m     
% ftenmin                           ftenmin.m                  ftenmin
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


