%
% FTenmlrn.m
%
% =========================================================================  
%                          FlexTools(ENM) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996
% =========================================================================  
% 
% Specify Learning Scheme extends for The Neural System
% choices, and other activities such as pop up menu for
% choice of Neural model(if opt1==20)
%

function ftenmlrn(opt1, opt2, opt3, seq4)

%
% opt1 : some occasions: set flags
% opt2 : some occasions: Connections
% opt3 : some occasions: Weights
% seq4 : some occasions: index of sequencer
%

global ftcolor_bc1VECgbl  ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl  ftcolor_fc2VECgbl 
global ftXYscaleVECgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl 
global ftFigPos_smallVECgbl ftFigPos_VsmallVECgbl
global ftflag_edtGUI      ftscr_cntSCAgbl    ftenmGUI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ENM Variables
%%%%%%%%%%%%%%%%
global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInVECgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl     ftENMwtbufMATgbl
global ftENMmmodelOPTgbl
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EA variables
%%%%%%%%%%%%%%
global ftGApmaxVECgbl     ftGApminVECgbl      ftGApresVECgbl   
global ftGAnopSCAgbl      ftGAnoofpeaksSCAgbl ftGAnichtestSCAgbl
global ftGAch_flagSCAgbl  ftGAgapVECgbl       ftGAnselectSCAgbl 
global ftGAtsizeSCAgbl    ftGAnpopSCAgbl      ftGAsspopSCAgbl 
global ftGAngenSCAgbl     ftGAregenSCAgbl     
global ftGApcrossSCAgbl   ftGApmutateSCAgbl   ftGAncrossSCAgbl 
global ftGAp1SCAgbl       ftGAp2SCAgbl     
global FTdel_range        FTdel_partitions    FTdel_fmfparm

global ftGApslopeVECgbl   ftGApcVECgbl        ftGAch_flagSCAgbl 
global ftGAFLGgbl         fts_tableMATgbl     ftm_tableMATgbl 
global ftGAp_typeVECgbl   
global ftENMFLGgbl      ftENM2FLGgbl
global ftNNfnflagSCAgbl ftnndef_flag
global ftENMltypeFLGgbl
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NN Variables
%%%%%%%%%%%%%%
global ftNNpp_typeMATgbl
global ftscr_cntSCAgbl ftflag_edtGUI
global ftNNtitleVECgbl ftNNtypeSCAgbl
global ftNNspecialSCAgbl ftNNpp_specMATgbl
global ftNNfn_errMATgbl ftNNer_typeSCAgbl ftNNpp_ertypeMATgbl
global ftNNer_betaSCAgbl
global ftNNlearnSCAgbl ftNNpp_lrnMATgbl
global ftNNconvSCAgbl ftNNpp_cnvMATgbl ftNNpp_actMATgbl
global ftNNno_inSCAgbl ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNh_layerSCAgbl ftNNpp_hlayerMATgbl ftNNno_hidVECgbl
global ftNNlrSCAgbl ftNNmrSCAgbl
global ftNNn_epSCAgbl ftNNe_thSCAgbl
global ftNNv_pcntSCAgbl ftNNasetFLGgbl
global ftNNassocMATgbl    ftNNassnCNTgbl   ftNNassocOPTgbl
global ftNNweightMATgbl  ftNNweightOPTgbl 
global ftNNwrnd_pcntSCAgbl ftNNfn_actMATgbl

global ftNNn_inameVECgbl ftNNn_imaxVECgbl ftNNn_iminVECgbl ftNNn_itypeVECgbl
global ftNNn_hnameVECgbl ftNNn_hmaxVECgbl ftNNn_hminVECgbl ftNNn_htypeVECgbl
global ftNNn_onameVECgbl ftNNn_omaxVECgbl ftNNn_ominVECgbl ftNNn_otypeVECgbl

global ftNNbase_maxSCAgbl ftNNbase_minSCAgbl ftNNbase_resSCAgbl

global ftNNn_iparmVECgbl ftNNn_hparmVECgbl ftNNn_oparmVECgbl
global ftNNtrainFLGgbl ftNNsimFLGgbl ftNNst_flagSCAgbl
global ftNNv_stringMATgbl ftNNv_countSCAgbl

global nn_in nn_desired nn_out rbf_mean_ rbf_sd_

[rtmp_,ctmp_] = find(ftNNassocMATgbl==1);
[rsiz_,csiz_] = size(ftNNweightMATgbl);
tmp_cnt_      = length(rtmp_);
tot_cnt_      = length(rsiz_);

%%%%%%%%%%%%%%%%%%%%%%%%
%% OPT1 FOR INIT SETUPS
%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%
if (opt1 == 1)
%%%%%%%%%%%%%%
% Complete NN system. This implys
% All weights, and input variable selection
% All we do here is set some flags.

	% Doesnt call the Sequencer. Just sets the first
 	% column to the appropriate values.
	ftENMSeqChVECgbl(1,1) = 3; 		% Will use EA for learning
%	ftENMeaConVECgbl(1,1) = 1; 		% Will not learn Connections
	ftENMeaWtVECgbl (1,1) = 2; 		% Will learn all weights
	ftENMselInVECgbl(1,1) = 2; 		% Will learn the best input var.
	ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; % Number of EA generations
						% currently this is the 
						% stopping criteria.
end % if

%%%%%%%%%%%%%%
if (opt1 == 2)
%%%%%%%%%%%%%%
% Topology of the NN system. This implys
% All Connections
% All we do here is set some flags.

	% Doesnt call the Sequencer. Just sets the first
 	% column to the appropriate values.
	ftENMSeqChVECgbl(1,1) = 3; 		% Will use EA for learning
	ftENMeaConVECgbl(1,1) = 2; 		% Will learn All Connections
%	ftENMeaWtVECgbl (1,1) = 1; 		% Will not learn weights
%	ftENMselInVECgbl(1,1) = 1; 		% Will not learn the best input var.
	ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; % Number of EA generations
						% currently this is the 
						% stopping criteria.
end % if	

%%%%%%%%%%%%%%
if (opt1 == 3)
%%%%%%%%%%%%%%
% All the Weights of the NN system. 
% All we do here is set some flags.

	% Doesnt call the Sequencer. Just sets the first
 	% column to the appropriate values.
	ftENMSeqChVECgbl(1,1) = 3; 		% Will use EA for learning
%	ftENMeaConVECgbl(1,1) = 1; 		% Will not learn Connections
	ftENMeaWtVECgbl (1,1) = 2; 		% Will learn all weights
%	ftENMselInVECgbl(1,1) = 1; 		% Will not learn the best input var.
	ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; % Number of EA generations
						% currently this is the 
						% stopping criteria.
end % if	

%%%%%%%%%%%%%%
if (opt1 == 5)
%%%%%%%%%%%%%%
% Best Input variable selection
% All we do here is set some flags.

	% Doesnt call the Sequencer. Just sets the first
 	% column to the appropriate values.
	ftENMSeqChVECgbl(1,1) = 3; 		% Will use EA for learning
	ftENMSeqChVECgbl(1,2) = 2;              % Then NN Learning
	ftENMselInVECgbl(1,1) = 2; 		% Will learn the best input var.
	ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl; % Number of EA generations
						% currently this is the 
						% stopping criteria.
	ftENMSeqTimeVECgbl(1,2)=ftNNn_epSCAgbl; % No. of epochs from NN
	ftENMSeqCNTgbl         =2;
end % if	

%%%%%%%%%%%%%%
if (opt1 == 6)
%%%%%%%%%%%%%%
% Input variable selection
% All we do here is set some flags.

   ftENMeaWtVECgbl(1,1)  = 2; 
   ftENMselInVECgbl(2)   = 2;
   ftENMSeqChVECgbl(1,1) = 3; 		% Will use EA for learning
   ftENMSeqChVECgbl(1,2) = 3;
   ftENMSeqTimeVECgbl(1,1)=44;
   ftENMSeqTimeVECgbl(1,2)=33;
   ftENMSeqCNTgbl         =2;
end % if opt1	

% RESET OPTION
if (opt1 == 7)

    for(i=1:4)	
	ftENMeaConVECgbl(1,i) = 1; 		% Will not learn Connections
	ftENMeaWtVECgbl (1,i) = 1; 		% Will not learn weights
	ftENMSeqChVECgbl(1,i) = 1;
	ftENMSeqTimeVECgbl(1,i)=1; 		% Number of EA generations
						% currently this is the 
						% stopping criteria.
        
	eval(['ftENMassn' num2str(i) 'CNTgbl = 0;']);
	eval(['ftENMassn' num2str(i) 'MATgbl = zeros(rsiz_, csiz_);']);
	eval(['ftENMwts'  num2str(i) 'CNTgbl = 0;']);
	eval(['ftENMwts'  num2str(i) 'MATgbl = zeros(rsiz_, csiz_);']);
        ftENMselInVECgbl(i)                  = 1; % Will not learn the best input var.
   end; % for i	
   ftENMSeqCNTgbl = 1;

end; % if

%%%%%%%%%%%%%%%%%%%%%%%%
%% OPT2 FOR CONNECTIONS
%%%%%%%%%%%%%%%%%%%%%%%%

if (opt2 == 1)
%%%%%%%%%%%%%%
% EA NONE
% None of the Connections will be learned. Hence
% the learning matrix should be set to 0s. 
%
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = 0;']);
	eval(['ftENMassn' num2str(seq4) 'MATgbl = zeros(rsiz_,csiz_);']);	
end; %if

%%%%%%%%%%%%%%
if (opt2 == 2)
%%%%%%%%%%%%%%
% EA ALL
% All the relevant Connections will be learned by EA. Hence
% the learning matrix should be set to 1s. 
%
      	eval(['ftENMassn' num2str(seq4) 'MATgbl = zeros(rsiz_, csiz_);']);
	for(fneuron_=1:rsiz_)
	   for(tneuron_=1:csiz_)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
	      	eval(['ftENMassn' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = tmp_cnt_;']);
end; %if

%%%%%%%%%%%%%%
if (opt2 == 3)
%%%%%%%%%%%%%%
% EA ALL Forward Connections
% All the Forward relevant Connections will be learned by EA. Hence
% the lower diagonal matrix should be set to 0s. 
%
	eval(['ftENMassn' num2str(seq4) 'MATgbl= zeros(rsiz_,csiz_);']);
	tmpCnt_ = 0;
	for(fneuron_=1:rsiz_)
	   for(tneuron_=fneuron_+1:csiz_)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
		tmpCnt_ = tmpCnt_ + 1;
	      	eval(['ftENMassn' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = tmpCnt_;']);
end; %if

%%%%%%%%%%%%%%
if (opt2 == 4)
%%%%%%%%%%%%%%
% EA ALL Recurrent Connections
% All the Recurrent relevant Connections will be learned by EA. Hence
% the lower diagonal matrix should be set to 0s. 
%

	eval(['ftENMassn' num2str(seq4) 'MATgbl= zeros(rsiz_,csiz_);']);
	tmpCnt_ = 0;
	for(fneuron_=1:rsiz_)
	   for(tneuron_=1:fneuron_-1)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
		tmpCnt_ = tmpCnt_+1;
	      	eval(['ftENMassn' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = tmpCnt_;']);
end; %if

%%%%%%%%%%%%%%
if (opt2 == 5)
%%%%%%%%%%%%%%
% EA Manual
% Will pop up the learning matrix GUI so that you can
% select the connections you want EA to learn, manually.
%
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = tot_cnt_;']);
	eval(['ftENMassn' num2str(seq4) 'MATgbl = zeros(rsiz_, csiz_);']);
	ftenlrn2(1,1,1,seq4);
end; %if

%%%%%%%%%%%%%%%%%%%%%%%%
%% OPT3 FOR WEIGHTS
%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%
if (opt3 == 1)
%%%%%%%%%%%%%%
% EA NONE
% None of the Weights will be learned. Hence
% the learning matrix should be set to 0s. 
%
	eval(['ftENMwts' num2str(seq4) 'CNTgbl = 0;']);
	eval(['ftENMwts' num2str(seq4) 'MATgbl = zeros(rsiz_, csiz_);']);
end; %if

%%%%%%%%%%%%%%
if (opt3 == 2)
%%%%%%%%%%%%%%
% EA ALL
% All the relevant Weights will be learned by EA. Hence
% the learning matrix should be set to 1s. 
%
	eval(['ftENMwts' num2str(seq4) 'MATgbl = zeros(rsiz_,csiz_);']);
	tmpCnt_ = 1;
	for(fneuron_=1:rsiz_)
	   for(tneuron_=1:csiz_)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
	      	eval(['ftENMwts' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
		tmpCnt_ = tmpCnt_+1;
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMwts' num2str(seq4) 'CNTgbl = tmpCnt_;']);
	
end; %if

%%%%%%%%%%%%%%
if (opt3 == 3)
%%%%%%%%%%%%%%
% EA ALL Forward Weights
% All the Forward relevant weights will be learned by EA. Hence
% the lower diagonal matrix should be set to 0s. 
%
	eval(['ftENMwts' num2str(seq4) 'MATgbl = zeros(rsiz_,csiz_);']);
	tmpCnt_ = 0;
	for(fneuron_ = rsiz_)
	   for(tneuron_=fneuron_+1:csiz_)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
		tmpCnt_ = tmpCnt_+1;
	      	eval(['ftENMwts' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMwts' num2str(seq4) 'CNTgbl = tmpCnt_;']);
end; %if

%%%%%%%%%%%%%%
if (opt3 == 4)
%%%%%%%%%%%%%%
% EA ALL Recurrent Weights
% All the Recurrent relevant Weights will be learned by EA. Hence
% the lower diagonal matrix should be set to 0s. 
%
	eval(['ftENMwts' num2str(seq4) 'MATgbl = zeros(rsiz_,csiz_);']);
	tmpCnt_ = 0;
	for(fneuron_=1:rsiz_)
	   for(tneuron_=1:fneuron_-1)
	      if(ftNNassocMATgbl(fneuron_,tneuron_)==1)
		tmpCnt_ = tmpCnt_+1;
	      	eval(['ftENMwts' num2str(seq4) 'MATgbl(fneuron_,tneuron_) = 1;']);
	      end; % if
	   end; % for tneuron_
	end; % for fneuron_
	eval(['ftENMwts' num2str(seq4) 'CNTgbl = tmpCnt_;']);
end; %if

%%%%%%%%%%%%%%
if (opt3 == 5)
%%%%%%%%%%%%%%
% EA Manual
% Will pop up the learning matrix GUI so that you can
% select the weights you want EA to learn, manually.
%
	eval(['ftENMassn' num2str(seq4) 'CNTgbl = 0;']);
	eval(['ftENMassn' num2str(seq4) 'MATgbl = ones(rsiz_, csiz_);']);
	ftenlrn3(1,1,1,seq4);
end; %if

%%%%%%%%%%%%%%
if (opt3 == 7)
%%%%%%%%%%%%%%
% EA learning for RBF
	ftENMSeqChVECgbl(1,1)  =3; 		% Will use EA for learning
	ftENMSeqTimeVECgbl(1,1)=ftGAngenSCAgbl;
end; % if

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%
if(opt1==20)
%%%%%%%%%%%%
global ftscr_cntSCAgbl ftflag_edtGUI ftFsNo_rulesCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl ftFSiLVtypeVECgbl ftFSoLVtypeVECgbl
global ftcolor_bc1VECgbl ftcolor_fc1VECgbl ftFSmax_LVSCAgbl ftFSNo_inCNTgbl ftFSNo_outCNTgbl
global rad_AL_1 rad_AL_2
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
global FigurePos_Vsmall bestp_n
fig_efr=ftfigure('fig_efr','FlexTool(ENM)',ftFigPos_smallVECgbl,'on','figure');

%=================
% Big Text Block
%=================

ftNNpp1_=' ';
ftNNpp2_=str2mat(...
            'Select the neuro model you want to use from the',...
            'set evolved by EA. You will have a set to select from',...
            'if you selected the Multiple Model option');

ftNNpp3_= [0.95 0.05 0.95 0.65 0.05 0.005];
ftscrhlp(fig_efr,ftNNpp1_,ftNNpp2_,ftNNpp3_,'left');
clear ftNNpp1_ ftNNpp3_

x0=0.05; y0=0.35; dy=0.1; dy1=0.12; dx=0.73; dx2=0.15; eps=0.02;

 ftNNpp1_=['Select Neuro Model Learned using ENM'];
 ftNNpp3_=[x0 y0 dx dy];
 ftscrtxt(fig_efr,ftNNpp1_,ftNNpp3_);
 clear ftNNpp1_ ftNNpp3_
 ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
 Nonn=size(ftGAbestPVECgbl,1);
 if(Nonn>=1)
	 ftNNpp1_='NN 1';
	 for i=2:Nonn
	  ftNNpp1_=str2mat(ftNNpp1_,['NN ' num2str(i)]); 
	 end
	 gaoptparams=ftGAbestPVECgbl;
	 ftNNpp3_=[x0+dx+eps y0 dx2 dy];
	 ftNNpp4_=['ftENMmmodelOPTgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); gaoptparams=ftGAbestPVECgbl(ftENMmmodelOPTgbl,:); ftenmeld(gaoptparams, ftENMSeqCNTgbl); close;'];
	 ftNNpp5_=Nonn;
	 ftNNpp6_=[1:Nonn];
	 ftscrpup(fig_efr,ftNNpp1_,ftNNpp3_,ftNNpp4_,ftNNpp5_,ftNNpp6_,ftscr_cntSCAgbl);
	 clear ftNNpp1_ ftNNpp3_ ftNNpp4_ ftNNpp5_ ftNNpp6_
 end;
%=====================
% Go back one screen
%=====================

ftscrpb(fig_efr,'Done',[0.4 0.05 0.2 0.12],'close');

end; % if

%
% end ftenmlrn.m
%


