%
% ftnnrun3.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1996                              
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
%
%
% Prompts user to enter nn_in, and nn_desired
%
function ftnnrun3

global ftFigPos_medVECgbl ftscr_cntSCAgbl ftflag_edtGUI
global ftNNtrainFLGgbl ftNNsimFLGgbl ftFigPos_mediumVECgbl
global nn_in nn_out nn_desired
global ftbprmSTRgbl

%global for all GUI windows
global ftNNrnGUIgbl

figpos_ = ftFigPos_mediumVECgbl;

save_scr_cnt_=ftscr_cntSCAgbl;

title_=['FlexTool (EN:NN) -- Neural Network Data'];
 
ftNNrnGUIgbl=ftfigure('ftNNrnGUIgbl',title_,figpos_,'on','figure');

 pp2=str2mat(...
            ' Enter Name of ".m" file that will generate input and desired output data.',...
            ' Please ensure that it returns input data.',...
            '               Ex: [nn_in,nn_desired]=yourfilename.',...
            ' Note: Default mode uses [nn_in,nn_desired] variables in the w/space.',...
            '    Enter the names of the vectors/matrices here.',...
            '    Number of rows=Number of data sets.',...
            '    Number of columns=Number of Inputs data to the NN.',...
 	    ' ',...
            ' Click on the Ok button to Proceed.');

        pp3= [0.95 0.05 0.95 0.35 0.075 0.01];
        pp1='FlexTool(EN) Help on Options';
        ftscrhlp(ftNNrnGUIgbl,pp1,pp2,pp3,'left');

        x0=0.05; y0=0.2; dy=0.075; dy1=0.075; dx=0.5; dx1=0.2; dx2=0.15; eps=0.02;
 	pp1='Enter File Name';
 	pp3=[x0 y0 dx dy];
 	ftscrtxt(ftNNrnGUIgbl,pp1,pp3);

  	pp3=[x0+dx+eps y0 dx1 dy];
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	pp4=['clear ftbprmSTRgbl; global ftbprmSTRgbl; ftbprmSTRgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'');',... 
             'inputfname=ftbprmSTRgbl; inputfname=ftfile(inputfname); if(exist(inputfname)),',...
             '[nn_in,nn_desired]=feval(inputfname); else, ftdispwn(''Attention! Exception'' , ''Note!',...
             'using [nn_in,nn_desired] default input data!''); end;'];
  	ftscredt(ftNNrnGUIgbl,ftbprmSTRgbl, pp3, pp4,ftscr_cntSCAgbl);
        pp41=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(EN): Use a .m File'',50,50);',...
            'if junkname~=0, ',...
            ' inputfname=junkname;',...
            ' set(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'',inputfname); inputfname=ftfile(inputfname);',...
            ' [nn_in,nn_desired]=feval(inputfname);',...
            'end;'];
      ftscrpb(ftNNrnGUIgbl,'..Browse',[x0+dx+dx1+2*eps y0 dx2 dy],pp41);
      
      
      %--------------------------------------------------------------------------------
      % checking the size of input
      global ftnn_ingbl
      nn_in_col=size(nn_in);
      ftnn_ingbl=nn_in_col(1,2);  
      %-----------------------------------------------------------------------------------
      
      clear pp4;
   
   
% need to add link to run GA   
ftscrpb(ftNNrnGUIgbl,'Ok',[0.4 0.05 0.2 0.09],'close');

%
% end ftnnrun3.m
%
