% =================================================================
% ftea1.m
% =================================================================
%                        FlexTool(EA) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(EA)
%

function ftentype(TEXT_)

global ftscr_cntSCAgbl ftflag_edtGUI
global ftFigPos_bigVECgbl ftFigPos_mediumVECgbl ftFigPos_smallVECgbl 
global ftcolor_bc1VECgbl ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 

global ftEApp_typeMATgbl
global ftEAtitleVECgbl ftEAtypeSCAgbl
global ftciGUI ftXYscaleVECgbl
global ftflag_edtGUI ftscr_cntSCAgbl

global ftEAmm_typeSCAgbl ftEApp_typeMATgbl 
global ftEApp_selMATgbl ftEAnoofpeaksSCAgbl ftEApp_noofpksMATgbl
global ftEApp_mmtypeMATgbl ftEAnselectSCAgbl ftEAnoofpSCAgbl
global ftEAsspopSCAgbl ftEAnpopSCAgbl ftEAngenSCAgbl
global ftEApcrossSCAgbl ftEApmutateSCAgbl ftEAncrossSCAgbl
global ftEAobj_nameGUI ftEAobjfuncVECgbl ftEAnichtestSCAgbl

global ftEAfunpVECgbl
global ftEAinitfuncVECgbl ftEAnoofpSCAgbl
global ftEAcodingSCAgbl ftEAnopSCAgbl ftEAlchromSCAgbl  
global ftEAnoofobjSCAgbl ftEApminVECgbl ftEApmaxVECgbl ftEApresVECgbl
global ftEAp2SCAgbl ftEAmmVECgbl ftEApresuVECgbl ftEAnbitsVECgbl

global ftFigPos_mainVECgbl

global ftEAer_typeSCAgbl ftGAfun_flagSCAgbl


ftEAlala=num2str(ftEApp_typeMATgbl(ftEAtypeSCAgbl,:));
ftEAlala=['FlexTool(EA)-- ' ftEAlala '--Build'];

save_scr_cnt_=ftscr_cntSCAgbl;

load ft3ea_def.mat


lala=['FlexTool (EA) -- EA Parameters and Obj. Function'];
fig_en2=ftfigure('fig_en2',lala,ftFigPos_smallVECgbl,'on','figure');


%x0=0.05; y0=0.6; dy=0.05; dx=0; eps=0.02;
%dx_no=0.05; dx_name=0.16; dx_max=0.1; dx_min=0.1; dx_units=0.16; dx_lv=0.1;

%x0=0.05; y0=.85; dy=0.07; dx=0; eps=0.02;
%dx_no=0.05; dx_name=0.16; dx_max=0.1; dx_min=0.1; dx_units=0.13; dx_lv=0.1;



%========================
% EA-Parameters Defn Block
%========================

ftEApp1='Objective Function';
ftEApp2=[' '];
%ftEApp3= [0.75 0.04 0.31 0.3 0.07 0.001];
ftEApp3= [0.75 0.04 0.31 0.54 0.07 0.001];

ftscrblk(fig_en2,ftEApp1,ftEApp2,ftEApp3);

ftEAobj_nameGUI=uicontrol('Style','edit',...
'string',ftEAobjfuncVECgbl,...
'Units','normalized', ...
'Position',[0.05 0.56 0.15 0.1],...
'BackgroundColor', [1 1 1],... %ftcolor_bc2VECgbl,...
'HorizontalAlignment','left',...
'callback',['ftEAobjfuncVECgbl=get(ftEAobj_nameGUI,''string''); ftEAobjfuncVECgbl=ftfile(ftEAobjfuncVECgbl); if(exist(ftEAobjfuncVECgbl)~=2), ftEAobjfuncVECgbl=''objfunc''; end;']);

ftEApp4=['[ftEAjunkname obpath]=uigetfile(''*.m'',''FlexTool(EA): Objective Function. Use a .m File'',50,50);',...
	'if ftEAjunkname~=0, ftEAobjfuncVECgbl=ftEAjunkname; end;',...
      'set(ftEAobj_nameGUI,''string'',ftEAobjfuncVECgbl);ftEAobjfuncVECgbl=ftfile(ftEAobjfuncVECgbl);'];

ftEApp3=[0.208 0.56 0.09 0.1];
ftscrpb(fig_en2,'..Brws',ftEApp3,ftEApp4);


ftEApp1='Selection';
%ftEApp3=[0.05 0.4 0.2 0.1];
ftEApp3=[0.07 0.36 0.2 0.1];

ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

%ftEApp3=[0.05 0.3 0.2 0.1];
ftEApp3=[0.07 0.26 0.2 0.1];

if ftEAtypeSCAgbl~=1 %Other than regular GA
  ftEApp6=[1:(size(ftEApp_selMATgbl,1)-1)]';
else
  ftEApp6=[1:(size(ftEApp_selMATgbl,1))]';
end

if ftEAtypeSCAgbl==2 % micro-GA
   ftEAnselectSCAgbl=2;
   ftEApp1=ftEApp_selMATgbl(ftEAnselectSCAgbl,:);
   ftstxt(fig_en2,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp4=['ftEAnselectSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
   ftEApp5=ftEAnselectSCAgbl;
   ftEApp6=[1:size(ftEApp_selMATgbl,1)]';
   ftscrpup(fig_en2,ftEApp_selMATgbl,ftEApp3,ftEApp4,ftEApp5,ftEApp6,ftscr_cntSCAgbl);
   clear ftEApp3;
end

%=================
% EA-Recombination
%=================
ftEApp1='EA Recombination';
ftEApp2=[' '];
%ftEApp3= [0.75 0.365 0.635 0.3 0.07 0.001];
ftEApp3= [0.75 0.365 0.635 0.3 0.07 0.001];

ftscrblk(fig_en2,ftEApp1,ftEApp2,ftEApp3);

%ftEApp3=[0.375 0.56 0.18 0.1];

ftEApp3=[0.375 0.56 0.18 0.1];
ftEApp1='Prob of Xover';
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.56 0.07 0.1];

if ftEAtypeSCAgbl==2  % micro-GA
   ftEApcrossSCAgbl=1;
   ftEApp1=num2str(ftEApcrossSCAgbl);
   ftstxtc(fig_en2,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEApcrossSCAgbl);
   ftEApp4=['ftEApcrossSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp3=[0.375 0.44 0.18 0.1];
ftEApp1='# of Xover Pts';
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.44 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEAncrossSCAgbl=1;
   ftEApp1=num2str(ftEAncrossSCAgbl);
   ftstxtc(fig_en2,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEAncrossSCAgbl);
   ftEApp4=['ftEAncrossSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp1='Prob of Mutation'; 
ftEApp3=[0.375 0.32 0.18 0.1];
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.555 0.32 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEApmutateSCAgbl=0;
   ftEApp1=num2str(ftEApmutateSCAgbl);
   ftstxtc(fig_en2,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEApmutateSCAgbl);
   ftEApp4=['ftEApmutateSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

%=================
% EA-EA Defn
%=================

ftEApp1='EA Parameters';
ftEApp2=[' '];
%ftEApp3= [0.75 0.69 0.96 0.3 0.07 0.001];
ftEApp3= [0.75 0.69 0.96 0.3 0.07 0.001];



ftscrblk(fig_en2,ftEApp1,ftEApp2,ftEApp3);

ftEApp3=[0.70 0.56 0.18 0.1];
ftEApp1='# of Gen';
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftEApp3=[0.88 0.56 0.07 0.1];
ftEApp1=num2str(ftEAngenSCAgbl);
ftEApp4=['ftEAngenSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);

ftEApp3=[0.7 0.44 0.18 0.1];
ftEApp1='Pop Size';
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.88 0.44 0.07 0.1];
ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
if ftEAtypeSCAgbl==2
   ftEAnpopSCAgbl=5;
   ftEApp1=num2str(ftEAnpopSCAgbl);
   ftEApp4=['ftEAnpopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
else
   ftEApp1=num2str(ftEAnpopSCAgbl);
   ftEApp4=['ftEAnpopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

ftEApp1='SS Pop Size'; 
ftEApp3=[0.7 0.32 0.18 0.1];
ftscrtxt(fig_en2,ftEApp1,ftEApp3);
clear ftEApp1 ftEApp3 ftEApp4;

ftEApp3=[0.88 0.32 0.07 0.1];

if ftEAtypeSCAgbl==2
   ftEAsspopSCAgbl=1;
   ftEApp1=num2str(ftEAsspopSCAgbl);
   ftstxtc(fig_en2,ftEApp1,ftEApp3);
   clear ftEApp3;
else
   ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
   ftEApp1=num2str(ftEAsspopSCAgbl);
   ftEApp4=['ftEAsspopSCAgbl=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
   ftscredt(fig_en2,ftEApp1,ftEApp3,ftEApp4,ftscr_cntSCAgbl);
end

%=====================
% Close
%=====================

ftscrpb(fig_en2,'Close',[0.4 0.1 0.15 0.1],'close'); % ftEAbestpMATgbl


ftscr_cntSCAgbl=save_scr_cnt_;

%
% end ftnn1.m
%
