%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% ften_def                          ften_def.m                 ften_def
% =========================================================================  
%                          FlexTools(ENM) for Matlab
%                             Copyright (c) 1996                               
%                       Flexible Intelligence Group (FIG)                            
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
% PURPOSE: Initialize ENM variables
%
function ften_def

% Initialize NN variables first
ftnn_def;

%if exist('ftnndef_flagGUI')~=0

%
% Set of global variables needed in the ftenmenu 
%
global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInVECgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl     ftENMltypeFLGgbl
global ftscr_cntSCAgbl    ftENMlrnCNTgbl     ftENMbldFLGgbl
global ftENMrwtlIDXgbl    ftENMcwtlIDXgbl    ftENMrassnlIDXgbl   
global ftENMcassnlIDXgbl  ftENMaFLGgbl       ftNNin_wtsVECgbl
global ftENMrestartFLGgbl ftENMwtbufMATgbl   ftENMnn_inMATgbl
global ftENMrbfOPTgbl     ftENMweightOPTgbl  ftENMassocOPTgbl
global ftENMFLGgbl        ftENMCycCNTgbl     ftENMCycfreqSCAgbl

global ftENMtypeSCAgbl ftENMpp_typeMATgbl ftENMfn_bpMATgbl ftENM_lrnMATgbl
global ftENMlearnSCAgbl ftENMpp_lrnMATgbl

ftENMFLGgbl=1;
ftENMlrnOPTgbl = 1;
ftENMlearnSCAgbl = 1;

ftENMpp_lrnMATgbl = str2mat('Topology and Weights',...
'Topology Only',...
'Weights Only',...
'Best Input Set');

ftENMpp_typeMATgbl=str2mat(...
'BP Network--Fully Connected', ...
'BP Network--Recurrent', ...
'BP Network--Hidden Layers',...
'RBF Network');

ftENMfn_bpMATgbl=str2mat(...
'bp',...
'br',...
'bl',...
'rb');

ftENMtypeSCAgbl=1;

ftENMmaxSeqCNTgbl  = 4;
ftENMSeqCNTgbl     = 1;

ftENMSeqChVECgbl   = ones(1,ftENMmaxSeqCNTgbl); 
ftENMSeqChNMATgbl  = str2mat('None',...
'NN',...
'EA');

ftENMSeqTimeVECgbl = ones(1,ftENMmaxSeqCNTgbl); % example 100 epochs NN, 10 gen EA

ftENMeaConVECgbl   = ones(1,ftENMmaxSeqCNTgbl);
ftENMeaWtVECgbl    = ones(1,ftENMmaxSeqCNTgbl);                 

ftENMeaOptNMATgbl  = str2mat('None',...
'All',...
'All Forward',...
'All Recurrent',...
'Manual');

ftENMselInVECgbl  = [1 1 1 1];

ftENMynNameMATgbl = str2mat('No',...
'Yes');

ftENMassn1MATgbl  = ones(22,22);
ftENMassn1CNTgbl  = 100;
ftENMassn2MATgbl  = zeros(22,22);
ftENMassn2CNTgbl  = 100;
ftENMassn3MATgbl  = zeros(22,22);
ftENMassn3CNTgbl  = 100;
ftENMassn4MATgbl  = zeros(22,22);
ftENMassn4CNTgbl  = 100;

ftENMwts1MATgbl   = ones(22,22);
ftENMwts1CNTgbl   = 100;
ftENMwts2MATgbl   = zeros(22,22);
ftENMwts2CNTgbl   = 100;
ftENMwts3MATgbl   = zeros(22,22);
ftENMwts3CNTgbl   = 100;
ftENMwts4MATgbl   = zeros(22,22);
ftENMwts4CNTgbl   = 100;

ftENMsameVECgbl   = zeros(1, ftENMmaxSeqCNTgbl);

ftENMltypeFLGgbl=1;

ftscr_cntSCAgbl=1;

ftEFMenpfGUI     =' ';

ftENMrwtlIDXgbl  =1;
ftENMcwtlIDXgbl  =1;
ftENMrassnlIDXgbl=1;
ftENMcassnlIDXgbl=1;

ftENMlrnCNTgbl   =0;
ftENMbldFLGgbl   =0;
ftENMaFLGgbl=0;
ftENMrestartFLGgbl=0;

ftNNin_wtsVECgbl=0;
ftENMwtbufMATgbl=0;
ftENMnn_inMATgbl=0;

ftENMrbfOPTgbl  =0;
ftENMweightOPTgbl=[1 3 3 3];
ftENMassocOPTgbl=[1 2 2 2];

%ftENMCycCNTgbl=1;
%ftENMCycfreqSCAgbl=10;

save ften_def.mat 

%end;

%
% end ften_def.m
%
