%
% ftfs2.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% GUI for FlexTool(FS)
%

function ftfs2(ftFSpflag_,ftFSil1_,ftFSil2_)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI
global ftFSvarCNTgbl ftFSlingCNTgbl ftscr_cntSCAgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl

ftFS2FLGgbl=ftFSpflag_;

ftFSlala_=['FlexTool (FS) -- Input/Output Variable Definitions'];
ftFSfig_fs2GUI=ftfigure('ftFSfig_fs2GUI',ftFSlala_,ftFigPos_bigVECgbl,'on','figure');

%fthelp(ftFSfig_fs2GUI,'FS');

%x0=0.05; y0=0.6; dy=0.05; dx=0; eps=0.02;
%dx_no=0.05; dx_name=0.2; dx_max=0.1; dx_min=0.1; dx_units=0.15; dx_lv=0.1;

x0=0.07; y0=.85; dy=0.07; dx=0; eps=0.02;
dx_no=0.05; dx_name=0.16; dx_max=0.1; dx_min=0.1; dx_units=0.13; dx_lv=0.1;


 i=0;
 ftFSpp1_='No';
 ftFSpp3_=[x0 y0-i*0.06 dx_no dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Variable Name';
 dx=dx+dx_no+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_name dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Min';
 dx=dx+dx_name+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_min dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Max';
 dx=dx+dx_min+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_max dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Units';
 dx=dx+dx_max+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_units dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 if ftFSfuztypeSCAgbl ~=2 | ftFSpflag_==1
   ftFSpp1_='# of LV';
   dx=dx+dx_units+eps;
   ftFSpp3_=[x0+dx y0-i*0.06 dx_lv dy];
   ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
   clear ftFSpp1_;
 end
if ftFSpflag_==1, 
 Noofvar=ftFSNo_inCNTgbl;
 STRING='i'; 
end
if ftFSpflag_==2, 
 Noofvar=ftFSNo_outCNTgbl; 
 STRING='o';
end

%================
% Loop through
%================
if nargin <2
 ftFSil1_=1; ftFSil2_=Noofvar;
end

if (Noofvar-ftFSil1_) > (7-1)
 ftFSil2_=ftFSil1_+6;
end

ii=0;
for i=ftFSil1_:ftFSil2_
 ii=ii+1;

 %x0=0.05; y0=0.6; dx=0; 
 x0=0.07; y0=0.85; dx=0; 

 
 ftFSpp1_=num2str(i);
% ftFSpp3_=[x0 y0-ii*0.06 dx_no dy];
  ftFSpp3_=[x0 y0-ii*0.1 dx_no dy];

 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftscr_cntSCAgbl = ftscr_cntSCAgbl + 1;
 ftFSpp1_=eval(['ftFS' STRING 'nameVECgbl(i,:)']);
 dx=dx+dx_no+eps;
% ftFSpp3_=[x0+dx y0-ii*0.06 dx_name dy];
 ftFSpp3_=[x0+dx y0-ii*0.1 dx_name dy];

 ftFSpp4_=['ftFS' STRING 'nameVECgbl(' num2str(i) ',:)=ftstrpak((get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'')),20);'];
 ftscredt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 ftFSpp1_=num2str(eval(['ftFS' STRING 'minVECgbl(i)']));
 dx=dx+dx_name+eps;
 %ftFSpp3_=[x0+dx y0-ii*0.06 dx_min dy];
 ftFSpp3_=[x0+dx y0-ii*0.1 dx_min dy];

 ftFSpp4_=['ftFS' STRING 'minVECgbl(' num2str(i) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
 ftscredt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 ftFSpp1_=num2str(eval(['ftFS' STRING 'maxVECgbl(i)']));
 dx=dx+dx_min+eps;
% ftFSpp3_=[x0+dx y0-ii*0.06 dx_max dy];
 ftFSpp3_=[x0+dx y0-ii*0.1 dx_max dy];

 ftFSpp4_=['ftFS' STRING 'maxVECgbl(' num2str(i) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
 ftscredt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 ftFSpp1_=eval(['ftFS' STRING 'unitVECgbl(i,:)']);
 dx=dx+dx_max+eps;
% ftFSpp3_=[x0+dx y0-ii*0.06 dx_units dy];
 ftFSpp3_=[x0+dx y0-ii*0.1 dx_units dy];

 ftFSpp4_=['ftFS' STRING 'unitVECgbl(' num2str(i) ',:)=ftstrpak((get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'')),11);'];
 ftscredt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_;

 if ftFSfuztypeSCAgbl ~=2 | ftFSpflag_==1
  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  ftFSpp1_=num2str(eval(['ftFS' STRING 'lingVECgbl(i)']));
  dx=dx+dx_units+eps;
%  ftFSpp3_=[x0+dx y0-ii*0.06 dx_lv dy];
  ftFSpp3_=[x0+dx y0-ii*0.1 dx_lv dy];

  ftFSpp4_=['ftFS' STRING 'lingVECgbl(' num2str(i) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));']
  ftscredt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
  clear ftFSpp1_;
 end

end 

if ftFSil1_ > 7
   ftFSil1_=ftFSil1_-7;
 ftFSpp1_='Up ^';
% ftFSpp3_=[x0+dx+dx_lv+eps y0-1*0.06 0.1 dy];
 ftFSpp3_=[x0+dx+dx_lv+eps y0-1*0.1 0.1 dy];

 ftFSpp4_=['close; ftfs2(' num2str(ftFSpflag_) ',' num2str(ftFSil1_) ',' num2str(Noofvar) ')'];
 ftscrpb(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end
if Noofvar > ftFSil2_
 ftFSil2_=ftFSil2_+1;
 ftFSpp1_='Down v';
% ftFSpp3_=[x0+dx+dx_lv+eps y0-8*0.06 0.1 dy];
  ftFSpp3_=[x0+dx+dx_lv+eps y0-4*0.175 0.1 dy];

 ftFSpp4_=['close; ftfs2(' num2str(ftFSpflag_) ',' num2str(ftFSil2_) ',' num2str(Noofvar) ')'];
 ftscrpb(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end

%=====================
% Go back one screen
%=====================

%ftscrpb(ftFSfig_fs2GUI,'Done',[0.4 0.025 0.2 0.075],'ftfswsve; close;');
ftscrpb(ftFSfig_fs2GUI,'Done',[0.56 0.025 0.1 0.08],'ftfswsve; close;');
ftscrpb(ftFSfig_fs2GUI,'Help',[.71 0.025 0.1 0.08],'ftfshlp1');


%
% end ftfs2.m
%
