%
% ftfs3.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% GUI for FlexTool(FS)
%

function ftfs3(ftFSpflag_,ftFSil1_,ftFSil2_)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl 
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl
global ftFSfmftypenMATgbl ftscr_cntSCAgbl ftEFMFLGgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl

ftFS2FLGgbl=0;

ftFSNo_ilingCNTgbl=sum(ftFSilingVECgbl(1:ftFSNo_inCNTgbl)); ftFSNo_olingCNTgbl=sum(ftFSolingVECgbl(1:ftFSNo_outCNTgbl));

if ftFSpflag_==1, 
 if ftFSvarCNTgbl > ftFSNo_inCNTgbl | ftFSvarCNTgbl < 1, break; end
 Noofvar=ftFSNo_inCNTgbl; 
 ftFSNo_lingCNTgbl=ftFSilingVECgbl; 
 vec_name=ftFSinameVECgbl(ftFSvarCNTgbl,:);
 ios='i';
end

if ftFSpflag_==2, 
 if ftFSvarCNTgbl > ftFSNo_outCNTgbl | ftFSvarCNTgbl < 1, break; end
 Noofvar=ftFSNo_outCNTgbl; 
 ftFSNo_lingCNTgbl=ftFSolingVECgbl;
 vec_name=ftFSonameVECgbl(ftFSvarCNTgbl,:);
 ios='o';
end

ftfs3_flag=ftFSpflag_;
ftFSlala_=['Linguistic Variables for ' vec_name];
fig_fs3=ftfigure('fig_fs3',ftFSlala_,ftFigPos_bigVECgbl,'on','figure');

%fthelp(fig_fs3,'fs');

%ftFSpp2_=str2mat(...
% 	    'FlexTool allows the user to enter the names of the Linguistic Variables',...
%            '(Ex: High, Low), the type of the membership functions (Ex: Triangular,',...
%            'Gaussian, etc), and the shape of the functions. Click on the POPUP menu',...
%            'to select the type and shape of the functions. The "Auto Settings" option',...
%            'helps set default FMF attributes for all the FMFs.');

%ftFSpp3_= [0.95 0.05 0.95 0.725 0.04 0.002];
%ftFSpp1_='FlexTool(FS) Help on Options';
%ftscrhlp(fig_fs3,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

%x0=0.15; y0=0.625; dy=0.05; dx=0; eps=0.02;
%dx_no=0.05; dx_name=0.4; dx_lvname=0.2; dx_learn=0.15; dx_type=0.25;

x0=0.08; y0=0.85; dy=0.07; dx=0; eps=0.02;
dx_no=0.05; dx_name=0.4; dx_lvname=0.2; dx_learn=0.15; dx_type=0.25;

 i=0;
 ftFSpp1_='No';
 ftFSpp3_=[x0 y0-i*0.06 dx_no dy];
 ftscrtxt(fig_fs3,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='LV Name';
 dx=dx+dx_no+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_lvname dy];
 ftscrtxt(fig_fs3,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 %ftFSpp1_='Learn';
 dx=dx+dx_lvname+eps;
 %ftFSpp3_=[x0+dx y0-i*0.06 dx_learn dy];
 %if isempty(ftEFMFLGgbl)==0, ftscrtxt(fig_fs3,ftFSpp1_,ftFSpp3_); end
 %clear ftFSpp1_;

 ftFSpp1_='LV Type';
 dx=dx+dx_learn+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_type dy];
 ftscrtxt(fig_fs3,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

%================
% Loop through
%================

if nargin <2
 ftFSil1_=1; ftFSil2_=ftFSNo_lingCNTgbl(ftFSvarCNTgbl);
end

if (ftFSNo_lingCNTgbl(ftFSvarCNTgbl)-ftFSil1_) > (7-1)
 ftFSil2_=ftFSil1_+6;
end

ii=0;
for i=ftFSil1_:ftFSil2_
 ii=ii+1;
 
 
 %x0=0.15; y0=0.625; dx=0;
  x0=0.08; y0=0.85; dx=0;

 
 ftFSlingCNTgbl=i+(ftFSvarCNTgbl-1)*ftFSmax_LVSCAgbl;
 
 ftFSpp1_=num2str(i);
% ftFSpp3_=[x0 y0-ii*0.06 dx_no dy];
 ftFSpp3_=[x0 y0-ii*0.1 dx_no dy*.9];

 ftscrtxt(fig_fs3,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;

 if ftFSpflag_==1, ftFSpp1_=ftFSiLVnameVECgbl(ftFSlingCNTgbl,:); end
 if ftFSpflag_==2, ftFSpp1_=ftFSoLVnameVECgbl(ftFSlingCNTgbl,:); end
 dx=dx+dx_no+eps;
% ftFSpp3_=[x0+dx y0-ii*0.06 dx_lvname dy];
 ftFSpp3_=[x0+dx y0-ii*0.1 dx_lvname dy*.9];

 ftFSpp4_=['ftFS' ios 'LVnameVECgbl(' num2str(ftFSlingCNTgbl) ',:)=ftstrpak((get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'')),12);'];
 ftscredt(fig_fs3,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_;

 dx=dx+dx_lvname+eps;
 %if isempty(ftEFMFLGgbl)==0, 
 %  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 %  ftFSpp1_=str2mat(...
 %'No-learn',...
 %  'GA-learn'); 
%   ftFSpp3_=[x0+dx y0-ii*0.1 dx_learn dy*.9];

%   ftFSpp4_=['ftFS' ios 'LVlearnVECgbl(' num2str(ftFSlingCNTgbl) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
%   if ftFSpflag_==1, ftFSpp5_=ftFSiLVlearnVECgbl(ftFSlingCNTgbl); end
%   if ftFSpflag_==2, ftFSpp5_=ftFSoLVlearnVECgbl(ftFSlingCNTgbl); end
%   ftFSpp6_=[1;2];
%   ftscrpup(fig_fs3,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
%   clear ftFSpp1_ ftFSpp3_
% end

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 dx=dx+dx_learn+eps;
ftFSpp3_=[x0+dx y0-ii*0.1 dx_type dy*.9];

 ftFSpp4_=['ftFS' ios 'LVtypeVECgbl(' num2str(ftFSlingCNTgbl) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
 if ftFSpflag_==1, ftFSpp4_=[ftFSpp4_ 'if ftFSiLVlearnVECgbl(' num2str(ftFSlingCNTgbl) ')==1, ftfsparm(1,' num2str(ftFSlingCNTgbl) '); end']; end
 if ftFSpflag_==2, ftFSpp4_=[ftFSpp4_ 'if ftFSoLVlearnVECgbl(' num2str(ftFSlingCNTgbl) ')==1, ftfsparm(2,' num2str(ftFSlingCNTgbl) '); end']; end
 if ftFSpflag_==1, ftFSpp5_=ftFSiLVtypeVECgbl(ftFSlingCNTgbl); end
 if ftFSpflag_==2, ftFSpp5_=ftFSoLVtypeVECgbl(ftFSlingCNTgbl); end
 ftFSpp6_=[1;2;3;4;5];
 ftscrpup(fig_fs3,ftFSfmftypenMATgbl,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
 clear ftFSpp1_ ftFSpp3_
end
if ftFSil1_ > 7  % was 8
 ftFSil1_=ftFSil1_-7;
 ftFSpp1_='Up ^';
 %ftFSpp3_=[x0+dx+dx_type+eps y0-1*0.06 0.1 dy];
 ftFSpp3_=[x0+dx+dx_type+eps+.01 y0-1*0.1 0.1 dy*.9];

 ftFSpp4_=['close; ftfs3(' num2str(ftFSpflag_) ',' num2str(ftFSil1_) ',' num2str(ftFSNo_lingCNTgbl(ftFSvarCNTgbl)) ')'];
 ftscrpb(fig_fs3,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end
if ftFSNo_lingCNTgbl(ftFSvarCNTgbl) > ftFSil2_
 ftFSil2_=ftFSil2_+1;
 ftFSpp1_='Down v';
% ftFSpp3_=[x0+dx+dx_type+eps y0-8*0.06 0.1 dy];
 ftFSpp3_=[x0+dx+dx_type+eps+.01 y0-4*0.175 0.1 dy*.95];

 ftFSpp4_=['close; ftfs3(' num2str(ftFSpflag_) ',' num2str(ftFSil2_) ',' num2str(ftFSNo_lingCNTgbl(ftFSvarCNTgbl)) ')'];
 ftscrpb(fig_fs3,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end

%=====================
% Go back one screen
%=====================
if ftFSpflag_==1, ftFSpp4_='ftfswsve; close; ftFSvarCNTgbl=ftFSvarCNTgbl-1; ftfs3(1)'; end
if ftFSpflag_==2, ftFSpp4_='ftfswsve; close; ftFSvarCNTgbl=ftFSvarCNTgbl-1; ftfs3(2)'; end

ftscrpb(fig_fs3,'<< Back',[0.025 0.025 0.125 0.08],ftFSpp4_);
ftscrpb(fig_fs3,'Done',[0.175 0.025 0.1 0.08],'close;');

if ftFSpflag_==1, ftFSpp4_=['ftmfdisp(1,' num2str(ftFSvarCNTgbl) ')']; end
if ftFSpflag_==2, ftFSpp4_=['ftmfdisp(2, ' num2str(ftFSvarCNTgbl) ')']; end

ftscrpb(fig_fs3,'View FMFs',[0.3 0.025 0.15 0.08],ftFSpp4_);

ftFSpp4_=['close; ftfsaset(' num2str(ftFSpflag_) ',' num2str(ftFSil1_) ',' num2str(ftFSil2_) ');'];
ftscrpb(fig_fs3,'Auto Settings',[0.475 0.025 0.13 0.08],ftFSpp4_);

%=====================
% Next Screen 
%=====================

if ftFSpflag_==1, ftFSpp4_='ftfswsve; close; ftFSvarCNTgbl=ftFSvarCNTgbl+1; ftfs3(1)'; end
if ftFSpflag_==2, ftFSpp4_='ftfswsve; close; ftFSvarCNTgbl=ftFSvarCNTgbl+1; ftfs3(2)'; end

ftscrpb(fig_fs3,'Help',[.63 .025 .1 .08],'ftfshlp2');
ftscrpb(fig_fs3,'Next Variable >>',[0.75 0.025 0.22 0.08],ftFSpp4_);

%
% END ftfs3.m
%
 
