%
% FTfsaset.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Automated settings for MF parameters and Rules
%

function ftfsaset(ftFSpflag_,ftFSil1_,ftFSil2_,ftFSjunk_)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl ftFSmaxsVECgbl ftFSminsVECgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_diffSCAgbl ftFSbase_resSCAgbl ftFSbase_setVECgbl ftFSNo_stepsCNTgbl 
global ftFSrbasisMATgbl ftFSbasisMATgbl ftFS_inMATgbl ftFSqual_critMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl ftFSaNo_critCNTgbl ftFSNo_altCNTgbl
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl mat_parm
global ftFSincMATgbl ftFSoutcMATgbl ftFSinlMATgbl ftFSoutlMATgbl ftFSinrMATgbl ftFSrulelearnVECgbl
global ftflag_edtGUI ftscr_cntSCAgbl
global ftcolor_bc1VECgbl ftcolor_bc2VECgbl ftcolor_fc1VECgbl
global ftFSfmfilenMATgbl ftFSfmfcntVECgbl ftFSimpnameMATgbl ftFSaggrfilenMATgbl ftFSdefuznameMATgbl
global ftFSaggrparmnMATgbl ftFSdefpfilnMATgbl
global ftFSfmftypenMATgbl ftFSimptypenMATgbl ftFSaggrtypenMATgbl ftFSdeftypenMATgbl
global ftFSfig_fsbaseGUI
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
global ftEFMlrnoptSCAgbl

if nargin==1
 ftFSfig_fsbaseGUI=ftfigure('ftFSfig_fsbaseGUI','FlexTool(FS)--Auto Settings',ftFigPos_medVECgbl,'on','none');

 %=================
 % Big Text Block
 %================= 

 ftFSpp1_='FlexTool(FS) Help on Options';
 ftFSpp2_=[ 'This option will set all possible rule combinations ',...
            'using all the input criteria and linguistic variables ',...
            'with AND operator. The user can then edit or delete the ',...
            'rules that are not needed. Keep in mind that the number ',...
            'of possible rules=(# of LV)^(# of Criteria). So, this ',...
            'option is meaningful only for small problems. CAUTION! ',...
            'You might hit MATLAB memory limits for large problems. ',...
            '"Clear All Rules" clears the definition of all rules.']; 

 ftFSpp3_= [0.95 0.05 0.95 0.45 0.07 0.005];
 ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');
 clear ftFSpp1_ ftFSpp3_

 x0=0.05; y0=0.35; dy=0.075; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

 ftFSpp3_=[0.05 0.2 0.3 0.1];
 ftFSpp4_=['ftfsaset(1,2);ftscrtxt(ftFSfig_fsbaseGUI,[''Rules have been set''],[0.15 0.05 0.7 0.1]); ftscrpb(ftFSfig_fsbaseGUI,[''Done''],[0.4 0.2 0.2 0.1], [''Close''] ); '];
 ftFSpp1_=['Auto Rule Set'];
 ftscrpb(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_

 ftFSpp4_=['close;' ];
 ftFSpp3_=[0.4 0.2 0.2 0.1];
 ftFSpp1_=['Cancel'];
 ftscrpb(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_

 ftFSpp3_=[0.65 0.2 0.3 0.1];
 ftFSpp4_=['ftfsaset(1,0);ftscrtxt(ftFSfig_fsbaseGUI,[''All rules are cleared''],[0.15 0.05 0.7 0.1]); ftscrpb(ftFSfig_fsbaseGUI,[''Done''],[0.4 0.2 0.2 0.1], [''Close''] ); '];
 ftFSpp1_=['Clear All Rules'];
 ftscrpb(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_

elseif nargin==2

 if ftFSil1_==0
  for i=1:ftFSNo_rulesCNTgbl %clear rules
   ftFSinrMATgbl(i,:)=ftFSinrMATgbl(i,:)*0;
   ftFSincMATgbl(i,:)=ftFSincMATgbl(i,:)*0+1;
   ftFSilrnMATgbl(i,:)=ftFSilrnMATgbl(i,:)*0+1;
   ftFSolrnMATgbl(i,:)=ftFSolrnMATgbl(i,:)*0+1;
   ftFSoutrMATgbl(i,:)=ftFSoutrMATgbl(i,:)*0;
   ftFSoutcMATgbl(i,:)=ftFSoutcMATgbl(i,:)*0+1;
   ftFSinlMATgbl(i,:)=ftFSinlMATgbl(i,:)*0;
   ftFSoutlMATgbl(i,:)=ftFSoutlMATgbl(i,:)*0;
  end; %for i
  ftFSNo_rulesCNTgbl=1;
  ftFSruleCNTgbl=0;
 elseif ftFSil1_==1 %add a rule
   isz=size(ftFSinlMATgbl,2);
   if ftFSNo_rulesCNTgbl < size(ftFSinlMATgbl,1)
     ftFSinrMATgbl(ftFSNo_rulesCNTgbl,:)=zeros(1,isz);
     ftFSincMATgbl(ftFSNo_rulesCNTgbl,:)=2*ones(1,isz);
     ftFSilrnMATgbl(ftFSNo_rulesCNTgbl,:)=ones(1,isz);
     ftFSrulelearnVECgbl(ftFSNo_rulesCNTgbl)=1;
     ftFSinlMATgbl(ftFSNo_rulesCNTgbl,:)=ones(1,isz);
   else
     ftFSinrMATgbl=[ftFSinrMATgbl; zeros(1,isz)];
     ftFSincMATgbl=[ftFSincMATgbl; 2*ones(1,isz)];
     ftFSilrnMATgbl=[ftFSilrnMATgbl; ones(1,isz)];
     ftFSrulelearnVECgbl=[ftFSrulelearnVECgbl;1];
     ftFSinlMATgbl=[ftFSinlMATgbl; ones(1,isz)];
   end

   isz=size(ftFSoutlMATgbl,2);
   if ftFSNo_rulesCNTgbl < size(ftFSinlMATgbl,1)
     ftFSolrnMATgbl(ftFSNo_rulesCNTgbl,:)=ones(1,isz);
     ftFSoutrMATgbl(ftFSNo_rulesCNTgbl,:)=zeros(1,isz);
     ftFSoutcMATgbl(ftFSNo_rulesCNTgbl,:)=2*ones(1,isz);
     ftFSoutlMATgbl(ftFSNo_rulesCNTgbl,:)=ones(1,isz);
   else
     ftFSolrnMATgbl=[ftFSolrnMATgbl; ones(1,isz)];
     ftFSoutrMATgbl=[ftFSoutrMATgbl; zeros(1,isz)];
     ftFSoutcMATgbl=[ftFSoutcMATgbl; 2*ones(1,isz)];
     ftFSoutlMATgbl=[ftFSoutlMATgbl; ones(1,isz)];
   end

 elseif ftFSil1_==2 %Auto set all rules
  prod=1;
  for i=1:ftFSNo_inCNTgbl
   prod=prod*ftFSilingVECgbl(i);
  end; %for i
  ftFSNo_rulesCNTgbl=prod;
  ftFSincMATgbl=ones(ftFSNo_rulesCNTgbl,(ftFSNo_inCNTgbl+1));
  ftFSinrMATgbl=ftFSincMATgbl*0;
  ftFSilrnMATgbl=ftFSincMATgbl*0;

  for i=1:ftFSNo_inCNTgbl
   ftFSincMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1)*(i+1);
   if i>1
    ftFSinrMATgbl(1:ftFSNo_rulesCNTgbl,(i-1))=ones(ftFSNo_rulesCNTgbl,1);
   end
   if isempty(ftEFMlrnoptSCAgbl)~=1
     if(ftEFMlrnoptSCAgbl==3)|(ftEFMlrnoptSCAgbl==6)
     	  ftFSilrnMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1);
     else
     	  ftFSilrnMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1)*2;
     end; %if
   else
   end % if isempty
  end; %for i
  ic=0;

  for j=1:ftFSNo_inCNTgbl
    ling_no=1;
    for k=j+1:ftFSNo_inCNTgbl
     ling_no=ling_no*ftFSilingVECgbl(k);
    end; %for k
    j1=1-ling_no;
    ic_count=0;
    while (ic_count < ftFSNo_rulesCNTgbl)
     for ic=1:ftFSilingVECgbl(j)
      j1=j1+ling_no; j2=j1+ling_no-1;
      ftFSinlMATgbl(j1:j2,j)=ones(ling_no,1)*ic;
      ic_count=ic_count+ling_no;
     end; %for ic
    end; %while 
  end; %for j

  ftFSoutcMATgbl=ones(ftFSNo_rulesCNTgbl,(ftFSNo_outCNTgbl+1));
  ftFSoutrMATgbl=zeros(ftFSNo_rulesCNTgbl,(ftFSNo_outCNTgbl+1));
  ftFSolrnMATgbl=zeros(ftFSNo_rulesCNTgbl,(ftFSNo_outCNTgbl+1));

  for i=1:ftFSNo_outCNTgbl
   ftFSoutcMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1)*(i+1);
   if i > 1
    ftFSoutrMATgbl(1:ftFSNo_rulesCNTgbl,(i-1))=ones(ftFSNo_rulesCNTgbl,1);
   end; %if
   if isempty(ftEFMlrnoptSCAgbl)~=1
     if(ftEFMlrnoptSCAgbl==3)|(ftEFMlrnoptSCAgbl==6)
   	  ftFSolrnMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1);
     else
        ftFSolrnMATgbl(1:ftFSNo_rulesCNTgbl,i)=ones(ftFSNo_rulesCNTgbl,1)*2;
     end; %if
   else
   end; %if isempty
  end; %for i

  if isempty(ftEFMlrnoptSCAgbl)~=1
  if(ftEFMlrnoptSCAgbl==3)|(ftEFMlrnoptSCAgbl==6)
  	ftFSrulelearnVECgbl(1:ftFSNo_rulesCNTgbl)=ones(ftFSNo_rulesCNTgbl,1);
  else
	ftFSrulelearnVECgbl(1:ftFSNo_rulesCNTgbl)=ones(ftFSNo_rulesCNTgbl,1)*2;
  end; %if
else
end % if isempty

  ftFSoutlMATgbl=ones(ftFSNo_rulesCNTgbl,(ftFSNo_outCNTgbl+1));
  for i=1:ftFSNo_rulesCNTgbl
   for j=1:ftFSNo_outCNTgbl 
    ftFSoutlMATgbl(i,j)=ceil(rand(1,1)*ftFSolingVECgbl(j));
   end; %for j
  end; %for i
 end 
elseif nargin==3
 ftFSfig_fsbaseGUI=ftfigure('ftFSfig_fsbaseGUI','FlexTool(FS)--Auto Settings',ftFigPos_medVECgbl,'on','none');

 %=================
 % Big Text Block
 %================= 

 ftFSpp1_='FlexTool(EFM) Help on Options';
         
  ftFSpp2_=[ ' You can choose the type of membership function that is common to all the Linguistic ',...
            'Variables. Also, the membership functions can be evenly spaced as defaults by clicking ',...
            'on the "Apply" button (only for Triangular, Trapezoidal, and Gaussian MFs). The user ',...
            'can later on change all of these defaults.']; 

 ftFSpp3_= [0.95 0.05 0.95 0.6 0.05 0.005];
 ftscrhlp(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');
 clear ftFSpp1_ ftFSpp3_
 x0=0.05; y0=0.55; dy=0.075; dy1=0.12; dx=0.55; dx1=0.35; dx2=0.15; eps=0.02;

 ftFSpp3_=[x0 y0-(1.5*dy) dx dy];
 ftscrtxt(ftFSfig_fsbaseGUI,'Default FMF',ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 ftFSpp3_=[x0+dx+eps y0-(1.5*dy) dx1 dy];
 myval=ftFSiLVtypeVECgbl(1);
 ftFSpp4_=['myval=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftFSiLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl) ')+ myval; ftFSoLVtypeVECgbl(1:' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ') = zeros(1,' num2str(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl) ')+myval;'];
 ftFSpp5_ = myval;
 ftFSpp6_=[1:size(ftFSfmftypenMATgbl,1)]';
 ftscrpup(ftFSfig_fsbaseGUI,ftFSfmftypenMATgbl,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
 clear ftFSpp1_ ftFSpp3_

 ftFSpp3_=[x0 y0-(3*dy) dx dy];
 ftFSpp1_=['Evenly Spaced FMFs'];
 ftscrtxt(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_

 ftFSpp3_=[x0+dx+eps y0-(3*dy) dx1 dy];
 ftFSpp4_=['ftfsaset(' num2str(ftFSpflag_) ',0,0,0);',...
      'if ftFSiLVtypeVECgbl(1,1)<4,',...
        'ftscrtxt(ftFSfig_fsbaseGUI,[''FMFs have been evenly spaced. Use view FMF option from main menu to view FMFs.''],[0.15 0.15 0.7 0.14]);',...
      'else ',...
        'ftscrtxt(ftFSfig_fsbaseGUI,[''FMFs cannot be evenly spaced. Select one of the first three FMFs.''],[0.15 0.15 0.7 0.14]);',...
      'end'];
 ftFSpp1_=['Apply'];
 ftscrpb(ftFSfig_fsbaseGUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_

 % 
 % Add for mirror image rules...
 %
 
 %=====================
 % Go back one screen
 %=====================
 ftFSpp4_=['close; ftfs3(' num2str(ftFSpflag_) ',' num2str(ftFSil1_) ',' num2str(ftFSil2_) ')'];
 ftscrpb(ftFSfig_fsbaseGUI,'Cancel',[0.35 0.05 0.3 0.1],ftFSpp4_);

elseif nargin==4 %Auto set FMFs

 for i=1:ftFSNo_inCNTgbl
   ftFSil1_=(ftFSmax_LVSCAgbl*(i-1))+1; ftFSil2_=ftFSil1_+ftFSilingVECgbl(i)-1;
   ftFSxmaxgbl=ftFSimaxVECgbl(i);
   ftxmingbl=ftFSiminVECgbl(i);
   ftFSdelxgbl=(ftFSxmaxgbl-ftxmingbl)/(ftFSilingVECgbl(i)-1);
   if (ftFSiLVtypeVECgbl(1,1)==1)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSiparmMATgbl(j,2)=ftxmingbl+ftFSdelxgbl*(jj-1);
      newval=ftFSiparmMATgbl(j,2)-ftFSdelxgbl;
      if(newval<=ftxmingbl)
	ftFSiparmMATgbl(j,1)=ftxmingbl;
      else
	ftFSiparmMATgbl(j,1)=newval;
      end; %if
      if(newval+(2*ftFSdelxgbl)>=ftFSxmaxgbl)
	ftFSiparmMATgbl(j,3)=ftFSxmaxgbl;
      else
	ftFSiparmMATgbl(j,3)=newval+(2*ftFSdelxgbl);
      end; %if
     end; % for
   end; % if

   if (ftFSiLVtypeVECgbl(1,1)==2)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSiparmMATgbl(j,2)=ftxmingbl+ftFSdelxgbl*(jj-1)-ftFSdelxgbl/2;
      newval=ftFSiparmMATgbl(j,2)-(ftFSdelxgbl/2);
      if(newval<=ftxmingbl)
	ftFSiparmMATgbl(j,1)=ftxmingbl;
      else
	ftFSiparmMATgbl(j,1)=newval;
      end; %if
      ftFSiparmMATgbl(j,3)=ftFSiparmMATgbl(j,2)+ftFSdelxgbl;
      newval=ftFSiparmMATgbl(j,3)+(ftFSdelxgbl/2);
      if(newval >=ftFSxmaxgbl)
	ftFSiparmMATgbl(j,4)=ftFSxmaxgbl;
      else
	ftFSiparmMATgbl(j,4)=newval;
      end; %if
    end; %for j
   end; %if

   if (ftFSiLVtypeVECgbl(1,1)==3)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSiparmMATgbl(j,1)=ftxmingbl+ftFSdelxgbl*(jj-1);
      ftFSiparmMATgbl(j,2)=ftFSdelxgbl/2;
     end; %for j
   end; %if

%   if (ftFSiLVtypeVECgbl(1,1)==4)
%   end

%   if (ftFSiLVtypeVECgbl(1,1)==5)
%   end

 end; %for i

 for i=1:ftFSNo_outCNTgbl
   ftFSil1_=(ftFSmax_LVSCAgbl*(i-1))+1; ftFSil2_=ftFSil1_+ftFSolingVECgbl(i)-1;
   ftFSxmaxgbl=ftFSomaxVECgbl(i);
   ftxmingbl=ftFSominVECgbl(i);
   ftFSdelxgbl=(ftFSxmaxgbl-ftxmingbl)/(ftFSolingVECgbl(i)-1);
   if (ftFSoLVtypeVECgbl(1,1)==1)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSoparmMATgbl(j,2)=ftxmingbl+ftFSdelxgbl*(jj-1);
      newval=ftFSoparmMATgbl(j,2)-ftFSdelxgbl;
      if(newval<=ftxmingbl)
	ftFSoparmMATgbl(j,1)=ftxmingbl;
      else
	ftFSoparmMATgbl(j,1)=newval;
      end; %if
      if(newval+(2*ftFSdelxgbl)>=ftFSxmaxgbl)
	ftFSoparmMATgbl(j,3)=ftFSxmaxgbl;
      else
	ftFSoparmMATgbl(j,3)=newval+(2*ftFSdelxgbl);
      end; %if
     end; % for
   end; % if

   if (ftFSoLVtypeVECgbl(1,1)==2)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSoparmMATgbl(j,2)=ftxmingbl+ftFSdelxgbl*(jj-1)-ftFSdelxgbl/2;
      newval=ftFSoparmMATgbl(j,2)-(ftFSdelxgbl/2);
      if(newval<=ftxmingbl)
	ftFSoparmMATgbl(j,1)=ftxmingbl;
      else
	ftFSoparmMATgbl(j,1)=newval;
      end; %if
      ftFSoparmMATgbl(j,3)=ftFSoparmMATgbl(j,2)+ftFSdelxgbl;
      newval=ftFSoparmMATgbl(j,3)+(ftFSdelxgbl/2);
      if(newval >=ftFSxmaxgbl)
	ftFSoparmMATgbl(j,4)=ftFSxmaxgbl;
      else
	ftFSoparmMATgbl(j,4)=newval;
      end; %if
     end; % for j
   end; % if

   if (ftFSoLVtypeVECgbl(1,1)==3)
     jj=0;
     for j=ftFSil1_:ftFSil2_
      jj=jj+1;
      ftFSoparmMATgbl(j,1)=ftxmingbl+ftFSdelxgbl*(jj-1);
      ftFSoparmMATgbl(j,2)=ftFSdelxgbl/2;
     end; %for j
   end; %if

%   if (ftFSoLVtypeVECgbl(1,1)==4)
%   end

%   if (ftFSoLVtypeVECgbl(1,1)==5)
%   end
 
 end; %for i
 %=====================
 % Go back one screen
 %=====================
 ftFSpp4_=['close; ftfs3(' num2str(ftFSpflag_) ',' num2str(ftFSil1_) ',' num2str(ftFSil2_) ')'];
 ftFSpp4_=['close; ftfs3(' num2str(ftFSpflag_) ')'];

 ftscrpb(ftFSfig_fsbaseGUI,'Done',[0.35 0.05 0.3 0.1],ftFSpp4_);
end
%
% end ftfsaset.m
%

