%
% ftfsdisp.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Displays and saves complete FS system description as a text string.
%

function ftfsdisp(STRING)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl 
global ftFSfuztypeSCAgbl ftFSfuzltypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSimptypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl ftFSpfGUI
global ftview_countGUI ftview_stringGUI ftFSfig_fsviewGUI
global fuztitle ftFSimptypenMATgbl ftFSaggrtypenMATgbl ftFSdeftypenMATgbl
global ftFSfmftypenMATgbl ftFSfmfcntVECgbl ftFStypeSCAgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
global ftFSTSKTypeNameMATgbl ftFSTSKTypeVECgbl

if nargin < 1

%position=[40 45 540 375].*ftXYscaleVECgbl;
%ftFSfig_fsviewGUI=ftfigure('ftFSfig_fsviewGUI','FlexTool (FS) -- Fuzzy System View',position,'on','none');

ftFSfig_fsviewGUI=ftfigure('ftFSfig_fsviewGUI','FlexTool (FS) -- Fuzzy System View',ftFigPos_bigVECgbl,'on','none');


ftFSpp2_='FlexTool(FS) is compiling all the data. Please Wait.';
ftFSpp3_=[0.2 0.55 0.6 0.1];
ftflag_edtGUI(997)=uicontrol(gcf, ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'HorizontalAlignment','left',...
        'Position',ftFSpp3_, ...
        'String',ftFSpp2_);
clear ftFSpp1_ ftFSpp2_ ftFSpp3_;

fs_string=' ';
if(ftFSfuzltypeSCAgbl)
	fsid=['FlexTool  Multiple'];
else
	fsid=['FlexTool']; 
end;

ftFSdummy_=[fsid ' FUZZY SYSTEM'];
fs_string=str2mat(fs_string,ftFSdummy_);
ftFSdummy_=['Type                   : ' fuztitle(ftFStypeSCAgbl,:)];
fs_string=str2mat(fs_string,ftFSdummy_);

if ftFSfuztypeSCAgbl ~=2 %No TSK
 ftFSdummy_=['Type of Aggregation    : ' ftFSaggrtypenMATgbl(ftFSaggrtypeSCAgbl,:)];
 fs_string=str2mat(fs_string,ftFSdummy_); 
 ftFSdummy_=['Type of Implication    : ' ftFSimptypenMATgbl(ftFSimptypeSCAgbl,:)];
 fs_string=str2mat(fs_string,ftFSdummy_);
 ftFSdummy_=['Type of Defuzzification: ' ftFSdeftypenMATgbl(ftFSdeftypeSCAgbl,:)];
 fs_string=str2mat(fs_string,ftFSdummy_);
end

fs_string=str2mat(fs_string,' ');

in_string=['Number of Inputs   : ' num2str(ftFSNo_inCNTgbl)];
in_string=str2mat(in_string,' ');

min_string=num2str(ftFSiminVECgbl(1));
max_string=num2str(ftFSimaxVECgbl(1));
ling_string=num2str(ftFSilingVECgbl(1));

for i=2:ftFSNo_inCNTgbl
  min_string=str2mat(min_string, num2str(ftFSiminVECgbl(i)));
  max_string=str2mat(max_string, num2str(ftFSimaxVECgbl(i)));
  ling_string=str2mat(ling_string, num2str(ftFSilingVECgbl(i)));
end

tmpStringVEC_=['P(a)      ' ; 'P(a,b)    ' ; 'P(a,b,c)  ' ; 'P(a,b,c,d)'];

for i=1:ftFSNo_inCNTgbl
 ftFSdummy_=['Name: ' ftFSinameVECgbl(i,:) ' ; ' 'Min: ' min_string(i,:) ' ; ' ...
                 'Max: ' max_string(i,:) ' ; ' 'Units: ' ftFSiunitVECgbl(i,:) ' ; ' ...
                 '# of LV: ' ling_string(i,:)];
 in_string=str2mat(in_string,ftFSdummy_);
 in_string=str2mat(in_string,' ');
 for j=1:ftFSilingVECgbl(i)
  count=j+(i-1)*ftFSmax_LVSCAgbl;
  tmpValStrVEC_=num2str(ftFSiparmMATgbl(count,1:ftFSfmfcntVECgbl(ftFSiLVtypeVECgbl(count))),2); 
  ftFSdummy_=['    LV Name: ' ftFSiLVnameVECgbl(count,:) ' ; ' 'LV Type: ' ftFSfmftypenMATgbl(ftFSiLVtypeVECgbl(count),:) ' ; ' ...
          tmpStringVEC_(ftFSfmfcntVECgbl(ftFSiLVtypeVECgbl(count)),:) ' = ' tmpValStrVEC_];
  in_string=str2mat(in_string,ftFSdummy_);
 end
 in_string=str2mat(in_string,' ');
end

out_string=['Number of Outputs: ' num2str(ftFSNo_outCNTgbl)];
out_string=str2mat(out_string,' ');

min_string=num2str(ftFSominVECgbl(1));
max_string=num2str(ftFSomaxVECgbl(1));
ling_string=num2str(ftFSolingVECgbl(1));

for i=2:ftFSNo_outCNTgbl
  min_string=str2mat(min_string, num2str(ftFSominVECgbl(i)));
  max_string=str2mat(max_string, num2str(ftFSomaxVECgbl(i)));
  ling_string=str2mat(ling_string, num2str(ftFSolingVECgbl(i)));
end

if ftFSfuztypeSCAgbl ~= 2 %if not TSK
 for i=1:ftFSNo_outCNTgbl
  ftFSdummy_=['Name: ' ftFSonameVECgbl(i,:) ' ; ' 'Min: ' min_string(i,:) ' ; ' ...
                 'Max: ' max_string(i,:) ' ; ' 'Units: ' ftFSounitVECgbl(i,:) ' ; ' ...
                 '# of LV: ' ling_string(i,:)];
  out_string=str2mat(out_string,ftFSdummy_);
  out_string=str2mat(out_string,' ');
  for j=1:ftFSolingVECgbl(i)
   count=j+(i-1)*ftFSmax_LVSCAgbl;
   tmpValStrVEC_=num2str(ftFSoparmMATgbl(count,1:ftFSfmfcntVECgbl(ftFSoLVtypeVECgbl(count))),2); 
   ftFSdummy_=['    LV Name: ' ftFSoLVnameVECgbl(count,:) ' ; ' 'LV Type: ' ftFSfmftypenMATgbl(ftFSoLVtypeVECgbl(count),:) ' ; ' ...
          tmpStringVEC_(ftFSfmfcntVECgbl(ftFSoLVtypeVECgbl(count)),:) ' = ' tmpValStrVEC_];
   out_string=str2mat(out_string,ftFSdummy_);
  end
  out_string=str2mat(out_string,' ');
 end
end

clear tmpStringVEC_, tmpValStrVEC_;

rule_string=['Number of Rules= ' num2str(ftFSNo_rulesCNTgbl) ' ;'];

cpp1=str2mat(...
  'AND',...
  'OR'); 
rule_string=str2mat(rule_string,' ');
if ftFSfuztypeSCAgbl==2
  rule_string=str2mat(rule_string, ['TSK Outputs are of the form:']);
  rule_string=str2mat(rule_string, ['          Output=B0+B1*(Input #1)+B2*(Input #2)+.....']);
  rule_string=str2mat(rule_string,' ');
end
for i=1:ftFSNo_rulesCNTgbl
 ftFSdummy_=['Rule # ' num2str(i)];
 rule_string=str2mat(rule_string,ftFSdummy_);
 rule_string=str2mat(rule_string,' ');

 count=1;
 if(ftFSincMATgbl(i,count)-1 ~= 0) & ftFSinlMATgbl(i,count)~=0
  crit_name=ftFSinameVECgbl(ftFSincMATgbl(i,count)-1,:);
  junk_kk=ftFSinlMATgbl(i,count)+ftFSmax_LVSCAgbl*(ftFSincMATgbl(i,count)-2);
  LV_name=ftFSiLVnameVECgbl(junk_kk,:);
  ftFSdummy_=['IF        ' crit_name '  IS   ' LV_name];
  rule_string=str2mat(rule_string,ftFSdummy_);

  while ftFSinrMATgbl(i,count)~=0,
   count=count+1;
   if(ftFSincMATgbl(i,count)-1 ~=0) & ftFSinlMATgbl(i,count)~=0
     conj_string=cpp1(ftFSinrMATgbl(i,count-1),:); 
     crit_name=ftFSinameVECgbl(ftFSincMATgbl(i,count)-1,:);
     junk_kk=ftFSinlMATgbl(i,count)+ftFSmax_LVSCAgbl*(ftFSincMATgbl(i,count)-2);
     LV_name=ftFSiLVnameVECgbl(junk_kk,:);
     ftFSdummy_=['   ' conj_string ' ' crit_name ' IS   ' LV_name];
     rule_string=str2mat(rule_string,ftFSdummy_);
   end
  end; % while  
 end; % if
 
 count=1;
 if ftFSfuztypeSCAgbl == 2 %TSK
  if(ftFSoutcMATgbl(i,count)-1 ~=0) 
   crit_name=ftFSonameVECgbl(ftFSoutcMATgbl(i,count)-1,:);
   ijk2=ftFSNo_outCNTgbl*(i-1)+count;
   LV_name=['( '];
   LV_name=[LV_name 'B0 = ' num2str(ftFSoparmMATgbl(ijk2,1))];

   for ijk=1:ftFSNo_inCNTgbl
    ijk1=ijk+1;
    LV_name=[LV_name ', B' num2str(ijk) '= ' num2str(ftFSoparmMATgbl(ijk2,ijk1))];
   end
   LV_name=[LV_name ' )'];
   ftFSdummy_=['THEN   ' crit_name ' IS   ' LV_name];
   rule_string=str2mat(rule_string,ftFSdummy_);

   while ftFSoutrMATgbl(i,count)~=0,
    count=count+1;
   % if(ftFSoutcMATgbl(i,count)-1 ~=0) & ftFSoutlMATgbl(i,count)~=0
       if(ftFSoutcMATgbl(i,count)-1 ~=0)
      conj_string=cpp1(ftFSoutrMATgbl(i, count-1),:); 
      crit_name=ftFSonameVECgbl(ftFSoutcMATgbl(i,count)-1,:);
      LV_name=['( '];
      ijk2=ftFSNo_outCNTgbl*(i-1)+count;
      LV_name=[LV_name 'B0 = ' num2str(ftFSoparmMATgbl(ijk2,1))];
      for ijk=1:ftFSNo_inCNTgbl
       ijk1=ijk+1;
       LV_name=[LV_name ', B' num2str(ijk) '= ' num2str(ftFSoparmMATgbl(ijk2,ijk1))];
      end
      LV_name=[LV_name ' )'];
      ftFSdummy_=['   ' conj_string ' ' crit_name ' IS   ' LV_name];
      rule_string=str2mat(rule_string,ftFSdummy_);
    end
   end; % while  
  end; % if
 else
  if(ftFSoutcMATgbl(i,count)-1 ~=0) & ftFSoutlMATgbl(i,count)~=0
   crit_name=ftFSonameVECgbl(ftFSoutcMATgbl(i,count)-1,:);
   junk_kk=ftFSoutlMATgbl(i,count)+ftFSmax_LVSCAgbl*(ftFSoutcMATgbl(i,count)-2);
   LV_name=ftFSoLVnameVECgbl(junk_kk,:);
   ftFSdummy_=['THEN   ' crit_name ' IS   ' LV_name];
   rule_string=str2mat(rule_string,ftFSdummy_);

   while ftFSoutrMATgbl(i,count)~=0,
    count=count+1;
    if(ftFSoutcMATgbl(i,count)-1 ~=0) & ftFSoutlMATgbl(i,count)~=0
      conj_string=cpp1(ftFSoutrMATgbl(i, count-1),:); 
      crit_name=ftFSonameVECgbl(ftFSoutcMATgbl(i,count)-1,:);
      junk_kk=ftFSoutlMATgbl(i,count)+ftFSmax_LVSCAgbl*(ftFSoutcMATgbl(i,count)-2);
      LV_name=ftFSoLVnameVECgbl(junk_kk,:);
      ftFSdummy_=['   ' conj_string ' ' crit_name ' IS   ' LV_name];
      rule_string=str2mat(rule_string,ftFSdummy_);
    end
   end; % while  
  end; % if
 end % if loop for TSK 
 rule_string=str2mat(rule_string,' ');
end; % for

ftview_stringGUI=str2mat(fs_string,in_string,out_string,rule_string);
[ro,co]=size(ftview_stringGUI);
clear fs_string in_string out_string rule_string
ftview_countGUI=20;

%ftscrpb(ftFSfig_fsviewGUI,'Done',[0.03 0.02 0.15 0.06],'close');
ftscrpb(ftFSfig_fsviewGUI,'Done',[0.03 0.02 0.1 0.08],'close');

fid=1;
ftFSpp4_=['ftfssave(' num2str(ro) ')'];

%ftscrpb(ftFSfig_fsviewGUI,'Save',[0.23 0.02 0.15 0.06],ftFSpp4_);
ftscrpb(ftFSfig_fsviewGUI,'Save',[0.23 0.02 0.1 0.08],ftFSpp4_);

clear ftFSpp4_;

%ftscrpb(ftFSfig_fsviewGUI,'Edit',[0.43 0.02 0.15 0.06],'close; ftfs1');
ftscrpb(ftFSfig_fsviewGUI,'Edit',[0.43 0.02 0.1 0.08],'close; ftfs1');

else
 delete(ftflag_edtGUI(999));
 delete(ftflag_edtGUI(998));
 delete(ftflag_edtGUI(997));
end % more view

view_size=size(ftview_stringGUI,1);

pp41=['ftview_countGUI=ftview_countGUI-20; ftfsdisp(''again'')'];
pp42=['ftview_countGUI=ftview_countGUI+20; ftfsdisp(''again'')'];

if ftview_countGUI < view_size,
 ONOFF2='on'; 
else
 ONOFF2='off'; 
end

if ftview_countGUI <= 20,
 ONOFF1='off'; 
else
 ONOFF1='on'; 
end

 ftflag_edtGUI(999)=uicontrol('Style','push',...
   'String','Up ^',...
   'Units','normalized',...
   'Position',[0.63 0.02 0.1 0.08],...
   'Visible',ONOFF1,...
   'CallBack',pp41);
%   'Position',[0.63 0.02 0.15 0.06],...

 ftflag_edtGUI(998)=uicontrol('Style','push',...
   'Units','normalized',...
   'Position',[0.83 0.02 0.1 0.08],...
   'String','Down v',...
   'Visible',ONOFF2,...
   'CallBack',pp42);
%   'Position',[0.83 0.02 0.15 0.06],...


if nargin < 1, 
  ftFSpp2_=ftview_stringGUI((1:20),:);
else
  if ftview_countGUI>view_size, ftview_countGUI=view_size; end
  if ftview_countGUI<20,        ftview_countGUI=20;        end
  ftFSpp2_=ftview_stringGUI(((ftview_countGUI-19):ftview_countGUI),:);
end

ftFSpp3_= [0.05 0.15 0.9 0.8];
ftFSpp1_=['FUZZY SYSTEM:'];

ftflag_edtGUI(997)=uicontrol(gcf, ...
	'Style','edit', ...
        'Units','normalized', ...
        'Max',10,...
        'BackgroundColor',[1 1 1], ...
        'HorizontalAlignment','left',...
        'Position',ftFSpp3_, ...
        'String',ftFSpp2_);

 ftFSpp1_='"Save" option saves the complete information in "ftfsinfo.out"';
 ftFSpp3_=[0.05 0.1 0.9 0.05];
% ftscrtxt(ftFSfig_fsviewGUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

%
% end ftfsdisp.m
%
