%
% ftfsparm.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% FlexTune for tuning FS parameters
%

function ftfsparm(ftFSpflag_,iling)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl mat_parm
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI 
global ftSlide_aGUI ftSlide_bGUI ftSlide_cGUI ftSlide_dGUI ftFt_PlotGUI ftxmingbl ftFSxmaxgbl ftFSdelxgbl  
global ftFSvarCNTgbl ftFSlingCNTgbl
global ftFSfmftypenMATgbl ftFSfmfilenMATgbl ftFSfmfcntVECgbl
global ftXYscaleVECgbl ftSliderMax ftSliderMin

if(ftFSpflag_==1) 
 ftFSNo_lingCNTgbl=ftFSilingVECgbl; 
 vec_type=ftFSiLVtypeVECgbl; 
 mat_parm=ftFSiparmMATgbl; 
 ftFSxmaxgbl=ftFSimaxVECgbl(ftFSvarCNTgbl);
 ftxmingbl=ftFSiminVECgbl(ftFSvarCNTgbl);
elseif(ftFSpflag_==2)
 ftFSNo_lingCNTgbl=ftFSolingVECgbl; 
 vec_type=ftFSoLVtypeVECgbl; 
 mat_parm=ftFSoparmMATgbl; 
 ftFSxmaxgbl=ftFSomaxVECgbl(ftFSvarCNTgbl); 
 ftxmingbl=ftFSominVECgbl(ftFSvarCNTgbl);
end; % if

ftFSlingCNTgbl=iling;

position=[100 100 400 300].*ftXYscaleVECgbl;
ftFSlala_=['Parameters for ' ftFSfmftypenMATgbl(vec_type(ftFSlingCNTgbl),:) ' ftFSfmfSTRgbl'];

fig_fs4=ftfigure('fig_fs4',ftFSlala_,position,'on','none');

label(1)='a'; label(2)='b'; label(3)='c'; label(4)='d';

%
% Determine number of parameters for the particular ftFSfmfSTRgbl choosen
%
no_of_parm=ftFSfmfcntVECgbl(vec_type(1,ftFSlingCNTgbl));



% TongSay--making sure that there is no slider limit

ftFSpp4_=['mat_parm(ftFSlingCNTgbl,1)=str2num(get(ftparm_edtGUI(1),''string''));',...
        'mat_parm(ftFSlingCNTgbl,2)=str2num(get(ftparm_edtGUI(2),''string''));',...
        'ftSlide_aGUI_max = get(ftSlide_aGUI,''max'');',...     
        'ftSlide_aGUI_min = get(ftSlide_aGUI,''min'');',...
        'ftSlide_bGUI_max = get(ftSlide_bGUI,''max'');',...
        'ftSlide_bGUI_min = get(ftSlide_bGUI,''min'');',...
        'ftSlide_aGUI_Val = (mat_parm(ftFSlingCNTgbl,1));',...
        'ftSlide_bGUI_Val = (mat_parm(ftFSlingCNTgbl,2));',...
        'if ftSlide_aGUI_Val > ftSlide_aGUI_max;',...   
        'set(ftSlide_aGUI,''max'', ftSlide_aGUI_Val);',...   
        'elseif ftSlide_aGUI_Val < ftSlide_aGUI_min;',...
        'set(ftSlide_aGUI,''min'', ftSlide_aGUI_Val);',...
        'end;',...
        'if ftSlide_bGUI_Val > ftSlide_bGUI_max;',...   
        'set(ftSlide_bGUI,''max'', ftSlide_bGUI_Val);',...   
        'elseif ftSlide_bGUI_Val < ftSlide_bGUI_min;',...
        'set(ftSlide_bGUI,''min'', ftSlide_bGUI_Val);',...
        'end;',...
        'set(ftSlide_aGUI,''value'', (mat_parm(ftFSlingCNTgbl,1)));',...
        'set(ftSlide_bGUI,''value'',(mat_parm(ftFSlingCNTgbl,2)));'];

if(vec_type(1,ftFSlingCNTgbl)==2)
   ftFSpp4_=[ftFSpp4_,...
        'mat_parm(ftFSlingCNTgbl,3)=str2num(get(ftparm_edtGUI(3),''string''));',...
        'mat_parm(ftFSlingCNTgbl,4)=str2num(get(ftparm_edtGUI(4),''string''));',...
        'ftSlide_aGUI_max = get(ftSlide_aGUI,''max'');',...     
        'ftSlide_aGUI_min = get(ftSlide_aGUI,''min'');',...
        'ftSlide_bGUI_max = get(ftSlide_bGUI,''max'');',...
        'ftSlide_bGUI_min = get(ftSlide_bGUI,''min'');',...
        'ftSlide_cGUI_max = get(ftSlide_cGUI,''max'');',...     
        'ftSlide_cGUI_min = get(ftSlide_cGUI,''min'');',...
        'ftSlide_dGUI_max = get(ftSlide_dGUI,''max'');',...
        'ftSlide_dGUI_min = get(ftSlide_dGUI,''min'');',...
        'ftSlide_aGUI_Val = (mat_parm(ftFSlingCNTgbl,1));',...
        'ftSlide_bGUI_Val = (mat_parm(ftFSlingCNTgbl,2));',...
        'ftSlide_cGUI_Val = (mat_parm(ftFSlingCNTgbl,3));',...
        'ftSlide_dGUI_Val = (mat_parm(ftFSlingCNTgbl,4));',...
        'if ftSlide_aGUI_Val > ftSlide_aGUI_max;',...   
        'set(ftSlide_aGUI,''max'', ftSlide_aGUI_Val);',...   
        'elseif ftSlide_aGUI_Val < ftSlide_aGUI_min;',...
        'set(ftSlide_aGUI,''min'', ftSlide_aGUI_Val);',...
        'end;',...
        'if ftSlide_bGUI_Val > ftSlide_bGUI_max;',...   
        'set(ftSlide_bGUI,''max'', ftSlide_bGUI_Val);',...   
        'elseif ftSlide_bGUI_Val < ftSlide_bGUI_min;',...
        'set(ftSlide_bGUI,''min'', ftSlide_bGUI_Val);',...
        'end;',...
        'if ftSlide_cGUI_Val > ftSlide_cGUI_max;',...   
        'set(ftSlide_cGUI,''max'', ftSlide_cGUI_Val);',...   
        'elseif ftSlide_cGUI_Val < ftSlide_cGUI_min;',...
        'set(ftSlide_cGUI,''min'', ftSlide_cGUI_Val);',...
        'end;',...
        'if ftSlide_dGUI_Val > ftSlide_dGUI_max;',...   
        'set(ftSlide_dGUI,''max'', ftSlide_dGUI_Val);',...   
        'elseif ftSlide_dGUI_Val < ftSlide_dGUI_min;',...
        'set(ftSlide_dGUI,''min'', ftSlide_dGUI_Val);',...
        'end;',...
        'set(ftSlide_aGUI,''value'',(mat_parm(ftFSlingCNTgbl,1)));',...
        'set(ftSlide_bGUI,''value'',(mat_parm(ftFSlingCNTgbl,2)));',...
        'set(ftSlide_cGUI,''value'',(mat_parm(ftFSlingCNTgbl,3)));',...
        'set(ftSlide_dGUI,''value'',(mat_parm(ftFSlingCNTgbl,4)));'];
end; % if

if vec_type(1,ftFSlingCNTgbl)==1 | vec_type(1,ftFSlingCNTgbl)==4 | vec_type(1,ftFSlingCNTgbl)==5,
    ftFSpp4_=[ftFSpp4_,...
        'mat_parm(ftFSlingCNTgbl,3)=str2num(get(ftparm_edtGUI(3),''string''));',...
        'ftSlide_aGUI_max = get(ftSlide_aGUI,''max'');',...     
        'ftSlide_aGUI_min = get(ftSlide_aGUI,''min'');',...
        'ftSlide_bGUI_max = get(ftSlide_bGUI,''max'');',...
        'ftSlide_bGUI_min = get(ftSlide_bGUI,''min'');',...
        'ftSlide_cGUI_max = get(ftSlide_cGUI,''max'');',...     
        'ftSlide_cGUI_min = get(ftSlide_cGUI,''min'');',...
        'ftSlide_aGUI_Val = (mat_parm(ftFSlingCNTgbl,1));',...
        'ftSlide_bGUI_Val = (mat_parm(ftFSlingCNTgbl,2));',...
        'ftSlide_cGUI_Val = (mat_parm(ftFSlingCNTgbl,3));',...
        'if ftSlide_aGUI_Val > ftSlide_aGUI_max;',...   
        'set(ftSlide_aGUI,''max'', ftSlide_aGUI_Val);',...   
        'elseif ftSlide_aGUI_Val < ftSlide_aGUI_min;',...
        'set(ftSlide_aGUI,''min'', ftSlide_aGUI_Val);',...
        'end;',...
        'if ftSlide_bGUI_Val > ftSlide_bGUI_max;',...   
        'set(ftSlide_bGUI,''max'', ftSlide_bGUI_Val);',...   
        'elseif ftSlide_bGUI_Val < ftSlide_bGUI_min;',...
        'set(ftSlide_bGUI,''min'', ftSlide_bGUI_Val);',...
        'end;',...
        'if ftSlide_cGUI_Val > ftSlide_cGUI_max;',...   
        'set(ftSlide_cGUI,''max'', ftSlide_cGUI_Val);',...   
        'elseif ftSlide_cGUI_Val < ftSlide_cGUI_min;',...
        'set(ftSlide_cGUI,''min'', ftSlide_cGUI_Val);',...
        'end;',...
        'set(ftSlide_aGUI,''value'',(mat_parm(ftFSlingCNTgbl,1)));',...
        'set(ftSlide_bGUI,''value'',(mat_parm(ftFSlingCNTgbl,2)));',...
        'set(ftSlide_cGUI,''value'',(mat_parm(ftFSlingCNTgbl,3)));'];
end; % if

%TongSay



ftFSdelxgbl=(ftFSxmaxgbl-ftxmingbl)/200;
x = (ftxmingbl:ftFSdelxgbl:ftFSxmaxgbl)';
ha=vec_type(1,ftFSlingCNTgbl);
Pling=['y= ' ftFSfmfilenMATgbl(ha,:) '(x, mat_parm(ftFSlingCNTgbl,:));'];
y = feval(ftFSfmfilenMATgbl(vec_type(1,ftFSlingCNTgbl),:),x, mat_parm(ftFSlingCNTgbl,:));

% normalize FMF curve
y = ftfsnorm(y);

subplot(2,1,1); ftFt_PlotGUI = plot(x,y);
axis([ftxmingbl ftFSxmaxgbl 0 1]);
if no_of_parm==2,
  pt=['title([''a = '' num2str(mat_parm(ftFSlingCNTgbl,1)) '', b = '' num2str(mat_parm(ftFSlingCNTgbl,2))]);'];
  eval(pt);
  pt2=['mat_parm(ftFSlingCNTgbl,1) = get(ftSlide_aGUI,''Value'');', ...
       'mat_parm(ftFSlingCNTgbl,2) = get(ftSlide_bGUI,''Value'');', ...
       'set(ftparm_edtGUI(1),''string'',num2str(mat_parm(ftFSlingCNTgbl,1)));',...
       'set(ftparm_edtGUI(2),''string'',num2str(mat_parm(ftFSlingCNTgbl,2)));',...
        pt];
elseif no_of_parm==3,
  pt=['title([''a = '' num2str(mat_parm(ftFSlingCNTgbl,1)) '', b = '' num2str(mat_parm(ftFSlingCNTgbl,2)) '', c = '' num2str(mat_parm(ftFSlingCNTgbl,3))]);'];
  eval(pt); 
  pt2=['mat_parm(ftFSlingCNTgbl,1) = get(ftSlide_aGUI,''Value'');', ...
       'mat_parm(ftFSlingCNTgbl,2) = get(ftSlide_bGUI,''Value'');', ...
       'mat_parm(ftFSlingCNTgbl,3) = get(ftSlide_cGUI,''Value'');', ...
       'set(ftparm_edtGUI(1),''string'',num2str(mat_parm(ftFSlingCNTgbl,1)));',...
       'set(ftparm_edtGUI(2),''string'',num2str(mat_parm(ftFSlingCNTgbl,2)));',...
       'set(ftparm_edtGUI(3),''string'',num2str(mat_parm(ftFSlingCNTgbl,3)));',...
        pt];
else
  pt=['title([''a = '' num2str(mat_parm(ftFSlingCNTgbl,1)) '', b = '' num2str(mat_parm(ftFSlingCNTgbl,2)) '', c = '' num2str(mat_parm(ftFSlingCNTgbl,3)) '', d = '' num2str(mat_parm(ftFSlingCNTgbl,4))]);'];
  eval(pt);
  pt2=['mat_parm(ftFSlingCNTgbl,1) = get(ftSlide_aGUI,''Value'');', ...
     'mat_parm(ftFSlingCNTgbl,2) = get(ftSlide_bGUI,''Value'');', ...
     'mat_parm(ftFSlingCNTgbl,3) = get(ftSlide_cGUI,''Value'');', ...
     'mat_parm(ftFSlingCNTgbl,4) = get(ftSlide_dGUI,''Value'');', ...
     'set(ftparm_edtGUI(1),''string'',num2str(mat_parm(ftFSlingCNTgbl,1)));',...
     'set(ftparm_edtGUI(2),''string'',num2str(mat_parm(ftFSlingCNTgbl,2)));',...
     'set(ftparm_edtGUI(3),''string'',num2str(mat_parm(ftFSlingCNTgbl,3)));',...
     'set(ftparm_edtGUI(4),''string'',num2str(mat_parm(ftFSlingCNTgbl,4)));',...
      pt];
end

xlabel('Click the sliders or edit to change parameters.');

drawnow
hh = gca;

ftFSpp4_ = ['x=(ftxmingbl:ftFSdelxgbl:ftFSxmaxgbl)'';', ...
        ftFSpp4_,...
        pt,...
        Pling, ...
	'set(ftFt_PlotGUI, ''ydata'', ftfsnorm(y) ); '];

pt2 = ['x=(ftxmingbl:ftFSdelxgbl:ftFSxmaxgbl)'';', ...
        pt2,...
        Pling,...
	'set(ftFt_PlotGUI, ''ydata'', ftfsnorm(y)); '];

if no_of_parm ==2
   pmin=ftxmingbl; pmax=ftFSxmaxgbl; 
  %TongSay  
   TempVal_1 = mat_parm(ftFSlingCNTgbl,1);
   
   if TempVal_1 > pmax 
      TempVal_1=pmax;      
   elseif TempVal_1 < pmin
      TempVal_1=pmin;
   end;
   %TongSay  
   
  x1=0.09; y1=0.4; dx=0.4; dy=0.05; eps=0.05;
  ftSlide_aGUI = uicontrol('Style','slider','Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,  ...
        'Value',TempVal_1,'CallBack',pt2);

  pmin=0.01; pmax=(ftFSxmaxgbl-ftxmingbl)/4;
     
 %TongSay  
   TempVal_2 = mat_parm(ftFSlingCNTgbl,2);
   
   if TempVal_2 > pmax 
      TempVal_2=pmax;      
   elseif TempVal_2 < pmin
      TempVal_2=pmin;
   end;
  %TongSay   
    
  x1=x1+dx+eps; 
  ftSlide_bGUI = uicontrol('Style','slider','Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,  ...
        'Value',TempVal_2,'CallBack',pt2);

elseif no_of_parm == 3
  if vec_type(1,ftFSlingCNTgbl)==1, pmin=ftxmingbl; pmax=ftFSxmaxgbl; end
  if vec_type(1,ftFSlingCNTgbl)==4, pmin=0.01; pmax=ftFSxmaxgbl; end
  if vec_type(1,ftFSlingCNTgbl)==5, pmin=ftxmingbl; pmax=ftFSxmaxgbl; end
  x1=0.025; y1=0.4; dx=0.275; dy=0.05; eps=0.05;
  %TongSay 
   TempVal_1 = mat_parm(ftFSlingCNTgbl,1);
   
   if TempVal_1 > pmax 
      TempVal_1=pmax;      
   elseif TempVal_1 < pmin
      TempVal_1=pmin;
   end;
  %TongSay
  
  ftSlide_aGUI = uicontrol('Style','slider','Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,  ...
        'Value',TempVal_1,'CallBack',pt2);

  if vec_type(1,ftFSlingCNTgbl)==4, pmin=1; pmax=10.0; end
  if vec_type(1,ftFSlingCNTgbl)==5, pmin=ftxmingbl; pmax=ftFSxmaxgbl; end
  x1=x1+dx+eps; 
  
  %TongSay 
   TempVal_2 = mat_parm(ftFSlingCNTgbl,2);
   
   if TempVal_2 > pmax 
      TempVal_2=pmax;      
   elseif TempVal_2 < pmin
      TempVal_2=pmin;
   end;
  %TongSay
  
  ftSlide_bGUI = uicontrol('Style','slider','Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,  ...
        'Value',TempVal_2,'CallBack',pt2);

  if vec_type(1,ftFSlingCNTgbl)==4, pmin=ftxmingbl; pmax=ftFSxmaxgbl; end
  if vec_type(1,ftFSlingCNTgbl)==5, pmin=-10; pmax=10; end
  x1=x1+dx+eps;
 %TongSay  
   TempVal_3 = mat_parm(ftFSlingCNTgbl,3);
   
   if TempVal_3 > pmax 
      TempVal_3=pmax;      
   elseif TempVal_3 < pmin
      TempVal_3=pmin;
   end;
  %TongSay 
  ftSlide_cGUI = uicontrol('Style','slider','Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax, ...
        'Value',TempVal_3,'CallBack',pt2);
else
  pmin=ftxmingbl; pmax=ftFSxmaxgbl;
  x1=0.025; y1=0.4; dx=0.2; dy=0.05; eps=0.05;
 %TongSay  
  TempVal_1 = mat_parm(ftFSlingCNTgbl,1);
   
   if TempVal_1 > pmax 
      TempVal_1=pmax;      
   elseif TempVal_1 < pmin
      TempVal_1=pmin;
   end;
  %TongSay 
  ftSlide_aGUI = uicontrol('Style','slider', 'Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,  ...
        'Value',TempVal_1,'CallBack',pt2);

     x1=x1+dx+eps; 
 %TongSay     
     TempVal_2 = mat_parm(ftFSlingCNTgbl,2);
    
   if TempVal_2 > pmax 
      TempVal_2=pmax;      
   elseif TempVal_2 < pmin
      TempVal_2=pmin;
   end;
  %TongSay

  ftSlide_bGUI = uicontrol('Style','slider', 'Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax,...
        'Value',TempVal_2,'CallBack',pt2);
     x1=x1+dx+eps;
     
 %TongSay     
   TempVal_3 = mat_parm(ftFSlingCNTgbl,3);
  
   if TempVal_3 > pmax 
      TempVal_3=pmax;      
   elseif TempVal_3 < pmin
      TempVal_3=pmin;
   end;
  %TongSay
  
  ftSlide_cGUI = uicontrol('Style','slider', 'Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax, ...
        'Value',mat_parm(ftFSlingCNTgbl,3),'CallBack',pt2);

     x1=x1+dx+eps;
     TempVal_4 = mat_parm(ftFSlingCNTgbl,4);
%TongSay  
   if TempVal_4 > pmax 
      TempVal_4=pmax;      
   elseif TempVal_4 < pmin
      TempVal_4=pmin;
   end;
 %TongSay

 ftSlide_dGUI = uicontrol('Style','slider', 'Units', 'normalized',...
        'Position',[x1 y1 dx dy],...
        'Min',pmin,'Max',pmax, ...
        'Value',TempVal_4,'CallBack',pt2);

end




y0=0.25; dy=0.065; eps=0.05;

if no_of_parm==2, x0=0.09;  dx_txt=0.4; end
if no_of_parm==3, x0=0.025;  dx_txt=0.275; end
if no_of_parm==4, x0=0.025; dx_txt=0.2; end

for i=1:no_of_parm

  j=i-1;
  ftFSpp1_=['Parameter ' label(i)];
  ftFSpp3_=[x0 y0 dx_txt dy];
  ftscrtxt(fig_fs4,ftFSpp1_,ftFSpp3_);
  clear ftFSpp1_;

  ftFSpp1_=num2str(mat_parm(ftFSlingCNTgbl,i));
  ftFSpp3_=[x0 y0-2*dy dx_txt dy];
  ftparm_edtGUI(i)=uicontrol(fig_fs4,...
	       'Style','edit', ...
               'Units','normalized', ...
               'Position',ftFSpp3_, ...
               'BackgroundColor',[0.50 0.50 0.50], ...
	       'ForegroundColor',[1 1 1], ...
               'String',ftFSpp1_,...
               'callback',ftFSpp4_);
  x0=x0+dx_txt+eps;
end

%=====================
% Go back one screen
%=====================
if ftFSpflag_==1, ftFSpp4_=['ftfswsve; ftFSiparmMATgbl=mat_parm; close']; end
if ftFSpflag_==2, ftFSpp4_=['ftfswsve; ftFSoparmMATgbl=mat_parm; close']; end

ftscrpb(fig_fs4,'Done',[0.4 0.025 0.2 0.075],ftFSpp4_);

%
% end ftfsparm.m
%

