%
% ftfsrul1.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% FlexTool(FS) Rule definition GUI--Part 1.
%
function ftfsrul1(i_begin,i_end)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSolrnMATgbl ftFSilrnMATgbl ftFStskbMATgbl
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSimptypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI fig_fs22
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl ftscr_cntSCAgbl ftFSN_totalCNTgbl ftEFMFLGgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl
global ftpbrul2H_VECgbl

save_cnt=ftscr_cntSCAgbl;
ftpbrul2H_VECgbl=zeros(ftFSmax_outSCAgbl,1);

ftFSlala_=['FlexTool (FS) -- Rules Definition -- Rule' num2str(ftFSruleCNTgbl)];

fig_fs22=ftfigure('fig_fs22',ftFSlala_,ftFigPos_bigVECgbl,'on','figure');

fthelp(fig_fs22,'fs');

      
         
ftFSpp2_=[ 'FlexTool lets you add, delete, and edit the rules. Addition is done by selecting "Add A Rule" button. Deletion is done ',...
            'by selecting the "Delete This Rule" button. All rules are "if then" rules. Only valid parts of an incomplete rule are ',...
            'kept. Inputs and Outputs are chosen by using the individual popup menus. Similarly, the linguistic variables can also ',...
            'be chosen. Click on the "Auto Settings" button to clear/create all possible Rules. For Fuzzy TSK, click on the ',...
            '"TSK Settings" button.'];


ftFSpp3_= [0.99 0.05 0.95 0.7 0.04 0.001];
ftFSpp1_='FlexTool(FS) Help on Options';
ftscrhlp(fig_fs22,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

ftFS2FLGgbl=0;

x0=0.025; y0=0.675; dy=0.05; dx=0; eps=0.02;
dx_no=0.065; dx_name=0.18; dx_lvname=0.125; dx_learn=0.15; dx_no1=0.1;
dx_name1=0.14; dx_no2=0.05;

if nargin<1,
 ftFSN_totalCNTgbl=ftFSNo_inCNTgbl+ftFSNo_outCNTgbl;
 i_begin=1;
 i_end=i_begin+7; 
 if i_end > ftFSN_totalCNTgbl, i_end=ftFSN_totalCNTgbl; end
end

if (ftFSN_totalCNTgbl) > 8, 
 ftFSpp3_=[x0 y0-9*0.06 dx_learn dy];
 ftFSpp1_='more';
 ftFSpp4_=['close; ftFSN_totalCNTgbl=ftFSN_totalCNTgbl-8; ftfsrul1(' num2str(i_begin+8) ',' num2str(i_end+8) ')'];
 ftscrpb(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end

if (ftFSNo_inCNTgbl+ftFSNo_outCNTgbl-ftFSN_totalCNTgbl) > 7
 ftFSpp3_=[x0 y0-0.06 dx_learn dy];
 ftFSpp1_='back';
 ftFSpp4_=['close; ftFSN_totalCNTgbl=ftFSN_totalCNTgbl+8; ftfsrul1(' num2str(i_begin-8) ',' num2str(i_end-8) ')'];
 ftscrpb(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end

if i_begin<1, i_begin=1; end
if i_end>(ftFSNo_inCNTgbl+ftFSNo_outCNTgbl), i_end=ftFSNo_inCNTgbl+ftFSNo_outCNTgbl; end
dx0=dx;

%================
% Loop through
%================
 idisp=0;
 for i=i_begin:i_end
  idisp=idisp+1;
  if i==1,
         if isempty(ftEFMFLGgbl)==0,
            ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
            ftFSpp1_=str2mat(...
                            'No-learn',...
                            'GA-Learn'); 
            dx=dx_lvname+eps;
            ftFSpp3_=[x0 y0-idisp*0.06 dx_learn dy];
            ftFSpp4_=['ftFSrulelearnVECgbl(' num2str(ftFSruleCNTgbl) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftefmlrn(0,4,' num2str(ftFSruleCNTgbl) ');'];
            ftFSpp5_=ftFSrulelearnVECgbl(ftFSruleCNTgbl);
            ftFSpp6_=[1;0];
            ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
            clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_
         end
        
    ftFSpp1_='IF';
    dx=dx_learn+eps;
    ftFSpp3_=[x0+dx y0-0.06*idisp dx_no1 dy];
    ftscrtxt(fig_fs22,ftFSpp1_,ftFSpp3_);
    clear ftFSpp1_ ftFSpp3_;
  end

  if i > 1 & i <= ftFSNo_inCNTgbl
    ftscr_cntSCAgbl=ftscr_cntSCAgbl+1; 
    ftFSpp1_=str2mat(...
    ' ',...
    'AND',...
    'OR'); 
    dx=dx_learn+eps;
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_no1 dy];
    ftFSpp4_=['ftFSinrMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(i-1) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'')-1;'];
    ftFSpp5_=ftFSinrMATgbl(ftFSruleCNTgbl,(i-1))+1;
    ftFSpp6_=[1;0];
    ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
    clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_
  end
  if i<= ftFSNo_inCNTgbl
    dx0=dx_learn+eps;
    ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
    dx=dx0+dx_no1+eps;
    ftFSpp1_=['                    '; ftFSinameVECgbl(1:ftFSNo_inCNTgbl,:)];
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_name dy];
    ftFSpp4_=['ftFSincMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(i) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
        'ftfsrul2(fig_fs22,ftFSincMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(i) '),' num2str(ftscr_cntSCAgbl) ',' num2str(idisp) ',' num2str(i) ',1);'];
    ftFSpp5_=ftFSincMATgbl(ftFSruleCNTgbl,i);
    ftFSpp6_=[0:ftFSNo_inCNTgbl];
    ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
    clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_

    ftfsrul2(fig_fs22,ftFSincMATgbl(ftFSruleCNTgbl,i),ftscr_cntSCAgbl,idisp,i,1,0);

    ftFSpp1_='IS';
    dx=dx+dx_name+eps;
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_no dy];
    ftscrtxt(fig_fs22,ftFSpp1_,ftFSpp3_);
    clear ftFSpp1_ ftFSpp3_;

    ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
    if isempty(ftEFMFLGgbl)==0,
     ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
     ftFSpp1_=str2mat(...
             'No-learn',...
             'GA-Learn'); 
     dx=dx+dx_name+dx_no+2*eps;
     ftFSpp3_=[x0+dx y0-idisp*0.06 dx_learn dy];
     ftFSpp4_=['ftFSilrnMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(i) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
     ftFSpp5_=ftFSilrnMATgbl(ftFSruleCNTgbl,i);
     ftFSpp6_=[1;0];
     ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
     clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_
    end
  end
 %================
 % Outputs
 %================
  if i==ftFSNo_inCNTgbl+1
    idisp=idisp+1;
    ftFSpp1_='THEN';
    dx=dx_learn+eps;
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_no1 dy];
    ftscrtxt(fig_fs22,ftFSpp1_,ftFSpp3_);
    clear ftFSpp1_ ftFSpp3_;
  end
  if i > ftFSNo_inCNTgbl
    j=i-ftFSNo_inCNTgbl;
    k=i;
    if j > 1
      ftscr_cntSCAgbl=ftscr_cntSCAgbl+1; 
      ftFSpp1_=str2mat(...
            ' ',...
            'AND',...
            'OR'); 
      dx=dx_learn+eps;
      ftFSpp3_=[x0+dx y0-idisp*0.06 dx_no1 dy];
      ftFSpp4_=['ftFSoutrMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j-1) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'')-1;'];
      ftFSpp5_=ftFSoutrMATgbl(ftFSruleCNTgbl,(j-1))+1;
      ftFSpp6_=[1;0];
      ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
      clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_
    end

    ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
    dx0=dx_learn+eps;
    dx=dx0+dx_no1+eps;
    ftFSpp1_=['                    '; ftFSonameVECgbl(1:ftFSNo_outCNTgbl,:)];
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_name dy];

    if ftFSfuztypeSCAgbl~=2 % Not TSK
         ftFSpp4_=['ftFSoutcMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
        'ftfsrul2(fig_fs22,ftFSoutcMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j) '),' num2str(ftscr_cntSCAgbl) ',' num2str(idisp) ',' num2str(j) ',2);'];
    else
 	 ftFSpp4_=['ftFSoutcMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
        'ftfsrul2(fig_fs22,num2str(ftFSoutcMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j) ')),' num2str(ftscr_cntSCAgbl) ',' num2str(idisp) ',' num2str(j) ',2);'];
    end;

    ftFSpp5_=ftFSoutcMATgbl(ftFSruleCNTgbl,j);
    ftFSpp6_=[0:ftFSNo_outCNTgbl];
    ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
    clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_

    ftfsrul2(fig_fs22,ftFSoutcMATgbl(ftFSruleCNTgbl,j),ftscr_cntSCAgbl,idisp,j,2,0);
    
    ftFSpp1_='IS';
    dx=dx+dx_name+eps;
    ftFSpp3_=[x0+dx y0-idisp*0.06 dx_no dy];
    ftscrtxt(fig_fs22,ftFSpp1_,ftFSpp3_);
    clear ftFSpp1_ ftFSpp3_;

    ftscr_cntSCAgbl=ftscr_cntSCAgbl+2;
    if ftFSfuztypeSCAgbl~=2 % Not TSK
      if isempty(ftEFMFLGgbl)==0,
         ftFSpp1_=str2mat(...
                'No-learn',...
                'GA-Learn'); 
         dx=dx+dx_name+dx_no+2*eps;
         ftFSpp3_=[x0+dx y0-idisp*0.06 dx_learn dy];
         ftFSpp4_=['ftFSolrnMATgbl(' num2str(ftFSruleCNTgbl) ',' num2str(j) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
         ftFSpp5_=ftFSolrnMATgbl(ftFSruleCNTgbl,j);
         ftFSpp6_=[1;0];
         ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
         clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_
      end
    end
  end
 end
%end

%=========
% Buttons
%=========
ftFSpp4_=['if ftFSruleCNTgbl > ftFSNo_rulesCNTgbl, ftFSNo_rulesCNTgbl=ftFSruleCNTgbl; end; ftFSruleCNTgbl=1; ftfswsve; close;'];
ftscrpb(fig_fs22,'Done',[0.025 0.05 0.1 0.07],ftFSpp4_);

ftscrpb(fig_fs22,'Auto Settings',[0.15 0.05 0.175 0.07],'close; ftfsaset(1);');
ftscrpb(fig_fs22,'Delete This Rule',[0.35 0.05 0.225 0.07],'ftfsdrul;');

ftFSpp4_=['ftfswsve; close; ftFSNo_rulesCNTgbl=ftFSNo_rulesCNTgbl+1; ftFSruleCNTgbl=ftFSNo_rulesCNTgbl; ftfsaset(1,1); ftfsrul1;'];
ftscrpb(fig_fs22,'Add A Rule',[0.6 0.05 0.175 0.07],ftFSpp4_);

ftFSpp1_='GoTo Rule';
ftFSpp3_=[0.8 0.01 0.175 0.05];
ftscrtxt(fig_fs22,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_ ftFSpp3_;

ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;

ftFSpp1_='Rule 1';
for i=2:ftFSNo_rulesCNTgbl
 ftFSpp1_=str2mat(ftFSpp1_,['Rule ' num2str(i)]); 
end

ftFSpp3_=[0.8 0.06 0.175 0.07];
ftFSpp4_=['ftfswsve; ftFSruleCNTgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); close; ftfsrul1'];
ftFSpp5_=ftFSruleCNTgbl;
ftFSpp6_=[1:ftFSNo_rulesCNTgbl];
ftscrpup(fig_fs22,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
clear ftFSpp1_ ftFSpp3_ ftFSpp4_ ftFSpp5_ ftFSpp6_

ftscr_cntSCAgbl=save_cnt;

%
% end ftfsrul1.m
%
