%
% FTfsrul3.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% FlexTool(FS) Rule definition GUI--Part 3.
%

function ftfsrul3(var_no)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSolrnMATgbl ftFSilrnMATgbl ftFStskbMATgbl
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSimptypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI fig_fs22
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl ftscr_cntSCAgbl ftFSN_totalCNTgbl ftEFMFLGgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl

ftFSlala_=['Fuzzy TSK Model Output Definition -- Rule' num2str(ftFSruleCNTgbl)];
fig_fs23=ftfigure('fig_fs23',ftFSlala_,ftFigPos_medVECgbl,'on','figure');

fthelp(fig_fs23,'fs');

ftFSpp2_=str2mat(...
 	    'FlexTool lets you enter a linear output relationship for each',...
            'rule output. The format is as follows:',...
	    ' Output_1 = B0+B1*Input_1+...+Bn*Input_n',...
	    'The crisp output Y, after applying all the r rules:',...
            ' Weight_rule_r=(deg.of firing_rule_r)/sum1_r(deg.of firing_rule)',...
            ' Output Y = Sum1_r(Weight_rule_i * Output_i)',...
            'Type in the constants B0 through Bn.');

ftFSpp3_= [0.95 0.05 0.95 0.6 0.06 0.002];
ftFSpp1_='FlexTool(FS) Help on Options';
ftscrhlp(fig_fs23,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

x0=0.35; y0=0.5; dy=0.075; dx=0; eps=0.02;
dx_no=0.065; dx_data=0.19; dy1=0.085; 

if ftFSNo_inCNTgbl > 4, x0=0.05; end

save_cnt=ftscr_cntSCAgbl;
ijk1=1;
ijk2=ftFSNo_outCNTgbl*(ftFSruleCNTgbl-1)+(var_no-1);
idisp=0;
ftFSpp1_='B0';
ftFSpp3_=[x0 y0-idisp*dy1 dx_no dy];
ftscrtxt(fig_fs23,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_ ftFSpp3_

dx=dx_no+eps;
ftFSpp1_=num2str(ftFSoparmMATgbl(ijk2,ijk1));
ftFSpp3_=[x0+dx y0-idisp*dy1 dx_data dy];
ftFSpp4_=['ftFSoparmMATgbl(' num2str(ijk2) ',' num2str(ijk1) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
ftscredt(fig_fs23,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
clear ftFSpp1_ ftFSpp3_ ftFSpp4_;

for i=1:ftFSNo_inCNTgbl
 if i==5, x0=0.35; idisp=-1; end
 if i==10, x0=0.65; idisp=-1; end
 idisp=idisp+1;
 ijk1=ijk1+1;
 ftFSpp1_=['B' num2str(i)];
 ftFSpp3_=[x0 y0-idisp*dy1 dx_no dy];
 ftscrtxt(fig_fs23,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1; 
 dx=dx_no+eps;
 ftFSpp1_=num2str(ftFSoparmMATgbl(ijk2,ijk1));
 ftFSpp3_=[x0+dx y0-idisp*dy1 dx_data dy];
 ftFSpp4_=['ftFSoparmMATgbl(' num2str(ijk2) ',' num2str(ijk1) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
 ftscredt(fig_fs23,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_
end
ftscr_cntSCAgbl=save_cnt;

ftscrpb(fig_fs23,'Done',[0.4 0.025 0.2 0.08],'ftfswsve; close');

%
% End FTfsrul3.m
%
