%
% ftfsrun.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
%
% Runs Fuzzy System
%

function ftfsrun(ftFSopts_)

global ftFSfuztypeSCAgbl ftFSinfnameSTRgbl ftscr_cntSCAgbl
global ftFigPos_medVECgbl ftFSbprmSCAgbl

if(ftusecal)
ftFSfig_fsrunGUI=ftfigure('ftFSfig_fsrunGUI','FlexTool (FS) -- Input Data',ftFigPos_medVECgbl,'on','figure');

if(ftFSopts_==1)
        ftFSpp2_=[' Enter Name of ".m" file that will generate input data.',...
            ' Please ensure that it returns input data. ',...
            ' Ex: ftFS_inMATgbl=yourfilename.',...
            ' Default mode uses "fs_in" variable in the workspace.',...
            ' Click on the Run/Test button to run the complete FS.',...
            ' The outputs of FS are stored in the variable "results".'];

        ftFSpp3_= [0.95 0.05 0.95 0.35 0.075 0.01];
        ftFSpp1_='FlexTool(FS) Help on Options';
        ftscrhlp(ftFSfig_fsrunGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

	x0=0.05; y0=0.2; dy=0.075; dy1=0.075; dx=0.5; dx1=0.2; dx2=0.15; eps=0.02;
 	ftFSpp1_='Enter File Name';
 	ftFSpp3_=[x0 y0 dx dy];
 	ftscrtxt(ftFSfig_fsrunGUI,ftFSpp1_,ftFSpp3_);

  	ftFSpp3_=[x0+dx+eps y0 dx1 dy];
	ftFSbprmSCAgbl = ftFSinfnameSTRgbl;
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	ftFSpp4_=['clear ftFSbprmSCAgbl; ftFSbprmSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'');',... 
             'ftFSinfnameSTRgbl=ftfile(ftFSinfnameSTRgbl); if(exist(ftFSinfnameSTRgbl)),',...
             'ftFS_inMATgbl=feval(ftFSinfnameSTRgbl); else, ftdispwn(''Attention! Exception'' , ''Note!',...
             'using ftFS_inMATgbl default input data!''); end;'];
   ftscredt(ftFSfig_fsrunGUI,ftFSbprmSCAgbl, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
       
      pp41=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(FS): Use a .m File'',50,50);',...
            'if junkname~=0, ',...
            ' ftFSinfnameSTRgbl=junkname;',...
            ' set(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'',ftFSinfnameSTRgbl); ftFSinfnameSTRgbl=ftfile(ftFSinfnameSTRgbl);',...
            ' ftFS_inMATgbl=feval(ftFSinfnameSTRgbl);',...
            'end;'];
        ftscrpb(ftFSfig_fsrunGUI,'..Browse',[x0+dx+dx1+2*eps y0 dx2 dy],pp41);
	clear ftFSpp4_;

elseif(ftFSopts_==2)

       ftFSpp2_=[' Create input data vector/matrix in the workspace.',...
            ' Then enter the name of the vector/matrix here.',...
            ' Number of rows=Number of data sets.',...
            ' Number of columns=Number of Inputs to the Fuzzy System.',...
            ' Click on the Run/Test button to run the complete FS.',...
            ' The outputs of FS are stored in the variable "results".'];
       
        ftFSpp3_= [0.95 0.05 0.95 0.35 0.075 0.01];
        ftFSpp1_='FlexTool(FS) Help on Options';
        ftscrhlp(ftFSfig_fsrunGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

	x0=0.13; y0=0.2; dy=0.1; dy1=0.12; dx=0.5; dx2=0.19; eps=0.02;
 	ftFSpp1_='Enter Variable Name';
 	ftFSpp3_=[x0 y0 dx dy];
 	ftscrtxt(ftFSfig_fsrunGUI,ftFSpp1_,ftFSpp3_);

  	ftFSpp3_=[x0+dx+eps y0 dx2 dy];
	ftFSbprmSCAgbl = 'ftFS_inMATgbl';
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	ftFSpp4_=['clear ftFSbprmSCAgbl; ftFSbprmSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); if(exist(ftFSbprmSCAgbl)), ftFS_inMATgbl=eval(ftFSbprmSCAgbl); else, ftdispwn(''Attention! Exception!!'' , ''Note! Using default input data in ftFS_inMATgbl''); end;'];
  	ftscredt(ftFSfig_fsrunGUI,ftFSbprmSCAgbl, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
	clear ftFSpp4_;

end; % if

if((ftFSfuztypeSCAgbl==3)|(ftFSfuztypeSCAgbl==4))
	ftFSpp1_='Enter Qualifying Criteria Vector in workspace: ';
 	ftFSpp3_=[x0 y0-3*(dy+eps) dx dy];
 	ftscrtxt(ftFSfig_fsrunGUI,ftFSpp1_,ftFSpp3_);
 	clear ftFSpp1_
   	ftFSpp3_=[x0+dx+eps y0-3*(dy+eps) dx2 dy];
	ftFSbprmSCAgbl = 'ftFSqual_critMATgbl';
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	ftFSpp4_=['clear ftFSbprmSCAgbl; ftFSbprmSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); if(exist(ftFSbprmSCAgbl)), ftFSqual_critMATgbl=ftFSbprmSCAgbl; else, ftdispwn(''Attention! Exception!!'' , ''Note! Using default input data in ftFSqual_critMATgbl''); end;'];
  	ftscredt(ftFSfig_fsrunGUI,ftFSbprmSCAgbl, ftFSpp3_, ftFSpp4_,ftscr_cntSCAgbl);
  	clear ftFSpp4_
end; %if 
	
ftscrpb(ftFSfig_fsrunGUI,'Cancel',[0.1 0.05 0.2 0.09],'close');

ftFSpp4_=['ftFSyouriterSTRgbl=1; ftFSyinitnameSTRgbl=''ftefobj5''; ftFSyobjname1STRgbl=''ftefobj6'';',...
     'if((ftFSfuztypeSCAgbl==3)|(ftFSfuztypeSCAgbl==4)), ftFSyobjname2STRgbl=''ftefobj9''; results=ftfsobb,',...
     'else, ftFSyobjname2STRgbl=''ftefobj7''; results=ftfsoba, end; close'];

ftscrpb(ftFSfig_fsrunGUI,'Run/Test',[0.7 0.05 0.2 0.09],ftFSpp4_);

else
	ftdispwn('Exception Detected!','Attention!! Missing FS parameters!');
end; %if

%
% end ftfsrun.m
%


