%
% ftfssave.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Saves data using a user defined mat file
%

function ftfssave(ro)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl ftFSpfGUI
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl
global ftFSrulelearnVECgbl ftFStypeSCAgbl ftFSfmfilenMATgbl ftFSfuncfilenMATgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSimptypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI
global ftFSvarCNTgbl ftFSlingCNTgbl ftFSruleCNTgbl
global ftview_countGUI ftview_stringGUI ftFSfig_fsviewGUI ftFigPos_smallVECgbl
global ftpbrul2H_VECgbl  ftFSfmfcntVECgbl

if nargin<1
 [ftFSpfGUI funpath]=uiputfile(ftFSpfGUI,'FlexTool(FS): Save FUZZY SYSTEM Parameters. Use a .mat File',50,50);
else
 ftFSfspf1GUI='ftfsinfo.txt';
 [ftFSfspf1GUI funpath]=uiputfile(ftFSfspf1GUI,'FlexTool(FS): Save FUZZY SYSTEM Description. ASCII format.',50,50);
end

if nargin<1 & ftFSpfGUI ~=0
  ftFSpp4_=[ 'fstypes(1)=ftFSfuztypeSCAgbl;',...
 'fstypes(2)=ftFSaggrtypeSCAgbl;',...
 'fstypes(3)=ftFSdeftypeSCAgbl;',...
 'fstypes(4)=ftFSimptypeSCAgbl;',...
 'fstypes(5)=ftFSimplicateSTRgbl;',...
 'fstypes(6)=ftFSaggregateSTRgbl;',...
 'eval([''save '' funpath ftFSpfGUI '' ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl ',...
 'ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ',...
 'ftFSNo_rulesCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl ftFSfmfilenMATgbl ',...
 'ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl ',...
 'ftFSiLVtypeVECgbl ftFSiLVnameVECgbl ftFSfuztypeSCAgbl ftFSfmfcntVECgbl ftFSfuncfilenMATgbl ',...
 'ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl ',...
 'ftFSoLVtypeVECgbl ftFSoLVnameVECgbl ftFSrulelearnVECgbl ftFSiLVlearnVECgbl ftFSoLVlearnVECgbl ',...
 'ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl ',...
 'ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl ',...
 'fstypes ftFSfmfparmMATgbl ftFSaggrparmMATgbl ftFSdefparmMATgbl ftFSdefuzSTRgbl ftFStypeSCAgbl ftpbrul2H_VECgbl'']);'];

 eval(ftFSpp4_);
 clear ftFSpp4_
else
 ftFSpfGUI='ftfuzzy.mat';
end

if nargin > 0 & ftFSfspf1GUI ~=0
 mydate=num2str(date); 
 fid=fopen( [funpath ftFSfspf1GUI], 'w' );
 fprintf(fid, '%s\n', mydate); 
 for(i=1:ro)
  fprintf(fid,'%s\n',ftview_stringGUI(i,:)); 
 end; 
 fclose(fid);
end

%
% end ftfssave.m
%
