%
% ftfs_def.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Some declarations required for FlexTool(FS) and FlexTool(EFM)
%

function ftfs_def(junk)

ftscreen;

if nargin > 0, 
  ftFSmax_rulesSCAgbl=20;
  ftFSmax_LVSCAgbl=20;
  ftFSmax_inSCAgbl=20;
  ftFSmax_outSCAgbl=20;
  ftfsdef_flagGUI=1;
end

if exist('ftfsdef_flagGUI')==0

clear all
global ftcolor_bc1VECgbl ftcolor_bc2VECgbl ftcolor_fc1VECgbl ftfig_defGUI ftfsdef_flagGUI
ftscreen;

ftcolor_bc1VECgbl=[0 0 1];
ftcolor_bc2VECgbl=[0.5 0.5 0.5];
ftcolor_fc1VECgbl=[1 1 1];

ftfsdef_flagGUI=1;
ftFSmax_rulesSCAgbl=20;
ftFSmax_LVSCAgbl=20;
ftFSmax_inSCAgbl=20;
ftFSmax_outSCAgbl=20;

ftFigPos_mediumVECgbl=[200 175 400 250].*ftXYscaleVECgbl;

ftfig_defGUI=figure( ...
	'NumberTitle','off', ...
	'Name','FlexTool (FS) -- Default Values', ...
	'Color',[0 0 0],...
        'Units','normalized',...
        'Position',ftFigPos_mediumVECgbl,...
        'MenuBar','figure', ...
	'Resize','on', ...
	'Pointer','crosshair');

%=================
% Big Text Block
%=================

ftFSpp2_=str2mat(...
            ' FlexTool(FS) lets the user define limits on Inputs, Outputs,',...
            ' Linguistic Variables, and Rules. These limits are used to',...
            ' define the data structures. CAUTION! These limits should',...
            ' not be changed once a FS is defined. They can be changed for',...
            ' any new problem. Hit "Set Defaults" to define defaults.');
 
     ftFSpp3_= [0.975 0.05 0.95 0.7 0.005 0.005];
     ftFSpp1_='FlexTool(FS) Help on Options';
     ftscrhlp(ftfig_defGUI,ftFSpp1_,ftFSpp2_,ftFSpp3_);

 x0=0.05; y0=0.6; dy=0.075; dy1=0.06; dx=0.5; dx1=0.2; eps=0.02;
 
 ftFSpp1_='Maximum # of Inputs';
 ftFSpp3_=[x0 y0 dx+dx1 dy1];
 ftscrtxt(ftfig_defGUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

edt_funp=uicontrol('Style','edit',...
'Units','normalized', ...
'string',num2str(ftFSmax_inSCAgbl),...
'Position',[x0+dx+dx1+eps y0 dx1 dy1],...
'callback',['ftFSmax_inSCAgbl=str2num(get(edt_funp,''string''));']);

ftFSpp1_='Maximum # of outputs';
ftFSpp3_=[x0 y0-dy dx+dx1 dy1];
ftscrtxt(ftfig_defGUI,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

edt_gap=uicontrol('Style','edit',...
'string',num2str(ftFSmax_outSCAgbl),...
'Units','normalized', ...
'Position',[x0+dx+dx1+eps y0-dy dx1 dy1],...
'callback',['ftFSmax_outSCAgbl=str2num(get(edt_gap,''string''));']);

ftFSpp1_='Maximum # of Linguistic Variables per Input and Output';
ftFSpp3_=[x0 y0-3*dy dx+dx1 2*dy1];
ftscrtxt(ftfig_defGUI,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

edt_gap1=uicontrol('Style','edit',...
'string',num2str(ftFSmax_LVSCAgbl),...
'Units','normalized', ...
'Position',[x0+dx+dx1+eps y0-3*dy dx1 2*dy1],...
'callback',['ftFSmax_LVSCAgbl=str2num(get(edt_gap1,''string''));']);

ftFSpp1_='Maximum # of Rules';
ftFSpp3_=[x0 y0-4*dy dx+dx1 dy1];
ftscrtxt(ftfig_defGUI,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

edt_gap2=uicontrol('Style','edit',...
'string',num2str(ftFSmax_rulesSCAgbl),...
'Units','normalized', ...
'Position',[x0+dx+dx1+eps y0-4*dy dx1 dy1],...
'callback',['ftFSmax_rulesSCAgbl=str2num(get(edt_gap2,''string''));']);

ftscrpb(ftfig_defGUI,'Exit',[0.1 0.02 0.3 0.09],'close');

ftFSpp4_=['ftscrtxt(ftfig_defGUI,[''FlexTool is creating all the default data structures. Please Wait.''],[0.15 0.125 0.7 0.14]);',...
     'ftfs_def;',...
     'ftscrtxt(ftfig_defGUI,[''FLexTool has created all the Data Structures. ''],[0.15 0.125 0.7 0.14]);',...
     'ftscrpb(ftfig_defGUI,''Done'',[0.1 0.02 0.3 0.09],''close'');'];

ftscrpb(ftfig_defGUI,'Set Defaults',[0.6 0.02 0.3 0.09],ftFSpp4_);

else

clear ftfsdef_flagGUI
ftscr_cntSCAgbl = 1;
ftFSdef_LVCNTgbl=8;

fuztitle=str2mat(...
'Fuzzy Controller', ...
'Fuzzy Controller (TSK)', ...
'Fuzzy Decision Maker', ...
'Fuzzy Evaluator', ...
'Fuzzy Predictor', ...
'Fuzzy Expert System');
ftFSpp_typeMATgbl=fuztitle;


%=============================================================================
% Fuzzy Membership Function Name
% selected using vec_LVtype / mat_fmftype

ftFSNo_fmfsCNTgbl = 3;

ftFSfmfilenMATgbl=str2mat(...
'ftfstria', ...
'ftfstrap', ...
'ftfsgaus');

 ftFSfmftypenMATgbl=str2mat(...
 'Triangular',...
 'Trapezoidal',...
 'Gaussian');
 
% Number of parameters for each Fuzzy Membership Function
% note: FlexTool computes No_fmfparm using mat_fmftype and ftFSfmfcntVECgbl

ftFSfmfcntVECgbl=[3 4 2];

%
% default fuzzy membership function parameter values
%
ftFSdfmfparmMATgbl=[-0.5 0 0.5 0; -0.5 -0.25 0.25 0.5; 0 1 0 0];

ftFSfmfparmMATgbl=ftFSdfmfparmMATgbl;






%ftFSNo_fmfsCNTgbl = 5;

%ftFSfmfilenMATgbl=str2mat(...
%'ftfstria', ...
%'ftfstrap', ...
%'ftfsgaus', ...
%'ftfsgenb', ...
%'ftfsexpo');

% ftFSfmftypenMATgbl=str2mat(...
% 'Triangular',...
 %'Trapezoidal',...
 %'Gaussian',...
 %'Generalized Bell',...
 %'Exponential');

%% Number of parameters for each Fuzzy Membership Function
%% note: FlexTool computes No_fmfparm using mat_fmftype and ftFSfmfcntVECgbl

%ftFSfmfcntVECgbl=[3 4 2 3 3];

%
%% default fuzzy membership function parameter values
%
%ftFSdfmfparmMATgbl=[-0.5 0 0.5 0; -0.5 -0.25 0.25 0.5; 0 1 0 0; 0.2 0.025 0.5 0; 0.2 0.2 0.2 0];

%ftFSfmfparmMATgbl=ftFSdfmfparmMATgbl;
%====================================================================================


% Implication Choices
% selected using imtype

ftFSimpnameMATgbl=str2mat(...
'ftfslukw', ...
'ftfskldl', ...
'ftfsklnd', ...
'ftfszadi', ...
'ftfswill', ...
'ftfsmami', ...
'ftfspdti', ...
'ftfsgodl', ...
'ftfsmeni', ...
'ftfsreci');

ftFSimptypenMATgbl=str2mat(...
'Lukasiewicz',...
'Kleene-D-L ',...
'Kleen-D',...
'Zadeh',...
'Willmott',...
'Mamdani (Min)',...
'Larsen (Product)',...
'Godel-Brouwer',...
'Menger-Goguen',...
'Reichenbach');

% Aggregation Choices
% selected using ftFSaggrtypeSCAgbl
% Set up also the default parameters and their ranges
% ftFSaggrparmMATgbl contains this info. 
% In each row, first 2 are parameters, next two - range
%
ftFSdaggrparmMATgbl=[0 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0; 1 0 0 1; 1 0 0 1; 1 0 0 1; 1 0 0 1; 1 0 0 1; 1 0 0 1];
ftFSaggrpcntVECgbl=[0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0]; 

ftFSaggrfilenMATgbl=str2mat(...
'ftfsmaxa', ...
'ftfsmina', ...
'ftfspdii', ...
'ftfsimin', ...
'ftfsyagu', ...
'ftfsyagi', ...
'ftfshamu', ...
'ftfshami', ...
'ftfsdubu', ...
'ftfsdubi');

%
% default fuzzy aggregation function parameter values
%
ftFSdaggrparmMATgbl=[ftFSdaggrparmMATgbl; 1 0 -1 1; 1 0 -1 1; 1 0 0 1; 1 0 0 1; 1 0 -1 1; 1 0 0 0; 1 0 0 0; 0 0 0 0; 0 0 0 0];

ftFSaggrparmMATgbl=ftFSdaggrparmMATgbl;

ftFSaggrfilenMATgbl=str2mat(ftFSaggrfilenMATgbl, ...
'ftfssklu', ...
'ftfsskli', ...
'ftfsdomu', ...
'ftfsdomi', ...
'ftfsgenm', ...
'ftfsluku', ...
'ftfsluki', ...
'ftfspdii', ...
'ftfssumu');

%
% Name of the Aggregation parameters
%
ftFSaggrparmnMATgbl=str2mat(...
' ', ...
' ', ...
' ', ...
' ', ...
'Omega W', ...
'Omega W', ...
'Lambda', ...
'Lambda', ...
'Alpha', ...
'Alpha');

ftFSaggrparmnMATgbl=str2mat(ftFSaggrparmnMATgbl, ...
'p ', ...
'p ', ...
'Alpha', ...
'Alpha', ...
'Alpha', ...
' ', ...
' ', ...
' ', ...
' ');

ftFSaggrtypenMATgbl=str2mat(...
'Simple Max',...
'Simple Min',...
'Hard Max',...
'Hard Min',...
'Yager-Union',...
'Yager-Intersection',...
'Hamacher-Union',...
'Hamacher-Intersection',...
'Duboi-P-Union',...
'Duboi-P-Intersection');

ftFSaggrtypenMATgbl=str2mat(ftFSaggrtypenMATgbl,...
'Sklar-Union',...
'Sklar-Intersection',...
'Dombi-Union',...
'Dombi-Intersection',...
'Generalized Means',...
'Lukasiewicz-Union',...
'Lukasiewicz-Intersection',...
'Product-Intersection',...
'Prob. Sum-Union');

% Defuzzification Choices
% selected using ftFSdeftypeSCAgbl

ftFSdefuznameMATgbl=str2mat(...
'ftfsdcoa', ...
'ftfsdmom', ...
'ftfsdmoh', ...
'ftfsbadd', ...
'ftfsmsli', ...
'ftfslide', ...
'ftfsrage', ...
'ftfsdefu');

ftFSNo_defuzCNTgbl=8;

%
% default fuzzy defuzzification parameter values
%
ftFSddefparmMATgbl=zeros(ftFSNo_defuzCNTgbl,ftFSmax_inSCAgbl+4);
ftFSddefparmMATgbl(3,1:4)=[1 0 0 4];
ftFSddefparmMATgbl(4,1:4)=[0 0 0 1];
ftFSddefparmMATgbl(5,1:4)=[1 0 0 1];
ftFSddefparmMATgbl(6,1:6)=[0.5 0.8 0 1 0 1];
ftFSddefparmMATgbl(7,1:4)=[1 0 0 1];

ftFSdefparmMATgbl = ftFSddefparmMATgbl;

ftFSdefpcntVECgbl=[0 0 1 1 2 1 1 0];

ftFSdeftypenMATgbl=str2mat(...
'COA',...
'MOM',...
'MOH',...
'BADD',...
'M-SLIDE',...   
'SLIDE',...
'RAGE',...
'Fuzzy Output');

ftFSdefpfilnMATgbl=str2mat(...
' ', ...
' ', ...
'Alpha-cut', ...
'Alpha', ...
'Beta', ...
'Alpha', ...
'Beta', ...
'Constraint', ...
'Beta', ...
' ');

ftFSfuncfilenMATgbl=str2mat(...
'ftfsfcrs', ...
'ftfstsks', ...
'ftfsfdms', ...
'ftfsfdms', ...
'ftfsfcrs', ...
'ftfsfcrs');


%**************************************************************************************************
ftFSdefmodelMATgbl=str2mat(...
'One FS Model',...
'Two FS Models',...
'Three FS Models',...
'Four FS Models');

ftFSdeflearnoptMATgbl=str2mat(...
'Complete System',...
'Rule Structure',...
'FMF Parameters',...
'Complete System w/ Fine Tune',...
'FMF Parameters w/ Fine Tune');


%**************************************************************************************************


ftFS2FLGgbl=0;
ftFSFLGgbl=1;
FTblanks1_='           ';
FTblanks2_='   ';

ftFSTSKTypeNameMATgbl=str2mat(...
'Linear', ...
'Non-Linear');

ftFSaggrtypeSCAgbl=1;
ftFSdeftypeSCAgbl=1;
ftFSimptypeSCAgbl=6;
ftFSfuztypeSCAgbl=1;
ftFStypeSCAgbl=1;
ftFSfuzltypeSCAgbl=0;

%load defaults
 ftFS2FLGgbl=0;
 for i=1:ftFSmax_inSCAgbl
  ftFSimaxVECgbl(i)=1.0;
  ftFSiminVECgbl(i)=-1.0;
  if i>9,  ftFSiunitVECgbl(i,:)=['Units_' num2str(i) FTblanks2_]; end
  if i<10, ftFSiunitVECgbl(i,:)=['Units_' num2str(i) ' ' FTblanks2_]; end
  if i>9,  ftFSinameVECgbl(i,:)=['Inputs_' num2str(i) FTblanks1_]; end
  if i<10, ftFSinameVECgbl(i,:)=['Inputs_' num2str(i) ' ' FTblanks1_]; end
  ftFSilingVECgbl(i)=ftFSdef_LVCNTgbl;
 end
 for i=1:ftFSmax_outSCAgbl
  ftFSomaxVECgbl(i)=1.0;
  ftFSominVECgbl(i)=-1.0;
  if i>9,  ftFSounitVECgbl(i,:)=['Units_' num2str(i) FTblanks2_]; end
  if i<10, ftFSounitVECgbl(i,:)=['Units_' num2str(i) ' ' FTblanks2_]; end
  if i>9,  ftFSonameVECgbl(i,:)=['Output_' num2str(i) FTblanks1_]; end
  if i<10, ftFSonameVECgbl(i,:)=['Output_' num2str(i) ' ' FTblanks1_]; end
  ftFSolingVECgbl(i)=ftFSdef_LVCNTgbl;
 end
  
 ftFSiparmMATgbl    = rand((ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl),4); 
 ftFSiLVtypeVECgbl  = ones(1,(ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl));
 ftFSiLVlearnVECgbl = ftFSiLVtypeVECgbl;

 ftFSoparmMATgbl    = rand((ftFSmax_LVSCAgbl*ftFSmax_inSCAgbl),ftFSmax_inSCAgbl);
 ftFSoLVtypeVECgbl  = ones(1,(ftFSmax_LVSCAgbl*ftFSmax_outSCAgbl));
 ftFSoLVlearnVECgbl = ftFSoLVtypeVECgbl;

 ftioLVtypeVECgbl  = [];
 ftioLVlearnVECgbl = [];

 ftFSparmMATgbl=0;

i=0;
for k=1:ftFSmax_inSCAgbl
 for j=1:ftFSmax_LVSCAgbl
  i=i+1;
  if i==1, 
    ftFSiLVnameVECgbl=['Ling_i_' num2str(i) '  '];
  else 
    ftFSdummy_=['Ling_i_' num2str(i) '  '];
    ftFSiLVnameVECgbl=str2mat(ftFSiLVnameVECgbl,ftFSdummy_);
  end; % if
 end; % for j loop
end; % for k loop

i=0;
for k=1:ftFSmax_outSCAgbl
 for j=1:ftFSmax_LVSCAgbl
  i=i+1;
  if i==1, 
    ftFSoLVnameVECgbl=['Ling_o_' num2str(i) '  '];
  else 
    ftFSdummy_=['Ling_o_' num2str(i) '  '];
    ftFSoLVnameVECgbl=str2mat(ftFSoLVnameVECgbl,ftFSdummy_);
  end
 end
 ftFSTSKTypeVECgbl(k)=1;
end

ftFSinrMATgbl=zeros(ftFSmax_rulesSCAgbl,ftFSmax_inSCAgbl);
ftFSinlMATgbl=ftFSinrMATgbl;
ftFSincMATgbl=ftFSinrMATgbl+1;

ftFSoutrMATgbl=zeros(ftFSmax_rulesSCAgbl,ftFSmax_outSCAgbl);
ftFSoutlMATgbl=ftFSoutrMATgbl;
ftFSoutcMATgbl=ftFSoutrMATgbl+1;
ftFSrulelearnVECgbl=ones(ftFSmax_rulesSCAgbl,1);

ftFsainrMATgbl=0;
ftFSainlMATgbl=0;
ftFSaincMATgbl=0;
ftFSaoutrMATgbl=0;
ftFsaoutlMATgbl=0;
ftFSaoutcMATgbl=0;

ftFSilrnMATgbl=ones(ftFSmax_rulesSCAgbl,ftFSmax_inSCAgbl);
ftFSolrnMATgbl=ones(ftFSmax_rulesSCAgbl,ftFSmax_outSCAgbl);
ftFStskbMATgbl=zeros(ftFSmax_rulesSCAgbl,ftFSmax_inSCAgbl);

% 
% Base set and resolution/granularity/discretization of ftFSfmfSTRgbl
%
ftFSbase_minSCAgbl  = -1;
ftFSbase_maxSCAgbl  =  1;
ftFSbase_resSCAgbl  = 0.01;
ftFSbase_diffSCAgbl = 2;
ftFSNo_stepsCNTgbl  = 201;
ftFSbase_setVECgbl  = [ftFSbase_minSCAgbl:ftFSbase_resSCAgbl:ftFSbase_maxSCAgbl];

ftFSrbasisMATgbl    = 0;
ftFSbasisMATgbl     = 0;

ftFS_inMATgbl     = [];
ftFSqual_critMATgbl = 0;

ftFSNo_rulesCNTgbl   = 1;
ftFSNo_critCNTgbl    = 2;
ftFSNo_inCNTgbl      = 1;
ftFSNo_outCNTgbl     = 1;
ftFSNo_altCNTgbl     = 1;
ftFSNo_ilingCNTgbl   = ftFSdef_LVCNTgbl*ftFSNo_inCNTgbl;
ftFSNo_olingCNTgbl   = ftFSdef_LVCNTgbl*ftFSNo_outCNTgbl;

ftFSunivMATgbl   = 0;
ftFSdisp1FLGgbl  = 0;
ftFSfmfSTRgbl        = 0;
ftFSimplicateSTRgbl  = 0;
ftFSaggregateSTRgbl  = 0;
ftFSdefuzSTRgbl      = 0;
ftFSvarCNTgbl  = 0;
ftFSlingCNTgbl = 0;
ftFSruleCNTgbl = 1;
ftFSsum_lingVECgbl   = 0;

ftFSmaxsVECgbl=1;
ftFSminsVECgbl=0;

ftFSinfnameSTRgbl=' ';
ftFSyouriterSTRgbl=1;
ftFSyinitnameSTRgbl = 'ftefobj5'; 
ftFSyobjname1STRgbl = 'ftefobj6';
ftFSyobjname2STRgbl = 'ftefobj7';

ftFsaNo_lingCNTgbl = 0;
ftFSaNo_critCNTgbl = 0;
ftFSpfGUI='ftfuzzy.mat';
clear xx ftcolor_bc1VECgbl ftcolor_bc2VECgbl ftcolor_fc1VECgbl

ftFSlvfmfparmMATgbl=ones(ftFSNo_fmfsCNTgbl+1,3*4);

ftFStwo_pow_kVECgbl(1:200)=2.^(0:199);

clear junk  j k i FTblanks1_ FTblanks2_

ftFSfmfcntVECgbl=[3 4 2 3 3];
ftpbrul2H_VECgbl=zeros(ftFSmax_outSCAgbl,1);

save ft3fs_def.mat
end

%
% end ftfs_def.m
%
 
