%
% FTfun_ch
%
% =========================================================================  
%                          FlexTools(EA) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  

%function ftfun_ch
      
global ftEAnopSCAgbl ftEAlchromSCAgbl
 
global ftEApminVECgbl ftEApmaxVECgbl ftEAnbitsVECgbl
global ftEApresVECgbl ftEApresuVECgbl ftEAmchildSCAgbl

global ftEAgapVECgbl ftEAfunpVECgbl ftEAcodingSCAgbl
global ftEAch_flagSCAgbl ftEAfun_flagSCAgbl 
global fts_tableMATgbl ftm_tableMATgbl ftEAp_typeVECgbl
global ftEApslopeVECgbl ftEApcVECgbl ftEAtypeSCAgbl 

%---------------------------    
%Define error messages    
%---------------------------    
FTerror_m1=' Wrong choice. Reenter';    
FTerror_m2=' Sorry, that choice is not available';    
FTerror_m3=' Wrong size. Reenter';    
FTerror_m4=' Maximum is not greater than the minimum. Not a valid choice. Reenter';    
FTwarn_m1=' Warning: EA might not find all the peaks';    

clc;   
%--------------------------------------------    
% # of Objective Function Parameters    
%--------------------------------------------    
if ftEAtypeSCAgbl ~= 4   % not Flex-EA
 ftEAfun_flagSCAgbl = 1;    
 while ftEAfun_flagSCAgbl == 1    
   ftEAfun_flagSCAgbl = 0;    
   disp(' ');
   disp('*******************************************************************');
   disp('MAXIMUM VALUES FOR PARAMETERS -- USER INTERACE ');    
   disp('*******************************************************************');
   disp(' ');
   disp(' Next statement asks for the MAXIMUM VALUE for the parameters.')    
   disp(' For each prompt, you can either enter:')    
   disp('               (a) One number common to all parameters or')     
   disp('               (b) A column vector of the same size or')    
   disp('               (c) The name of a predefined vector.')    
   disp(' ')    
   disp(' Note1: For column vector, enter a row vector transposed')    
   disp(' ')    
   disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
   disp('        create a column vector for MAXIMUM values')    
   disp(' ');    
  %----------------------    
  % MAX Parm. Val.    
  %----------------------    
  ftEAfun_flagSCAgbl=0;    
  FTpmax1  =input(' Enter maximum value for each parameter [Default:Workspace]:  ');    
  if isempty(FTpmax1), ftEAfun_flagSCAgbl=1; ftgakey; FTpmax1=0; end    
  clc;    
  FTsn=size(FTpmax1,1);    
  if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
  if size(FTpmax1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
 end
 ftEAfun_flagSCAgbl = 1;    
 while ftEAfun_flagSCAgbl == 1    
  ftEAfun_flagSCAgbl = 0;    
  disp('*******************************************************************');
  disp('MINIMUM VALUES FOR PARAMETERS -- USER INTERACE ');    
  disp('*******************************************************************');
  disp(' ');
  disp(' Next statement asks for the MINIMUM VALUE for the parameters.')    
  disp(' For each prompt, you can either enter:')    
  disp('               (a) One number common to all parameters or')     
  disp('               (b) A column vector of the same size or')    
  disp('               (c) The name of a predefined vector.')    
  disp(' ')    
  disp(' Note1: For column vector, enter a row vector transposed')    
  disp(' ')    
  disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
  disp('        create a column vector for MINIMUM values')    
  disp(' ')     

  FTpmin1  =input(' Enter minimum value for each parameter [Default:Workspace] :  ');     
  if isempty(FTpmin1), ftgakey; ftEAfun_flagSCAgbl=1; FTpmin1=0; end    
  clc;    
  FTsn=size(FTpmin1,1);    
  if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
  if size(FTpmin1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end 
  if FTpmax1 <= FTpmin1, disp(FTerror_m4); ftEAfun_flagSCAgbl=1; end;
 end   
 %-------------------------    
 % Update MIN, MAX    
 %-------------------------    
 ftEApmaxVECgbl = zeros(ftEAnopSCAgbl,1)+FTpmax1;    
 ftEApminVECgbl = zeros(ftEAnopSCAgbl,1)+FTpmin1;    
 %----------------------------    
 % Parm. RESOLUTION    
 %----------------------------
 ftEAfun_flagSCAgbl = 1;    
 while ftEAfun_flagSCAgbl == 1    
   ftEAfun_flagSCAgbl = 0;    
   disp(' ');
   disp('*******************************************************************');
   disp('RESOLUTION VALUES FOR PARAMETERS -- USER INTERACE ');    
   disp('*******************************************************************');
   disp(' ');
   disp(' Next statement asks for the RESOLUTION for the parameters.')    
   disp(' For each prompt, you can either enter:')    
   disp('               (a) One number common to all parameters or')     
   disp('               (b) A column vector of the same size or')    
   disp('               (c) The name of a predefined vector.')    
   disp(' ')    
   disp(' Note1: For column vector, enter a row vector transposed')    
   disp(' ');    
   disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
   disp('        create a column vector for RESOLUTION values')    
   disp(' ')    
   ftEAfun_flagSCAgbl=0;    
   FTpres1  =input(' Enter resolution value for each parameter [Default: Workspace] :  ');    
   if isempty(FTpres1), ftgakey; ftEAfun_flagSCAgbl=1; FTpres1=0; end    
   clc;    
   FTsn=size(FTpres1,1);    
   if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
   if size(FTpres1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end       
   if FTpres1 <= 0, disp(FTerror_m1); ftEAfun_flagSCAgbl=1; end
 end    
%.......................................................    
% Resolution, Range, Nbits, Lchrom    
%.......................................................    
  ftEApresVECgbl    = zeros(ftEAnopSCAgbl,1)+FTpres1;    
  range   = (ftEApmaxVECgbl-ftEApminVECgbl)./ftEApresVECgbl;    
  ftEAnbitsVECgbl   = ceil(log(range+1.0)./log(2.0));    
  ftEApresuVECgbl   = ftEApresVECgbl;
  ftEApresVECgbl    = (ftEApmaxVECgbl-ftEApminVECgbl)./(2.^(ftEAnbitsVECgbl)-1);
  ftEAlchromSCAgbl  = sum(ftEAnbitsVECgbl);    
%........................    
% Nbits, Lchrom    
%........................    
  ftEAnbitsVECgbl    = zeros(ftEAnopSCAgbl,1)+ftEAnbitsVECgbl;    
  ftEAlchromSCAgbl   = sum(ftEAnbitsVECgbl);    
elseif (ftEAtypeSCAgbl == 4)  % Flex-EA
 ftEAmchildSCAgbl=2;
 ftEAfun_flagSCAgbl = 1;    
 while ftEAfun_flagSCAgbl == 1    
   ftEAfun_flagSCAgbl = 0;    
  
   disp('*******************************************************************');
   disp('MAXIMUM VALUES FOR PARAMETERS -- USER INTERACE ');    
   disp('*******************************************************************');
   disp(' ');
   disp(' Next statement asks for the MAXIMUM VALUE for the parameters.')    
   disp(' For each prompt, you can either enter:')    
   disp('               (a) One number common to all parameters or')     
   disp('               (b) A column vector of the same size or')    
   disp('               (c) The name of a predefined vector.')    
   disp(' ')    
   disp(' Note1: For column vector, enter a row vector transposed')    
   disp(' ')    
   disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
   disp('        create a column vector for MAXIMUM values')    
   disp(' ');    
  %----------------------    
  % MAX Parm. Val.    
  %----------------------    
  FTpmax1  =input(' Enter maximum value for each parameter [Default:Workspace]:  ');    
  if isempty(FTpmax1), ftEAfun_flagSCAgbl=1; ftgakey; FTpmax1=0; end    
  clc;    
  FTsn=size(FTpmax1,1);    
  if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
  if size(FTpmax1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end
 end    
 ftEAfun_flagSCAgbl = 1;    
 while ftEAfun_flagSCAgbl == 1    
  ftEAfun_flagSCAgbl = 0;    
  disp(' ');
  disp('*******************************************************************');
  disp('MINIMUM VALUES FOR PARAMETERS -- USER INTERACE ');    
  disp('*******************************************************************');
  disp(' ');
  disp(' Next statement asks for the MINIMUM VALUE for the parameters.')    
  disp(' For each prompt, you can either enter:')    
  disp('               (a) One number common to all parameters or')     
  disp('               (b) A column vector of the same size or')    
  disp('               (c) The name of a predefined vector.')    
  disp(' ')    
  disp(' Note1: For column vector, enter a row vector transposed')    
  disp(' ')    
  disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
  disp('        create a column vector for MINIMUM values')    
  disp(' ')     
  ftEAfun_flagSCAgbl=0;    
  FTpmin1  =input(' Enter minimum value for each parameter [Default:Workspace] :  ');     
  if isempty(FTpmin1), ftgakey; ftEAfun_flagSCAgbl=1; FTpmin1=0; end    
  clc;    
  FTsn=size(FTpmin1,1);    
  if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
  if size(FTpmin1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end 
  if FTpmax1 <= FTpmin1, disp(FTerror_m4); ftEAfun_flagSCAgbl=1; end;
 end   
 %-------------------------    
 % Update MIN, MAX    
 %-------------------------    
 ftEApmaxVECgbl = zeros(ftEAnopSCAgbl,1)+FTpmax1;    
 ftEApminVECgbl = zeros(ftEAnopSCAgbl,1)+FTpmin1;    
 %---------------------
  ftEAfun_flagSCAgbl = 1;    
  while ftEAfun_flagSCAgbl == 1    
   ftEAfun_flagSCAgbl = 0;    
   disp(' ');
   disp('*******************************************************************');
   disp('RESOLUTION VALUES FOR PARAMETERS -- USER INTERACE ');    
   disp('*******************************************************************');
   disp(' ');
   disp(' Next statement asks for the RESOLUTION for the parameters.')    
   disp(' For each prompt, you can either enter:')    
   disp('               (a) One number common to all parameters or')     
   disp('               (b) A column vector of the same size or')    
   disp('               (c) The name of a predefined vector.')    
   disp(' ')    
   disp(' Note1: For column vector, enter a row vector transposed')    
   disp(' ');    
   disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
   disp('        create a column vector for RESOLUTION values')    
   disp(' ')    
   FTpres1  =input(' Enter resolution value for each parameter [Default: Workspace] :  ');    
   if isempty(FTpres1), ftgakey; ftEAfun_flagSCAgbl=1; FTpres1=0; end    
   clc;    
   FTsn=size(FTpres1,1);    
   if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
   if size(FTpres1,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end       
   if FTpres1 <= 0, disp(FTerror_m1); ftEAfun_flagSCAgbl=1; end    
   ftEApresVECgbl = zeros(ftEAnopSCAgbl,1)+FTpres1;    
  end
  ftEAfun_flagSCAgbl = 1;    
  while ftEAfun_flagSCAgbl == 1    
   ftEAfun_flagSCAgbl = 0;    
   disp(' ');
   disp('*******************************************************************');
   disp('PARAMETER TYPE FOR PARAMETERS -- USER INTERACE ');    
   disp('*******************************************************************');
   disp(' ');
   disp(' Next statement asks for the parameter Type.')    
   disp(' For each prompt, you can either enter:')    
   disp('               (a) One number common to all parameters or')     
   disp('               (b) A column vector of the same size or')    
   disp('               (c) The name of a predefined vector.')    
   disp(' ')    
   disp(' Use the following:');
   disp('  1: Binary, 2: Real and Discrete, 3: Real and Continuous');
   disp(' ');
   disp(' Note1: For column vector, enter a row vector transposed')    
   disp(' ');    
   disp(' Note2: Enter nothing at the next prompt to go to MATLAB Workspace and ')    
   disp('        create a column vector for PARAMETER TYPE values')    
   disp(' ')    
   ftEAfun_flagSCAgbl=0;    
   FTptype_  =input(' Enter parameter type for each parameter [Default: Workspace] :  ');    
   if isempty(FTptype_), ftgakey; ftEAfun_flagSCAgbl=1; ftEAo_typeVECgbl=0; end    
   clc;    
   FTsn=size(FTptype_,1);    
   if FTsn > 1 & FTsn ~= ftEAnopSCAgbl, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end    
   if size(FTptype_,2) ~= 1, disp(FTerror_m3); ftEAfun_flagSCAgbl=1; end       
   if FTptype_ <= 0, disp(FTerror_m1); ftEAfun_flagSCAgbl=1; end
  end    
  ftEAp_typeVECgbl = zeros(ftEAnopSCAgbl,1)+FTptype_;    
 %------------------------------------------------------------  
 % ftEApcVECgbl,ftEApslopeVECgbl,ftEApresVECgbl,ftEAnbitsVECgbl,mean_table,sigma_table,etc.   
 %------------------------------------------------------------
     FTmax_Nbits=12;	%maximum # of bits per variable 
     FTmax_rows=8;

     ftm_tableMATgbl=zeros(FTmax_rows,ftEAnopSCAgbl);
     fts_tableMATgbl=zeros(FTmax_rows,ftEAnopSCAgbl);

     ftEApresuVECgbl 		= ftEApresVECgbl;

     for j=1:ftEAnopSCAgbl
	if ftEAp_typeVECgbl(j) == 1	%Integer Type
      		ftEApcVECgbl(j)     = ftEApminVECgbl(j);
      		ftEAnbitsVECgbl(j)  = ceil(log2(ftEApmaxVECgbl(j)-ftEApminVECgbl(j)+1));
      		ftEApslopeVECgbl(j) = (ftEApmaxVECgbl(j)-ftEApminVECgbl(j))/(2^ftEAnbitsVECgbl(j)-1);
  	end; %if

	if ftEAp_typeVECgbl(j) == 2	%Real Type with discrete values
		ftEApcVECgbl(j)     = ftEApminVECgbl(j);
		ftEApslopeVECgbl(j) = ftEApresVECgbl(j);
		ftEAnbitsVECgbl(j)  = ceil(log2((ftEApmaxVECgbl(j)-ftEApminVECgbl(j))/ftEApresVECgbl(j)));
		ftEApslopeVECgbl(j) = (ftEApmaxVECgbl(j)-ftEApminVECgbl(j))/(2^ftEAnbitsVECgbl(j)-1);
	end; %if 

	if ftEAp_typeVECgbl(j) > 2	%Real Type with continuous values
		for i=1:2^(ftEAp_typeVECgbl(j))
		      ftEApcVECgbl(j)      = 0;
		      ftEApslopeVECgbl(j)  = (ftEApmaxVECgbl(j)-ftEApminVECgbl(j))/(2^ftEAp_typeVECgbl(j)-1);
		      ftm_tableMATgbl(i,j) = ftEApminVECgbl(j)+(i-1)*ftEApslopeVECgbl(j);
		      fts_tableMATgbl(i,j) = ftEApslopeVECgbl(j)/2;
		      ftEAnbitsVECgbl(j)   = ftEAp_typeVECgbl(j);     
		end; %for i
     	end; %if
	ftEAlchromSCAgbl=sum(ftEAnbitsVECgbl);
    end; %for j

end; % if Flex-EA
ft3pak; ftea1;

%
% END FTfun_ch
%
