%
% fthelp.m
%
% =========================================================================  
%                          FlexTool( ) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% General Help module for all FlexTools
%

function fthelp(Help_FigHndle,STRING)

global ftHndleVECgbl 

global ftGA_HelpTopicVECgbl 
global ftFS_HelpTopicVECgbl
global ftEF_HelpTopicVECgbl
global ftEN_HelpTopicVECgbl
global ftNN_HelpTopicVECgbl
global ftCI_HelpTopicVECgbl

HelpLevel=str2mat(...
 'High',...
 'Medium',...
 'Low');

if STRING=='AL'
 pp1=['FT HELP'];
 h2=uimenu('Label',pp1);
end

if STRING=='GA'
  pp1=['GA HELP'];
  h2=uimenu('Label',pp1);

  ftGA_HelpTopicVECgbl=str2mat(...
  'Type of GA',...
  'Selection',...
  'Crossover',...
  'Mutation',...
  'Stopping Criteria',...
  'String Length',...
  'Niching',...
  'Number of Peaks',...
  'Population Size');

  [HlpSize,dummy]=size(ftGA_HelpTopicVECgbl);

  for i=1:HlpSize
  pp4=['ftgahelp(' num2str(i) ',0);'];
  FtHndleVECgbl(i)=uimenu(h2,'Label',ftGA_HelpTopicVECgbl(i,:),...
                 'CallBack',pp4);
  end; % for i loop

elseif STRING=='FS'

  pp1=['FS HELP'];
  h2=uimenu('Label',pp1);
  
  ftFS_HelpTopicVECgbl=str2mat(...
  '1.  Fuzzy Systems (FS)',...
  '2.  Design Choices',...
  '3.  Type Options',...
  '4.  Input/Output',...
  '5.  I/O Names',...
  '6.  I/O Units',...
  '7.  Universe of Discourse',...
  '8.  Base Set',...
  '9.  Linguistic Term',...
  '10. Linguistic Names');
  ftFS_HelpTopicVECgbl=str2mat(ftFS_HelpTopicVECgbl,...
  '11. Membership Function',...
  '12. FMF Learning Scheme',...
  '13. Linguistc Mapper',...
  '14. Rulebase',...
  '15. Rule Structure',...
  '16. Rule Learning Scheme',...
  '17. AND/OR',...
  '18. Implication',...
  '19. Aggregation');
  ftFS_HelpTopicVECgbl=str2mat(ftFS_HelpTopicVECgbl,...
  '20. Defuzzification',...
  '21. Reasoning',...
  '22. Evolutionary Fuzzy Modeling');

  [HlpSize,dummy]=size(ftFS_HelpTopicVECgbl);

  for i=1:HlpSize
   pp4=['ftfshelp(' num2str(i) ');'];
   FtHndleVECgbl(i)=uimenu(h2,'Label',ftFS_HelpTopicVECgbl(i,:),...
      'CallBack',pp4);
   

  end

elseif STRING=='EF'

  pp1=['EFM HELP'];
  h2=uimenu('Label',pp1);

  ftEF_HelpTopicVECgbl=str2mat(...
  '1.  Evolutionary Fuzzy Modeling (EFM)',...
  '2.  Learning Schemes',...
  '3.  Type Options',...
  '4.  Fuzzy Systems',...
  '5.  Genetic Algorithms',...
  '6.  Linguistic Mapper',...
  '7.  Multiple Fuzzy Models',...
  '8.  Objective/Cost Function',...
  '9.  Multiple Objectives');

  [HlpSize,dummy]=size(ftEF_HelpTopicVECgbl);

  for i=1:HlpSize
   pp4=['ftefhelp(' num2str(i) ');'];
   FtHndleVECgbl(i)=uimenu(h2,'Label',ftEF_HelpTopicVECgbl(i,:),...
                 'CallBack',pp4);
  end; % for i loop

elseif STRING=='EN'

  pp1=['ENM HELP'];
  h2=uimenu('Label',pp1);

  ftEN_HelpTopicVECgbl=str2mat(...
  '1.  Evolutionary Neuro Modeling (ENM)',...
  '2.  Learning Schemes',...
  '3.  Type Options',...
  '4.  Neural Systems',...
  '5.  Evolutionary Algorithms',...
  '6.  Sequencer',...
  '7.  Niching',...
  '8.  Multiple Neuro Models',...
  '9.  Objective/Cost Function',...
  '10. Multiple Objectives');

  [HlpSize,dummy]=size(ftEN_HelpTopicVECgbl);

  for i=1:HlpSize
   pp4=['ftenhelp(' num2str(i) ');'];
   FtHndleVECgbl(i)=uimenu(h2,'Label',ftEN_HelpTopicVECgbl(i,:),...
                 'CallBack',pp4);
  end; % for i loop
end; % if

% 
% end fthelp.m
%


