%
% ftlrnseq.m
%
% =========================================================================  
%                          FlexTools(EFM) for Matlab                          
%                             Copyright (c) 1996                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                                 06/05/1996                                  
% =========================================================================  
% ENM Sequencer
function ftlrnseq

global ftcolor_bc1VECgbl  ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl  ftcolor_fc2VECgbl 
global ftXYscaleVECgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl 
global ftFigPos_smallVECgbl ftFigPos_VsmallVECgbl
global ftflag_edtGUI      ftscr_cntSCAgbl    ftenmGUI
%
% ENM
%
global ftENMlrnOPTgbl     ftENMlrnNMATgbl    ftENMmaxSeqCNTgbl
global ftENMSeqChVECgbl   ftENMSeqChNMATgbl  ftENMeaConVECgbl
global ftENMSeqTimeVECgbl ftENMeaWtVECgbl    ftENMeaOptNMATgbl 
global ftENMselInVECgbl   ftENMynNameMATgbl  ftENMassn1MATgbl 
global ftENMassn1CNTgbl   ftENMassn2MATgbl   ftENMassn2CNTgbl
global ftENMassn3MATgbl   ftENMassn3CNTgbl   ftENMassn4MATgbl
global ftENMassn4CNTgbl   ftENMwts1MATgbl    ftENMwts1CNTgbl 
global ftENMwts2MATgbl    ftENMwts2CNTgbl    ftENMwts3MATgbl
global ftENMwts3CNTgbl    ftENMwts4MATgbl    ftENMwts4CNTgbl
global ftENMsameVECgbl    ftENMSeqCNTgbl
%
% NN 
%
global ftFigPos_bigVECgbl ftscr_cntSCAgbl   ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl  fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl   ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl  ftNNno_outSCAgbl 
global ftNNno_totSCAgbl   ftENMwtsMATgbl    ftENMweightOPTgbl 
global ftNNassocMATgbl    ftENMasetFLGgbl   ftNNtypeSCAgbl
global fneuron_           tneuron_          retval_

global sval io1 io2 io3 io4

ftFigPos_bigVECgbl = [60 45 500 375].*   ftXYscaleVECgbl;
ftFigPos_medVECgbl = [120 100 400 250].* ftXYscaleVECgbl;


fig_ef1=ftfigure('fig_ef1','FlexTool(ENM) Learning Sequencer Menu',ftFigPos_bigVECgbl,'on','figure');

%---------
% MENU BAR
%---------
fthelp(fig_ef1,'EN');

ftFSpp3_= [0.98 0.05 0.95 0.45 0.05 0.005];
ftscrblk(fig_ef1,'ENM Learning Sequencer Menu',[' '],ftFSpp3_);
clear ftFSpp3_

ftscrtxt(fig_ef1,'1',[.32 .82 .1 .05]);
ftscrtxt(fig_ef1,'2',[.47 .82 .1 .05]);
ftscrtxt(fig_ef1,'3',[.62 .82 .1 .05]);
ftscrtxt(fig_ef1,'4',[.77 .82 .1 .05]);

ftscrtxt(fig_ef1,'Choice: ',[.06 .76 .2 .05]);

loc_ = 0.30;
rhs_ = 0;

ftFSpp1_=ftENMSeqChNMATgbl;
for(sval=1:4)
	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
        eval(['io' num2str(sval) '= ftENMSeqChVECgbl(1, ' num2str(sval) ');']);
	ftFSpp3_=[loc_+rhs_ .76 .14 .075];
	ftFSpp4_=['io' num2str(sval) '=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
        ' ftENMSeqChVECgbl(1,' num2str(sval) ') = io' num2str(sval) ';'];
	ftFSpp5_=eval(['io' num2str(sval)]);
	ftFSpp6_=[1:size(ftFSpp1_,1)]';
	ftscrpup(fig_ef1,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
	clear ftFSpp3_
	rhs_=rhs_+0.15;
end;
clear ftFSpp1_;

ftscrtxt(fig_ef1,'Duration: ',[.06 .70 .2 .05]);

rhs_ = 0;
for(sval=1:4)
	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
        ftFSpp1_ = ftENMSeqTimeVECgbl(1,sval);
        eval(['io' num2str(sval) '= ftENMSeqTimeVECgbl(1, ' num2str(sval) ');']);
	ftFSpp3_=[loc_+rhs_ .70 .14 .05];
	ftFSpp4_=['io' num2str(sval) '= str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));',...
        ' ftENMSeqTimeVECgbl(1, ' num2str(sval) ')= io' num2str(sval) ';'];
	ftscredt(fig_ef1,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftscr_cntSCAgbl);
	clear ftFSpp3_
	rhs_=rhs_+0.15;
end;
clear ftFSpp1_;

ftFSpp3_=[.06 .63 .88 .05];
ftscrtxt(fig_ef1,'EA Learning Options',ftFSpp3_);
clear ftFSpp3_

ftscrtxt(fig_ef1,'Connection: ',[.06 .57 .2 .05]);

rhs_ = 0;
ftFSpp1_=ftENMeaOptNMATgbl;
for(sval=1:4)
	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
        eval(['io' num2str(sval) '= ftENMeaConVECgbl(1,' num2str(sval) ');']);
	ftFSpp3_=[loc_+rhs_ .57 .14 .075];
	ftFSpp4_=['io' num2str(sval) '=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
	' ftENMeaConVECgbl(1, ' num2str(sval) ')= io' num2str(sval) '; if io' num2str(sval) '==5, ftenmlrn(0,5,0,' num2str(sval) '); end;'];
	ftFSpp5_=eval(['io' num2str(sval)]);
	ftFSpp6_=[1:size(ftFSpp1_,1)]';
	ftscrpup(fig_ef1,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
	clear ftFSpp3_
	rhs_=rhs_+0.15;
end;
clear ftFSpp1_;

ftscrtxt(fig_ef1,'Weight: ',[.06 .51 .2 .05]);

rhs_ = 0;
ftFSpp1_=ftENMeaOptNMATgbl;
for(sval=1:4)
	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
        eval(['io' num2str(sval) '= ftENMeaWtVECgbl(1, ' num2str(sval) ');']);
	ftFSpp3_=[loc_+rhs_ .51 .14 .075];
	ftFSpp4_=['io' num2str(sval) '=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
	' ftENMeaWtVECgbl(1, ' num2str(sval) ')= io' num2str(sval) '; if io' num2str(sval) '==5, ftenmlrn(0,0,5,' num2str(sval) '); end;'];
	ftFSpp5_=eval(['io' num2str(sval)]);
	ftFSpp6_=[1:size(ftFSpp1_,1)]';
	ftscrpup(fig_ef1,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
	clear ftFSpp3_
	rhs_=rhs_+0.15;
end;
clear ftFSpp1_;

ftscrtxt(fig_ef1,'Best Input: ',[.06 .45 .2 .05]);

rhs_=0;
ftFSpp1_=ftENMynNameMATgbl;
for(sval=1:4)
    ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
    eval(['io' num2str(sval) '= ftENMselInVECgbl(1, ' num2str(sval) ');']);
    ftFSpp3_=[loc_+rhs_ .45 .14 .075];
    ftFSpp4_=['io' num2str(sval) '= get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
  	  ' ftENMselInVECgbl(1, ' num2str(sval) ')= io' num2str(sval) ';'];
    ftFSpp5_=eval(['io' num2str(sval)]);
    ftFSpp6_=[1:size(ftFSpp1_,1)]';
    ftscrpup(fig_ef1,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
    clear ftFSpp3_
    rhs_ = rhs_ + 0.15;
end;

clear ftFSpp3_
clear ftFSpp1_

ftENMpp1='FlexTool(ENM) Sequencer Help';
ftENMpp2=str2mat(...
	    'Maximum 4 Phase Sequence are available for ENM learning. Options for learning using:',...
	    '        (a) EA/NN (b) Specify Duration (EA:# generations, NN: Epochs.',...
	    '        (c) Weights/Connections/Best Input');
ftENMpp2=str2mat(ftENMpp2,...
	    '            Caution: Do not use weights & Connections together!',...
	    '            Weights, Connections: None, All, All Fwd, All Rec., Manual',...
	    '            Manual option pops up another window.',...
	    'Recommended Option: Sequence (1)EA,Connections,All. (2)EA,Weights,All. (3)NN');

ftENMpp3= [0.4 0.05 0.95 0.1 0.05 0.005];
ftscrhlp(fig_ef1,ftENMpp1,ftENMpp2,ftENMpp3,'left');
clear ftENMpp1 ftENMpp2 ftENMpp3

ftscrpb(fig_ef1,'Ok',[.45 .005 .1 .075],['ftENMSeqCNTgbl = length(find(ftENMSeqChVECgbl~=1)); ftenset2(2); close;']);

%
% end ftlrnseq.m
%