%
% ftmapart.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% GUI for FlexTool(FS)
%

function ftmapart(ftFSpflag_,ftFSil1_,ftFSil2_)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl 
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI
global ftFSvarCNTgbl ftFSlingCNTgbl ftscr_cntSCAgbl
global ftFigPos_bigVECgbl ftFigPos_medVECgbl FigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl

ftFS2FLGgbl=ftFSpflag_;
ftFSNo_lingCNTgbl=1;
STRING='i';

ftFSfig_fs2GUI=ftfigure('ftFSfig_fs2GUI','FlexTool(EFM) -- LV Mapper Partition Definitions',ftFigPos_bigVECgbl,'on','figure');

fthelp(ftFSfig_fs2GUI,'EF');

ftFSpp2_=str2mat(...
 	    'FlexTool Linguistic Mapper Partition Definer allows the user to enter ', ...
	    'the LV partition markers and LV names for input and output variables.', ...
          '(Ex: for the input variable speed in mph with an Universe of Discourse,', ...
            'Min - Max, 25 - 75, and the 5 LV, the user may set up the partition',...
            'as 35, 45, 55, 65, 75 (where the first partition starts as [25-35]) ',...
            'and the corresponding LV names Very Slow, Slow, Average, Fast, Very Fast.)');

ftFSpp3_= [0.95 0.05 0.95 0.7 0.04 0.002];
ftFSpp1_='FlexTool(EFM) Help on Options';
ftscrhlp(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp2_,ftFSpp3_,'left');

x0=0.05; y0=0.6; dy=0.05; dx=0; eps=0.02;
dx_no=0.05; dx_name=0.2; dx_max=0.1; dx_min=0.1; dx_units=0.15; dx_lv=0.1;

 i=0;
 ftFSpp1_='No';
 ftFSpp3_=[x0 y0-i*0.06 dx_no dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Variable Name';
 dx=dx+dx_no+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_name dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Max';
 dx=dx+dx_name+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_max dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Min';
 dx=dx+dx_max+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_min dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftFSpp1_='Units';
 dx=dx+dx_min+eps;
 ftFSpp3_=[x0+dx y0-i*0.06 dx_units-0.02 dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 if ftFSfuztypeSCAgbl ~=2 | ftFSpflag_==1
   ftFSpp1_='# of LV';
   dx=dx+dx_units+eps;
   ftFSpp3_=[x0+dx-0.02 y0-i*0.06 dx_lv dy];
   ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
   clear ftFSpp1_;
 end
if ftFS2FLGgbl==1, 
 Noofvar=ftFSNo_inCNTgbl;
 STRING='i'; 
end
if ftFS2FLGgbl==2, 
 Noofvar=ftFSNo_outCNTgbl; 
 STRING='o';
end

ftFSpp1_=['Partition'];
dx=dx+dx_units-0.05;
ftFSpp3_=[x0+dx y0-i*0.06 dx_lv dy];
ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
clear ftFSpp1_;

%================
% Loop through
%================
if nargin <2
 ftFSil1_=1; ftFSil2_=Noofvar;
end

if (Noofvar-ftFSil1_) > (8-1)
 ftFSil2_=ftFSil1_+7;
end

ii=0;
for i=ftFSil1_:ftFSil2_
 ii=ii+1;

 x0=0.05; y0=0.6; dx=0; 
 
 ftFSpp1_=num2str(i);
 ftFSpp3_=[x0 y0-ii*0.06 dx_no dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_;

 ftFSpp1_=eval(['ftFS' STRING 'LVnameVECgbl(i,:)']);
 dx=dx+dx_no+eps;
 ftFSpp3_=[x0+dx y0-ii*0.06 dx_name dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_;

 ftFSpp1_=num2str(eval(['ftFS' STRING 'maxVECgbl(i)']));
 dx=dx+dx_name+eps;
 ftFSpp3_=[x0+dx y0-ii*0.06 dx_max dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_;

 ftFSpp1_=num2str(eval(['ftFS' STRING 'minVECgbl(i)']));
 dx=dx+dx_max+eps;
 ftFSpp3_=[x0+dx y0-ii*0.06 dx_min dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_;

 ftFSpp1_=eval(['ftFS' STRING 'unitVECgbl(i,:)']);
 dx=dx+dx_min+eps;
 ftFSpp3_=[x0+dx y0-ii*0.06 dx_units-0.02 dy];
 ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_ ftFSpp3_;

 if ftFSfuztypeSCAgbl ~=2 | ftFSpflag_==1
  ftFSpp1_=num2str(eval(['ftFS' STRING 'lingVECgbl(i)']));
  dx=dx+dx_units+eps;
  ftFSpp3_=[x0+dx-0.02 y0-ii*0.06 dx_lv dy];
  ftscrtxt(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_);
  clear ftFSpp1_ ftFSpp3_;
 end

%ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
 ftFSpp1_=['LV'];
 dx=dx+dx_units;
 ftFSpp3_=[x0+dx-0.05 y0-ii*0.06 dx_lv dy];
 ftFSpp4_=['if ftFS2FLGgbl==1, ftFSNo_lingCNTgbl=ftFSilingVECgbl(' num2str(i) '); else, ftFSNo_lingCNTgbl=ftFSolingVECgbl(' num2str(i) '); end; ftFSvarCNTgbl=' num2str(i) '; ftmapar3(ftFS2FLGgbl,1,ftFSNo_lingCNTgbl);'];
 ftscrpb(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
 clear ftFSpp1_ ftFSpp3_ ftFSpp4_;

end 

if ftFSil1_ > 8
 ftFSil1_=ftFSil1_-8;
 ftFSpp1_='back';
 ftFSpp3_=[x0+dx+dx_lv+eps y0-1*0.06 0.1 dy];
 ftFSpp4_=['close; ftmapart(' num2str(ftFS2FLGgbl) ',' num2str(ftFSil1_) ',' num2str(Noofvar) ')'];
 ftscrpb(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end
if Noofvar > ftFSil2_
 ftFSil2_=ftFSil2_+1;
 ftFSpp1_='more';
 ftFSpp3_=[x0+dx+dx_lv+eps y0-8*0.06 0.1 dy];
 ftFSpp4_=['close; ftmapart(' num2str(ftFS2FLGgbl) ',' num2str(ftFSil2_) ',' num2str(Noofvar) ')'];
 ftscrpb(ftFSfig_fs2GUI,ftFSpp1_,ftFSpp3_,ftFSpp4_);
end

%=====================
% Go back one screen
%=====================

pbstart=uicontrol('Style','push',...
'Units','normalized',...
'Position',[0.4 0.025 0.2 0.075],...
'String','Done',...
'CallBack','ftfswsve; close;' );

%
% end ftmapart.m
%
