%
% ftmfdisp.m
%
% =========================================================================  
%                          FlexTools(FS) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Displays FMF graphically.
%
function ftmfdisp(ftFSpflag_,ftFSvarCNTgbl)

global ftFSmax_rulesSCAgbl ftFSmax_LVSCAgbl ftFSmax_inSCAgbl ftFSmax_outSCAgbl
global ftFSbase_minSCAgbl ftFSbase_maxSCAgbl ftFSbase_resSCAgbl ftFSNo_stepsCNTgbl ftFSrbasisMATgbl ftFSbasisMATgbl ftFSbase_setVECgbl ftFS_inMATgbl
global ftFSNo_rulesCNTgbl ftFSNo_critCNTgbl ftFSNo_ilingCNTgbl ftFSNo_olingCNTgbl  
global ftFSilingVECgbl ftFSimaxVECgbl ftFSiminVECgbl ftFSiunitVECgbl ftFSinameVECgbl ftFSNo_inCNTgbl
global ftFSiLVlearnVECgbl ftFSiLVtypeVECgbl ftFSiLVnameVECgbl 
global ftFSolingVECgbl ftFSomaxVECgbl ftFSominVECgbl ftFSounitVECgbl ftFSonameVECgbl ftFSNo_outCNTgbl
global ftFSoLVlearnVECgbl ftFSoLVtypeVECgbl ftFSoLVnameVECgbl 
global ftFSrulelearnVECgbl
global ftFSunivMATgbl ftFSlnameMATgbl ftFSincMATgbl ftFSinlMATgbl ftFSinrMATgbl ftFSoutcMATgbl ftFSoutlMATgbl 
global ftFSoutrMATgbl ftFSiparmMATgbl ftFSoparmMATgbl ftFSilrnMATgbl ftFSolrnMATgbl mat_parm
global ftFSfuztypeSCAgbl ftFSdisp1FLGgbl ftFSaggrtypeSCAgbl ftFSdeftypeSCAgbl ftFSfmfparmMATgbl ftFSaggrparmMATgbl
global ftFSdefparmMATgbl ftFSfmfSTRgbl ftFSimplicateSTRgbl ftFSaggregateSTRgbl ftFSdefuzSTRgbl ftFSfmfilenMATgbl
global ftFSFLGgbl ftFS2FLGgbl ftflag_edtGUI ftparm_edtGUI ftscr_cntSCAgbl fig_fs4
global ftSlide_aGUI ftSlide_bGUI ftSlide_cGUI ftSlide_dGUI ftFt_PlotGUI ftxmingbl ftFSxmaxgbl ftFSdelxgbl  
global ftFigPos_bigVECgbl ftFigPos_medVECgbl ftFigPos_smallVECgbl ftXscaleVECgbl ftYscaleVECgbl ftXYscaleVECgbl

if ftFSpflag_==1, 
 if ftFSvarCNTgbl > ftFSNo_inCNTgbl, ftFSvarCNTgbl=1; end
 ftFSNo_lingCNTgbl=ftFSilingVECgbl; 
 vec_type=ftFSiLVtypeVECgbl; 
 mat_parm=ftFSiparmMATgbl; 
 ftFSxmaxgbl=ftFSimaxVECgbl(ftFSvarCNTgbl);
 ftxmingbl=ftFSiminVECgbl(ftFSvarCNTgbl);
 vec_name=ftFSinameVECgbl;
 vec_unit=ftFSiunitVECgbl;
elseif ftFSpflag_==2,  
  if ftFSvarCNTgbl > ftFSNo_outCNTgbl, ftFSvarCNTgbl=1; end
  ftFSNo_lingCNTgbl=ftFSolingVECgbl; 
  vec_type=ftFSoLVtypeVECgbl; 
  mat_parm=ftFSoparmMATgbl; 
  ftFSxmaxgbl=ftFSomaxVECgbl(ftFSvarCNTgbl); 
  ftxmingbl=ftFSominVECgbl(ftFSvarCNTgbl);
  vec_name=ftFSonameVECgbl;
  vec_unit=ftFSounitVECgbl;
end

if((ftFSpflag_==2)&(ftFSfuztypeSCAgbl==2)) % for TSK output
 fig_fs4=ftfigure('fig_fs4',['Fuzzy TSK Controller. Use View FS to see Constants for ' vec_name(ftFSvarCNTgbl,:)],ftFigPos_medVECgbl,'on','none');
else
 fig_fs4=ftfigure('fig_fs4',['Fuzzy Membership Functions for ' vec_name(ftFSvarCNTgbl,:)],ftFigPos_medVECgbl,'on','none');

 ftFSdelxgbl=(ftFSxmaxgbl-ftxmingbl)/100;
 x = (ftxmingbl:ftFSdelxgbl:ftFSxmaxgbl)';
 ftFSil1_=ftFSmax_LVSCAgbl*(ftFSvarCNTgbl-1)+1; ftFSil2_=ftFSil1_+ftFSNo_lingCNTgbl(ftFSvarCNTgbl)-1;

 for ftFSlingCNTgbl=ftFSil1_:ftFSil2_
  y = feval(ftFSfmfilenMATgbl(vec_type(1,ftFSlingCNTgbl),:),x, mat_parm(ftFSlingCNTgbl,:));
  y = ftfsnorm(y);
  if ftFSlingCNTgbl==ftFSil1_, y_mat=y; else, y_mat=[y_mat y]; end
 end
 subplot('position',[0.1 0.3 0.8 0.6]); ftFt_PlotGUI = plot(x,y_mat);
 axis([ftxmingbl ftFSxmaxgbl 0 max(max(y_mat))]);
 xlabel(vec_unit(ftFSvarCNTgbl,:));
end

%=====================
% Go back one screen
%=====================
if ftFSpflag_==1, ftFSpp4_=['close']; end
if ftFSpflag_==2, ftFSpp4_=['close']; end

ftscrpb(fig_fs4,'Done',[0.42 0.05 0.16 0.075],ftFSpp4_);

 ftFSpp1_='Select Variable';
 ftFSpp3_=[0.65 0.125 0.3 0.075];
 ftscrtxt(fig_fs4,ftFSpp1_,ftFSpp3_);
 clear ftFSpp1_;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 ftFSpp3_=[0.65 0.05 0.3 0.1];
 ftFSpp4_=['ftFSvarCNTgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
 ftFSpp4_=[ftFSpp4_ 'close; ftmfdisp(' num2str(ftFSpflag_) ',ftFSvarCNTgbl);'];
 if ftFSpflag_==1,
   ftFSpp1_=ftFSinameVECgbl(1:ftFSNo_inCNTgbl,:); 
   ftFSpp6_=[1:ftFSNo_inCNTgbl];
 else
   ftFSpp1_=ftFSonameVECgbl(1:ftFSNo_outCNTgbl,:); 
   ftFSpp6_=[1:ftFSNo_outCNTgbl];
 end
 ftFSpp5_=ftFSvarCNTgbl;
 ftscrpup(fig_fs4,ftFSpp1_,ftFSpp3_,ftFSpp4_,ftFSpp5_,ftFSpp6_,ftscr_cntSCAgbl);
 
%
% end ftmfdisp.m
%
