% =================================================================
% ftnn1.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(NN)
%

function ftnn1(TEXT_)

global ftscr_cntSCAgbl ftflag_edtGUI
global ftFigPos_bigVECgbl ftFigPos_mediumVECgbl 
global ftcolor_bc1VECgbl ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 

global ftNNpp_typeMATgbl
global ftNNtitleVECgbl ftNNtypeSCAgbl
global ftNNspecialSCAgbl ftNNpp_specMATgbl
global ftNNer_typeSCAgbl ftNNpp_ertypeMATgbl
global ftNNlearnSCAgbl ftNNpp_lrnMATgbl
global ftNNconvSCAgbl ftNNpp_cnvMATgbl
global ftNNno_inSCAgbl ftNNno_in_userSCAgbl ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNh_layerSCAgbl ftNNpp_hlayerMATgbl ftNNno_hidVECgbl
global ftNNweightMATgbl   ftNNweightOPTgbl ftNNassocMATgbl
global ftciGUI ftNNrbf_sdMATgbl ftXYscaleVECgbl
global ftNNn_itypeVECgbl ftNNn_htypeVECgbl ftNNn_otypeVECgbl

if nargin < 1

ftNNlala=num2str(ftNNpp_typeMATgbl(ftNNtypeSCAgbl,:));
if (ftNNtypeSCAgbl < 3)
 ftNNlala=['FlexTool(NN)-- ' ftNNlala '--Build;  [' ftNNpp_specMATgbl(ftNNspecialSCAgbl,:) ']'];
else
 ftNNlala=['FlexTool(NN)-- ' ftNNlala '--Build'];
end

%ftFigPos_mainVECgbl=[15  240  575   200].*ftXYscaleVECgbl;
%ftnn1GUI=ftfigure('ftnn1GUI',ftNNlala,ftFigPos_mainVECgbl,'on','figure');

save_scr_cnt_=ftscr_cntSCAgbl;


%========================
% NN-Parameters Defn Block
%========================

ftNNpp1='Error Type';
ftNNpp3=[0.075 0.21 0.2 0.09];
ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
clear ftNNpp1 ftNNpp3 ftNNpp4;

%ftNNpp3=[0.075 0.13 0.2 0.1];
ftNNpp3=[0.075 0.13 0.2 0.08];

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;

if ftNNtypeSCAgbl==5 %Linear
  ftNNer_typeSCAgbl=1;
  ftNNpp1= ftNNpp_ertypeMATgbl(ftNNer_typeSCAgbl,:);
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif ftNNtypeSCAgbl==6 %Perceptrons
  ftNNer_typeSCAgbl=6;
  ftNNpp1= ftNNpp_ertypeMATgbl(ftNNer_typeSCAgbl,:);
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif ftNNtypeSCAgbl==7 | ftNNtypeSCAgbl==8 | ftNNtypeSCAgbl==10 %Hebbian or Instar or Kohonen
  ftNNpp1= 'Unsupervised';
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif ftNNtypeSCAgbl==9 | ftNNtypeSCAgbl==12 %Outstar or LVQ
  ftNNpp1= 'Least Square';
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif ftNNtypeSCAgbl==14 %RBF
  ftNNer_typeSCAgbl=1;
  ftNNpp1= ftNNpp_ertypeMATgbl(ftNNer_typeSCAgbl,:);
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif ftNNtypeSCAgbl < 5 %All BP nets (No linear error)
  ftNNpp4=['ftNNer_typeSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); if (ftNNer_typeSCAgbl > 1 & ftNNer_typeSCAgbl < 6), ftnnask(7); end'];
  ftNNpp5= ftNNer_typeSCAgbl;
  ftNNpp6=[1:(size(ftNNpp_ertypeMATgbl,1)-1)]';
  ftNNpp2=[ftNNpp_ertypeMATgbl((1:size(ftNNpp_ertypeMATgbl,1)-1),:)];
  ftscrpup(ftciGUI,ftNNpp2,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3 ftNNpp2
else
  ftNNpp4=['ftNNer_typeSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); if (ftNNer_typeSCAgbl > 1 & ftNNer_typeSCAgbl < 6), ftnnask(7); end'];
  ftNNpp5= ftNNer_typeSCAgbl;
  ftNNpp6=[1:size(ftNNpp_ertypeMATgbl,1)]';
  ftscrpup(ftciGUI,ftNNpp_ertypeMATgbl,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3
end

ftNNpp1='Learning';
ftNNpp3=[0.4 0.21 0.2 0.09];

ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
clear ftNNpp1 ftNNpp3 ftNNpp4;

%ftNNpp3=[0.4 0.13 0.2 0.1];
ftNNpp3=[0.4 0.13 0.2 0.08];

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
if ftNNtypeSCAgbl==14 %RBF
  ftNNlearnSCAgbl=2;
  ftNNpp1= ftNNpp_lrnMATgbl(ftNNlearnSCAgbl,:);
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
elseif (ftNNtypeSCAgbl > 10) & (ftNNtypeSCAgbl < 12) %Associative
  ftNNpp4=['ftNNlearnSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftnnask(1)'];
  ftNNpp5=ftNNlearnSCAgbl;
  ftNNpp6=[1:size(ftNNpp_lrnMATgbl,1)]';
  ftscrpup(ftciGUI,ftNNpp_lrnMATgbl,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3;
else
  ftNNpp4=['ftNNlearnSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftnnask(1)'];
  ftNNpp5=ftNNlearnSCAgbl;
  ftNNpp6=[1:size(ftNNpp_lrnMATgbl,1)]';
  ftscrpup(ftciGUI,ftNNpp_lrnMATgbl,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3;
end

ftNNpp1='Convergence'; 
ftNNpp3=[0.725 0.21 0.2 0.09];

ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
clear ftNNpp1 ftNNpp3 ftNNpp4;

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
%ftNNpp3=[0.725 0.13 0.2 0.1];
ftNNpp3=[0.725 0.13 0.2 0.08];


if (ftNNtypeSCAgbl > 6) & (ftNNtypeSCAgbl < 13) %Associative
  ftNNconvSCAgbl=1;
  ftNNpp4=['ftNNconvSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftnnask(2)'];
  ftNNpp5=ftNNconvSCAgbl;
  ftNNpp6=[1;2];
  ftscrpup(ftciGUI,ftNNpp_cnvMATgbl(1:2,:),ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3;
elseif ftNNtypeSCAgbl==14 %RBF
  ftNNconvSCAgbl=2;
  ftNNpp1=ftNNpp_cnvMATgbl(ftNNconvSCAgbl,:);
 %ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  ftstxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp3
else
  ftNNpp4=['ftNNconvSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); ftnnask(2)'];
  ftNNpp5=ftNNconvSCAgbl;
  ftNNpp6=[1:size(ftNNpp_cnvMATgbl,1)]';
  ftscrpup(ftciGUI,ftNNpp_cnvMATgbl,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3;
end

%==============
% NN-Input Neurons
%==============

ftNNpp1='NN-Input Neurons';
ftNNpp2=[' '];
ftNNpp3= [0.8 0.04 0.31 0.4 0.07 0.001];

ftscrblk(ftciGUI,ftNNpp1,ftNNpp2,ftNNpp3);
clear ftNNpp1 ftNNpp2 ftNNpp3;

ftNNpp1='# of Input Neurons';
ftNNpp3=[0.05 0.58 0.2 0.1];
ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
clear ftNNpp1 ftNNpp3;

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftNNpp1=num2str(ftNNno_in_userSCAgbl);
ftNNpp3=[0.26 0.58 0.04 0.1];

ftNNpp41=['ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_hidSCAgbl+ftNNno_outSCAgbl; ftNNweightMATgbl=rand(ftNNno_totSCAgbl,ftNNno_totSCAgbl); ftnn1(1);'];
ftNNpp4=[' ftNNno_in_userSCAgbl =fix(abs(str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''))));' ftNNpp41];
ftscredt(ftciGUI,ftNNpp1,ftNNpp3,ftNNpp4,ftscr_cntSCAgbl);
clear ftNNpp1 ftNNpp3 ftNNpp4;

if ftNNtypeSCAgbl < 5 
 ftNNp_in_11='Neuron Definition';
 ftNNp_in_31=[0.05 0.45 0.25 0.1];
 ftNNpp4='ftnn2(1);';
 ftscrpb(ftciGUI, ftNNp_in_11, ftNNp_in_31,ftNNpp4);
 clear ftNNpp4 ftNNp_in_11 ftNNp_in_31
else
 ftNNp_in_11='Linear Neurons';
  ftNNp_in_31=[0.05 0.45 0.25 0.09];
  ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);

 clear ftNNp_in_11 ftNNp_in_31
end
%===============
% NN-Hidden Neurons
%===============

if ftNNtypeSCAgbl < 5 | ftNNtypeSCAgbl >= 11

 ftNNpp1='NN-Hidden Neurons';
 ftNNpp2=[' '];
 ftNNpp3= [0.8 0.365 0.635 0.4 0.07 0.001];

 ftscrblk(ftciGUI,ftNNpp1,ftNNpp2,ftNNpp3);
 clear ftNNpp1 ftNNpp2 ftNNpp3;

 if ftNNtypeSCAgbl~=3 
    if ftNNtypeSCAgbl==14
      ftNNpp1='Max # of Neurons';
    if (ftNNno_hidSCAgbl==0), ftNNno_hidSCAgbl=20; end
  else
     ftNNpp1='# of Hidden Neurons';
  end
  if ftNNtypeSCAgbl==12
     if (ftNNno_hidSCAgbl==0), ftNNno_hidSCAgbl=2; end
  end

  ftNNpp3=[0.375 0.58 0.19 0.1];
  ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
  clear ftNNpp1 ftNNpp3;

  ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  ftNNpp1=num2str(ftNNno_hidSCAgbl);
  ftNNpp3=[0.577 0.58 0.05 0.1];


  ftNNpp4=[' ftNNno_hidSCAgbl =fix(abs(str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''))));' ftNNpp41];
  ftscredt(ftciGUI,ftNNpp1,ftNNpp3,ftNNpp4,ftscr_cntSCAgbl);
  clear ftNNpp1 ftNNpp3 ftNNpp4;
 else
  ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  ftNNpp3= [0.375 0.58 0.25 0.1];
  ftNNpp4=['ftNNh_layerSCAgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value''); close; ft3pak; ftnn1; ftnnask(3);'];
  ftNNpp5=ftNNh_layerSCAgbl;
  ftNNpp6=[1:size(ftNNpp_hlayerMATgbl,1)]';
  ftscrpup(ftciGUI,ftNNpp_hlayerMATgbl,ftNNpp3,ftNNpp4,ftNNpp5,ftNNpp6,ftscr_cntSCAgbl);
  clear ftNNpp3;
 end

 if ftNNtypeSCAgbl==14
  ftNNp_in_11='Spread Factor';
  %ftNNp_in_31=[0.375 0.45 0.2 0.09];
  ftNNp_in_31=[0.375 0.45 0.19 0.09];
  ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);
  clear ftNNp_in_11 ftNNp_in_31

  ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  ftNNpp1=num2str(ftNNrbf_sdMATgbl(1,1));
%  ftNNpp3=[0.585 0.45 0.04 0.1];
  ftNNpp3=[0.577 0.45 0.05 0.095];
  ftNNpp4=['ftNNrbf_sdMATgbl=(abs(str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''))));'];
  ftscredt(ftciGUI,ftNNpp1,ftNNpp3,ftNNpp4,ftscr_cntSCAgbl);
  clear ftNNpp1 ftNNpp3 ftNNpp4;

 elseif ftNNtypeSCAgbl==12
  ftNNp_in_11='Competitive Neurons';
   ftNNp_in_31=[0.375 0.45 0.25 0.09];
   ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);

  clear ftNNp_in_11 ftNNp_in_31
  if (ftNNno_hidSCAgbl==0), ftNNno_hidSCAgbl=20; end
 elseif ftNNtypeSCAgbl==11
  ftNNp_in_11='Kohonen Layer';
   ftNNp_in_31=[0.375 0.45 0.25 0.09];
   ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);

  clear ftNNp_in_11 ftNNp_in_31
 else
  ftNNp_in_11='Neuron Definition';
  ftNNp_in_31=[0.375 0.45 0.25 0.1];
  ftNNpp4='ftnn2(2);';
  ftscrpb(ftciGUI, ftNNp_in_11, ftNNp_in_31,ftNNpp4);
  clear ftNNpp4 ftNNp_in_11 ftNNp_in_31
 end
else
 ftNNno_hidSCAgbl=0;
end

%=============
% NN-Output Bock
%=============
ftNNdy=0.28;

ftNNpp1='NN-Output Neurons';
ftNNpp2=[' '];
ftNNpp3= [0.8 0.69 0.96 0.4 0.07 0.002];

ftscrblk(ftciGUI,ftNNpp1,ftNNpp2,ftNNpp3);
clear ftNNpp1 ftNNpp2 ftNNpp3;

ftNNpp1='# of Output Neurons';
ftNNpp3=[0.70 0.58 0.2 0.1];
ftscrtxt(ftciGUI,ftNNpp1,ftNNpp3);
clear ftNNpp1 ftNNpp3;

ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
ftNNpp1=num2str(ftNNno_outSCAgbl);
ftNNpp3=[0.91 0.58 0.04 0.1];
ftNNpp4=[' ftNNno_outSCAgbl =fix(abs(str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''))));' ftNNpp41];
ftscredt(ftciGUI,ftNNpp1,ftNNpp3,ftNNpp4,ftscr_cntSCAgbl);
clear ftNNpp1 ftNNpp3 ftNNpp4;

if ftNNtypeSCAgbl < 5 | (ftNNtypeSCAgbl > 6 & ftNNtypeSCAgbl < 14 & ftNNtypeSCAgbl ~= 10)
 ftNNp_in_11='Neuron Definition';
 ftNNp_in_31=[0.70 0.45 0.25 0.1];

 ftNNpp4='ftnn2(3);';
 ftscrpb(ftciGUI, ftNNp_in_11, ftNNp_in_31,ftNNpp4);
 clear ftNNpp4 ftNNp_in_11 ftNNp_in_31
elseif (ftNNtypeSCAgbl == 6 | ftNNtypeSCAgbl == 10)
 ftNNn_otypeVECgbl=2*ones(size(ftNNn_otypeVECgbl));
 ftNNp_in_11='Hard Limit Neurons';
 %ftNNp_in_31=[0.70 0.45 0.25 0.1];
  ftNNp_in_31=[0.70 0.45 0.25 0.09];
 ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);
 clear ftNNp_in_11 ftNNp_in_31
else
 ftNNn_otypeVECgbl=ones(size(ftNNn_otypeVECgbl));
 ftNNp_in_11='Linear Neurons';
 %ftNNp_in_31=[0.70 0.45 0.25 0.1];
 ftNNp_in_31=[0.70 0.45 0.25 0.09];
 ftscrtxt(ftciGUI, ftNNp_in_11, ftNNp_in_31);
 clear ftNNp_in_11 ftNNp_in_31
end

%=====================
% Back, quit, next
%=====================

% Need to check the use of Apply
% ftscrpb(ftciGUI,'Apply',[0.45 0.025 0.1 0.1],'ftnnsave(''warm'');');

ftscrpb(ftciGUI,'Train',[0.65 0.9 0.1 0.1],'ftnnsave(''warm''); ftnnrun(2);','y');
ftscrpb(ftciGUI,'View',[0.76 0.9 0.1 0.1],'ftnndisp');
ftscrpb(ftciGUI,'Run/Sim',[0.87 0.9 0.1 0.1],'ftnnsave(''warm''); ftnnrun(3);');

%ftscr_cntSCAgbl=save_scr_cnt_;

else

%
%set weights and associations depending on the type of NN chosen
%

if ftNNtypeSCAgbl < 5
  ftNNno_inSCAgbl=ftNNno_in_userSCAgbl+1;
else
  ftNNno_inSCAgbl=ftNNno_in_userSCAgbl;
end

ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_hidSCAgbl+ftNNno_outSCAgbl;

nt_=ftNNno_totSCAgbl;
ni_=ftNNno_inSCAgbl;
no_=ftNNno_outSCAgbl;

if ftNNtypeSCAgbl==1 %Fully connected
 ftNNweightMATgbl=zeros(nt_,nt_);
 ftNNassocMATgbl=zeros(nt_,nt_);
 for i=2:nt_
  ftNNweightMATgbl(i,1:(i-1))=(2*rand(1,(i-1))-1);
  ftNNassocMATgbl(i,1:(i-1))=ones(1,(i-1));
 end

elseif ftNNtypeSCAgbl==2 %Recurrent

 ftNNweightMATgbl=(2*rand(nt_,nt_)-1);
 ftNNassocMATgbl=ones(nt_,nt_);

 for i=1:ni_
  for j=1:nt_
   ftNNweightMATgbl(i,j)=0.0;
   ftNNassocMATgbl(i,j)=0.0;
  end
 end
 for j=(nt_-no_+1):nt_
  for i=1:nt_
   ftNNweightMATgbl(i,j)=0.0;
   ftNNassocMATgbl(i,j)=0.0;
  end
 end
elseif ftNNtypeSCAgbl==3 %layered	

 %Inputs and outputs are not considered as layers
 %nt_(1)=0;
 %nt_(2)=nt_(1)+number of inputs;
 %nt_(3)=nt_(2)+number of neurons in first hidden layer

 nl_=ftNNh_layerSCAgbl;
 nt_(1)=0;
 nt_(2)=ftNNno_inSCAgbl; 

 for i=1:nl_
    nt_(i+2)=nt_(i+1)+ftNNno_hidVECgbl(i);
 end
 nt_(nl_+3)=nt_(nl_+2)+ftNNno_outSCAgbl;
 ftNNno_hidVECgbl=ftNNno_hidVECgbl(1,1:nl_);
 ntt_=nt_(nl_+3);
 ftNNweightMATgbl=zeros(ntt_,ntt_);
 ftNNassocMATgbl=zeros(ntt_,ntt_);
 dummy1_=(2*rand(ntt_,ntt_)-1);
 dummy2_=ones(ntt_,ntt_);

% if nl_ < 3, ftNNno_hidVECgbl(1,3)=0; end
% if nl_ < 2, ftNNno_hidVECgbl(1,2)=0; end

 ftNNweightMATgbl(nt_(2)+1:nt_(3),1:nt_(2))=dummy1_(nt_(2)+1:nt_(3),1:nt_(2));
 ftNNassocMATgbl(nt_(2)+1:nt_(3),1:nt_(2))=dummy2_(nt_(2)+1:nt_(3),1:nt_(2));

 for j=1:nl_+1;	%hidden layers + Output layer
  ftNNweightMATgbl(nt_(j+1)+1:nt_(j+2),nt_(j)+1:nt_(j+1))=dummy1_(nt_(j+1)+1:nt_(j+2),nt_(j)+1:nt_(j+1));
  ftNNassocMATgbl(nt_(j+1)+1:nt_(j+2),nt_(j)+1:nt_(j+1))=dummy2_(nt_(j+1)+1:nt_(j+2),nt_(j)+1:nt_(j+1));
 end
 clear dummy1_ dummy2_

elseif ftNNtypeSCAgbl == 5 % Linear 

 [ftNNweightMATgbl,ftNNassocMATgbl]=ftnnlni(ni_,no_);	
 ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_outSCAgbl;

elseif ftNNtypeSCAgbl == 6 %Perceptrons

 [ftNNweightMATgbl,ftNNassocMATgbl]=ftnnpci(ni_,no_);	
 ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_outSCAgbl;

elseif ftNNtypeSCAgbl == 7 %Hebbian

 [ftNNweightMATgbl,ftNNassocMATgbl]=ftnnhbi(ni_,no_);	
 ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_outSCAgbl;

elseif ftNNtypeSCAgbl == 8 %Instar

 [ftNNweightMATgbl,ftNNassocMATgbl]=ftnnili(ni_,no_);	
 ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_outSCAgbl;

elseif ftNNtypeSCAgbl > 7 & ftNNtypeSCAgbl < 14

 ftNNweightMATgbl=(2*rand(ftNNno_outSCAgbl,ftNNno_inSCAgbl)-1);	
 ftNNassocMATgbl=ones(ftNNno_outSCAgbl,ftNNno_inSCAgbl);	
 ftNNno_totSCAgbl=ftNNno_inSCAgbl+ftNNno_outSCAgbl;

elseif ftNNtypeSCAgbl == 14
 ftNNweightMATgbl=(2*rand(ftNNno_outSCAgbl,ftNNno_hidSCAgbl)-1);	
 ftNNassocMATgbl=ones(ftNNno_outSCAgbl,ftNNno_hidSCAgbl);	

end

end


%
% end ftnn1.m
%
