% =================================================================
% ftnn2.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(NN)
%

function ftnn2(pflag,il1,il2)

global ftFigPos_bigVECgbl 
global ftscr_cntSCAgbl ftflag_edtGUI
global ftNNn_typeVECgbl ftNNc_typeVECgbl
global ftNNn_inameVECgbl ftNNn_imaxVECgbl ftNNn_iminVECgbl ftNNn_itypeVECgbl
global ftNNn_hnameVECgbl ftNNn_hmaxVECgbl ftNNn_hminVECgbl ftNNn_htypeVECgbl
global ftNNn_onameVECgbl ftNNn_omaxVECgbl ftNNn_ominVECgbl ftNNn_otypeVECgbl
global ftNNno_inSCAgbl ftNNno_hidSCAgbl ftNNno_outSCAgbl; 
global ftNNpp_actMATgbl ftNNbiasFLGgbl
global ftNNtypeSCAgbl

ftnn2_flag=pflag;
lala=['FlexTool (NN) -- Input/Output/Hidden Neuron Definitions'];
fig_nn2=ftfigure('fig_nn2',lala,ftFigPos_bigVECgbl,'on','figure');

fthelp(fig_nn2,'NN');

%x0=0.05; y0=0.6; dy=0.05; dx=0; eps=0.02;
%dx_no=0.05; dx_name=0.16; dx_max=0.1; dx_min=0.1; dx_units=0.16; dx_lv=0.1;

x0=0.05; y0=.85; dy=0.07; dx=0; eps=0.02;
dx_no=0.05; dx_name=0.16; dx_max=0.1; dx_min=0.1; dx_units=0.13; dx_lv=0.1;


 i=0;
 pp1='No';
 pp3=[x0 y0-i*0.06 dx_no dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 pp1='Neuron Name';
 dx=dx+dx_no+eps;
 pp3=[x0+dx y0-i*0.06 dx_name dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 pp1='Min Val';
 dx=dx+dx_name+eps;
 pp3=[x0+dx y0-i*0.06 dx_max dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 pp1='Max Val';
 dx=dx+dx_max+eps;
 pp3=[x0+dx y0-i*0.06 dx_min dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 pp1='Activation';
 dx=dx+dx_min+eps;
 pp3=[x0+dx y0-i*0.06 dx_units dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 pp1='Association';
 dx=dx+dx_units+eps;
 pp3=[x0+dx y0-i*0.06 dx_units dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;
 
if pflag==1, 
  Noofvar=ftNNno_inSCAgbl-1;
  STRING='i'; 
elseif pflag==2, 
  Noofvar= ftNNno_hidSCAgbl; 
  STRING='h';
elseif pflag==3, 
  Noofvar= ftNNno_outSCAgbl; 
  STRING='o';
end

%================
% Loop through
%================
if nargin <2
  il1=1; il2=Noofvar;
end

if (Noofvar-il1) > (7-1)
  il2=il1+6;
end

ii=0;
for i=il1:il2
 ii=ii+1;

x0=0.05; y0=0.85; dx=0; 

 
 pp1=num2str(i);
 pp3=[x0 y0-ii*0.1 dx_no dy];
 ftscrtxt(fig_nn2,pp1,pp3);
 clear pp1;

 dx=dx+dx_no+eps;
 %pp3=[x0+dx y0-ii*0.1 dx_name dy];
 pp3=[x0+dx y0-ii*0.1 dx_name dy*.9];
 ftscr_cntSCAgbl = ftscr_cntSCAgbl + 1;
 pp1=eval(['ftNNn_' STRING 'nameVECgbl(i,:)']);
 pp4=['ftNNn_' STRING 'nameVECgbl(' num2str(i) ',:)=ftstrpak((get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'')),20);'];
 ftscredt(fig_nn2,pp1,pp3,pp4,ftscr_cntSCAgbl);
 clear pp1;

 dx=dx+dx_name+eps;
 %pp3=[x0+dx y0-ii*0.1 dx_max dy];
 pp3=[x0+dx y0-ii*0.1 dx_max dy*.9];
 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 pp1=num2str(eval(['ftNNn_' STRING 'minVECgbl(i)']));
 pp4=['ftNNn_' STRING 'minVECgbl(' num2str(i) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
 ftscredt(fig_nn2,pp1,pp3,pp4,ftscr_cntSCAgbl);

 dx=dx+dx_max+eps;
 %pp3=[x0+dx y0-ii*0.1 dx_min dy];
 pp3=[x0+dx y0-ii*0.1 dx_min dy*.9]; 
 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 pp1=num2str(eval(['ftNNn_' STRING 'maxVECgbl(i)']));
 pp4=['ftNNn_' STRING 'maxVECgbl(' num2str(i) ')=str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));'];
 ftscredt(fig_nn2,pp1,pp3,pp4,ftscr_cntSCAgbl);
 clear pp1;

 ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
 dx=dx+dx_lv+eps;
% pp3=[x0+dx y0-ii*0.1 dx_units dy];
 pp3=[x0+dx y0-ii*0.1 dx_units dy-.01];

 pp4=['ftNNn_' STRING 'typeVECgbl(' num2str(i) ')=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');'];
 if pflag==1, pp5=ftNNn_itypeVECgbl(i); end
 if pflag==2, pp5=ftNNn_htypeVECgbl(i); end
 if pflag==3, pp5=ftNNn_otypeVECgbl(i); end
 pp6=[1:(size(ftNNpp_actMATgbl,1)-1)]';
 ftscrpup(fig_nn2,ftNNpp_actMATgbl(1:5,:),pp3,pp4,pp5,pp6,ftscr_cntSCAgbl);
 clear pp1 pp3

 pp1='Associations';
 dx=dx+dx_units+eps;
%pp3=[x0+dx y0-ii*0.1 dx_units dy];
 pp3=[x0+dx y0-ii*0.1 dx_units dy*.95];
 pp4=['ftnnasn(1,' num2str(i) ',' num2str(i) ')'];
 ftscrpb(fig_nn2,pp1,pp3,pp4);
 clear pp1;
end 

if il1 > 7
   il1=il1-7;
 pp1='Up ^';
 pp3=[x0+dx+dx_units+eps+0.01 y0-1*0.1 0.1 dy*.95];
 %pp3=[x0+dx+dx_units+eps y0-1*0.06 0.1 dy];
 

 pp4=['close; ftnn2(' num2str(pflag) ',' num2str(il1) ',' num2str(Noofvar) ')'];
 ftscrpb(fig_nn2,pp1,pp3,pp4);
end
if Noofvar > il2
 il2=il2+1;
 pp1='Down v';
 pp3=[x0+dx+dx_units+eps+0.01 y0-4*0.175 0.1 dy*.95];
% pp3=[x0+dx+dx_units+eps y0-7*0.06 0.1 dy];

 pp4=['close; ftnn2(' num2str(pflag) ',' num2str(il2) ',' num2str(Noofvar) ')'];
 ftscrpb(fig_nn2,pp1,pp3,pp4);
end

%=====================
% Go back one screen
%=====================

ftscrpb(fig_nn2,'Auto Settings',[0.12 0.025 0.15 0.075],'ftnnask(10)');
ftscrpb(fig_nn2,'Done',[0.57 0.025 0.1 0.08],'ftnn3; ftnnsave(''warm''); close;');
ftscrpb(fig_nn2,'Help',[.72 0.025 0.1 0.08],'ftnnhp01');


%
% end ftnn2.m
%
