% =================================================================
% ftnnasn.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(NN) Association Matrix
%

function ftnnasn(pflag_, rfrom_, cfrom_)

global ftFigPos_bigVECgbl ftscr_cntSCAgbl  ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl  ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNassocMATgbl    ftNNassnCNTgbl   ftNNassocOPTgbl

global fneuron_ tneuron_ retval_
global ftNNasetFLGgbl ftNNtypeSCAgbl

figpos_ = ftFigPos_bigVECgbl;

ftnn2_flag=pflag_;
title_=['FlexTool (NN) -- Association Matrix'];
fig_nnasnGUI=ftfigure('fig_nnasn',title_,figpos_,'on','figure');

fthelp(fig_nnasnGUI,'NN');


y0=0.67; x0=0.23; tx0=x0; dx_no1=0.15; dx_no=0.075; 
dx=.08; dy_no=0.08; dy_no2=0.055;
dy=0.07; dx2=x0-0.21; dy2_no=0.06; y0b=y0;

if ((ftNNasetFLGgbl==1) & (ftNNtypeSCAgbl < 5))

  pp1='Forward';
  pp3=[dx2 y0-(1.2*dy) dx_no1 0.05];
  ftscrtxt(fig_nnasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'Yes');
  pp3=[dx2 y0-(1.95*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNassocOPTgbl(2)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=fneuron_+1:ftNNno_totSCAgbl),',...
   'ftNNassocMATgbl(tneuron_,fneuron_) = retval_-1; end; end;',...
   'close; ftnnasn(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNassocOPTgbl(2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Self Recur';
  pp3=[dx2 y0-(3.4*dy) dx_no1 0.05];
  ftscrtxt(fig_nnasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'Yes');
  pp3=[dx2 y0-(4.15*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNassocOPTgbl(3)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), ',...
   'ftNNassocMATgbl(fneuron_,fneuron_) = retval_-1; end;',...
   'close; ftnnasn(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNassocOPTgbl(3); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Recurrence';
  pp3=[dx2 y0-(5.6*dy) dx_no1 0.05];
  ftscrtxt(fig_nnasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'Yes');
  pp3=[dx2 y0-(6.35*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNassocOPTgbl(4)=retval_; if(retval_<3), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=1:fneuron_-1),',...
   'ftNNassocMATgbl(tneuron_,fneuron_) = retval_-1; end; end;',...
   'close; ftnnasn(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNassocOPTgbl(4); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3
 end

if ((ftNNasetFLGgbl==1) & (ftNNtypeSCAgbl >= 5))
  pp1='All';
  pp3=[dx2 y0-(0.8*dy) dx_no1 0.05];
  ftscrtxt(fig_nnasnGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'No',...
		'Yes');
  pp3=[dx2 y0-(1.55*dy) dx_no1 dy2_no];
  pp4=['ftNNassocOPTgbl(2)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   ' if ftNNassocOPTgbl(2)==1, ftNNassocMATgbl=ftNNassocMATgbl*0.0; end; ',...
   ' if ftNNassocOPTgbl(2)==2, ftNNassocMATgbl=ones(size(ftNNassocMATgbl)); end; ',...
   ' close; ftnnasn(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNassocOPTgbl(2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3
end
%================
% Loop through
%================
if ftNNtypeSCAgbl < 5
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_totSCAgbl;
  cfrom_ = 1; cto_ = rto_;
 else
  %rto_ = rfrom_+8;
  %cto_ = cfrom_+8;
  rto_ = rfrom_+13;
  cto_ = cfrom_+13;
 end;

 if rto_ > ftNNno_totSCAgbl, rto_= ftNNno_totSCAgbl; end
 if rfrom_ > ftNNno_totSCAgbl, rfrom_= ftNNno_totSCAgbl; end
 if cto_ > ftNNno_totSCAgbl, cto_= ftNNno_totSCAgbl; end
 if cfrom_ > ftNNno_totSCAgbl, cfrom_= ftNNno_totSCAgbl; end
elseif ftNNtypeSCAgbl==14
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_hidSCAgbl;
 else
  %rto_ = rfrom_+8;
  %cto_ = cfrom_+8;
  rto_ = rfrom_+13;
  cto_ = cfrom_+13;
 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_hidSCAgbl, cto_= ftNNno_hidSCAgbl; end
 if cfrom_ > ftNNno_hidSCAgbl, cfrom_= ftNNno_hidSCAgbl; end
else
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_inSCAgbl;
 else
 % rto_ = rfrom_+8;
 % cto_ = cfrom_+8;
  rto_ = rfrom_+13;
  cto_ = cfrom_+13;

 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_inSCAgbl, cto_= ftNNno_inSCAgbl; end
 if cfrom_ > ftNNno_inSCAgbl, cfrom_= ftNNno_inSCAgbl; end
end

if ftNNasetFLGgbl==1
 
  bigpp1_=[' Fr:    ' sprintf('%3d     ', [cfrom_:1:cto_])];
  if cfrom_ > 9
    bigpp1_=[' Fr:    ' sprintf('%3d    ', [cfrom_:1:cto_])];
  end

  bigpp1_=str2mat(bigpp1_,' ',' To: ');

  for (fneuron_=rfrom_:rto_)
     if fneuron_ < 10
        pp11=sprintf('  %1d     ',fneuron_);
     elseif fneuron_ < 99
        pp11=sprintf(' %2d    ',fneuron_);
     else
        pp11=sprintf('%3d     ',fneuron_);
     end

     pp12=sprintf('%3d     ', ftNNassocMATgbl(fneuron_,cfrom_:cto_));
     bigpp1_=str2mat(bigpp1_,[pp11 pp12]);
  end;  %for fneuron_
  
%  pp3= [0.65 0.20 0.95 0.15 0.04 0.002];
   pp3= [0.9 0.20 0.95 0.15 0.04 0.002];
  pp1='FlexTool(NN) Association Matrix';
  ftscrhlp(fig_nnasnGUI,pp1,bigpp1_,pp3,'left');

else
  gblcnt_=0;
  fttmpscrcntSCA_ = ftscr_cntSCAgbl+1;

  for (fneuron_=rfrom_:rto_)
   x0=0.23;

   pp1=num2str(fneuron_);
   pp3=[x0-0.05 y0+0.005 0.05 0.04];
   ftscrtxt(fig_nnasnGUI,pp1,pp3);
   clear pp1;
 
   for (tneuron_=cfrom_:cto_)
     gblcnt_=gblcnt_+1;

     if(fneuron_==rfrom_)
   	pp1=num2str(tneuron_);
   	pp3=[x0+0.015 0.61 0.05 0.05];
	ftscrtxt(fig_nnasnGUI,pp1,pp3);
	clear pp1;
     end; %if

     ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
     scr_cnt_ = ftscr_cntSCAgbl;
     pp1= str2mat(...
		'No',...
		'Yes');
     pp3=[x0 y0 dx_no dy_no];
     pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
      'ftNNassocMATgbl(' num2str(fneuron_) ',' num2str(tneuron_) ') = retval_-1;'];
     pp5=ftNNassocMATgbl(fneuron_,tneuron_)+1; % default is existing association!
     pp6=[1:size(pp1,1)]';
     ftscrpup(fig_nnasnGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
     clear pp1 pp3
     x0=x0+dx;
   end; %for tneuron_
   y0=y0-dy_no2;
  end;  %for fneuron_
end %ftNNasetFLGgbl

x0=tx0;

%=====================
% Go Back to the Left
%=====================
%if cfrom_ > 9
%   temp_=cfrom_-9;
 if cfrom_ > 14
 temp_=cfrom_-14;

 pp1='< Back';
% pp3=[x0 0.01 0.1 dy_no];
 pp3=[x0+(-2*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnasn(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ')'];
 ftscrpb(fig_nnasnGUI,pp1,pp3,pp4);
end
%=====================
% Go Back Up
%=====================
%if rfrom_ > 9
%   temp_=rfrom_-9;
if rfrom_ > 14
 temp_=rfrom_-14;
 pp1='Up ^';
 %pp3=[x0+(2*dx) 0.01 0.1 dy_no];
  pp3=[x0 0.01 0.1 dy_no];

 pp4=['close; ftnnasn(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ')'];
 ftscrpb(fig_nnasnGUI,pp1,pp3,pp4);
end
%=====================
% Go to the Right
%=====================
if ftNNno_totSCAgbl > cto_
 temp_=cto_+1;
 pp1='More >';
% pp3=[x0+(4*dx) 0.01 0.1 dy_no];
  pp3=[x0+(2*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnasn(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ')'];
 ftscrpb(fig_nnasnGUI,pp1,pp3,pp4);
end
%=====================
% Go Down
%=====================
if ftNNno_totSCAgbl > rto_
 temp_=rto_+1;
 pp1='Down v';
 %pp3=[x0+(6*dx) 0.01 0.1 dy_no];
  pp3=[x0+(4*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnasn(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ')'];
 ftscrpb(fig_nnasnGUI,pp1,pp3,pp4);
end

%=====================
% Done
%=====================


ftscrpb(fig_nnasnGUI,'Done',[x0+(8*dx) 0.01 0.1 0.08],'ftnnsave(''warm''); close;');
ftscrpb(fig_nnasnGUI,'Help',[x0+(6*dx) 0.01 0.1 0.08],'ftnnhp02');



%
% end ftnnasn.m
%
