% =================================================================
% ftnndisp.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% Displays and saves complete NN system description as a text string.
%

function ftnndisp(TEXT_)

global ftNNrnGUIgbl ftNNevlGUIgbl

global ftcolor_bc1VECgbl ftcolor_bc2VECgbl 
global ftcolor_fc1VECgbl ftcolor_fc2VECgbl 
global ftXYscaleVECgbl
global ftFigPos_bigVECgbl ftFigPos_mediumVECgbl 
global ftFigPos_smallVECgbl ftFigPos_VsmallVECgbl
global ftNNenn_1GUI ftNNenn_2GUI ftNNenn_3GUI ftNNenn_4GUI

global ftNNpp_typeMATgbl
global ftscr_cntSCAgbl ftflag_edtGUI
global ftNNtitleVECgbl ftNNtypeSCAgbl
global ftNNspecialSCAgbl ftNNpp_specMATgbl
global ftNNfn_errMATgbl ftNNer_typeSCAgbl ftNNpp_ertypeMATgbl
global ftNNer_betaSCAgbl
global ftNNlearnSCAgbl ftNNpp_lrnMATgbl
global ftNNconvSCAgbl ftNNpp_cnvMATgbl ftNNpp_actMATgbl
global ftNNno_inSCAgbl ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNh_layerSCAgbl ftNNpp_hlayerMATgbl ftNNno_hidVECgbl
global ftNNlrSCAgbl ftNNmrSCAgbl
global ftNNn_epSCAgbl ftNNe_thSCAgbl
global ftNNv_pcntSCAgbl ftNNasetFLGgbl
global ftNNassocMATgbl    ftNNassnCNTgbl   ftNNassocOPTgbl
global ftNNweightMATgbl  ftNNweightOPTgbl 
global ftNNwrnd_pcntSCAgbl ftNNfn_actMATgbl

global ftNNn_inameVECgbl ftNNn_imaxVECgbl ftNNn_iminVECgbl ftNNn_itypeVECgbl
global ftNNn_hnameVECgbl ftNNn_hmaxVECgbl ftNNn_hminVECgbl ftNNn_htypeVECgbl
global ftNNn_onameVECgbl ftNNn_omaxVECgbl ftNNn_ominVECgbl ftNNn_otypeVECgbl

global ftNNbase_maxSCAgbl ftNNbase_minSCAgbl ftNNbase_resSCAgbl

global ftNNn_iparmVECgbl ftNNn_hparmVECgbl ftNNn_oparmVECgbl
global ftNNtrainFLGgbl ftNNsimFLGgbl ftNNst_flagSCAgbl

global ftNNv_stringMATgbl ftNNv_countSCAgbl
global ftNNrbf_meanMATgbl ftNNrbf_sdMATgbl

if nargin < 1
   %position=[125 45 580 350].*ftXYscaleVECgbl;
    position=[125 45 500 310].*ftXYscaleVECgbl;

  ftnnviewGUI=ftfigure('ftnnviewGUI','FlexTool (NN) -- Neural Network View',position,'on','none');
 
  pp2=[' FlexTool(NN) is compiling all the data. ' ...
       ' Please wait. ' ...
       ' The information presented here might not be correct if the' ...
       ' NN has not been trained yet.'];
 
  pp3=[0.2 0.55 0.62 0.12];

  ftflag_edtGUI(997)=uicontrol(gcf, ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'Position',pp3, ...
        'String',pp2);
  clear pp1 pp2 pp3;
  pause(2);

  separate_=['========================================================================'];
  fs_string=' ';

  dummy=[' FLEXTOOL NEURAL SYSTEM'];
  fs_string=str2mat(fs_string,dummy,separate_);
  dummy=[' NN Type                : ' ftNNpp_typeMATgbl(ftNNtypeSCAgbl,:)];
  fs_string=str2mat(fs_string,dummy);

  if (ftNNtypeSCAgbl == 7) | (ftNNtypeSCAgbl == 8) | (ftNNtypeSCAgbl == 10)  
    dummy=[' Type of Error          :  Unsupervised'];;
  else
    dummy=[' Type of Error          : ' ftNNpp_ertypeMATgbl(ftNNer_typeSCAgbl,:)];
  end

  fs_string=str2mat(fs_string,dummy);
  dummy=[' Learning Rate          : ' num2str(ftNNlrSCAgbl)];
  fs_string=str2mat(fs_string,dummy);
  dummy=[' Momentum Rate          : ' num2str(ftNNmrSCAgbl)];
  fs_string=str2mat(fs_string,dummy);
  dummy=[' Number of Epochs       : ' num2str(ftNNn_epSCAgbl)];
  fs_string=str2mat(fs_string,dummy);
  fs_string=str2mat(fs_string,separate_,' ');

%==========>
  in_string=[' Number of Inputs   : ' num2str(ftNNno_inSCAgbl)];
  in_string=str2mat(in_string,' ');

  if (ftNNtypeSCAgbl < 5)  
    i1_=2;
    in_string=str2mat(in_string,' Bias is considered as the first input.',' ');
    min_string=' No scaling is defined.';
    max_string=' ';
  else
    i1_=1;
  end

  No_in=ftNNno_inSCAgbl;
  for i=i1_:No_in
     if (ftNNn_iminVECgbl(i-i1_+1)==1) & (ftNNn_imaxVECgbl(i-i1_+1)==1)
       min_string=str2mat(min_string,' No scaling is defined.');
       max_string=str2mat(max_string,' ');
    else
       min_string=str2mat(min_string, [' Min: ' num2str(ftNNn_iminVECgbl(i-i1_+1))]);
       max_string=str2mat(max_string, [' Max: ' num2str(ftNNn_imaxVECgbl(i-i1_+1))]);
    end
  end

  for i=1:No_in
    dummy=[' Name: ' ftNNn_inameVECgbl(i,:) ' ; ' ...
           ' Type: ' ftNNpp_actMATgbl(ftNNn_itypeVECgbl(i),:) ';' ... 
           min_string(i,:) ' ; ' ...
           max_string(i,:) ' ; '];
    in_string=str2mat(in_string,dummy);
  end
  in_string=str2mat(in_string,separate_,' ');
%==========>

  No_hid=ftNNno_hidSCAgbl;
  if ftNNtypeSCAgbl==14
    No_hid=size(ftNNrbf_meanMATgbl,1);
  end
  hid_string=[' # of Hidden  Neurons: ' num2str(No_hid)];
  hid_string=str2mat(hid_string,' ');

  if (ftNNtypeSCAgbl == 3)
     layer_string=[' # of Hidden  Layers: ' num2str(ftNNh_layerSCAgbl)];  
     hid_string=str2mat(hid_string,'layer_string',' ');
  end

  min_string=num2str(ftNNn_hminVECgbl(1));
  max_string=num2str(ftNNn_hmaxVECgbl(1)); 

  for i=2:No_hid
    min_string=str2mat(min_string, num2str(ftNNn_hminVECgbl(i)));
    max_string=str2mat(max_string, num2str(ftNNn_hmaxVECgbl(i)));
  end

  for i=1:No_hid
    if ftNNtypeSCAgbl==14
       dummy=[' Name: ' ftNNn_hnameVECgbl(i,:) ' ; ' ...
              ' Type:  Gaussian Basis Function;']; 
       dummy_mean = ['    Mean: ' mat2str(ftNNrbf_meanMATgbl(i,:),4)];
       dummy_sd   = ['    SD:   ' mat2str(ftNNrbf_sdMATgbl(i,:),4)];
       dummy=str2mat(dummy,dummy_mean,dummy_sd); 
    elseif ftNNtypeSCAgbl==11  
       dummy=[' Name: ' ftNNn_hnameVECgbl(i,:) ' ; ' ...
           ' Type: Kohonen Layer Neuron;']; 

    elseif ftNNtypeSCAgbl==12
       dummy=[' Name: ' ftNNn_hnameVECgbl(i,:) ' ; ' ...
              ' Type: Competitive Layer Neuron;']; 

    else 
       dummy=[' Name: ' ftNNn_hnameVECgbl(i,:) ' ; ' ...
           ' Type: ' ftNNpp_actMATgbl(ftNNn_htypeVECgbl(i),:) ';' ... 
           ' Min: ' min_string(i,:) ' ; ' ...
           ' Max: ' max_string(i,:) ' ; '];
    end
    hid_string=str2mat(hid_string,dummy);
  end
  hid_string=str2mat(hid_string,separate_,' ');
%==========>

  if ftNNtypeSCAgbl==12  
     out_string=[' Number of Outputs   : ' num2str(ceil(ftNNno_outSCAgbl/2))];
  else
     out_string=[' Number of Outputs   : ' num2str(ftNNno_outSCAgbl)];
  end 
  out_string=str2mat(out_string,' ');

  if (ftNNn_ominVECgbl(1)==1) & (ftNNn_omaxVECgbl(1)==1)
     min_string=' No scaling is defined.';
     max_string=' ';
  else 
     min_string=[' Min: ' num2str(ftNNn_ominVECgbl(1))];
     max_string=[' Max: ' num2str(ftNNn_omaxVECgbl(1))];
  end

  No_out=ftNNno_outSCAgbl;
  for i=2:No_out
    if (ftNNn_ominVECgbl(i)==1) & (ftNNn_omaxVECgbl(i)==1)
      min_string=str2mat(min_string,' No scaling is defined.');
      max_string=str2mat(max_string,' ');
    else
      min_string=str2mat(min_string, [' Min: ' num2str(ftNNn_ominVECgbl(i))]);
      max_string=str2mat(max_string, [' Max: ' num2str(ftNNn_omaxVECgbl(i))]);
    end
  end

  for i=1:No_out
    dummy=[' Name: ' ftNNn_onameVECgbl(i,:) ' ; ' ...
           ' Type: ' ftNNpp_actMATgbl(ftNNn_otypeVECgbl(i),:) ';' ... 
           min_string(i,:) ' ; ' ...
           max_string(i,:) ' ; '];
    out_string=str2mat(out_string,dummy);
  end
  out_string=str2mat(out_string,separate_,' ');
%==========>
  if (ftNNtypeSCAgbl==11) | (ftNNtypeSCAgbl==12)
      ni_   = ftNNno_inSCAgbl;  
      nh_   = ftNNno_hidSCAgbl;
      no_   = ftNNno_outSCAgbl;  
      wts_  = ftNNweightMATgbl;
% size(wts_)
      wts1_ = wts_(1:nh_,1:ni_);
      wts2_ = wts_(((nh_+1):(nh_+no_)),((ni_+1):(ni_+nh_)));
      wt1_string=[' Weight Matrix (Inputs to Hidden Layer): (To, From) = Connection strength']; 
      wt1_string=str2mat(wt1_string,' ');
      wts_=wts1_;
      for i=1:size(wts_,1)
        for j=1:size(wts_,2)
          if wts_(i,j)~=0
             dummy=[' ( ' num2str(i) ' , ' num2str(j) ' ) = ' num2str(wts_(i,j),4)];
             wt1_string=str2mat(wt1_string,dummy);
          end
        end
      end
      wt1_string=str2mat(wt1_string,separate_,' ');

      wt2_string=[' Weight Matrix (Hidden Layer to Outputs): (To, From) = Connection strength']; 
      wt2_string=str2mat(wt2_string,' ');
      wts_=wts2_;
      for i=1:size(wts_,1)
        for j=1:size(wts_,2)
          if wts_(i,j)~=0
             dummy=[' ( ' num2str(i) ' , ' num2str(j) ' ) = ' num2str(wts_(i,j),4)];
             wt2_string=str2mat(wt2_string,dummy);
          end
        end
      end
      wt2_string=str2mat(wt2_string,separate_,' ');
  else
    if ftNNtypeSCAgbl==14
      wt1_string=[' Weight Matrix: (From Hidden Neuron,To Output Neuron) = Connection strength']; 
    else 
      wt1_string=[' Weight Matrix: (To Neuron, From Neuron) = Connection strength']; 
    end

    wt2_string=[' '];
    wts_=ftNNweightMATgbl;

    for i=1:size(wts_,1)
      for j=1:size(wts_,2)
        if wts_(i,j)~=0
           dummy=[' ( ' num2str(i) ' , ' num2str(j) ' ) = ' num2str(wts_(i,j),4)];
           wt2_string=str2mat(wt2_string,dummy);
        end
      end
    end
  end
 
  ftNNv_stringMATgbl=str2mat(fs_string,in_string,out_string,hid_string,wt1_string,wt2_string);
  [ro,co]=size(ftNNv_stringMATgbl);
  clear fs_string in_string out_string wt_string hid_string 
  ftNNv_countSCAgbl=20;

%  ftscrpb(ftnnviewGUI,'Done',[0.03 0.02 0.15 0.08],'close');
%  pp4=['ftnnsave(''view'')'];
%  ftscrpb(ftnnviewGUI,'Save',[0.23 0.02 0.15 0.08],pp4);
%  clear pp4;
%  ftscrpb(ftnnviewGUI,'Edit',[0.43 0.02 0.15 0.08],'close; ftnn1');
  
  ftscrpb(ftnnviewGUI,'Done',[0.04 0.02 0.10 0.08],'close');
  pp4=['ftnnsave(''view'')'];
  ftscrpb(ftnnviewGUI,'Save',[0.23 0.02 0.10 0.08],pp4);
  clear pp4;
  ftscrpb(ftnnviewGUI,'Edit',[0.43 0.02 0.10 0.08],'close; ftnn1');

else
  delete(ftflag_edtGUI(999));
  delete(ftflag_edtGUI(998));
  delete(ftflag_edtGUI(997));
end % more view

view_size=size(ftNNv_stringMATgbl,1);
pp41=['ftNNv_countSCAgbl=ftNNv_countSCAgbl-20; ftnndisp(''again'')'];
pp42=['ftNNv_countSCAgbl=ftNNv_countSCAgbl+20; ftnndisp(''again'')'];

if ftNNv_countSCAgbl < view_size,
  ONOFF2='on'; 
else
  ONOFF2='off'; 
end

if ftNNv_countSCAgbl <= 20,
  ONOFF1='off'; 
else
  ONOFF1='on'; 
end

ftflag_edtGUI(999)=uicontrol('Style','push',...
   'Units','normalized',...
   'Position',[0.65 0.02 0.10 0.08],...
   'String','Up ^',...
   'Visible',ONOFF1,...
   'CallBack',pp41);
%   'Position',[0.63 0.02 0.15 0.08],...


ftflag_edtGUI(998)=uicontrol('Style','push',...
   'Units','normalized',...
   'Position',[0.85 0.02 0.10 0.08],...
   'String','Down v',...
   'Visible',ONOFF2,...
   'CallBack',pp42);
%   'Position',[0.83 0.02 0.15 0.08],...


if nargin < 1, 
   pp2=ftNNv_stringMATgbl((1:20),:);
else
   if ftNNv_countSCAgbl > view_size, ftNNv_countSCAgbl=view_size; end
   if ftNNv_countSCAgbl<20,        ftNNv_countSCAgbl=20;        end
   pp2=ftNNv_stringMATgbl(((ftNNv_countSCAgbl-19):ftNNv_countSCAgbl),:);
end

pp3= [0.05 0.15 0.9 0.8];
pp1=['NEURAL NETWORK:'];

ftflag_edtGUI(997)=uicontrol(gcf, ...
	     'Style','edit', ...
        'Units','normalized', ...
        'Position',pp3, ...
        'Max',10,...
        'BackgroundColor',[1 1 1], ...
        'HorizontalAlignment','left',...
                'String',pp2);

%
% end ftnndisp.m
%
