function ftnnplot(i_epochs,t_error,v_error)

% =================================================================
% ftnnplot.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% FlexTool(NN) Plotting Routine
%

global ftFigPos_bigVECgbl ftnntrnGUI ftTxtHndle2_ ftTxtHndle1_
global ftNNpp_typeMATgbl ftNNtypeSCAgbl ftNNn_epSCAgbl ftNNplotFLGgbl
global ftNNpl_freqSCAgbl ftNNv_pcntSCAgbl ftNNcnvSTRgbl

% used for code such as ENM
if(ftNNpl_freqSCAgbl>100000), return; end;

flag_=0;
if ((rem(i_epochs,ftNNpl_freqSCAgbl) ==0) | (i_epochs==1))
   flag_=1;
end

if (i_epochs==999998)
   ftNNpp3= [0.085 0.23 0.77 0.005 0.005 0.0025];
   ftNNpp2=str2mat([' Simulation in Progress; Please Wait.']);
   ftNNpp1='Evolution Statistics';
   if exist('ftTxtHndle2_')
      delete(ftTxtHndle2_);
   end
   ftTxtHndle2_=ftscrhlp(ftNNpp1,ftNNpp2,ftNNpp3);
   drawnow;
   return
end

if (i_epochs==999997)
   ftNNpp3= [0.085 0.23 0.77 0.005 0.005 0.0025];
   ftNNpp2=str2mat([' Simulation Done; Output variable is "nn_out". ']);
   ftNNpp1='Evolution Statistics';
   if exist('ftTxtHndle2_')
      delete(ftTxtHndle2_);
   end
   ftTxtHndle2_=ftscrhlp(ftNNpp1,ftNNpp2,ftNNpp3);
   drawnow;
   return
end

if ((ftNNplotFLGgbl==0) & (i_epochs==0))
   return
end

if (ftNNplotFLGgbl==0) & (flag_==1)
%      ftNNpp3= [0.085 0.23 0.77 0.03 0.005 0.0025];
      ftNNpp3= [0.12 0.23 0.77 0.015 0.005 0.0025];
   
      if i_epochs < 999999
         if (ftNNv_pcntSCAgbl~=0)
            ftNNpp2=str2mat(['  Epoch: ' num2str(i_epochs) '; Trn Error : ' num2str(t_error(i_epochs),5) '; Vld Error: ' num2str(v_error(i_epochs),5)]);
         else
            ftNNpp2=str2mat(['  Epoch: ' num2str(i_epochs) '; Training Error : ' num2str(t_error(i_epochs),5) ]);
         end
         ftNNpp1='Evolution Statistics';
         if exist('ftTxtHndle2_')
            delete(ftTxtHndle2_);
         end
         ftTxtHndle2_=ftscrhlp(ftNNpp1,ftNNpp2,ftNNpp3);
         drawnow;
         return
      end
end

% Set up the figure
if i_epochs==0
  lala=['FlexTool(NN) -- NN Training. Use <ctrl-C> or Stop button to Stop.'];
  ftnntrnGUI=ftfigure('ftnntrnGUI','FlexTool(NN)--Training Evolution',ftFigPos_bigVECgbl,'on','figure');
  pp2=['FlexTool(NN) will update Training plots every ' num2str(ftNNpl_freqSCAgbl) ' epochs. ',...
       'Use "<Ctrl> c" to terminate Training.'];
  pp3=[0.1 0.48 0.8 0.085];
  TxtHndle1_=ftscrtxt(ftnntrnGUI,pp2,pp3);

  pb_startga=uicontrol('Style','push',...
   'Units', 'normalized',...
   'Position',[0.375 0.4 0.25 0.06],...
   'BackgroundColor',[0 0 0],...
   'String','Stop and go back',...
   'Enable','on',...
   'CallBack','ftEAst_flagSCAgbl=1;');

  drawnow
  clear pp2 pp3;
  tic;
end

ftnnst_flagSCAgbl=0;

time_per_epoch_ = toc;
tic;

if ((nargin > 1) & (flag_==1))
 % PLOT GRAPH  
   if i_epochs > 10, 
      b_i_epochs_  = i_epochs-9;
      n_ep_p_      = [b_i_epochs_:1:i_epochs];   
   else 
      b_i_epochs_  = 1;
      n_ep_p_      = [1:1:i_epochs];
   end   

   i_epoch_vec_ = [1:1:i_epochs];
   t_er_p_      = t_error(b_i_epochs_:i_epochs);   
   v_er_p_      = v_error(b_i_epochs_:i_epochs);   

   pp2=['Every epoch will take approximately ',...
         num2str(fix(time_per_epoch_)) ' Seconds. ',...
        'Use "<Ctrl> c" to terminate Training.'];
   pp3=[0.1 0.48 0.8 0.085];

   if exist('ftTxtHndle1_')
      delete(ftTxtHndle1_); 
   end
   ftTxtHndle1_=ftscrtxt(ftnntrnGUI,pp2,pp3);

   if (ftNNv_pcntSCAgbl~=0)
      subplot(3,1,1)
      plot(i_epoch_vec_,t_error,'g',i_epoch_vec_,v_error,'w');    
      xlabel('Number of Epochs');   
      ylabel('Error');
      title('green = Training Error, White = Validation Error');   
      subplot(3,3,7)
      plot(n_ep_p_,t_er_p_,'g',n_ep_p_,v_er_p_,'w');    
      xlabel('Number of Epochs');   
      ylabel('Error');
      title('Ten Epoch Window');   
      ftNNpp2=str2mat(['  ' num2str(ftNNpp_typeMATgbl(ftNNtypeSCAgbl,:))],...
                      [' '],...
                      ['  Epochs to go           :   ' num2str(ftNNn_epSCAgbl-i_epochs)],...
                      ['  Total Training Error   :   ' num2str(t_error(i_epochs),5)],...
                      ['  Total Validation Error :   ' num2str(v_error(i_epochs),5)],...
                       '  ');
   else
      subplot(3,1,1)
      plot(i_epoch_vec_,t_error,'g');    
      xlabel('Number of Epochs');   
      ylabel('Error');
      title('green = Training Error');   
      subplot(3,3,7)
      plot(n_ep_p_,t_er_p_,'g');    
      xlabel('Number of Epochs');   
      ylabel('Error');
      title('Ten Epoch Window');   
      ftNNpp2=str2mat(['  ' num2str(ftNNpp_typeMATgbl(ftNNtypeSCAgbl,:))],...
                      [' '],...
                      ['  Epochs to go           :   ' num2str(ftNNn_epSCAgbl-i_epochs)],...
                      ['  Total Training Error   :   ' num2str(t_error(i_epochs),5)],...
                       '  ');
   end 

   ftNNpp3= [0.325 0.45 0.80 0.075 0.05 0.005];
   ftNNpp1='Evolution Statistics';

   if exist('ftTxtHndle2_')
      delete(ftTxtHndle2_)
   end
   ftTxtHndle2_=ftscrhlp(ftnntrnGUI,ftNNpp1,ftNNpp2,ftNNpp3,'left');
   drawnow;
end

if (i_epochs == 999999) 
   if (ftNNplotFLGgbl~=0)
     ftNNpp3= [0.325 0.45 0.8 0.075 0.05 0.005];

     if (ftNNcnvSTRgbl == 'epoch')
        ftNNpp2=str2mat(['Training stopped;'],...
                        ['    Maximum # of Epochs reached.']);
     elseif (ftNNcnvSTRgbl == 'valid')
        ftNNpp2=str2mat(['Training was stopped due to:'],...
	       	        ['     Validation Error Difference'],... 
                        ['               > Training Error Difference.']);
     elseif (ftNNcnvSTRgbl == 'error')
        ftNNpp2=str2mat(['Training stopped;'],...
                        ['     Error limit achieved.']);
     end
     ftNNpp1='Training Terminated';
     ftscrhlp(ftnntrnGUI,ftNNpp1,ftNNpp2,ftNNpp3,'left');
     drawnow;
   else
     if (ftNNcnvSTRgbl == 'epoch')
         ftNNpp2=[' Training stopped; Max "# of Epochs" reached.'];
     elseif (ftNNcnvSTRgbl == 'valid')
         ftNNpp2=[' Training stopped; "Validation Error" diverges.'];
     elseif (ftNNcnvSTRgbl == 'error')
         ftNNpp2=[' Training stopped; "Error Threshold" reached.'];
     end
     ftNNpp1='Evolution Statistics';
     ftNNpp3= [0.085 0.23 0.77 0.03 0.005 0.0025];
     ftscrhlp(ftNNpp1,ftNNpp2,ftNNpp3);
     drawnow;
   end
end

%===================================================================
% END ftnnplot.m
