% =================================================================
% ftnnrun.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% Runs and trains Neural System
%

function ftnnrun(opts)

global ftFigPos_mediumVECgbl ftscr_cntSCAgbl ftflag_edtGUI
global ftNNtrainFLGgbl ftNNsimFLGgbl
global ftNNtypeSCAgbl ftNNplotFLGgbl ftNNpl_freqSCAgbl
global ftbprmSTRgbl

%global for all GUI windows
global ftNNrnGUIgbl

figpos_ = ftFigPos_mediumVECgbl;

save_scr_cnt_=ftscr_cntSCAgbl;

if(ftNNplotFLGgbl==1)
 pp4_=[' (Plot Option--On )'];
else
 pp4_=[' (Plot Option--Off)'];
end

if(opts==3)
 title_=['FlexTool(NN) -- Simulation Data' pp4_];
else
 title_=['FlexTool(NN) -- Training Data' pp4_];
end
 
ftNNrnGUIgbl=ftfigure('ftNNrnGUIgbl',title_,figpos_,'on','figure');

if(opts~=3)
   %====================================
   % Menu Bar-NN Options 
   %====================================

   h1=uimenu(gcf,'Labe','Plot Options');
   h11=uimenu(h1,'Label','Text Only');
   h121=uimenu(h11,'Label','Epochs');
   h126=uimenu(h11,'Label','1','Callback',['ftNNplotFLGgbl=0; ftNNpl_freqSCAgbl=1; close; ftnnrun(' num2str(opts) ');']);
   h122=uimenu(h11,'Label','2','Callback',['ftNNplotFLGgbl=0; ftNNpl_freqSCAgbl=2; close; ftnnrun(' num2str(opts) ');']);
   h123=uimenu(h11,'Label','5','Callback',['ftNNplotFLGgbl=0; ftNNpl_freqSCAgbl=5; close; ftnnrun(' num2str(opts) ');']);
   h124=uimenu(h11,'Label','10','Callback',['ftNNplotFLGgbl=0; ftNNpl_freqSCAgbl=10; close; ftnnrun(' num2str(opts) ');']);
   h125=uimenu(h11,'Label','Other','Callback',['ftNNplotFLGgbl=0; close; ftnnrun(' num2str(opts) '); ftnnask(8);']);
   h12=uimenu(h1,'Label','Plots','separator','on');
   h121=uimenu(h12,'Label','Epochs');
   h126=uimenu(h12,'Label','1','Callback',['ftNNplotFLGgbl=1; ftNNpl_freqSCAgbl=1; close; ftnnrun(' num2str(opts) ');']);
   h122=uimenu(h12,'Label','2','Callback',['ftNNplotFLGgbl=1; ftNNpl_freqSCAgbl=2; close; ftnnrun(' num2str(opts) ');']);
   h123=uimenu(h12,'Label','5','Callback',['ftNNplotFLGgbl=1; ftNNpl_freqSCAgbl=5; close; ftnnrun(' num2str(opts) ');']);
   h124=uimenu(h12,'Label','10','Callback',['ftNNplotFLGgbl=1; ftNNpl_freqSCAgbl=10; close; ftnnrun(' num2str(opts) ');']);
   h125=uimenu(h12,'Label','Other','Callback',['ftNNplotFLGgbl=1; close; ftnnrun(' num2str(opts) '); ftnnask(8);']);

end

if(opts==1)
  pp2=str2mat(...
            ' Enter Name of ".m" file that will generate input/desired data.',...
            ' Please ensure that it returns input/desired data.',...
            '               Ex: [nn_in,nn_desired]=yourfilename.',...
            ' Default mode uses [nn_in,nn_desired] variables in the w/space.',...
            ' ',...
            ' Click on the Train button to Train the NN.',...
            ' Use Plot Options for choosing between text and plots, and display frequency.');
         
 
        pp3= [0.95 0.05 0.95 0.35 0.075 0.01];
        pp1='FlexTool(NN) Help on Options';
        ftscrhlp(ftNNrnGUIgbl,pp1,pp2,pp3);

       % x0=0.05; y0=0.2; dy=0.075; dy1=0.075; dx=0.5; dx1=0.2; dx2=0.15; eps=0.02;
        x0=0.05; y0=0.2; dy=0.075; dy1=0.075; dx=0.5; dx1=0.2; dx2=0.15; eps=0.02;

 	pp1='Enter File Name';
 	pp3=[x0 y0 dx dy];
 	ftscrtxt(ftNNrnGUIgbl,pp1,pp3);

  	pp3=[x0+dx+eps y0 dx1 dy];

  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	pp4=['clear ftbprmSTRgbl; global ftbprmSTRgbl; ftbprmSTRgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'');',... 
             'ftbprmSTRgbl=ftfile(ftbprmSTRgbl); if(exist(ftbprmSTRgbl)),',...
             '[nn_in,nn_desired]=feval(ftbprmSTRgbl); else, ftdispwn(''Attention! Exception'' , ''Note!',...
             'using [nn_in,nn_desired] default input data!''); end;'];
  	ftscredt(ftNNrnGUIgbl,ftbprmSTRgbl, pp3, pp4,ftscr_cntSCAgbl);
        pp41=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(NN): Use a .m File'',50,50);',...
            'if junkname~=0, ',...
            ' ftbprmSTRgbl=ftfile(junkname);',...
            ' set(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'',ftbprmSTRgbl); ftbprmSTRgbl=ftfile(ftbprmSTRgbl);',...
            ' [nn_in,nn_desired]=feval(ftbprmSTRgbl);',...
            'end;'];
        ftscrpb(ftNNrnGUIgbl,'..Browse',[x0+dx+dx1+2*eps y0 dx2 dy],pp41);
	clear pp4;

elseif(opts==2)

       pp2=str2mat(...
            ' Create input and desired data vector/matrix in the workspace.',...
            ' Then enter the names of the vectors/matrices here.',...
            ' Number of rows=Number of data sets.',...
            ' Number of columns=Number of Inputs/desired data to the NN.',...
            ' ',...
            ' Click on the Train button to Train the NN.',...
            ' Use Plot Options for choosing between text and plots, and',...
            ' display frequency.');

        pp3= [0.95 0.05 0.95 0.45 0.075 0.01];
        pp1='FlexTool(NN) Help on Options';
        ftscrhlp(ftNNrnGUIgbl,pp1,pp2,pp3);

	x0=0.1; y0=0.3; dy=0.1; dy1=0.12; dx=0.63; dx2=0.19; eps=0.02;
 	pp1='Enter NN Inputs Variable Vector Name';
 	pp3=[x0 y0 dx dy];
 	ftscrtxt(ftNNrnGUIgbl,pp1,pp3);

  	pp3=[x0+dx+eps y0 dx2 dy];
	ftbprmSTRgbl = 'nn_in';
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	pp4=['clear ftbprmSTRgbl; global ftbprmSTRgbl; ftbprmSTRgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); if(exist(ftbprmSTRgbl)), nn_in=eval(ftbprmSTRgbl); else, ftdispwn(''Attention! Exception!!'' , ''Note! Using default input data in [nn_in]''); end;'];
  	ftscredt(ftNNrnGUIgbl,ftbprmSTRgbl, pp3, pp4,ftscr_cntSCAgbl);
	clear pp4;

	x0=0.1; y0=0.175; dy=0.1; dy1=0.12; dx=0.63; dx2=0.19; eps=0.02;
 	pp1='Enter NN Desired Output Vector Name';
 	pp3=[x0 y0 dx dy];
 	ftscrtxt(ftNNrnGUIgbl,pp1,pp3);

  	pp3=[x0+dx+eps y0 dx2 dy];
	ftbprmSTRgbl = 'nn_desired';
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	pp4=['clear ftbprmSTRgbl; global ftbprmSTRgbl; ftbprmSTRgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''); if(exist(ftbprmSTRgbl)), nn_desired=eval(ftbprmSTRgbl); else, ftdispwn(''Attention! Exception!!'' , ''Note! Using default input data in [nn_desired]''); end;'];
  	ftscredt(ftNNrnGUIgbl,ftbprmSTRgbl, pp3, pp4,ftscr_cntSCAgbl);
	clear pp4;
elseif (opts==3)
  pp2=str2mat(...
            ' Enter Name of ".m" file that will generate input',...
            ' Please ensure that it returns input.',...
            '               Ex: [nn_in]=yourfilename.',...
            ' Number of rows=Number of data sets.',...
            ' Number of columns=Number of Input data to the NN.',...
            ' OR',...
            ' Create input data vector/matrix in the workspace.',...
            ' Then enter the names of the vector/matrix here.',...
            ' Click on the Simulate button to Simulate the NN.',...
            ' The outputs of NN are stored in the variable "nn_out".');

        pp3= [0.95 0.05 0.95 0.35 0.075 0.01];
        pp1='FlexTool(NN) Help on Options';
        ftscrhlp(ftNNrnGUIgbl,pp1,pp2,pp3);

        x0=0.08; y0=0.225; dy=0.075; dy1=0.075; dx=0.52; dx1=0.2; dx2=0.15; eps=0.02;
        dx3=0.1;

 	pp1='Enter Input Vector or ".m" File Name';
 	pp3=[x0 y0 dx dy];
 	ftscrtxt(ftNNrnGUIgbl,pp1,pp3);

  	pp3=[x0+dx+eps y0 dx2 dy];
	ftbprmSTRgbl = 'nn_in';
  	ftscr_cntSCAgbl = ftscr_cntSCAgbl+1;
  	pp4=['clear ftbprmSTRgbl; global ftbprmSTRgbl; ftbprmSTRgbl=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'');',... 
             'ftbprmSTRgbl=ftfile(ftbprmSTRgbl); if(exist(ftbprmSTRgbl)==2),',...
             'nn_in=feval(ftbprmSTRgbl); else, disp([''Attention!'',''File does not exist. A vector is assumed'']);' ,...
             'ftbprmSTRgbl, nn_in=eval(ftbprmSTRgbl); end;'];
  	ftscredt(ftNNrnGUIgbl,ftbprmSTRgbl, pp3, pp4,ftscr_cntSCAgbl);
        pp41=['[junkname obpath]=uigetfile(''*.m'',''FlexTool(NN): Use a .m File'',50,50);',...
            'if junkname~=0, ',...
            ' ftbprmSTRgbl=junkname;',...
            ' set(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string'',ftbprmSTRgbl); ftbprmSTRgbl=ftfile(ftbprmSTRgbl);',...
            ' [nn_in]=feval(ftbprmSTRgbl);',...
            'end;'];
        ftscrpb(ftNNrnGUIgbl,'..Browse',[x0+dx+dx2+2*eps y0 dx2 dy],pp41);
	clear pp4 pp41
end

if opts==3
 TEXT_='Simulate';
 pp4=[' ftNNtrainFLGgbl=0; ftNNsimFLGgbl=1; close(ftNNrnGUIgbl); pause(1); nn_out=ftnntrn(nn_in)'];
else
 TEXT_='Train';
 pp4=[' ftNNtrainFLGgbl=1; ftNNsimFLGgbl=0; close(ftNNrnGUIgbl); pause(1); nn_out=ftnntrn(nn_in,nn_desired);'];
end

ftscrpb(ftNNrnGUIgbl,'Cancel',[0.1 0.05 0.2 0.09],'close;');
ftscrpb(ftNNrnGUIgbl,TEXT_,[0.7 0.05 0.2 0.09],pp4);

%
% end ftnnrun.m
%
