% =================================================================
% ftnnwarm.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% This function loads data stored during a FlexTool NN session
%

function ftnnwarm

global ftFigPos_smallVECgbl

%Save globals

global ftNNasetFLGgbl ftNNfnflagSCAgbl ftnndef_flag 
global ftNNlrSCAgbl ftNNmrSCAgbl ftNNtitleVECgbl
global ftNNn_epSCAgbl ftNNe_thSCAgbl ftNNv_pcntSCAgbl 
global ftNNbase_resSCAgbl ftNNbase_minSCAgbl ftNNbase_maxSCAgbl 
global ftNNtypeSCAgbl ftNNspecialSCAgbl ftNNlearnSCAgbl 
global ftNNer_typeSCAgbl ftNNer_betaSCAgbl ftNNconvSCAgbl 
global ftNNno_inSCAgbl ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNno_in_userSCAgbl ftNNh_layerSCAgbl ftNNno_hidVECgbl 
global ftNNassocMATgbl ftNNassnCNTgbl ftNNassocOPTgbl
global ftNNweightMATgbl ftNNweightOPTgbl
global max_in max_hidden max_out 
global ftNNn_iparmVECgbl ftNNn_hparmVECgbl ftNNn_oparmVECgbl
global ftNNn_imaxVECgbl ftNNn_iminVECgbl ftNNn_itypeVECgbl ftNNn_inameVECgbl
global ftNNn_hmaxVECgbl ftNNn_hminVECgbl ftNNn_htypeVECgbl ftNNn_hnameVECgbl
global ftNNn_omaxVECgbl ftNNn_ominVECgbl ftNNn_otypeVECgbl ftNNn_onameVECgbl
global ftNNbase_maxSCAgbl ftNNbase_minSCAgbl ftNNbase_resSCAgbl
global ftNNn_iparmVECgbl ftNNn_hparmVECgbl ftNNn_oparmVECgbl
global ftNNv_stringMATgbl ftNNv_countSCAgbl
global ftNNt_errorVECgbl ftNNv_errorVECgbl
global ftNNrbf_meanMATgbl ftNNrbf_sdMATgbl

if ~exist(' ftnnwarm.mat')
    ftNNpp2=str2mat(' This option loads data saved from any earlier',...
                    ' menu activity. Data from previous menu activity',...
                    ' is not available (ftnnwarm.mat). ');
    helpdlg(ftNNpp2,'Attention! Exception!');
else
    fig_nnwarmGUI=ftfigure('fig_nnwarmGUI','FlexTool(NN) -- NN WARM', ftFigPos_smallVECgbl,'on','none');
    ftNNpp3= [0.9 0.1 0.9 0.5 0.005 0.005];
    ftNNpp1=' ';

    ftNNpp2=str2mat(' This option loads data saved from any earlier',...
                ' menu activity. If you want to load data that you',...
                '  have saved, enter Ok or enter Cancel.');

    ftscrhlp(fig_nnwarmGUI,ftNNpp1,ftNNpp2,ftNNpp3,'left');
    ftscrpb(fig_nnwarmGUI,'Ok',[0.1 0.05 0.3 0.15],'load ftnnwarm; close;');
    ftscrpb(fig_nnwarmGUI,'Cancel',[0.6 0.05 0.3 0.15],'close;');
end

clear ftNNpp1 ftNNpp2 ftNNpp3

%
% end ftnnwarm.m
%

