% =================================================================
% ftnnwts.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% GUI for FlexTool(NN) Degree of Association Matrix
%

function ftnnwts(pflag_, rfrom_, cfrom_)

global ftFigPos_bigVECgbl ftscr_cntSCAgbl  ftflag_edtGUI
global ftNNn_typeVECgbl   ftNNc_typeVECgbl fttmpscrcntSCA_
global ftNNn_nameVECgbl   ftNNn_maxVECgbl  ftNNn_minVECgbl
global ftNNno_inSCAgbl    ftNNno_hidSCAgbl ftNNno_outSCAgbl ftNNno_totSCAgbl
global ftNNweightMATgbl   ftNNweightOPTgbl ftNNassocMATgbl
global ftNNasetFLGgbl ftNNtypeSCAgbl
global fneuron_ tneuron_ retval_

figpos_ = ftFigPos_bigVECgbl;

ftnn2_flag=pflag_;
save_scr_cnt_=ftscr_cntSCAgbl;
title_=['FlexTool (NN) -- Weight Matrix'];
fig_nnwtGUI=ftfigure('fig_wtasnGUI',title_,figpos_,'on','figure');

fthelp(fig_nnwtGUI,'NN');


%y0=0.54; x0=0.23; tx0=x0; dx_no1=0.14; dx_no=0.07; 
%dx=.075; dy_no=0.04; dy_no2=0.05;
%dy=0.07; dx2=x0-0.21; dy2_no=0.06; y0b=y0;

y0=0.7; x0=0.23; tx0=x0; dx_no1=0.14; dx_no=0.07; 
dx=.075; dy_no=0.08; dy_no2=0.05;
dy=0.07; dx2=x0-0.21; dy2_no=0.06; y0b=y0;



if ((ftNNasetFLGgbl==1) & (ftNNtypeSCAgbl < 5))
  pp1='Forward';
  pp3=[dx2 y0-(0.8*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(1.55*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNweightOPTgbl(2)=retval_; if(retval_==3), retval_=randn(ftNNno_totSCAgbl)/2;',...
   'else, retval_=ones(ftNNno_totSCAgbl)*(retval_-1); end; ',...
   'if(ftNNweightOPTgbl(2)<4), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=fneuron_+1:ftNNno_totSCAgbl),',...
   'ftNNweightMATgbl(tneuron_,fneuron_) = retval_(tneuron_,fneuron_); end; end;',...
   'close; ftnnwts(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNweightOPTgbl(2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Self Recur';
  pp3=[dx2 y0-(2.6*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(3.35*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNweightOPTgbl(3)=retval_; if(retval_==3), retval_=randn(ftNNno_totSCAgbl)/2; else,',...
   'retval_=ones(ftNNno_totSCAgbl)*(retval_-1); end; if(ftNNweightOPTgbl(3)<4), for(fneuron_=1:ftNNno_totSCAgbl), ',...
   'ftNNweightMATgbl(fneuron_,fneuron_) = retval_(fneuron_,fneuron_); end;',...
   'close; ftnnwts(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNweightOPTgbl(3); % Set for all
  pp6=[1:size(pp1,1)]'; 
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Recurrence';
  pp3=[dx2 y0-(4.4*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(5.15*dy) dx_no1 dy2_no];
  pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'ftNNweightOPTgbl(4)=retval_; if(retval_==3), retval_=randn(ftNNno_totSCAgbl)/2;',...
   'else, retval_ = ones(ftNNno_totSCAgbl)*(retval_ - 1); end;',...
   'if(ftNNweightOPTgbl(4)<4), for(fneuron_=1:ftNNno_totSCAgbl), for(tneuron_=1:fneuron_-1),',...
   'ftNNweightMATgbl(tneuron_,fneuron_) = retval_(tneuron_,fneuron_); end; end;',...
   'close; ftnnwts(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNweightOPTgbl(4); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3

  pp1='Random';
  pp3=[dx2 y0-(6.2*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'None',...
		'Forward',...
		'Self Recur',...
		'Recurrence');
  pp3=[dx2 y0-(6.95*dy) dx_no1 dy2_no];


   pp4=['retval_ = get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   'if retval_ > 1, ftnnask(4,' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=1; 	% None
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3 pp2 pp4 pp5 pp6
 end

if ((ftNNasetFLGgbl==1) & (ftNNtypeSCAgbl >= 5))
  pp1='All';
  pp3=[dx2 y0-(0.8*dy) dx_no1 0.05];
  ftscrtxt(fig_nnwtGUI,pp1,pp3);
  clear pp1;

  ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
  scr_cnt_ = ftscr_cntSCAgbl;
  pp1= str2mat(...
		'0',...
		'1',...
		'Random');
  pp3=[dx2 y0-(1.55*dy) dx_no1 dy2_no];
  pp4=['ftNNweightOPTgbl(2)=get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''value'');',...
   ' if ftNNweightOPTgbl(2)==1, ftNNweightMATgbl=ftNNweightMATgbl*0.0; end; ',...
   ' if ftNNweightOPTgbl(2)==2, ftNNweightMATgbl=ones(size(ftNNweightMATgbl)); end; ',...
   ' if ftNNweightOPTgbl(2)==3, ftNNweightMATgbl=randn(size(ftNNweightMATgbl))/2; end; ',...
   ' close; ftnnwts(' num2str(ftnn2_flag) ',' num2str(rfrom_) ',' num2str(cfrom_) '); end;'];
  pp5=ftNNweightOPTgbl(2); % Set for all
  pp6=[1:size(pp1,1)]';
  ftscrpup(fig_nnwtGUI,pp1,pp3,pp4,pp5,pp6,scr_cnt_);
  clear pp1 pp3
end
%================
% Loop through
%================
if ftNNtypeSCAgbl < 5
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_totSCAgbl;
  cfrom_ = 1; cto_ = rto_;
 else
%  rto_ = rfrom_+8;
%  cto_ = cfrom_+8;
  rto_ = rfrom_+11;
  cto_ = cfrom_+11;

 end;

 if rto_ > ftNNno_totSCAgbl, rto_= ftNNno_totSCAgbl; end
 if rfrom_ > ftNNno_totSCAgbl, rfrom_= ftNNno_totSCAgbl; end
 if cto_ > ftNNno_totSCAgbl, cto_= ftNNno_totSCAgbl; end
 if cfrom_ > ftNNno_totSCAgbl, cfrom_= ftNNno_totSCAgbl; end

elseif ftNNtypeSCAgbl==14

 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_hidSCAgbl;
 else
%  rto_ = rfrom_+8;
%  cto_ = cfrom_+8;
  rto_ = rfrom_+11;
  cto_ = cfrom_+11;

 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_hidSCAgbl, cto_= ftNNno_hidSCAgbl; end
 if cfrom_ > ftNNno_hidSCAgbl, cfrom_= ftNNno_hidSCAgbl; end
else
 if nargin <2
  rfrom_ = 1; rto_ = ftNNno_outSCAgbl;
  cfrom_ = 1; cto_ = ftNNno_inSCAgbl;
 else
%  rto_ = rfrom_+8;
%  cto_ = cfrom_+8;
  rto_ = rfrom_+11;
  cto_ = cfrom_+11;

 end;

 if rto_ > ftNNno_outSCAgbl, rto_= ftNNno_outSCAgbl; end
 if rfrom_ > ftNNno_outSCAgbl, rfrom_= ftNNno_outSCAgbl; end
 if cto_ > ftNNno_inSCAgbl, cto_= ftNNno_inSCAgbl; end
 if cfrom_ > ftNNno_inSCAgbl, cfrom_= ftNNno_inSCAgbl; end
end
  
if ftNNasetFLGgbl==1
  bigpp1_=[' Fr:     ' sprintf(' %3d    ', [cfrom_:1:cto_])];
  if cfrom_ > 9
    bigpp1_=[' Fr:    ' sprintf('%3d     ', [cfrom_:1:cto_])];
  end

  bigpp1_=str2mat(bigpp1_,' ',' To: ');

  for (fneuron_=rfrom_:rto_)
    if fneuron_ < 10
       pp11=sprintf('  %1d     ',fneuron_);
    elseif fneuron_ < 99
       pp11=sprintf(' %2d    ',fneuron_);
    else
       pp11=sprintf('%3d     ',fneuron_);
    end
    pp12=sprintf('%5.2f  ', ftNNweightMATgbl(fneuron_,cfrom_:cto_));
    bigpp1_=str2mat(bigpp1_,[pp11 pp12]);
  end;  %for fneuron_

%  pp3= [0.65 0.20 0.95 0.15 0.04 0.002];
   pp3= [0.9 0.20 0.95 0.15 0.04 0.002];

  pp1='FlexTool(NN) Weights Matrix';
  ftscrhlp(fig_nnwtGUI,pp1,bigpp1_,pp3,'left');

else

  gblcnt_=0;
  fttmpscrcntSCA_ = ftscr_cntSCAgbl+1;
  for (fneuron_=rfrom_:rto_)
   x0=0.23;

   pp1=num2str(fneuron_);
   pp3=[x0-0.0575 y0+0.005 0.05 0.04];
   ftscrtxt(fig_nnwtGUI,pp1,pp3);
   clear pp1;

   for (tneuron_=cfrom_:cto_)
   
     gblcnt_=gblcnt_+1;

     if(fneuron_==rfrom_)
   	pp1=num2str(tneuron_);
   	pp3=[x0+0.015 0.61 0.05 0.05];
	ftscrtxt(fig_nnwtGUI,pp1,pp3);
	clear pp1;
     end; %if
  
     pp1= num2str(ftNNweightMATgbl(fneuron_,tneuron_),3);
  
     pp3=[x0 y0 dx_no dy_no];
     pp4=['retval_ = str2num(get(ftflag_edtGUI(' num2str(ftscr_cntSCAgbl) '),''string''));',...
      'ftNNweightMATgbl(' num2str(fneuron_) ',' num2str(tneuron_) ') = retval_;'];

     if(ftNNassocMATgbl(fneuron_,tneuron_)==0)
	ftNNweightMATgbl(fneuron_,tneuron_)=0;
	ftscrtxt(fig_nnwtGUI,' ',pp3);
     else
		ftscr_cntSCAgbl=ftscr_cntSCAgbl+1;
		scr_cnt_ = ftscr_cntSCAgbl;
		ftscredt(fig_nnwtGUI,pp1,pp3,pp4,scr_cnt_);
     end;

     clear pp1 pp3
     x0=x0+dx;
   end; %for tneuron_
   y0=y0-dy_no2;
  end;  %for fneuron_
end %ftNNasetFLGgbl

x0=tx0;

%=====================
% Go Back to the Left
%=====================
%if cfrom_ > 9
%   temp_=cfrom_-9;
 if cfrom_ > 12
 temp_=cfrom_-12;

 pp1='< Back';
 %pp3=[x0 0.01 0.1 0.08];
  pp3=[x0+(-2*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnwts(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go Back Up
%=====================
%if rfrom_ > 9
%   temp_=rfrom_-9;
if rfrom_ > 12
 temp_=rfrom_-12;

 pp1='Up ^';
% pp3=[x0+(2*dx) 0.01 0.1 0.08];
  pp3=[x0 0.01 0.1 dy_no];

 pp4=['close; ftnnwts(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go to the Right
%=====================
if ftNNno_totSCAgbl > cto_
 temp_=cto_+1;
 pp1='More >';
 %pp3=[x0+(4*dx) 0.01 0.1 0.08];
   pp3=[x0+(2*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnwts(' num2str(pflag_) ',' num2str(rfrom_) ',' num2str(temp_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end
%=====================
% Go Down
%=====================
if ftNNno_totSCAgbl > rto_
 temp_=rto_+1;
 pp1='Down v';
% pp3=[x0+(6*dx) 0.01 0.1 0.08];
   pp3=[x0+(4*dx) 0.01 0.1 dy_no];

 pp4=['close; ftnnwts(' num2str(pflag_) ',' num2str(temp_) ',' num2str(cfrom_) ')'];
 ftscrpb(fig_nnwtGUI,pp1,pp3,pp4);
end

%=====================
% Done
%=====================

ftscrpb(fig_nnwtGUI,'Done',[x0+(8*dx) 0.01 0.1 0.08],'ftnnsave(''warm''); close;');
ftscrpb(fig_nnwtGUI,'Help',[x0+(6*dx) 0.01 0.1 0.08],'ftnnhp03');


ftscr_cntSCAgbl=save_scr_cnt_;

%
% end ftnnwts.m
%
