% =================================================================
% ftnn_def.m
% =================================================================
%                        FlexTool(NN) for Matlab                          
%                           Copyright (c) 1996                               
%                   Flexible Intelligence Group (FIG)       	             
%            P. O. Box 861477, Tuscaloosa, AL 35486-0013, USA.            
%                              06/05/1996                                  
% =================================================================
% Some declarations required for FlexTool(NN) and FlexTool(ENM)
%

function ftnn_def

ftNNasetFLGgbl = 1;
ftNNfnflagSCAgbl = 1;
ftnndef_flag = 1;
ftNNbiasFLGgbl = 1;
ftscr_cntSCAgbl = 1;
ftNNlrSCAgbl = 0.01;
ftNNmrSCAgbl = 0.0;
ftNNn_epSCAgbl = 100; 
ftNNe_thSCAgbl = 0.0; 
ftNNv_pcntSCAgbl = 00;
ftNNbase_resSCAgbl = 0.01;
ftNNbase_minSCAgbl = -1.0;
ftNNbase_maxSCAgbl = 1.0;
ftNNer_betaSCAgbl = 1.0;
ftNNrbf_sdMATgbl=0.1;

ftNNpp_typeMATgbl=str2mat(...
'BP Network--Fully Connected', ...
'BP Recurrent Network', ...
'BP Network--Hidden Layers', ...
'N/A in the current version', ...
'Linear Network',...
'Perceptrons',...
'Hebbian Learning',...
'Instar Learning');
ftNNpp_typeMATgbl=str2mat(ftNNpp_typeMATgbl,...
'Outstar Learning',...
'Kohonen Learning', ...
'Counter Prop Network',...
'LVQ Network', ...
'N/A in the current version', ...
'RBF Network');

ftNNfn_bpMATgbl=str2mat(...
'bp',...
'br',...
'bl',...
'xx',...
'ln',...
'pc');
ftNNfn_bpMATgbl=str2mat(ftNNfn_bpMATgbl,...
'hb',...
'il',...
'ol',...
'kn',...
'cp',...
'lv',...
'ar',...
'rb');

ftNNtypeSCAgbl=1;

ftNNpp_specMATgbl=str2mat(...
'UnPruned NN',...
'Lean NN(Pruned)');

ftNNspecialSCAgbl=1;

ftNNpp_lrnMATgbl=str2mat(...
'Pattern Learning',...
'Batch Learning');

ftNNlearnSCAgbl=1;

ftNNpp_cnvMATgbl=str2mat(...
'Number of Epochs',...
'Error Threshold',...
'Validation');

ftGAtype_cnvMATgbl=str2mat(...
'Flex GA',...
'Micro GA',...
'Generational GA');


ftNNer_typeSCAgbl=1;

ftNNpp_ertypeMATgbl=str2mat(...
'Least Square',...
'Hampel Error',...
'Huber Error',...
'Logistic Error',...
'Talvars Error',...
'Linear Error');

ftNNfn_errMATgbl=str2mat(...
'ftnnlse',...
'ftnnhae',...
'ftnnhue',...
'ftnnloe',...
'ftnntae',...
'ftnnlie');

ftNNconvSCAgbl=1;

ftNNno_in_userSCAgbl=1;
ftNNno_inSCAgbl=2;
ftNNno_hidSCAgbl=20;
ftNNno_outSCAgbl=1;
ftNNno_totSCAgbl=22;

ftNNactSCAgbl=1;

ftNNpp_actMATgbl=str2mat(...
'Linear',...
'Hard Limiter',...
'Saturated Linear',...
'Sigmoidal',...
'Bipolar Sigmoidal',...
'Gaussian');

ftNNfn_actMATgbl=str2mat(...
'ftnnlin',...
'ftnnhal',...
'ftnnsln',...
'ftnnsig',...
'ftnnbis',...
'ftnngau',...
'ftnnuse');

ftNNact_p_cntVECgbl=[1;2;2;1;1;2;1];
ftNNact_parmMATgbl=...
[1 0 0;
1 0 0;
1 1 0;
1 1 0;
1 1 -1;
0 1 0];

ftNNh_layerSCAgbl=1;

ftNNpp_hlayerMATgbl=str2mat(...
'One-hidden Layer',...
'Two-hidden Layers',...
'Three-hidden Layers'); 

ftNNno_hidVECgbl=[20 0 0];

ftNNassocMATgbl = ones(22,22);
ftNNassnCNTgbl  = 100;
ftNNassocOPTgbl = [1 2 2 2];

ftNNweightMATgbl= rand(22,22);
ftNNweightOPTgbl= [1 3 3 3];

FTmax_in=25;
FTmax_hidden=60;
FTmax_out=25;

for i=1:FTmax_in
 ftNNn_iparmVECgbl(i,:)=ftNNact_parmMATgbl(1,:);
end
for i=1:FTmax_hidden
  ftNNn_hparmVECgbl(i,:)=ftNNact_parmMATgbl(5,:);
end
for i=1:FTmax_out
  ftNNn_oparmVECgbl(i,:)=ftNNact_parmMATgbl(1,:);
end

ftNNn_imaxVECgbl=ones(FTmax_in,1);
ftNNn_iminVECgbl=ones(FTmax_in,1);
ftNNn_itypeVECgbl=ones(FTmax_in,1);
FTempty_=['            '];
for i=1:FTmax_in
 if i < 10, ftNNn_inameVECgbl(i,:)=['input_' num2str(i) FTempty_ ' ']; end
 if i >  9,  ftNNn_inameVECgbl(i,:)=['input_' num2str(i) FTempty_]; end
end

ftNNn_hmaxVECgbl=ones(FTmax_hidden,1);
ftNNn_hminVECgbl=-ones(FTmax_hidden,1);
ftNNn_htypeVECgbl=5*ones(FTmax_hidden,1);
FTempty_=['           '];
for i=1:FTmax_hidden
 if i < 10, ftNNn_hnameVECgbl(i,:)=['hidden_' num2str(i) FTempty_ ' ']; end
 if i >  9,  ftNNn_hnameVECgbl(i,:)=['hidden_' num2str(i) FTempty_]; end
end

ftNNn_omaxVECgbl=ones(FTmax_out,1);
ftNNn_ominVECgbl=ones(FTmax_out,1);
ftNNn_otypeVECgbl=ones(FTmax_out,1);
FTempty_=['           '];
for i=1:FTmax_out
 if i < 10, ftNNn_onameVECgbl(i,:)=['output_' num2str(i) FTempty_ ' ']; end
 if i >  9,  ftNNn_onameVECgbl(i,:)=['output_' num2str(i) FTempty_]; end
end

FTtwo_power_k(1:200)=2.^(0:199);

ftbprmSTRgbl = 'fname';
clear i

save ft3nn_def.mat

%
% end ftnn_def.m
%
 
