%
% FTscrscr
%
% =========================================================================  
%                          FlexTools(GA) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% General purpose GUI routine--Scroller
%

function outval=ftscrscr(p1,p2,p3,p4,p5,p6)
global ftscrl_valSCAgbl

if nargin==6
 fignumber=p1;
 scr_loc_=p2;
 scr_min_=p3;
 scr_max_=p4;
 scr_val_=p5;
 scr_cback_=p6;
elseif nargin==5
 fignumber=gcf;
 scr_loc_=p1;
 scr_min_=p2;
 scr_max_=p3;
 scr_val_=p4;
 scr_cback_=p5;
end

if scr_loc_=='rt'		%Right
 scr_loc_=[0.95 0 0.06 1.00];
elseif scr_loc_=='lt'		%Left
 scr_loc_=[0.0 0.0 0.03 0.96];
elseif scr_loc_=='tp'		%Top
 scr_loc_=[0.0 0.96 0.97 0.04];
elseif scr_loc_=='bt'		%Bottom
 scr_loc_=[0.0 0.0 0.97 0.04];
end

outval=uicontrol(fignumber, ...
        'Style','slider', ...
        'Units','normalized', ...
        'Position',scr_loc_, ...
        'Min',scr_min_, ...
        'Max',scr_max_, ...
        'Value',scr_val_, ...
        'Callback',scr_cback_);

%
% END FTscrscr
%

