%
% FTstatus
%
% =========================================================================  
%                          FlexTool( ) for Matlab                          
%                             Copyright (c) 1995                               
%                       Flexible Intelligence Group (FIG)       	             
%                   P. O. Box 1477, Tuscaloosa, AL 35486, USA.            
%                                 06/05/1995                                  
% =========================================================================  
%
% Sets up the status graphics
% 

function ftstatus(fx,fgen,fxmax,fgenmax,flag_fn);
global ftfxoldSCAgbl

fx=(fx/fxmax);
fgen=(fgen/fgenmax);
fx0=fx-1/fxmax;
fgen0=fgen-1/fgenmax;

xcon1=3;
xcon2=4;
xcon3=5;
xcon4=6;

subplot(3,3,9);

if flag_fn==1	%Only the first time
  ftfxoldSCAgbl=fx;
  hold off;
  axis('off');
  title('Evolution Status      ')
  text(1.75,-0.1,'# pop');
  text(1.25,0.96,num2str(fxmax));
  text(xcon2-0.25,-0.1,'# gen');
  text(xcon3+0.1,0.96,num2str(fgenmax));
  hold on;
  drawnow;

  %Function Evaluations
  x1=[2;2;   xcon1;  xcon1;xcon2];
  y1=[0;1;1;0;0;];
  fill(x1,y1,'w');
  hold on;

  %Generation Evaluations
  x1=[xcon2;xcon2;   xcon3;  xcon3;xcon4];
  y1=[0;1;1;0; 0;];
  fill(x1,y1,'w');
  hold on;

  x1=[xcon2;xcon2;   xcon3;  xcon3;xcon4 ];
  y1=[0;fgen;fgen;0; 0;];
  fill(x1,y1,'r');
  hold on;
end

%Function Evaluations

x1=[2;2;xcon1;xcon1];
y1=[0;fx;fx;0;];
fill(x1,y1,'b');
ftfxoldSCAgbl=fx;
%hold on;
drawnow;